angular.module('childcareOnApp').controller('AdminClassroomsDetailCtrl', function($scope, $rootScope, $state, AdminProfilesFactory, CommonFactory, ChildFactory, $translate, $ionicHistory) {


  var getClassroom = function(){
    AdminProfilesFactory.getClassroom($rootScope.classSelected.id).then(function(classroom){
      $scope.classroom = classroom;
      $scope.studentsNumber = classroom.hasOwnProperty('students') ? Object.keys(classroom.students).length : 0;
      if (!$scope.classroom.hasOwnProperty('options')) {
        $scope.classroom.options = {};
      }
      if (!!$rootScope.settings.hideCard && !!$rootScope.settings.hideCard[$scope.classroom.$id] && $rootScope.settings.hideCard[$scope.classroom.$id].bottles) {
        $scope.classroom.options.bottles = false;
      } else {
        if (!$scope.classroom.options.hasOwnProperty('bottles')) {
          $scope.classroom.options.bottles = true;
        }
      }
      console.log("classroom",classroom);
    },function(){
      alert($translate.instant('serverError'));
    });
  };

  $scope.typeSelection = [{name:"0-3 "+ $translate.instant('years'), value: 1},{name:"3-6 "+ $translate.instant('years'), value: 2}];

  $scope.manageParents = function(){
    $rootScope.studentParents = $scope.student;
  };

  $scope.setClassroom = function(){
    console.log("$scope.classroom",$scope.classroom);
    $rootScope.setGoTo('adminStudentsInfo');
    $rootScope.classSelected = {id:$scope.classroom.$id,name:$scope.classroom.name};
  };

  $scope.updateClassroom = function(){
    console.log("updateClassroom params",$scope.classroom);
    $rootScope.show();
    CommonFactory._save($scope.classroom).then(function(){
      console.log("success save classroom");
      $rootScope.classSelected.name = $scope.classroom.name;
      $rootScope.school.classrooms[$scope.classroom.$id] = $scope.classroom.name;
      CommonFactory._save($rootScope.school).then(function(){
        ChildFactory.updateChildrenClassroomName($scope.classroom.name, $scope.classroom.students);
        if(!$rootScope.settings.classroomsDetails) $rootScope.settings.classroomsDetails = {};
        if (!$scope.classroom.type || !$scope.classroom.type.value) {
          $scope.classroom.type = {
            value: 1
          };
        }
        if ($scope.classroom.type.value !== 1) {
          $rootScope.settings.classroomsDetails[$scope.classroom.$id] = $scope.classroom.type.value;
        }
        if (!$scope.classroom.options.bottles) {
          if (!$rootScope.settings.hasOwnProperty('hideCard')) {
            $rootScope.settings.hideCard = {};
          }
          if (!$rootScope.settings.hideCard.hasOwnProperty($scope.classroom.$id)) {
            $rootScope.settings.hideCard[$scope.classroom.$id] = {};
          }
          $rootScope.settings.hideCard[$scope.classroom.$id].bottles = true;
        } else {
          if (!!$rootScope.settings.hideCard && !!$rootScope.settings.hideCard[$scope.classroom.$id] && $rootScope.settings.hideCard[$scope.classroom.$id].bottles) {
            delete $rootScope.settings.hideCard[$scope.classroom.$id].bottles;
            if (Object.keys($rootScope.settings.hideCard[$scope.classroom.$id]).length === 0) {
              delete $rootScope.settings.hideCard[$scope.classroom.$id];
            }
            if (Object.keys($rootScope.settings.hideCard).length === 0) {
              delete $rootScope.settings.hideCard;
            }
          }
        }
        console.log("settings now",$rootScope.settings);
        CommonFactory._save($rootScope.settings).then(function(){
          $rootScope.hide();
          $rootScope.showToast('infoSavedSuccessfully');
          $ionicHistory.goBack();
        });
      });
    },function(){
      console.log("error save user");
      alert($translate.instant('serverError'));
    });
  };

  $scope.deleteClassroom = function(){
    console.log("$scope.classroom",$scope.classroom);
    if($scope.classroom.hasOwnProperty('students')){
      $rootScope.showToast('adminProfiles_cantDeleteClassroom');
      return;
    }
    _confirm($translate.instant('adminProfiles_deleteClassroom'), $translate.instant('confirmGeneric') ,$translate.instant('login_forgotPassword_cancelButton'), $translate.instant('button_accept'), function(buttonIndex){
      if(buttonIndex === 2){
        AdminProfilesFactory.deleteClassroom($scope.classroom.$id).then(function(){
          $ionicHistory.goBack();
          $rootScope.showToast('adminProfiles_classroomDeleted');
        },function(){
          alert($translate.instant('serverError'));
        });
      }
    });
  };

  (function(){
    getClassroom();
  }());

});
