angular.module('childcareOnApp').controller('AdminClassroomsCtrl', function($scope, $rootScope, $state, $translate, $ionicModal, AdminProfilesFactory, UserFactory, ClassroomFactory) {

  $scope.classroomToAdd = {name:null, type:{value:null}, options:{bottles: true}};
  $scope.typeSelection = [{name:"0-3 "+ $translate.instant('years'), value: 1},{name:"3-6 "+ $translate.instant('years'), value: 2}];

  $scope.setClassroom = function(item,name){
    $rootScope.classSelected = {id:item,name:name};
    console.log("classSelected 1", $rootScope.classSelected);
  };

  $scope.addClassroom = function(){
    console.log("classroomToAdd",$scope.classroomToAdd);
    if(!$scope.classroomToAdd.name){
      alert($translate.instant('fillFields'));
      return;
    }
    var teachers = angular.copy($scope.classroomToAdd.teachers);
    console.log("teachers",teachers);
    for(var i in teachers){
      if(!teachers[i]) delete teachers[i];
      else teachers[i] = $rootScope.school.teachers[i];
    }
    var classroomToAdd = {
      name:$scope.classroomToAdd.name,
      type:$scope.classroomToAdd.type,
      options: $scope.classroomToAdd.options
    };
    if(!!(teachers) &&  Object.keys(teachers).length > 0) classroomToAdd.teachers = teachers;
    console.log("classroomToAdd modified",classroomToAdd);
    $rootScope.show();
    ClassroomFactory.addClassroom(classroomToAdd).then(function(id){
      if(!$rootScope.parsedClassroomAccess) $rootScope.parsedClassroomAccess = [];
      $rootScope.parsedClassroomAccess.push({id:id,name:classroomToAdd.name});
      if(!$rootScope.globalClassSelected){
        $rootScope.globalClassSelected = {id:id,name:classroomToAdd.name};
        UserFactory.saveGlobalClassroom();
      }
      $rootScope.hide();
      $scope.classroomToAdd = {name:null, type:{value:null}, options:{bottles: true}};
      $scope.closeModal();
    },function(){
      alert($translate.instant('serverError'));
    });
  };

  $scope.getIfShowTeachers = function(){
    return ($rootScope.school.hasOwnProperty('teachers') && Object.keys($rootScope.school.teachers).length > 0);
  };

  $ionicModal.fromTemplateUrl('modal-add.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modal = modal;
  });
  $scope.openModal = function() {
    $scope.modal.show();
  };
  $scope.closeModal = function() {
    $scope.modal.hide();
  };
  // Cleanup the modal when we're done with it!
  $scope.$on('$destroy', function() {
    if (!!$scope.modal) {
      $scope.modal.remove();
    }
  });

  (function(){
  }());

});
