angular.module('childcareOnApp').controller('SelectStudentDetailCtrl', function($scope, $rootScope, $state, $stateParams, $translate, AdminProfilesFactory, ClassroomFactory, $ionicModal, ChildFactory, DiaryFactory) {
  if (!$rootScope.allUserInfo) {
    $state.go('app.splash',{error:true});
  }
  $scope.studentToAdd = {};
  $scope.sendToAllClassroom = {
    childs: {}
  };
  $scope.fields = [{
    value: $rootScope.allUserInfo.email
  }];
  $scope.sendingAllClassroom = false;
  if(!$rootScope.classSelected && $rootScope.globalClassSelected) $rootScope.classSelected = $rootScope.globalClassSelected;

  switch($rootScope.goTo){
    case "meeting":
        $scope.globalActions = [{
          name: "selectStudent_meeting_allClassroom",
          fn: function(){
            $state.go('app.meeting',{allClassroomMeeting:true});
          }
        }];
      break;
    case "diary":
        $scope.globalActions = [{
          name: "diary_setParameter",
          fn: function(){
            setParameterDiary();
          }
        }];
      break;
    case "health":
      var globalActions = [];
      if ($rootScope.allUserInfo.type === 'principal') {
        globalActions.push({
          name: "attendance_exportExcel",
          disabled: (!$rootScope.settings.premium),
          fn: function(){
            openExportHealth();
          }
        });
      }
      $scope.globalActions = globalActions;
      break;
    default: $scope.globalActions = false;
  }

  function setStudents(){
    var students = [];
    for(var i in $rootScope.classroom.students){
      var student = $rootScope.classroom.students[i];
      students.push({
        id:i,
        name: student
      });
    }
    $scope.students = students;
  }

  var getClassroom = function(){
    $rootScope.show();
    if(!$stateParams.comeFromSelectClassroom){
      $rootScope.classSelected = $rootScope.globalClassSelected;
    }
    var id = $rootScope.classSelected.id;
    ClassroomFactory.getClassroomStudents(id).then(function(classroom){
      $rootScope.classroom = classroom;
      setStudents();
      setTimeout(function () {
        $rootScope.hide();
      }, 10);
    },function(){
      alert($translate.instant('serverError'));
    }).finally($rootScope.hide);
  };

  $scope.setStudent = function(item,name){
    $rootScope.studentSelected = {id:item,name:name};
    $state.go('app.'+$rootScope.goTo, $rootScope.goToArgs);
    delete $rootScope.goToArgs;
  };

  $scope.addStudent = function(){
    if(!$scope.studentToAdd.birthdate || !$scope.studentToAdd.name || !$scope.studentToAdd.surname || !$scope.studentToAdd.gender){
      alert($translate.instant('fillFields'));
      return;
    }
    var bir = $scope.studentToAdd.birthdate;
    console.log("studentToAdd",$scope.studentToAdd);
    var allClassrooms = {};
    allClassrooms[$rootScope.classroom.$id] = $rootScope.classroom.name;
    var studentToAdd = {
      allClassrooms: allClassrooms,
      classroomId:$rootScope.classroom.$id,
      classroomName:$rootScope.classroom.name,
      name:$scope.studentToAdd.name,
      surname:$scope.studentToAdd.surname,
      school:$rootScope.allUserInfo.school,
      birthdate:bir.substring(0, 2)+"/"+bir.substring(2, 4)+"/"+bir.substring(4, 8),
      birthdateParsed: bir.substring(0, 2)+"_"+bir.substring(2, 4),
      gender:$scope.studentToAdd.gender
    };
    console.log("studentToAdd modified",studentToAdd);
    $rootScope.show();
    AdminProfilesFactory.addStudent(studentToAdd).then(function(){
      $rootScope.showToast('adminProfiles_userCreated');
      $scope.studentToAdd = {};
      $scope.closeModal();
      $rootScope.hide();
      setStudents();
    },function(){
      alert($translate.instant('serverError'));
    });
  };

  $scope.sendToAllClassroomSend = function(){
    if (!$scope.sendToAllClassroom.hasOwnProperty('type') || !$scope.sendToAllClassroom.type.hasOwnProperty('type')){
      $scope.sendToAllClassroom = {
        childs: {}
      };
      return alert($translate.instant('fillDataAgain'));
    }
    $scope.sendingAllClassroom = true;
    switch($scope.sendToAllClassroom.type.type){
      case 'comment':
      if(!$scope.sendToAllClassroom.text) return alert($translate.instant('fillFields'));
      DiaryFactory.sendCommentAllClassroom($scope.sendToAllClassroom.text, $scope.sendToAllClassroom.childs).then(function(){
        $scope.closeModalSelectStudents();
        $scope.sendToAllClassroom = {
          childs: {}
        };
        return alert($translate.instant('sentSuccessfully'));
      },function(error){
        if(error === 'noChildren'){
          return alert($translate.instant('fillFields'));
        }else{
          $scope.closeModalSelectStudents();
          alert($translate.instant('serverError'));
        }
      });
      break;
      case 'dailyActivity':
      if(!$scope.sendToAllClassroom.text) return alert($translate.instant('fillFields'));
      DiaryFactory.sendDailyActivityAllClassroom($scope.sendToAllClassroom.text, $scope.sendToAllClassroom.childs).then(function(){
        $scope.closeModalSelectStudents();
        $scope.sendToAllClassroom = {
          childs: {}
        };
        return alert($translate.instant('sentSuccessfully'));
      },function(error){
        if(error === 'noChilds'){
          return alert($translate.instant('fillFields'));
        }else{
          $scope.closeModalSelectStudents();
          alert($translate.instant('serverError'));
        }
      });
      break;
      case 'sleep':
      if(!$scope.sendToAllClassroom.text || !$scope.sendToAllClassroom.text.type) return alert($translate.instant('fillFields'));
      DiaryFactory.sendSleepAllClassroom($scope.sendToAllClassroom.text, $scope.sendToAllClassroom.childs).then(function(){
        $scope.closeModalSelectStudents();
        $scope.sendToAllClassroom = {
          childs: {}
        };
        return alert($translate.instant('sentSuccessfully'));
      },function(error){
        if(error === 'noChilds'){
          return alert($translate.instant('fillFields'));
        }else{
          $scope.closeModalSelectStudents();
          alert($translate.instant('serverError'));
        }
      });
      break;
      case 'breakfast':
      case 'lunch':
      case 'snack':
      if(!$scope.sendToAllClassroom.text) return alert($translate.instant('fillFields'));
      DiaryFactory.sendMealAllClassroom($scope.sendToAllClassroom.text, $scope.sendToAllClassroom.childs, $scope.sendToAllClassroom.type.type).then(function(){
        $scope.closeModalSelectStudents();
        $scope.sendToAllClassroom = {
          childs: {}
        };
        return alert($translate.instant('sentSuccessfully'));
      },function(error){
        if(error === 'noChilds'){
          return alert($translate.instant('fillFields'));
        }else{
          $scope.closeModalSelectStudents();
          alert($translate.instant('serverError'));
        }
      });
      break;
      case 'defecations':
      if(!$scope.sendToAllClassroom.text || Object.keys($scope.sendToAllClassroom.childs).length === 0) return alert($translate.instant('fillFields'));
      DiaryFactory.sendDefecationsAllClassroom($scope.sendToAllClassroom.text, $scope.sendToAllClassroom.childs).then(function(){
        $scope.closeModalSelectStudents();
        $scope.sendToAllClassroom = {
          childs: {}
        };
        return alert($translate.instant('sentSuccessfully'));
      },function(error){
        if(error === 'noChilds'){
          return alert($translate.instant('fillFields'));
        }else{
          $scope.closeModalSelectStudents();
          alert($translate.instant('serverError'));
        }
      });
      default: return false;
    }
  };

  var setParameterDiary = function(){
    $scope.sendToAllClassroom.childs = {};
    $scope.openModalSelectStudents();
  };

  var showCard = function(name, classroomType){
    if (typeof classroomType === 'undefined') classroomType = 0;
    return DiaryFactory.getIfShowCard(name, classroomType, $rootScope.classSelected.id);
  };

  var openExportHealth = function() {
    $scope.openModalExportHealth();
  };

  $scope.addField = function() {
    $scope.fields.push({value: ""});
  };

  function exportHealthExcel(data) {
    $rootScope.showToast('loading');
    $scope.closeModal();
    ChildFactory.exportHealthExcel(data)
    .then(function(body) {
      $rootScope.showToast('sentSuccessfully');
      $scope.closeModalExportHealth();
    }, function(error) {
      console.log("error!",error);
      alert("error: "+error);
    });
  }

  $scope.exportHealthExcel = function() {
    var emailTotal = [];
    for(var i=0; i<$scope.fields.length; i++) {
      if ($scope.fields[i].value !== "") {
        emailTotal.push($scope.fields[i].value);
      }
    }
    emailTotal = emailTotal.join(", ");
    console.log("emailTotal",emailTotal);
    return exportHealthExcel({
      email: emailTotal,
      classroomId: $rootScope.classSelected.id,
      schoolId: $rootScope.allUserInfo.school,
      lang: $rootScope.school.lang || "es"
    });
  };

  $scope.timeSelection = ['30min','45min','1h','1:15h','1:30h','1:45h','2h','2:30h','3h'];


  $scope.sleepType = ['morning','afternoon'];
  $scope.selectAllTheClassroom = function(){
    console.log('classroom is', $scope.classroom);
    if (!$scope.classroom || !$scope.classroom.students) {
      $state.go('app.home');
      alert($translate.instant('contentNotLoaded'));
      return;
    }
    var set = $scope.sendToAllClassroom.sendToAll;
    if (!$scope.sendToAllClassroom) {
      $scope.sendToAllClassroom = {
        childs: {}
      };
    }
    if (!$scope.sendToAllClassroom || !$scope.sendToAllClassroom.childs) {
      $scope.sendToAllClassroom.childs = {};
    }
    for(var i in $scope.classroom.students) {
      $scope.sendToAllClassroom.childs[i] = set;
    }
  };

  $scope.alertIfDisabled = function(isDisabled) {
    if (isDisabled) {
      var message = ($rootScope.allUserInfo.type === 'principal') ? 'freeMessage_principal' : 'freeMessage_users';
      alert($translate.instant(message));
      return false;
    } else {
      return true;
    }
  };

  $ionicModal.fromTemplateUrl('modal-add.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modal = modal;
  });
  $scope.openModal = function() {
    $scope.modal.show();
  };
  $scope.closeModal = function() {
    $scope.modal.hide();
  };
  $ionicModal.fromTemplateUrl('modal-selectStudents.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modalSelectStudents = modal;
  });
  $scope.openModalSelectStudents = function() {
    $scope.modalSelectStudents.show();
  };
  $scope.closeModalSelectStudents = function() {
    $scope.sendingAllClassroom = false;
    $scope.modalSelectStudents.hide();
  };
  $ionicModal.fromTemplateUrl('modal-exportHealthExcelEmail.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modalExportHealth = modal;
  });
  $scope.openModalExportHealth = function() {
    $scope.modalExportHealth.show();
  };
  $scope.closeModalExportHealth = function() {
    $scope.modalExportHealth.hide();
  };

  // Cleanup the modal when we're done with it!
  $scope.$on('$destroy', function() {
    if (!!$scope.modal) {
      $scope.modal.remove();
    }
    if (!!$scope.modalSelectStudents) {
      $scope.modalSelectStudents.remove();
    }
    if (!!$scope.modalExportHealth) {
      $scope.modalExportHealth.remove();
    }
  });

  $scope.$on("$ionicView.afterEnter", function(){
    $scope.loaded = true;
    try {
      var typeSelection = [];
      if (showCard('observations')) {
        typeSelection.push({
          name: 'diary_sendCommentAllClassroom',
          type: 'comment'
        });
      }
      if (showCard('dailyActivity')) {
        typeSelection.push({
          name: 'diary_dailyActivity',
          type:'dailyActivity'
        });
      }
      if (showCard('rest', 1)) {
        typeSelection.push({
          name: 'diary_setSleepHours',
          type:'sleep'
        });
      }
      if (showCard('foodAndDrinks')) {
        if (showCard('breakfast')) {
          typeSelection.push({
            name: 'diary_setBreakfast',
            type:'breakfast'
          });
        }
        if (showCard('lunch')) {
          typeSelection.push({
            name: 'diary_setLunch',
            type:'lunch'
          });
        }
        if (showCard('meal')) {
          typeSelection.push({
            name: 'diary_setSnack',
            type:'snack'
          });
        }
      }
      if (showCard('defecations', 1)) {
        typeSelection.push({
          name: 'diary_setDefecations',
          type:'defecations'
        });
      }
      $scope.typeSelection = typeSelection;
    } catch (error) {
      console.log('error typeSelection', error);
      $scope.typeSelection = [{
        name: 'diary_sendCommentAllClassroom',
        type: 'comment'
      },{
        name: 'diary_dailyActivity',
        type:'dailyActivity'
      },{
        name: 'diary_setSleepHours',
        type:'sleep'
      },{
        name: 'diary_setBreakfast',
        type:'breakfast'
      },{
        name: 'diary_setLunch',
        type:'lunch'
      },{
        name: 'diary_setSnack',
        type:'snack'
      },{
        name: 'diary_setDefecations',
        type:'defecations'
      }];
    }
  });


  (function(){
    if(!$rootScope.classSelected && $rootScope.globalClassSelected) $rootScope.classSelected = $rootScope.globalClassSelected;
    getClassroom();
  }());

});
