angular.module('childcareOnApp').controller('AdminStudentsInfoCtrl', function($scope, $rootScope, $state, $translate, ChildFactory, CommonFactory, AdminProfilesFactory, ImageFactory, $ionicHistory, $jrCrop, $ionicModal, $localStorage) {

  $scope.edit = false;
  $scope.student = false;

  $scope.editClick = function(){
    $scope.$evalAsync(function(){
      $scope.edit = !$scope.edit;
    });
  };

  $scope.uploadChildPhoto = function(){
    navigator.notification.confirm(
      $translate.instant('communications_selectImage'), // message
       function(index){
         console.log("index is",index);
         if(index === 2) return;
         var source = (index === 1)? Camera.PictureSourceType.CAMERA: Camera.PictureSourceType.PHOTOLIBRARY;
         navigator.camera.getPicture(onSuccess, onFail, { correctOrientation:false, quality: 100,targetWidth: 400, targetHeight:400, sourceType: source, allowEdit:!$rootScope.isAndroid,
           destinationType: getDestinationType(), encodingType: Camera.EncodingType.JPEG
         });
       },
      $translate.instant('communications_imageTitle'),           // title
      [$translate.instant('communications_camera'), $translate.instant('login_forgotPassword_cancelButton'), $translate.instant('communications_gallery')]     // buttonLabels
    );
  };

  $scope.manageParents = function() {
    if (!$scope.student) {
      $state.go('app.home');
    }
    var studentParent = {
      $id: $scope.student.$id,
      classroomId: $scope.student.classroomId,
      classroomName: $scope.student.classroomName,
      name: $scope.student.name,
      school: $scope.student.school,
      surname: $scope.student.surname,
    };
    if (!!$scope.student.parents) {
      studentParent.parents = $scope.student.parents;
    }
    $state.go('app.adminStudentsInfoParents', {studentParents: studentParent});
  };


  var getDestinationType = function(){
    if($rootScope.isAndroid) return Camera.DestinationType.FILE_URI;
    else return Camera.DestinationType.DATA_URL;
  };

  function onSuccess(imageData) {
    console.log("success",imageData);
    //$scope.$evalAsync(function(){$rootScope.userImg = imageData;});
    if($rootScope.isAndroid){
      $scope.crop(imageData);
    }else{
      ImageFactory.setChildImage(imageData,$scope.student).then(function(url){
        $rootScope.showToast("imageUpdatedSuccess");
        $scope.$evalAsync(function(){$scope.childPhoto = url;});
      },function(){
        alert($translate.instant('serverError'));
      });
    }
  }

  $scope.crop = function(image) {
    $jrCrop.crop({
      url: image,
      width: 250,
      height: 250,
      cancelText: $translate.instant('login_forgotPassword_cancelButton'),
      chooseText: $translate.instant('button_save')/*,
      title: "Titleee"*/
    }).then(function(canvas) {
      console.log("canvas is",canvas);
      image = canvas.toDataURL("image/jpeg");
      ImageFactory.setChildImage(image.replace("data:image/jpeg;base64,",""),$scope.student).then(function(url){
        $rootScope.showToast("imageUpdatedSuccess");
        var obj = {
          photo: url
        };
        $localStorage.setCHObject('photo_' + $scope.student.$id, obj, $scope.student.$id);
        $scope.$evalAsync(function(){$scope.childPhoto = url;});
      },function(){
        alert($translate.instant('serverError'));
      });

    });
  };

  function onFail(message) {
    if(message.indexOf('cancelled') === -1) alert($translate.instant('imageUpdatedError'));
    console.log('Failed because: ' + message);
  }

  var getChild = function(){
    $rootScope.show();
    ChildFactory.getChild($rootScope.studentSelected.id).then(function(student){
      $rootScope.hide();
      $scope.student = student;
      console.log("student",student);
      if(student.photo) {
        $scope.childPhoto = student.photo;
        var obj = {
          photo: student.photo
        };
        $localStorage.setCHObject('photo_' + $scope.student.$id , obj, $scope.student.$id);
      } else {
        $scope.childPhoto = "img/user_noPhoto.png";
      }
    },function(){
      $rootScope.hide();
      alert($translate.instant('serverError'));
    });
  };

  $scope.deleteUserHandler = function(){
    if(navigator.notification){
      navigator.notification.confirm($translate.instant('confirmGeneric'), function(buttonIndex) {
        switch(buttonIndex) {
          case 1: console.log("Cancel"); break;
          case 2: console.log("Accept"); deleteUser(); break;
        }
      }, $translate.instant('adminProfiles_deleteStudent'), [ $translate.instant('login_forgotPassword_cancelButton'), $translate.instant('button_accept')]);
    }else{
      if(confirm($translate.instant('confirmGeneric'))) deleteUser();
    }
  };

  var deleteUser = function(){
    $rootScope.show();
    AdminProfilesFactory.deleteStudent($scope.student).then(function(){
      $rootScope.hide();
      $ionicHistory.goBack();
      $rootScope.showToast('adminProfiles_userDeleted');
    },function(){
      $rootScope.hide();
      alert($translate.instant('serverError'));
    });
  };

  $scope.updateProfile = function(){
    console.log("updateProfile params",$scope.student);
    $scope.student.birthdateParsed = $scope.student.birthdate.substring(0, 2)+"_"+$scope.student.birthdate.substring(3, 5);
    CommonFactory._save($scope.student).then(function(){
      console.log("success save student");
      if($rootScope.classroom.students[$scope.student.$id] !== ($scope.student.name+" "+$scope.student.surname)){
        $rootScope.classroom.students[$scope.student.$id] = $scope.student.name+" "+$scope.student.surname;
        CommonFactory._save($rootScope.classroom).then(function(){
          $rootScope.studentSelected.name = $scope.student.name+" "+$scope.student.surname;
          console.log("success save classroom");
          $rootScope.showToast('profile_updateSuccess');
        },function(){
          console.log("error save classroom");
          $rootScope.showToast('profile_updateSuccess');
        });
      }else $rootScope.showToast('profile_updateSuccess');
    },function(){
      console.log("error save user");
      alert($translate.instant('serverError'));
    });
  };

  $scope.moveToClassroom = function(classroom){
    $translate(['adminProfiles_changeStudentClassroom','login_forgotPassword_cancelButton','button_accept']).then(function(t){
      _confirm(t.adminProfiles_changeStudentClassroom, $translate.instant('adminProfiles_changeStudentClassroomText',{name:$scope.student.name}) ,t.login_forgotPassword_cancelButton, t.button_accept, function(buttonIndex){
        if(buttonIndex === 2){
          if (!!$scope.student.photo) {
            firebase.database().ref('classrooms/'+$scope.student.classroomId+'/studentsPhoto/'+$rootScope.studentSelected.id).set(null);
          }
          if (!!$scope.student.allClassrooms && $scope.student.allClassrooms[$scope.student.classroomId]) {
            delete $scope.student.allClassrooms[$scope.student.classroomId];
            $scope.student.allClassrooms[classroom] = $rootScope.school.classrooms[classroom];
          }
          $scope.student.classroomId = classroom;
          $scope.student.classroomName = $rootScope.school.classrooms[classroom];
          CommonFactory._save($scope.student).then(function(){
            $rootScope.showToast('profile_updateSuccess');
            $scope.closeModal();
          },function(){
            alert($translate.instant('serverError'));
          });
        }
      });
    });
  };

  $ionicModal.fromTemplateUrl('modal-change-classroom.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modal = modal;
  });
  $scope.openModal = function() {
    $scope.modal.show();
  };
  $scope.closeModal = function() {
    $scope.modal.hide();
  };
  // Cleanup the modal when we're done with it!
  $scope.$on('$destroy', function() {
    if (!!$scope.modal) {
      $scope.modal.remove();
    }
  });

  (function(){
    getChild();
  }());

});
