angular.module('childcareOnApp').controller('AdminStudentsParentsCtrl', function($scope, $translate, $rootScope, $state, $stateParams, $ionicModal, AdminProfilesFactory, $q, ChildFactory) {

  $scope.parentEmail = {};
  $scope.loadingCode = false;
  $scope.loadingParents = false;

  //studentParents = niño
  var getParents = function() {
    $scope.usersInvited = AdminProfilesFactory.getInvitationsByChildV2($scope.studentParents.$id);
    $scope.loadingParents = true;
    $scope.childParents = ChildFactory.getParents($scope.studentParents.$id);
    $scope.childParents.$loaded()
    .then(function() {
      console.log('$scope.childParents', $scope.childParents);
      $scope.parents = ChildFactory.getChildParents($scope.childParents);
      var promises = [];
      $scope.parents.forEach(function(parentPromise) {
        promises.push(
          parentPromise.$loaded()
        );
      });
      $q.all(promises)
      .then(function() {
        $scope.loadingParents = false;
      });
      $scope.childParents.$watch(function(event) {
        $scope.parents = ChildFactory.getChildParents($scope.childParents);
      });
    });
  };

  $scope.changeUserStatus = function(parent){
    console.log("parent",parent);
    var text = $translate.instant('adminProfiles_confirmDeactivate',parent);
    var title = $translate.instant('adminProfiles_titleConfirmDeactivate');
    var buttonText = $translate.instant('adminProfiles_buttonConfirmDeactivate');
    _confirm(title,text,$translate.instant('no'),buttonText,
    function(buttonIndex){
      if(buttonIndex === 2) saveNewStatusUser(parent.$id);
    });
  };

  $scope.transformEmail = function(email){
    return email.replace(";",".");
  };

  $scope.inviteParent = function(){
    if(!$scope.parentEmail.email){
      return alert($translate.instant('fillFields'));
    }
    if (!validateEmail($scope.parentEmail.email)) {
      return alert($translate.instant('emailFormat_invalid'));
    }
    $rootScope.show();
    console.log("parentEmail",$scope.parentEmail.email,$scope.studentParents);
    $scope.parentEmail.email = $scope.parentEmail.email.toLowerCase();
    AdminProfilesFactory.inviteParentV2($scope.parentEmail.email,$scope.studentParents.$id,$rootScope.allUserInfo.email,$scope.studentParents.name+" "+$scope.studentParents.surname).then(function(){
      $rootScope.hide();
      $scope.closeModal();
      $scope.parentEmail = {};
      $rootScope.showToast('infoSavedSuccessfully');
    },function(){
      $rootScope.hide();
      alert($translate.instant('serverError'));
    });
  };

  function getCode() {
    $scope.childCode = AdminProfilesFactory.getChildCode($scope.studentParents.$id);
  }

  var saveNewStatusUser = function(parentId){
    ChildFactory.removeParent($scope.studentParents.$id, parentId)
    .then(function() {
      $scope.parents.forEach(function(parent, index) {
        if (parent.$id === parentId) {
          $scope.$evalAsync(function() {
            $scope.parents.splice(index, 1);
          });
        }
      });
      $rootScope.showToast('infoSavedSuccessfully');
    }, function() {
      alert($translate.instant('serverError'));
    });
  };

  $scope.deleteInvitationConfirm = function(index){
    if(navigator.notification){
      navigator.notification.confirm($translate.instant('invitations_confirmDeleteText'), function(buttonIndex) {
        switch(buttonIndex) {
          case 1:
          console.log("Cancel");
          break;
          case 2:
          console.log("Accept");
          deleteInvitation(index);
          break;
        }
      }, $translate.instant('invitations_confirmDeleteTitle'), [ $translate.instant('login_forgotPassword_cancelButton'), $translate.instant('yes')]);
    }else{
      if(confirm($translate.instant('invitations_confirmDeleteText'))){
        deleteInvitation(index);
      }
    }
  };

  function validateEmail(email) {
    var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(email);
  }

  var deleteInvitation = function(index){
    AdminProfilesFactory.deleteInvitation($scope.usersInvited,index).then(function(){
      $rootScope.showToast('infoDeletedSuccessfully');
    },function(){
      $rootScope.showToast('serverError');
    });
  };

  $scope.clickCode = function() {
    if ($scope.childCode.length > 0) {
      alert($translate.instant('code_generated', {code: $scope.childCode[0].code}));
    } else {
      $scope.loadingCode = true;
      AdminProfilesFactory.generateCode($scope.studentParents)
      .then(function(code) {
        $scope.loadingCode = false;
        alert($translate.instant('code_generated', {code: code}));
      }, function() {
        alert($translate.instant('serverError'));
      });
    }
  };

  $ionicModal.fromTemplateUrl('modal-add-parent.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modal = modal;
  });
  $scope.openModal = function() {
    $scope.modal.show();
  };
  $scope.closeModal = function() {
    $scope.modal.hide();
  };
  // Cleanup the modal when we're done with it!
  $scope.$on('$destroy', function() {
    if (!!$scope.modal) {
      $scope.modal.remove();
    }
  });

  $scope.$on("$ionicView.afterEnter", function(){
    if (!$stateParams.studentParents) {
      return $state.go('app.home');
    }
    $scope.studentParents = $stateParams.studentParents;
    console.log('$stateParams.studentParents', $stateParams.studentParents);
    getParents();
    getCode();
  });

});
