angular.module('childcareOnApp').controller('AdminSuggestionsCtrl', function($scope, $rootScope, $state, $stateParams, $translate, $filter, CommonFactory, DiaryFactory, MenusFactory, ionicMaterialInk, ionicMaterialMotion) {

  ionicMaterialInk.displayEffect();
  ionicMaterialMotion.ripple();

  $scope.suggestionParams = {};
  $scope.suggestionMenusParams = {};
  $scope.tabOpened = null;

  $scope.suggestionItems = {
    diary:['dailyActivity','needed','breakfastComment','lunchComment','mealComment','bottlesComment','restComment','defecationsComment','psychomotricityComment','teachersObservations'],
    health:['urgentNotification'],
    menus:['breakfast','lunch','meal','puree'],
    marks:['subject','mark','markComments']
  };

  $scope.openTab = function(tabToOpen){
    $scope.$evalAsync(function(){
      $scope.tabOpened = ($scope.tabOpened === tabToOpen)? null:tabToOpen;
    });
  };

  $scope.addSuggestion = function(item){
    if(!$scope.suggestionParams[item]){
      alert($translate.instant('fillFields'));
      return;
    }
    if(!$scope.suggestions[item]) $scope.suggestions[item] = {};
    var length = 0;
    for(var i in $scope.suggestions[item]){
      length++;
    }
    var objName = "K"+(length+1);
    if(objName in $scope.suggestions[item]) objName = "S"+ objName;
    $scope.suggestions[item][objName] = $scope.suggestionParams[item].value;
    console.log("suggestions",$scope.suggestions);
    CommonFactory._save($scope.suggestions).then(function(){
      $scope.suggestionParams[item] = null;
    },function(){
      $rootScope.showToast('serverError');
      delete $scope.suggestions[item][objName];
    });
  };

  $scope.addSuggestionMenus = function(item){
    if(!$scope.suggestionMenusParams[item]){
      alert($translate.instant('fillFields'));
      return;
    }
    if(!$scope.suggestionsMenus[item]) $scope.suggestionsMenus[item] = {};
    var length = 0;
    for(var i in $scope.suggestionsMenus[item]){
      length++;
    }
    var objName = "K"+(length+1);
    if(objName in $scope.suggestionsMenus[item]) objName = "S"+ objName;
    $scope.suggestionsMenus[item][objName] = $scope.suggestionMenusParams[item].value;
    console.log("suggestionsMenus",$scope.suggestionsMenus);
    CommonFactory._save($scope.suggestionsMenus).then(function(){
      $scope.suggestionMenusParams[item] = null;
    },function(){
      $rootScope.showToast('serverError');
      delete $scope.suggestionsMenus[item][objName];
    });
  };

  $scope.removeSuggestion = function(item,key){
    var itemValue = $scope.suggestions[item][key];
    delete $scope.suggestions[item][key];
    CommonFactory._save($scope.suggestions).then(null,function(){
      $rootScope.showToast('serverError');
      $scope.suggestions[item][key] = itemValue;
    });
  };

  $scope.removeSuggestionMenus = function(item,key){
    var itemValue = $scope.suggestionsMenus[item][key];
    delete $scope.suggestionsMenus[item][key];
    CommonFactory._save($scope.suggestionsMenus).then(null,function(){
      $rootScope.showToast('serverError');
      $scope.suggestionsMenus[item][key] = itemValue;
    });
  };

  $scope.getSuggestions = function(){
    DiaryFactory.getDictionary().then(function(suggestions){
      $scope.suggestions = suggestions;
    },function(){
      $rootScope.showToast('serverError');
    });
    MenusFactory.getDictionary().then(function(suggestionsMenus){
      $scope.suggestionsMenus = suggestionsMenus;
    },function(){
      $rootScope.showToast('serverError');
    });
  };

  (function(){
    $scope.getSuggestions();
  }());
});
