angular.module('childcareOnApp').controller('TeacherInfoCtrl', function($scope, $rootScope, $state, $stateParams, $translate, $filter, TeacherFactory, ChildcareOnUtils, CommonFactory, ionicMaterialInk, ionicMaterialMotion) {

  ionicMaterialInk.displayEffect();
  ionicMaterialMotion.ripple();

  $scope.removeAccessQuestion = function(){
    if(navigator.notification){
      navigator.notification.confirm($translate.instant('confirmRemove'), function(buttonIndex) {
        switch(buttonIndex) {
          case 1:
          console.log("Cancel");
          break;
          case 2:
          console.log("Accept");
          removeAccess();
          break;
        }
      }, $translate.instant('removeAccess'), [ $translate.instant('no'), $translate.instant('yes')]);
    }else{
      if(confirm($translate.instant('confirmRemove'))){
        removeAccess();
      }
    }
  };

  var removeAccess = function(){
    //borrar las clases, quitar la escuela y cambiar el tipo. mirar en classroomAcces y quitarle acceso de las clases.
    if($scope.teacher.classrooms) delete $scope.teacher.classrooms;
    if($scope.teacher.school) delete $scope.teacher.school;
    $scope.teacher.type = "user";
    CommonFactory._save($scope.teacher).then(function(){
      for(var i in $rootScope.classroomAccess){
        if(i.indexOf('$') === -1){
          console.log("i is",i);
          console.log("classroomAccess", $rootScope.classroomAccess[i]);
          if($rootScope.classroomAccess[i][$scope.teacher.id]) delete $rootScope.classroomAccess[i][$scope.teacher.id];
        }
      }
      CommonFactory._save($rootScope.classroomAccess).finally(function(){
        delete $rootScope.school.teachers[$scope.teacher.id];
        CommonFactory._save($rootScope.school).then(function(){
          $rootScope.showToast('infoSavedSuccessfully');
          $state.go('app.adminTeachers');
        },function(){
          alert($translate.instant('serverError'));
        });
      });
    },function(e){alert($translate.instant('serverError'))});
  };


  (function(){
    TeacherFactory.getTeacher($stateParams.teacher).then(function(teacher){
      console.log("teacher is",teacher);
      $scope.teacher = teacher;
      $scope.registrationDate = ChildcareOnUtils.parseTimestampToDate(teacher.registrationDate);
    },function(){
      alert($translate.instant('serverError'));
    });
  }());
});
