angular.module('childcareOnApp').controller('AdminTeachersCtrl', function($scope, $rootScope, $translate, $state, $ionicModal, TeacherFactory, NotificationFactory, UserFactory, AdminProfilesFactory) {

  $scope.teacherToInvite = {};
  $scope.classroomsToSend = {};
  $scope.teachersAvailabilityLoaded = false;
  $scope.days = ["monday","tuesday","wednesday","thursday","friday","saturday","sunday"];
  $scope.viewDisplayed = 'teachers';

  $ionicModal.fromTemplateUrl('modal-add.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modal = modal;
  });
  $ionicModal.fromTemplateUrl('modal-availability.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modalAvailability = modal;
  });
  $scope.openModal = function() {
    $scope.modal.show();
  };
  $scope.closeModal = function() {
    $scope.modal.hide();
  };
  // Cleanup the modal when we're done with it!
  $scope.$on('$destroy', function() {
    if (!!$scope.modal) {
      $scope.modal.remove();
    }
    if (!!$scope.modalAvailability) {
      $scope.modalAvailability.remove();
    }
  });

  $scope.addTeacher = function(){
    if(!$scope.teacherToInvite.email){
      $rootScope.showToast('fillFields');
      return;
    }
    try {
      $scope.teacherToInvite.email = $scope.teacherToInvite.email.toLowerCase();
    } catch (error) {
      console.log('error converting email to lowercase');
    }
    for(var i=0; i<$rootScope.invitations.length; i++){
      if($rootScope.invitations[i].email === $scope.teacherToInvite.email && !$rootScope.invitations[i].accepted){
        alert($translate.instant('userAlreadyInvited'));
        return;
      }
    }
    for (var classroomId in $scope.classroomsToSend) {
      if (!$scope.classroomsToSend[classroomId]) {
        delete $scope.classroomsToSend[classroomId];
      }
    }
    TeacherFactory.addTeacherToSchool($scope.teacherToInvite.email, $scope.classroomsToSend).then(function(){
      $rootScope.showToast('infoSavedSuccessfully');
      $scope.teacherToInvite = {};
      $scope.classroomsToSend = {};
      $scope.closeModal();
    },function(){
      console.log("error en addTeacher");
    });
  };

  $scope.selectTeacher = function(key){
    console.log("key teacher",key);
    $state.go('app.teacherInfo',{teacher:key});
  };

  $scope.selectInvitation = function(key){
    console.log("key invitation",key);
    $state.go('app.invitationInfo',{invitation:key});
  };

  $scope.seeTeachersAvailability = function() {
    $scope.teachersAvailability = NotificationFactory.getAllTeachersAvailability();
    $scope.modalAvailability.show();
  };

  $scope.changeView = function(element) {
    $scope.viewDisplayed = element;
  };

  var getInvitations = function() {
    $rootScope.invitations = AdminProfilesFactory.getInvitationsBySchool($rootScope.allUserInfo.school);
  };

  (function(){
    getInvitations();
  }());

});
