angular.module('childcareOnApp').controller('CommunicationsCtrl', ['$scope', '$rootScope', '$filter', '$firebaseObject', 'UserFactory', 'CommunicationsFactory', '$state', '$stateParams', '$q', CommunicationsCtrl]);

function CommunicationsCtrl($scope, $rootScope, $filter, $firebaseObject, UserFactory, CommunicationsFactory, $state, $stateParams, $q) {

  var vm = this;
  
  vm.selectMessage = selectMessage;

  var classroomId, individualMessages;

  function selectMessage(message){
    // CommunicationsFactory.saveReadedMessage(message.$id);
    $state.go("app.message",{message:message});
  }

  function parseCommunications() {
    var communicationsClassroom = angular.copy(vm.messages || []);
    var communicationsIndividual = angular.copy(individualMessages || []);
    var mergedMessages = communicationsClassroom;
    communicationsIndividual.forEach(function (message) {
      var newMessage = message;
      newMessage.individual = true;
      mergedMessages.push(newMessage);
    });
    vm.mergedMessages = mergedMessages;
  }

  $scope.$on("$ionicView.afterEnter", function(){
    var type = $stateParams.type;
    vm.type = type;

    if ($rootScope.allUserInfo.type === 'user') {
      classroomId = $rootScope.allUserChilds[$rootScope.childSelected].classroomId;
      individualMessages = CommunicationsFactory.getChildMessages($rootScope.childSelected);
      vm.messages = CommunicationsFactory.getClassroomMessages(classroomId);
      $q.all([individualMessages.$loaded(), vm.messages.$loaded()])
      .then(function () {
        parseCommunications();
        individualMessages.$watch(function () {
          console.log('individualMessages watcher triggered');
          parseCommunications();
        });
        vm.messages.$watch(function () {
          console.log('vm.messages watcher triggered');
          parseCommunications();
        });
      });
    } else {
      classroomId = $rootScope.classSelected.id;
      if (type === 'classrooms') {
        vm.messages = CommunicationsFactory.getClassroomMessages(classroomId);
        vm.scheduledMessages = CommunicationsFactory.getScheduledMessages(classroomId);
      } else {
        vm.messages = CommunicationsFactory.getChildMessages($rootScope.studentSelected.id);
        vm.scheduledMessages = CommunicationsFactory.getChildScheduledMessages($rootScope.studentSelected.id);
      }
    }

  });

  (function(){

  }());
}