angular.module('childcareOnApp').controller('MessageCtrl', function($scope, $rootScope, $stateParams, UserFactory, $state, $translate, $ionicHistory, CommunicationsFactory, ImageFactory) {

  var inAppBrowserRef;
  $scope.downloadDoc = function(){
    var doc = {
      name: $translate.instant('menu_communications'),
      url: $scope.messageSelected.document
    };
    $rootScope.show();
    ImageFactory.openDocument(doc)
    .then(function() {
      $rootScope.hide();
    }, function() {
      $rootScope.hide();
      window.open($scope.messageSelected.document, '_system', 'location=yes');
    });
  };

  $scope.openImage = function(index){
    // var imageComplete = {image:$scope.messageSelected.images[index].image, date: index+$scope.messageSelected.date}
    // $state.go('app.imageViewer',{img:$scope.messageSelected.images[index].image, canDownload:true, imageComplete: imageComplete});
    $state.go('app.multiImage', { img: $scope.messageSelected.images, index: index, canDelete: false, canDownload: true });
  };

  $scope.openUrl = function(url){
    if (url.indexOf('http') === -1) {
      url = 'http://' + url;
    }
    $rootScope.show();
    inAppBrowserRef = cordova.InAppBrowser.open(url, "_blank", "location=yes,hidden=yes,shouldPauseOnSuspend=yes");

    inAppBrowserRef.addEventListener('loadstart', function() {
      console.log('loadstart');
    });

    inAppBrowserRef.addEventListener('loadstop', function() {
      console.log('loadStop');
      $rootScope.hide();
      inAppBrowserRef.show();
    });

    inAppBrowserRef.addEventListener('loaderror', function() {
      console.log('loaderror');
      $rootScope.show();
      inAppBrowserRef.close();
      window.open(url, '_system', 'location=false');
    });
  };

  $scope.removeCommunication = function(){
    console.log("entra aqui");
    $translate(['confirmRemoveGeneric','communications_deleteCommunication','login_forgotPassword_cancelButton','button_accept']).then(function(t){
      _confirm(t.communications_deleteCommunication, t.confirmRemoveGeneric, t.login_forgotPassword_cancelButton, t.button_accept, function(index){
        console.log("index is",index);
        console.log("$scope.messageSelected",$scope.messageSelected);
        if(index === 2) _removeCommunication();
      });
    });


    var _removeCommunication = function(){
      CommunicationsFactory.deleteCommunication($scope.messageSelected).then(function(){
        $rootScope.showToast('infoDeletedSuccessfully');
        $ionicHistory.goBack();
      },function(){
        $rootScope.showToast('serverError');
      });
    };
  };

  (function(){
    $scope.messageSelected = $stateParams.message;
    $scope.messageSelected.message = $scope.messageSelected.message.replace(/\n/g,'<br />')
    .replace(/\r/g,'<br />')
    .replace(/\r\n/g,'<br />');
    if($scope.messageSelected){
      $scope.userSender = UserFactory.getUserById($scope.messageSelected.userSender);
    }
  }());
})
