angular.module('childcareOnApp').controller('ConfigNotificationsCtrl', function($scope, $rootScope, $state, $translate, NotificationFactory, CommonFactory, ionicMaterialInk, ionicMaterialMotion, $q) {

  ionicMaterialInk.displayEffect();
  ionicMaterialMotion.ripple();

  $scope.days = ["monday","tuesday","wednesday","thursday","friday","saturday","sunday"];
  //$scope.notificationParams = {};
  $scope.timeSelection = ["00:00","00:30","01:00","01:30","02:00","02:30","03:00","03:30","04:00","04:30","05:00","05:30","06:00","06:30","07:00",
  "07:30","08:00","08:30","09:00","09:30","10:00","10:30","11:00","11:30","12:00","12:30","13:00","13:30","14:00","14:30","15:00","15:30","16:00",
  "16:30","17:00","17:30","18:00","18:30","19:00","19:30","20:00","20:30","21:00","21:30","22:00","22:30","23:00","23:30"];
  $scope.notificationsDisplayed = "classrooms";

  $scope.changeCurrentNotification = function(type){
    $scope.$evalAsync(function(){$scope.notificationsDisplayed = type;});
  };

  $scope.updateNotifications = function(){
    for(var i in $scope.notificationParams){
      if($scope.days.indexOf(i) !== -1 && $scope.notificationParams[i].value && !$scope.notificationParams[i].allDay){
        if(!$scope.notificationParams[i].from || !$scope.notificationParams[i].to){
          alert($translate.instant('fillFields'));
          return;
        }
        var fromParsedDate = parseInt($scope.notificationParams[i].from.slice(0,2).toString() + $scope.notificationParams[i].from.slice(3,5).toString());
        var toParsedDate = parseInt($scope.notificationParams[i].to.slice(0,2).toString() + $scope.notificationParams[i].to.slice(3,5).toString());
        if(fromParsedDate > toParsedDate){
          var dayTranslated = $translate.instant(i);
          alert($translate.instant('config_notifications_toLowerThanFrom',{day:$translate.instant(i)}));
          return;
        }
      }
    }
    $scope.notificationParams[$rootScope.allUserInfo.school] = "school";
    $scope.notificationParams.type = $rootScope.allUserInfo.type;
    if($rootScope.allUserInfo.type === 'principal'){
      for(var i in $scope.notificationParams){
        if($scope.notificationParams[i] === "teacher_classroom") delete $scope.notificationParams[i];
      }
      for(var i in $scope.classroomsToSend){
        if($scope.classroomsToSend[i]) $scope.notificationParams[i] = "teacher_classroom";
      }
    }else{
      for(var i=0; i<$rootScope.parsedClassroomAccess.length; i++){
        $scope.notificationParams[$rootScope.parsedClassroomAccess[i].id] = "teacher_classroom";
      }
    }
    $scope.notificationParams.timeZoneOffset = new Date().getTimezoneOffset() * -1;
    CommonFactory._save($scope.notificationParams).then(function(){
      $rootScope.showToast('infoSavedSuccessfully');
    },function(){
      alert($translate.instant('serverError'));
    });
  };

  var fillDefaultNot = function () {
    for (var i=0; i< $scope.days.length; i++) {
      $scope.notificationParams[$scope.days[i]] = {value: true, allDay: true};
    }
  };

  var getNotifications = function(){
    return $q(function(resolve,reject){
      if($scope.notificationParams){
        resolve(); return;
      }
      $scope.notificationParams = NotificationFactory.getUserNotificationSettings();
      console.log("$scope.notificationParams",$scope.notificationParams);
      $scope.notificationParams.$loaded()
      .then(resolve);
    });
  };

  $scope.$on("$ionicView.afterEnter", function() {
    if (!$rootScope.school) {
      $state.go('app.splash');
      return;
    }
    $rootScope.show();
    getNotifications().then(function(){
      $scope.classroomsToSend = {};
      if (!$rootScope.school.classrooms) {
        $rootScope.school.classrooms = {};
      }
      for(var i in $rootScope.school.classrooms){
        $scope.classroomsToSend[i] = false;
        if($scope.notificationParams[i] === "teacher_classroom") $scope.classroomsToSend[i] = true;
      }
      var isFilled = false;
      $scope.notificationParams.forEach(function(elem){
        isFilled = true;
      });
      $rootScope.hide();
      if (!isFilled) return fillDefaultNot();
    });
  });

  (function(){
    $scope.isLoaded = false;
  }());
});
