angular.module('childcareOnApp').controller('ProfileCtrl', function($scope, $rootScope, $state, UserFactory, DiaryFactory, ClassroomFactory, NotificationFactory, $translate, $ionicModal, CommonFactory, ChildFactory, ImageFactory, $window, ionicMaterialInk, ionicMaterialMotion, $jrCrop, $q) {

  ionicMaterialInk.displayEffect();
  ionicMaterialMotion.ripple();
  $scope.childs = [];

  $scope.editChild = function(childUid){
    $state.go('app.profileEditChild',{ child:childUid });
  };

  var getDestinationType = function(){
    if($rootScope.isAndroid) return Camera.DestinationType.FILE_URI;
    else return Camera.DestinationType.DATA_URL;
  };

  // get photo
  $scope.getPhotoFromDevice = function(){
    navigator.camera.getPicture(onSuccess, onFail, { correctOrientation:false,quality: 100,targetWidth: 400, targetHeight:400,sourceType: Camera.PictureSourceType.PHOTOLIBRARY, allowEdit:!$rootScope.isAndroid,
      /*destinationType: Camera.DestinationType.DATA_URL, encodingType: Camera.EncodingType.JPEG*/
      destinationType: getDestinationType(), encodingType: Camera.EncodingType.PNG
    });
  };

  function onSuccess(imageData) {
    console.log("success",imageData);
    if($rootScope.isAndroid){
      $scope.crop(imageData);
    }else{
      ImageFactory.setUserImage(imageData).then(function(url){
        $rootScope.showToast("imageUpdatedSuccess");
        $scope.$evalAsync(function(){$rootScope.userImg = url;});
      },function(){
        alert($translate.instant('serverError'));
      });
    }
  }

  function onFail(message) {
    if(message.indexOf('cancelled') === -1) alert($translate.instant('imageUpdatedError'));
    console.log('Failed because: ' + message);
  }

  $scope.crop = function(image) {
    $jrCrop.crop({
      url: image,
      width: 250,
      height: 250,
      cancelText: $translate.instant('login_forgotPassword_cancelButton'),
      chooseText: $translate.instant('button_save')/*,
      title: "Titleee"*/
    }).then(function(canvas) {
      console.log("canvas is",canvas);
      image = canvas.toDataURL("image/jpeg");
      ImageFactory.setUserImage(image.replace("data:image/jpeg;base64,","")).then(function(url){
        $rootScope.showToast("imageUpdatedSuccess");
        $scope.$evalAsync(function(){$rootScope.userImg = url;});
      },function(){
        alert($translate.instant('serverError'));
      });

    });
  };


  $scope.updateProfile = function(){
    console.log("updateProfile params",$rootScope.allUserInfo.name,$rootScope.allUserInfo.surname,$rootScope.allUserInfo.parentType);
    var promises = [
      CommonFactory._save($rootScope.allUserInfo)  
    ];
    var toUpdate = {}; toUpdate[$rootScope.allUserInfo.id] = $rootScope.allUserInfo.name + ' ' + $rootScope.allUserInfo.surname;
    switch($rootScope.allUserInfo.type) {
      case 'principal': promises.push(firebase.database().ref('schools/'+$rootScope.allUserInfo.school+'/principals/').update(toUpdate));
        break;
      case 'teacher': promises.push(firebase.database().ref('schools/'+$rootScope.allUserInfo.school+'/teachers/').update(toUpdate));
      break;
      default: console.log('nothing more to update');
    }
    $q.all(promises).then(function(){
      if(window.plugins){
        window.plugins.toast.show($translate.instant('profile_updateSuccess'), 'short', 'bottom');
      }else{
        alert($translate.instant('profile_updateSuccess'));
      }
    },function(){
      console.log("error save user");
      alert($translate.instant('serverError'));
    });
  };

  $scope.getUserChilds = function(){
    ChildFactory.getUserChilds($rootScope.allUserInfo.childs).then(function(r){
      $scope.userChilds = r;
      console.log("success en getUserChilds",r);
    },function(){
      console.log("error en getUserChilds");
    });
  };

  $scope.changePassword = function(){
    if(!$scope.password.oldPassword || !$scope.password.newPassword || !$scope.password.confirmNewPassword){
      alert($translate.instant('fillFields'));
      return;
    }
    if($scope.password.newPassword === $scope.password.confirmNewPassword){
      $scope.authObj.$signInWithEmailAndPassword($scope.userInfo.email,$scope.password.oldPassword).then(function(e){
        $scope.authObj.$updatePassword($scope.password.confirmNewPassword).then(function(){
          $scope.closeModal();
          alert($translate.instant('profile_updateSuccess'));
        },function(e){
          console.log("error updatePassword",e);
          alert($translate.instant('serverError'));
        });
      },function(e){
         alert($translate.instant('profile_oldPasswordNotCorrect'));
      });
    }else{
      alert($translate.instant('signup_error_passwordNotMatch'));
    }
   };

   var getChild = function(){
    return $q(function(resolve,reject){
      console.log("childs",$rootScope.allUserInfo.childs);
      ChildFactory.getUserChilds($rootScope.allUserInfo.childs).then(function(childInfo){
        console.log("childInfo",childInfo,childInfo.length);
        $rootScope.allUserChilds = childInfo;
        for(var i in childInfo){
          if(i.indexOf("$") !== -1 || typeof childInfo[i] === 'function') continue;
          $rootScope.childSelected = i;
          if(childInfo[i].photo) $scope.$evalAsync(function(){$rootScope.userImg = childInfo[i].photo;});
          else $scope.$evalAsync(function(){$rootScope.userImg = "img/user_noPhoto.png";});
          break;
        }
        // write here code to delete child from user
        console.log('$rootScope.allUserChilds', $rootScope.allUserChilds);
        DiaryFactory.getSettings($rootScope.allUserChilds[$rootScope.childSelected].school)
        .then(function (settings) {
          $rootScope.settings = settings;
          var classroomId = $rootScope.allUserChilds[$rootScope.childSelected].classroomId;
          $scope.classroomType = ClassroomFactory.getClassroomType(settings,classroomId);
          if(!$rootScope.childSelected) {
            $scope.$evalAsync(function(){$rootScope.userImg = "img/user_noPhoto.png";});
            $rootScope.childSelected = null;
            NotificationFactory.getUserNotifications($rootScope.allUserInfo.id).then(resolve,resolve);
          } else {
            NotificationFactory.childTeachersAvailable.set($rootScope.allUserChilds[$rootScope.childSelected]);
            NotificationFactory.getUserNotifications($rootScope.allUserInfo.id).then(resolve,resolve);
          }
        });
      },function(e) {
        console.log("error en getChild",e);
        var obj = { user: $rootScope.allUserInfo.id, error:stripslashes(JSON.stringify(e)), page:$state.current.name, date: JSON.stringify(new Date())};
        CommonFactory.saveLog(obj);
        $rootScope.allUserChilds = [];
        $rootScope.childSelected = null;
        resolve();
      });
    });
  };

  function deleteCode(code) {
    for (var i=0; i < code.length; i++) {
      code.$remove(code[i]);
    }
  }

   function addChild(parsedChilds, codeDB){
    $rootScope.show();
    console.log("parsedChilds",parsedChilds);
    ChildFactory.addParentToChild(parsedChilds,$rootScope.allUserInfo.id).then(function(){
      console.log("parent added to child");
      if(!$rootScope.allUserInfo.childs) $rootScope.allUserInfo.childs = {};
      for(var i in parsedChilds){
        $rootScope.allUserInfo.childs[i] = parsedChilds[i];
        $rootScope.allUserInfo[i] = "child";
      }
      $rootScope.allUserInfo.$save().then(function(){
        deleteCode(codeDB);
        getChild().then(function(){
          $rootScope.hide();
          var number = Object.keys(parsedChilds).length;
          if(number > 1) alert($translate.instant('invitations_addedChilds',{number:number}));
          else alert($translate.instant('invitations_addedChild'));
        });
      },function(e){
        console.log("error saving user",e);
        alert($translate.instant('serverError'))
      });
    },function(){
      return alert($translate.instant('serverError'));
    });
   }

   function manageCode(results){
     return $q(function(resolve, reject){
      if(results.buttonIndex === 1 && results.input1 !== ''){
        var code = results.input1;
      }else return alert($translate.instant('fillFields'));
      console.log(code.toUpperCase());
      UserFactory.sendCodeSignup(code.toUpperCase())
      .then(function(codeDB){
        console.log("codeDB",codeDB);
        var parsedChilds = {};
        for(var i=0; i<codeDB.length; i++){
          if(codeDB[i].type !== 'user') continue
          parsedChilds[codeDB[i].childUid] = "father";
        }
        alert($translate.instant('profile_addingChildren'));
        return addChild(parsedChilds, codeDB);
      },function(){
        return alert($translate.instant('signupName_errorCode'));
      });
    });
  }


   $scope.inputCode = function(){
    navigator.notification.prompt(
      $translate.instant('configuration_inputCodeText'),  // message
      manageCode,                  // callback to invoke
      $translate.instant('configuration_inputCode'),            // title
      [$translate.instant('button_send'),$translate.instant('login_forgotPassword_cancelButton')],             // buttonLabels
      ''                 // defaultText
    );
  };

   $scope.logout = function(){
     UserFactory.logout()
     .then(null,function(){
       alert($translate.instant('serverError'));
     });
   };

   $ionicModal.fromTemplateUrl('modal-change-password.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modal = modal;
  });
  $scope.openModal = function() {
    $scope.password = {};
    $scope.modal.show();
  };
  $scope.closeModal = function() {
    $scope.modal.hide();
  };
  // Cleanup the modal when we're done with it!
  $scope.$on('$destroy', function() {
    if (!!$scope.modal) {
      $scope.modal.remove();
    }
  });

  (function(){
  }());
})

angular.module('childcareOnApp').controller('ProfileEditChildCtrl', function($scope, $rootScope, $state, $stateParams, UserFactory, $ionicPopup, $translate, $firebaseAuth, CommonFactory, ChildFactory, ImageFactory, $window, ionicMaterialInk, ionicMaterialMotion) {

  $scope.updateParentType = function(){
    key = $stateParams.child;
    console.log("parentData new",$rootScope.allUserInfo);
    console.log("child",key);
    $rootScope.allUserInfo.childs[key] = $scope.child.parents[$rootScope.allUserInfo.$id];
    //first we save the user
    CommonFactory._save($rootScope.allUserInfo).then(function(){
      //in success we save the child
      ChildFactory.getChild(key).then(function(childInfo){
        childInfo.parents[$rootScope.allUserInfo.$id] = $rootScope.allUserInfo.childs[key];
        console.log("childinfo before save",childInfo);
        CommonFactory._save(childInfo).then(function(){
          console.log("child saved");
          $rootScope.showToast('profile_updateSuccess');
        },function(){
          console.log("error saving child");
        });
      },function(){
        console.log("error getting child");
      });
    },function(){
      console.log("error saveUser",e);
    });
  };

  (function(){
    $scope.child = $rootScope.allUserChilds[$stateParams.child];
  }());
});
