angular.module('childcareOnApp').controller('DiaryCtrl', function($scope, $rootScope, $translate, $filter, $state, $stateParams, $ionicPlatform, $localStorage, DiaryFactory, $q, CommonFactory, NotificationFactory, ChildFactory, ChildcareOnUtils, $ionicActionSheet, ionicMaterialInk, ionicMaterialMotion, ionicDatePicker, ClassroomFactory, ImageFactory, $ionicModal) {

  ionicMaterialInk.displayEffect();
  ionicMaterialMotion.ripple();


  $scope.nullDiary = false;
  $scope.currentDiaryDate = null;
  $scope.isToday = false;
  $scope.diary = {};
  $scope.selected = {};
  var studentId, childTitle, schoolId, diaryLoaded, imagesUploading = 0, tempThumb;
  var possibleObjects = ['defecations','meals','observationsParent','observationsTeacher','psychomotricity','rest','bottles','behaviour','hygiene','images', 'videos', 'needed', 'dailyActivity'];

  $scope.observationsParent = {};
  if($rootScope.allUserInfo.type !== 'user') $scope.teacherComment = {sender:$rootScope.allUserInfo.id,message:null,date:null,senderName:$rootScope.allUserInfo.name};

  var ipObj1 = {
    callback: function (val) {  //Mandatory
      console.log('Return value from the datepicker popup is : ' + val, new Date(val));
      $scope.currentDiaryDate = ChildcareOnUtils.parseDateToNumbers(new Date(val));
      $scope.isToday = (new Date(val).toDateString() === ChildcareOnUtils.getCurrentDayOrMonday().toDateString());
      $scope.getDiary(studentId,$scope.currentDiaryDate);
    },
    from: new Date(2016, 9, 1), //Optional
    titleLabel: $translate.instant('diary_selectADay'),
    todayLabel: $translate.instant('date_today'),
    closeLabel: $translate.instant('diary_close'),
    setLabel: 'Ok',
    weeksList:[$translate.instant('sunday_short'),$translate.instant('monday_short'),$translate.instant('tuesday_short'),$translate.instant('wednesday_short'),$translate.instant('thursday_short'),$translate.instant('friday_short'),$translate.instant('saturday_short')],
    monthsList:[$translate.instant('january'),$translate.instant('february'),$translate.instant('march'),$translate.instant('april'),$translate.instant('may'),$translate.instant('june'),$translate.instant('july'),$translate.instant('august'),$translate.instant('september'),$translate.instant('october'),$translate.instant('november'),$translate.instant('december')]
  };

  $scope.openDatePicker = function(){
    ionicDatePicker.openDatePicker(ipObj1);
  };

  // function checkTempThumb () {
  //   if (!!$scope.diary[$scope.studentId][$scope.inputDate].images) {
  //     try {
  //       $scope.diary[$scope.studentId][$scope.inputDate].images.forEach(function (image, imageIndex) {
  //         if (!!tempThumb[image.date] && !image.thumbnail) {
  //           for (var key in tempThumb[image.date]) {
  //             $scope.diary[$scope.studentId][$scope.inputDate].images[imageIndex][key] = tempThumb[image.date][key];
  //           }
  //         }
  //       });
  //     } catch (error) {
  //       console.log('error checking thumb', error);
  //     }
  //   }
  // }

  function removeOtherChildDiary() {
    try {
      for (var childId in $scope.diary) {
        if (childId !== studentId) {
          console.warn('delete', childId);
          delete $scope.diary[childId];
        }
      }
    } catch (error) {
      console.log('error removing diary');
    }
  }

  $scope.sendComment = function(){
    if(!$scope.diary || Object.keys($scope.diary).length === 0){
      alert($translate.instant('contentNotLoaded'));
      $rootScope.show();
      return;
    }
    if(!$scope.observationsParent.comment){
      alert($translate.instant('fillFields'));
      return;
    }
    console.log("$scope.diary",$scope.diary);
    var date = new Date();
    if(!$scope.diary[$scope.studentId][$scope.inputDate].observationsParent) $scope.diary[$scope.studentId][$scope.inputDate].observationsParent = {};
    $scope.diary[$scope.studentId][$scope.inputDate].observationsParent[date.getTime()] = {
      date: date.getTime(),
      message: $scope.observationsParent.comment,
      sender: $rootScope.allUserInfo.id,
      senderName: $rootScope.allUserInfo.name
    };
    console.log("observationsParent",$scope.diary[$scope.studentId][$scope.inputDate].observationsParent[date.getTime()]);
    console.log("comment to add",$scope.diary[$scope.studentId][$scope.inputDate].observationsParent);
    CommonFactory._save($scope.diary[$scope.studentId][$scope.inputDate]).then(function(){
      $scope.sendNewComment($scope.observationsParent.comment, 'parent');
      $rootScope.showToast('diary_commentSaved');
      $scope.observationsParent.comment = null;
    },function(){
      alert($translate.instant('serverError'));
    });



    // if(!$scope.allDiary[$scope.currentDiaryDate]) $scope.allDiary[$scope.currentDiaryDate] = {};
    // $scope.allDiary[$scope.currentDiaryDate].observationsParent = $scope.diary.observationsParent;
    // console.log("allDiary",$scope.allDiary);
    // CommonFactory._save($scope.allDiary).then(function(){
    //   $rootScope.showToast('diary_commentSaved');
    //   $scope.observationsParent.comment = null;
    // },function(){
    //   alert($translate.instant('serverError'));
    // });
  };

  $scope.sendNewComment = function(comment, type) {
    $scope.chat.$add({
      date: new Date().getTime(),
      message: comment,
      sender: $rootScope.allUserInfo.id,
      senderName: $rootScope.allUserInfo.name,
      type: type
    });
  };

  $scope.getDiary = function(studentId,inputDate){
    console.log("inputDate",inputDate,"studentId",studentId);
    $scope.inputDate = inputDate;
    if ($scope.isToday) {
      console.log('is today');
      $scope.chat = DiaryFactory.getDiaryChat(studentId, inputDate);
    } else {
      console.log('is not today');
      $scope.localChat = DiaryFactory.getOtherDayLocalDiaryChat(studentId, inputDate);
      $scope.chat = [];
    }
    if(studentId in $scope.diary && inputDate in $scope.diary[studentId]){
      console.log("aprovecha el codigo");
      parseDiary(studentId,inputDate,$scope.diary[studentId][inputDate]);
      //poner aqui el watcher if isToday
      return;
    }
    if($rootScope.allUserInfo.type === 'user' && !$scope.isToday){
      var localDiary = $localStorage.getCHObject('diary.'+inputDate);
      console.log("localDiary",localDiary);
      if(localDiary.id === studentId){
        console.log("usa localStorage en diary");
        if(!$scope.diary) $scope.diary = {};
        if(!$scope.diary[studentId]) $scope.diary[studentId] = {};
        $scope.diary[studentId][inputDate] = localDiary.obj;
        $scope.diary[studentId][inputDate].$resolved = true;
        parseDiary(studentId,inputDate,localDiary.obj);
        return;
      }
    } else if($rootScope.allUserInfo.type !== 'user') {
      $scope.lastview = DiaryFactory.getLastView(studentId,inputDate);
      console.log("lastview",$scope.lastview);
      // if ($scope.isToday) {
      //   tempThumb = DiaryFactory.getTempThumb(studentId,inputDate);
      //   tempThumb.$loaded()
      //   .then(function () {
      //     if (!!$scope.diary[$scope.studentId][$scope.inputDate].images) {
      //       checkTempThumb();
      //     }
      //   });
      // }
    }

    // $rootScope.show();
    console.log("no aprovecha el codigo");

    if(!$scope.diary[studentId]){
      $scope.diary[studentId] = {};
    }
    $scope.diary[studentId][inputDate] = DiaryFactory.getNewDiaryV2(studentId,inputDate);
    $scope.diary[studentId][inputDate].$loaded()
    .then(function(diary){
      $scope.medals = DiaryFactory.getMedals(studentId);
      $scope.parentsDocuments = DiaryFactory.getParentsDocuments(studentId, inputDate);
      console.log("$scope.diary[studentId][inputDate]",$scope.diary[studentId][inputDate]);
      parseDiary(studentId,inputDate,diary);
      if($rootScope.allUserInfo.type === 'user' && !$scope.isToday) $localStorage.setCHObject('diary.'+inputDate,diary,studentId);
    });
  };

  var parseDiary = function(studentId,inputDate, diary){
    var nullDiary = true, dateChanged = false;
    console.log("diary is",diary);
    for(var i in diary){
      if(possibleObjects.indexOf(i) !== -1){
        if(i !== 'observationsParent' && i !== 'observationsTeacher') nullDiary = false;
        if(diary.date){
          var dateTrimed = diary.date.split("/");
          dateTrimed[1] = parseInt(dateTrimed[1]) -1;
          $scope.dateObject = ChildcareOnUtils.getDateParsed(new Date(dateTrimed[2],dateTrimed[1],dateTrimed[0]));
          dateChanged = true;
        }else{
          $scope.dateObject = ChildcareOnUtils.getDateParsed(new Date("20"+inputDate.slice(4,6),parseInt(inputDate.slice(2,4)) -1,inputDate.slice(0,2)));
          dateChanged = true;
        }
        if(i !== 'observationsParent' && i !== 'observationsTeacher') break;
      }
    }
    console.log("is nullDiary",nullDiary);
    if(!$scope.dateObject || !dateChanged){
      console.log("try to change dateobject");
      $scope.dateObject = ChildcareOnUtils.getDateParsed(new Date("20"+$scope.currentDiaryDate.slice(4,6),parseInt($scope.currentDiaryDate.slice(2,4)) -1,$scope.currentDiaryDate.slice(0,2)));
      dateChanged = true;
    }
    if($rootScope.allUserInfo.type !== 'user' && $scope.isToday) nullDiary = false;
    console.log("is nullDiary 2",nullDiary);
    $scope.nullDiary = nullDiary;
    $rootScope.hide();
    if($scope.isToday){
      $scope.diary[studentId][inputDate].$watch(function(event){
        console.log("changed!!",event);
        // poner watcher si isToday & nullDiary & parent
        if($rootScope.allUserInfo.type === 'user' && nullDiary && !!$scope.diary[studentId]){
          parseDiary(studentId,inputDate, $scope.diary[studentId][inputDate]);
        }
      });
    }
  };

  $scope.updateDiary = function(){
    if(!$scope.diary || Object.keys($scope.diary).length === 0){
      alert($translate.instant('contentNotLoaded'));
      $rootScope.show();
      return;
    }
    if($scope.diary[$scope.studentId][$scope.inputDate].hasOwnProperty('needed') &&
      $scope.diary[$scope.studentId][$scope.inputDate].needed.hasOwnProperty('other') && 
      $scope.diary[$scope.studentId][$scope.inputDate].needed.other.value &&
      (!$scope.diary[$scope.studentId][$scope.inputDate].needed.other.hasOwnProperty('comment') || $scope.diary[$scope.studentId][$scope.inputDate].needed.other.comment === "")
    ) {
      return alert($translate.instant('diary_neededCommentError'));
    }
    var date = ChildcareOnUtils.getCurrentDayOrMonday();
    var student = angular.copy($rootScope.studentSelected);
    var notificationTitle = $translate.instant('menu_agenda',$scope.childTitle);
    var dateMessage = date.getTime();
    $scope.teacherComment.date = dateMessage;
    if($scope.isToday) $scope.diary[$scope.studentId][$scope.inputDate].date = date.getDate().toString() + "/" + parseInt(date.getMonth() + 1).toString() + "/" + date.getFullYear();
    console.log("teacherComment",$scope.teacherComment);
    console.log("observationsTeacher",$scope.diary[$scope.studentId][$scope.inputDate].observationsTeacher);
    var currentDiary = {};
    for(var i=0; i<possibleObjects.length; i++){
      if($scope.diary[$scope.studentId][$scope.inputDate][possibleObjects[i]]) {
        currentDiary[possibleObjects[i]] = $scope.diary[$scope.studentId][$scope.inputDate][possibleObjects[i]];
      } else {
        console.log($scope.diary[$scope.studentId][$scope.inputDate][possibleObjects[i]]);
        if($scope.isToday && $scope.diary[$scope.studentId][$scope.inputDate][possibleObjects[i]]) delete $scope.diary[$scope.studentId][$scope.inputDate][possibleObjects[i]];
      }
    }
    // if (!!$scope.diary[$scope.studentId][$scope.inputDate].images) {
    //   checkTempThumb();
    // }
    try {
      if (!!$scope.diary[$scope.studentId][$scope.inputDate].needed) {
        for (var key in $scope.diary[$scope.studentId][$scope.inputDate].needed) {
          if (!$scope.diary[$scope.studentId][$scope.inputDate].needed[key].value) {
            delete $scope.diary[$scope.studentId][$scope.inputDate].needed[key];
          }
        }
        if (Object.keys($scope.diary[$scope.studentId][$scope.inputDate].needed).length === 0) {
          delete $scope.diary[$scope.studentId][$scope.inputDate].needed;
        }
      }
    } catch (error) {
      console.log('error removing needed keys', error);
    }
    CommonFactory._save($scope.diary[$scope.studentId][$scope.inputDate]).then(function(){
      $rootScope.showToast('infoSavedSuccessfully');
      if($scope.teacherComment.message != null){
        $scope.sendNewComment($scope.teacherComment.message, 'teacher');
        $scope.teacherComment = {sender:$rootScope.allUserInfo.id,message:null,date:null,senderName:$rootScope.allUserInfo.name};
      }
      if (!!$scope.diary[$scope.studentId][$scope.inputDate].needed) {
        DiaryFactory.saveNeeded($scope.studentId, $scope.inputDate);
      }
    },function(){
      console.log("error updateDiary");
      alert($translate.instant('serverError'));
    });
  };

  $scope.timeSelection = ['30min','45min','1h','1:15h','1:30h','1:45h','2h','2:30h','3h'];

  var loadDiary = function(){
    // $rootScope.show();
    console.log("intenta getDiary",$rootScope.childSelected);
    var date = ChildcareOnUtils.getCurrentDayOrMonday();
    $scope.currentDiaryDate = ChildcareOnUtils.parseDateToNumbers(date);
    $scope.isToday = true;
    $scope.getDiary(studentId,$scope.currentDiaryDate);
  };

  $rootScope.calendarInMenu = function(){
    console.log("calendarInMenu pushed");
    $scope.openDatePicker();
  };

  $scope.showCard = function(name, classroomType){
    if (typeof classroomType === 'undefined') classroomType = 0;
    return DiaryFactory.getIfShowCard(name, classroomType, $scope.classroomId);
  };
  
  function uploadVideo(videoUrl) {
    var date = new Date().getTime();
    var interval = setInterval(function() {
      $rootScope.showToast((49 + parseInt(ImageFactory.getPercentageProgress() / 2)) + '%');
    }, 800);
    ImageFactory.uploadVideo(videoUrl, 'diary/' + $scope.studentId, date)
    .then(function(obj) {
      delete obj.month;
      delete obj.type;
      var indexOfVideo = Array.isArray($scope.diary[$scope.studentId][$scope.inputDate].videos) ? $scope.diary[$scope.studentId][$scope.inputDate].videos.length : 0;
      firebase.database().ref('diary/' + $scope.studentId + '/' + $scope.inputDate + '/videos/' + indexOfVideo).set(obj)
      .then(function() {
        clearInterval(interval);
        alert($translate.instant('diary_videoUploaded'));
      }, function() {
        clearInterval(interval);
        alert($translate.instant('serverError'));
      });
    }, function() {
      clearInterval(interval);
      alert($translate.instant('serverError'));
    });
  }

  $scope.uploadVideo = function() {
    if (Array.isArray($scope.diary[$scope.studentId][$scope.inputDate].videos) && $scope.diary[$scope.studentId][$scope.inputDate].videos.length > 1) {
      alert($translate.instant('diary_videoAlreadyUpload', {name: $scope.childTitle}));
      return;
    }

    navigator.camera.getPicture(function (videoUrl) {
      if (!!$rootScope.allUserInfo.avoidCompressVideo) {
        uploadVideo(videoUrl);
      } else {
        VideoEditor.transcodeVideo(
          function (info) {
            console.log("success transcoding video", info);
            uploadVideo(info);
          }, // success cb
          function (error) {
            console.log("error transcoding video", error);
            try {
              CommonFactory.saveLog({
                user: $rootScope.allUserInfo.id,
                error: "error transcoding video diary. video url: file://" + videoUrl,
                errorMessage: JSON.stringify(error)
              });
            } catch (error) {
              console.log('error saving log', error);
            }
            uploadVideo(videoUrl);
          }, // error cb
          {
            fileUri: 'file://' + videoUrl, // the path to the video on the device
            outputFileName: 'childcareon-diary-thumb_'+ new Date().getTime(), // the file name for the transcoded video
            outputFileType: VideoEditorOptions.OutputFileType.MPEG4, // android is always mp4
            optimizeForNetworkUse: VideoEditorOptions.OptimizeForNetworkUse.YES, // ios only
            saveToLibrary: false, // optional, defaults to true
            deleteInputFile: false, // optional (android only), defaults to false
            maintainAspectRatio: true, // optional (ios only), defaults to true
            width: 1080, // optional, see note below on width and height
            height: 720, // optional, see notes below on width and height
            videoBitrate: 8000000, // optional, bitrate in bits, defaults to 1 megabit (1000000)
            fps: 25, // optional (android only), defaults to 24
            // audioChannels: 2, // optional (ios only), number of audio channels, defaults to 2
            // audioSampleRate: 44100, // optional (ios only), sample rate for the audio, defaults to 44100
            // audioBitrate: 128000, // optional (ios only), audio bitrate for the video in bits, defaults to 128 kilobits (128000)
            progress: function(info) {
              console.log("progress", info);
              progress = info;
              if (!!info && info > 0) {
                console.log((info * 50));
                console.log((info * 50) + '%');
                $rootScope.showToast(parseInt(info * 50) + '%');
              }
            } // info will be a number from 0 to 100
          }
        );
      }
      alert($translate.instant('diary_uploadingVideo'));
    }, function(message) {
      console.log('Failed because: ' + message);
    }, { correctOrientation: true, quality: 60,targetWidth: 800, targetHeight: 800, sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
      destinationType: Camera.DestinationType.FILE_URI, encodingType: Camera.EncodingType.JPEG, mediaType: Camera.MediaType.VIDEO
    });
  };

  var actionUploadImage = function(type) {
    var success = function(imageData){
      console.log("success",imageData);
      imagesUploading++;
      ImageFactory.uploadDiaryImage(imageData,"image/jpeg",$scope.studentId).then(function(data){
        var url = data.url;
        var date = data.date;
        console.log("imagen subida",url, date);
        if(!$scope.diary[$scope.studentId][$scope.inputDate].images) $scope.diary[$scope.studentId][$scope.inputDate].images = [];
        $scope.diary[$scope.studentId][$scope.inputDate].images.push({
          image: url,
          date: date
        });
        $rootScope.showToast('diary_rememberSave');
        imagesUploading--;
      },function(){
        imagesUploading--;
        alert($translate.instant('serverError'));
      });
    };
    var failed = function(message){
      // if(message.indexOf('cancelled') === -1) alert($translate.instant('imageUpdatedError'));
      console.log('Failed because: ' + message);
    };
    var source;
    if (type === 'camera') {
      source = Camera.PictureSourceType.CAMERA;
    } else {
      source = Camera.PictureSourceType.PHOTOLIBRARY;
    }
    navigator.camera.getPicture(success, failed, { correctOrientation: false, quality: 70, targetWidth: 1600, targetHeight: 1600, sourceType: source,
      destinationType: Camera.DestinationType.DATA_URL, encodingType: Camera.EncodingType.JPEG
    });
  };

  var uploadMultipleImages = function(countImagesToPick) {
    if (!!$rootScope.settings && !!$rootScope.settings.premium) {
      countImagesToPick = 8;
    }
    var args = {
      'selectMode': 100, //101=picker image and video , 100=image , 102=video
      'maxSelectCount': countImagesToPick, //default 40 (Optional)
      'maxSelectSize': 188743680, //188743680=180M (Optional)
    };
    mediaType = Camera.MediaType.PICTURE;
    MediaPicker.getMedias(args, function(medias) {
      //medias [{mediaType: "image", path:'/storage/emulated/0/DCIM/Camera/20170808_145202.jpg', size: 21993}]
      if (!medias || medias.length === 0) {
        return console.log('no images selected');
      }
      $rootScope.show();
      imagesUploading = imagesUploading + medias.length;
      ImageFactory.multipleImages.getCompressedImages(medias)
      .then(function(thumbnails) {
        setTimeout(function () {
          $rootScope.hide();
        }, 500 * medias.length);
        alert($translate.instant('gallery_uploadingMultipleImages'));
        ImageFactory.multipleImages.uploadImages(thumbnails, 'diary/' + $scope.studentId)
        .then(function (imagesUploaded) {
          console.log('after images uploaded');
          if(!$scope.diary[$scope.studentId][$scope.inputDate].images) $scope.diary[$scope.studentId][$scope.inputDate].images = [];
          $scope.diary[$scope.studentId][$scope.inputDate].images = $scope.diary[$scope.studentId][$scope.inputDate].images.concat(imagesUploaded);
          $rootScope.showToast('diary_rememberSave');
          imagesUploading = imagesUploading - imagesUploaded.length;
        });
      });
    }, function(e) { console.log(e) });
  };

  function confimPhotoVideoActions(type) {
    return $q(function (resolve, reject) {
      var deleteText, seeText;
      if (type === 'image') {
        deleteText = $translate.instant('gallery_deleteImageTitle');
        seeText = $translate.instant('diary_seeImage')
      } else {
        deleteText = $translate.instant('gallery_deleteVideoTitle');
        seeText = $translate.instant('diary_seeVideo');
      }
      navigator.notification.confirm(
        '', // message
        function(index){
          resolve(index);
        },
        $translate.instant('diary_selectOption'),           // title
        [deleteText, $translate.instant('login_forgotPassword_cancelButton'), seeText]     // buttonLabels
      );
    });
  }

  $scope.selectPhoto = function(images, imageIndex) {
    var image = images[imageIndex];
    if($rootScope.allUserInfo.type === 'user'){
      $state.go('app.multiImage', {img: images, index: imageIndex, canDelete: false, canDownload: true });
      return;
    }
    confimPhotoVideoActions('image').then(function(index) {
      switch(index) {
        case 1:
        console.log("image index is",$scope.diary[$scope.studentId][$scope.inputDate].images.indexOf(image));
        var imgIndex = $scope.diary[$scope.studentId][$scope.inputDate].images.indexOf(image);
        if(imgIndex === -1){
          alert($translate.instant('serverError'));
          return;
        }
        $scope.$evalAsync(function(){$scope.diary[$scope.studentId][$scope.inputDate].images.splice(imgIndex, 1);});
        if (!$scope.isToday) {
         CommonFactory._save($scope.diary[$scope.studentId][$scope.inputDate]);
        } else {
          $rootScope.showToast('diary_saveToApplyChanges');
        }
        break;
        case 2: return console.log("cancel selected");
        break;
        case 3: $state.go('app.imageViewer',{img:image.image, canDelete:false, canDownload:true, imageComplete: image});
        break;
      }
    });
  };

  $scope.selectVideo = function(video) {
    if($rootScope.allUserInfo.type === 'user'){
      $state.go('app.videoViewer',{url:video.image, canDelete: false, videoComplete: video, canDownload: true});
      return;
    }
    confimPhotoVideoActions('video').then(function(index) {
      switch(index) {
        case 1:
        console.log("video index is",$scope.diary[$scope.studentId][$scope.inputDate].videos.indexOf(video));
        var videoIndex = $scope.diary[$scope.studentId][$scope.inputDate].videos.indexOf(video);
        if(videoIndex === -1){
          alert($translate.instant('serverError'));
          return;
        }
        $scope.$evalAsync(function(){$scope.diary[$scope.studentId][$scope.inputDate].videos.splice(videoIndex, 1);});
        if (!$scope.isToday) {
         CommonFactory._save($scope.diary[$scope.studentId][$scope.inputDate]);
        } else {
          $rootScope.showToast('diary_saveToApplyChanges');
        }
        break;
        case 2: return console.log("cancel selected");
        break;
        case 3: $state.go('app.videoViewer',{url:video.image, canDelete: false, videoComplete: video, canDownload: true});
        break;
      }
    });
  };

  $scope.selectMessage = function(message){
    console.log("message",message);
    $scope.message = message;
    var nonReaded = [];
    var readed = [];
    for(var i=0; i<$scope.lastview.length; i++) {
      if($scope.lastview[i].date > $scope.message.date) {
        readed.push($scope.lastview[i]);
      }
    }
    $scope.readed = readed;
    $scope.nonReaded = nonReaded;
    $scope.modalLastview.show();
  };

  $ionicModal.fromTemplateUrl('modal-lastview.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modalLastview = modal;
  });
  if ($rootScope.allUserInfo.type === 'user') {
    $ionicModal.fromTemplateUrl('modal-medal.html', {
      scope: $scope,
      animation: 'slide-in-up'
    }).then(function(modal) {
      $scope.modalMedal = modal;
    });
  }
  // Cleanup the modal when we're done with it!
  $scope.$on('$destroy', function() {
    if (!!$scope.modalLastview) {
      $scope.modalLastview.remove();
    }
    if ($rootScope.allUserInfo.type === 'user' && !!$scope.modalMedal) {
      $scope.modalMedal.remove();
    }
  });

  $scope.$on("$ionicView.beforeEnter", function(){
    console.log("$stateParams.changes",$stateParams.changes);
    if(!$stateParams.changes){
      $scope.changes = {};
      return;
    }
    var changes = {};
    $stateParams.changes.forEach(function(x){
      changes[x] = true;
    });
    $scope.changes = changes;
    console.log("changes",changes);
  });

  $scope.deleteRadio = function(object,subObject) {
    if(!$scope.diary[$scope.studentId][$scope.inputDate].hasOwnProperty(object) && !$scope.diary[$scope.studentId][$scope.inputDate][object].hasOwnProperty(subObject)) return console.log('nothing to remove');
    if(typeof subObject !== 'undefined') {
      delete $scope.diary[$scope.studentId][$scope.inputDate][object][subObject].value;
      if(Object.keys($scope.diary[$scope.studentId][$scope.inputDate][object][subObject]).length === 0) delete $scope.diary[$scope.studentId][$scope.inputDate][object][subObject];
    } else {
      delete $scope.diary[$scope.studentId][$scope.inputDate][object].value;
    }
    if(Object.keys($scope.diary[$scope.studentId][$scope.inputDate][object]).length === 0) delete $scope.diary[$scope.studentId][$scope.inputDate][object];
    console.log($scope.diary[$scope.studentId][$scope.inputDate]);
  };

  $scope.uploadImage = function() {
    var countImagesToPick = 4 - imagesUploading;
    if($scope.diary[$scope.studentId][$scope.inputDate].hasOwnProperty('images')){
      countImagesToPick = countImagesToPick - $scope.diary[$scope.studentId][$scope.inputDate].images.length;
    }
    if (countImagesToPick < 1 && !$rootScope.settings.premium) {
      alert($translate.instant('diary_maximumImages'));
      return console.log("maximum images reached");
    }
    var ionicActionSheet;
    var options = {
      buttons: [
        { text: '<i class="icon ion-camera"></i>'+ $translate.instant('communications_camera') },
        { text: '<i class="icon ion-image"></i>'+ $translate.instant('communications_gallery') },
        { text: '<i class="icon ion-images"></i>'+ $translate.instant('communications_images') }
        // { text: '<i class="icon ion-images"></i>'+ $translate.instant('gallery_video') },
      ],
      titleText: $translate.instant('communications_imageTitle'),
      cancelText: $translate.instant('login_forgotPassword_cancelButton'),
      cancel: function() {
        // add cancel code..
      },
      buttonClicked: function(index) {
        console.log('button clicked', index);
        switch(index) {
          case 0: actionUploadImage('camera'); break;
          case 1: actionUploadImage('gallery'); break;
          case 2: uploadMultipleImages(countImagesToPick); break;
          default: console.log('default');
        }
        ionicActionSheet();
        return true;
      }
    };
    ionicActionSheet = $ionicActionSheet.show(options);
  };

  $scope.$on("$ionicView.afterEnter", function(){
    diaryLoaded = false;
    if($rootScope.allUserInfo.type === 'user'){
      studentId = $rootScope.childSelected;
      childTitle = $rootScope.allUserChilds[$rootScope.childSelected].name.split(" ");
      schoolId = $rootScope.allUserChilds[$rootScope.childSelected].school;
      $scope.classroomId = $rootScope.allUserChilds[$rootScope.childSelected].classroomId;
      $scope.childTitle = {name:childTitle[0]};
    }else{
      if(typeof $rootScope.classSelected === 'undefined' || $rootScope.studentSelected === 'undefined'){
        $state.go('app.home');
        return;
      }
      studentId = $rootScope.studentSelected.id;
      // childTitle = $rootScope.studentSelected.name.split(" ");
      // $scope.childTitle = {name:childTitle[0]};
      $scope.childTitle = $rootScope.studentSelected.name;
      schoolId = $rootScope.allUserInfo.school;
      $scope.classroomId = $rootScope.classSelected.id;
      if(!$rootScope.dictionary) DiaryFactory.getDictionary().then(function(dictionary){
        $rootScope.dictionary = dictionary;
      });
    }
    $scope.studentId = studentId;
    if($rootScope.settings){
      console.log("entra en scope.settings");
      $scope.classroomType = ClassroomFactory.getClassroomType(false,$scope.classroomId);
    }else $scope.classroomType = 1;
    // $scope.classroomType = 1;

    console.log("$scope.classroomType",$scope.classroomType);
    console.log('studentId', studentId);

    // if(!$stateParams.notification_day && (!$scope.diary || $scope.diary.$id != $rootScope.childSelected)) loadDiary();
    if(!$stateParams.notification_day && (!$scope.diary || !$scope.currentDiaryDate || !$scope.diary[studentId] || !$scope.diary[studentId][$scope.currentDiaryDate])) {
      removeOtherChildDiary();
      loadDiary();
      diaryLoaded = true;
    } else {
      removeOtherChildDiary();
    }
    if(!$rootScope.settings || $rootScope.settings.$id !== schoolId) {
      DiaryFactory.getSettings(schoolId).then(function(settings){
        $scope.$evalAsync(function(){$rootScope.settings = settings;});
      });
    }
    if($stateParams.notification_day){
      $scope.currentDiaryDate = $stateParams.notification_day;
      $scope.isToday = ($scope.currentDiaryDate == ChildcareOnUtils.parseDateToNumbers(ChildcareOnUtils.getCurrentDayOrMonday()));
      $scope.getDiary(studentId,$scope.currentDiaryDate);
      diaryLoaded = true;
    }

    if($rootScope.allUserInfo.type === 'user' && $scope.isToday){
      $scope.diary[studentId][$scope.currentDiaryDate].$loaded()
      .then(function(){
        DiaryFactory.saveLastView(studentId,$scope.currentDiaryDate);
      });
    }
  });

  (function(){
  }());
});
