angular.module('childcareOnApp').controller('DiaryExportCtrl', function($scope, $rootScope, $translate, $state, DiaryFactory, $q, $firebaseStorage) {

  var childSelected, product, inAppBrowserRef, langSelected, productName, hasPaid = false;
  $scope.isLoadingExampleDiary = false;
  $scope.showRestore = false;

  if ($rootScope.isAndroid) {
    productName = 'export_diary_20_21';
  } else {
    productName = 'export_diary_20_21_no_consumable';
  }

  $scope.openLink = function(link) {
    console.log('open link', link);
    window.open(link, '_system', 'location=false');
  };
  $scope.openDocument = function(link) {
    console.log('open link', link.document);
    if (!!link.path) {
      $firebaseStorage(firebase.storage().ref(link.path)).$getDownloadURL().then(function(url) {
        console.log('url', url);
        window.open(url, '_system', 'location=false');
      }, function() {
        window.open(link.document, '_system', 'location=false');
      });
    } else {
      window.open(link.document, '_system', 'location=false');
    }
  };

  $scope.openExampleDiary = function() {
    var currentLang = $translate.use();
    var url = 'https://childcareon.com/assets/exportedPDF/';
    switch(currentLang) {
      case 'ca': url += 'ca.pdf'; break;
      default: url += 'es.pdf';
    }
    window.open(url, '_system', 'location=yes');
  };

  function pay(childId, lang) {
    console.log('childId', childId);
    if (product.canPurchase) {
      if (product.loaded && product.owned) {
        DiaryFactory.savePossibleBuyer();
      }
      langSelected = lang;
      switch (productName) {
        case "export_diary_20_21": childSelected = childId; break;
        case "export_diary_20_21_no_consumable": childSelected = childId; break;
        default: childSelected = Object.keys($scope.paid); break;
      }
      if (Array.isArray(childSelected)) {
        childSelected.forEach(function (child) {
          DiaryFactory.saveLogPayClick(child, lang, productName);
        });
      } else {
        DiaryFactory.saveLogPayClick(childSelected, lang, productName);
      }
      store.order(productName)
    } else {
      alert($translate.instant('in_app_purchase_not_ready'));
    }
  }

  $scope.pay = function(childId) {
    navigator.notification.confirm(
      '', // message
       function(index){
         console.log("index is",index);
         switch(index){
           case 1: pay(childId, 'ca');
           break;
           case 2: pay(childId, 'es');
           break;
           case 3: pay(childId, 'en');
           break;
         }
       },
      $translate.instant('mySchool_preferredLang'),           // title
      [$translate.instant('lang_ca'), $translate.instant('lang_es'), $translate.instant('lang_en')]     // buttonLabels
    );
  };

  $scope.restorePurchase = function() {
    store.refresh();
    alert($translate.instant('nothing_restore_no_children'));
  };

  function finishPurchase(p) {
    console.log('product paid!', p);
    DiaryFactory.saveTransactionLog(p.transaction);
    if (Array.isArray(childSelected)) {
      childSelected.forEach(function (child) {
        DiaryFactory.productPurchased(p.transaction, child, langSelected, productName);
      });
    } else {
      DiaryFactory.productPurchased(p.transaction, childSelected, langSelected, productName);
    }
    alert($translate.instant('diary_purchased_alert'));
    p.finish();
    refreshUI();
  }

  function refreshUI() {
    product = store.get(productName);
    console.log('refreshUI', product);
    if (product.state === 'owned' && !hasPaid) {
      hasPaid = true;
      DiaryFactory.saveLoginPossibleBuyer();
    }
  }

  $scope.paid = {};
  var promises = [];
  (function(){
    for (var i in $rootScope.allUserInfo.diaryExport) {
      $scope.paid[i] = DiaryFactory.getIfPaidDiary(i);
      promises.push(
        $scope.paid[i].$loaded()
      );
    }
    console.log($scope.paid);
    $q.all(promises).then(function () {
      for (var key in $scope.paid) {
        if (!$scope.paid[key].date) {
          $scope.showRestore = true;
        }
      }
      if ($scope.showRestore && typeof cordova !== 'undefined') {
        if ($rootScope.isAndroid) {
          store.register({type: store.CONSUMABLE, id: productName});
        } else {
          switch (Object.keys($scope.paid).length) {
            case 1: productName = 'export_diary_20_21_no_consumable'; break;
            case 2: productName = 'export_diary_20_21_no_consumable_2'; break;
            default: productName = 'export_diary_20_21_no_consumable_2'; break;
          }
          store.register({type: store.NON_CONSUMABLE, id: productName});
        }
        product = store.get(productName);
        console.log('product', product);
        console.log(angular.copy(product.loaded));
        console.log(angular.copy(product.owned));
        store.when(productName)
          .updated(refreshUI)
          .approved(finishPurchase);
        store.refresh();
      }
    });
  })();
});