angular.module('childcareOnApp').controller('FoldersDetailCtrl', ['$scope', '$rootScope', '$translate', '$state', '$stateParams', 'ImageFactory', '$ionicHistory', FoldersDetailCtrl]);

function FoldersDetailCtrl($scope, $rootScope, $translate, $state, $stateParams, ImageFactory, $ionicHistory) {

  var vm = this;

  function deleteFolderHandler() {
    vm.folderImages.$loaded().then(function() {
      if (vm.folderImages.length > 0) {
        alert($translate.instant('gallery_cantDeleteFolder'));
        return;
      }
      if(navigator.notification){
        navigator.notification.confirm($translate.instant('confirmGeneric'), function(buttonIndex) {
          switch(buttonIndex) {
            case 1: console.log("Cancel"); break;
            case 2: console.log("Accept"); deleteFolder(); break;
          }
        }, $translate.instant('gallery_deleteFolder'), [ $translate.instant('login_forgotPassword_cancelButton'), $translate.instant('button_accept')]);
      }else{
        if(confirm($translate.instant('confirmGeneric'))) deleteFolder();
      }
    });
  }

  function deleteFolder() {
    firebase.database().ref('galleryFolders/folders/' + $rootScope.allUserInfo.school + '/' + vm.folder.$id).remove()
    .then(function() {
      $rootScope.showToast('infoDeletedSuccessfully');
      $ionicHistory.goBack();
    }, function() {
      alert($translate.instant('serverError'));
    });
  }

  function updateFolder() {
    for (var classroomId in vm.folder.classrooms) {
      if (!vm.folder.classrooms[classroomId]) {
        delete vm.folder.classrooms[classroomId];
      }
    }
    if (Object.keys(vm.folder.classrooms).length === 0) {
      alert($translate.instant('select_almost_one_classroom'));
      return;
    }
    console.log('vm.folder', vm.folder);
    firebase.database().ref('galleryFolders/folders/' + $rootScope.allUserInfo.school + '/' + vm.folder.$id).update({
      name: vm.folder.name,
      classrooms: vm.folder.classrooms
    })
    .then(function() {
      alert($translate.instant('infoSavedSuccessfully'));
      $ionicHistory.goBack();
    }, function() {
      alert($translate.instant('serverError'));
    });
  }

  vm.deleteFolderHandler = deleteFolderHandler;
  vm.updateFolder = updateFolder;

  (function(){
    vm.folder = $stateParams.folder;
    vm.folderImages = ImageFactory.getCustomFolderImages(vm.folder.$id, 'full');
    console.log('vm.folder', vm.folder);
  }());
}