angular.module('childcareOnApp').controller('FoldersCtrl', ['$scope', '$rootScope', '$filter', '$firebaseObject', '$firebaseArray', 'UserFactory', '$translate', '$state', '$ionicModal', FoldersCtrl]);

function FoldersCtrl($scope, $rootScope, $filter, $firebaseObject, $firebaseArray, UserFactory, $translate, $state, $ionicModal) {

  var vm = this;

  vm.addFolder = addFolder;
  vm.folders = $firebaseArray(firebase.database().ref('galleryFolders/folders/' + $rootScope.allUserInfo.school));
  vm.folderToAdd = {name:''};
  vm.classroomsToSend = {};

  function addFolder() {
    if (vm.folderToAdd.name === '') {
      return alert($translate.instant('fillFields'));
    }
    $rootScope.show();
    for (var classroomId in vm.classroomsToSend) {
      if (!vm.classroomsToSend[classroomId]) {
        delete vm.classroomsToSend[classroomId];
      }
    }
    if (Object.keys(vm.classroomsToSend).length === 0) {
      return alert($translate.instant('select_almost_one_classroom'));
    }
    vm.folderToAdd.classrooms = vm.classroomsToSend;
    vm.folderToAdd.date = new Date().getTime();
    vm.folders.$add(vm.folderToAdd)
    .then(function(folderRef) {
      console.log('folderRef', folderRef.key);
      vm.folderToAdd = {name:''};
      vm.classroomsToSend = {};
      $rootScope.hide();
      $scope.closeModal();
    }, function (error) {
      console.log('error', error);
      $rootScope.hide();
      alert($translate.instant('serverError'));
    });
  }

  $ionicModal.fromTemplateUrl('modal-create-folder.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modalCreateFolder = modal;
  });
  $scope.openCreateFolder = function() {
    $scope.modalCreateFolder.show();
  };
  $scope.closeModal = function() {
    $scope.modalCreateFolder.hide();
  };
  // Cleanup the modal when we're done with it!
  $scope.$on('$destroy', function() {
    if (!!$scope.modalCreateFolder) {
      $scope.modalCreateFolder.remove();
    }
  });

  
  (function(){

  }());
}
