angular.module('childcareOnApp').controller('HealthCtrl', function($scope, $rootScope, $q, $state, $translate, CommonFactory, ChildFactory, ImageFactory, DiaryFactory, ChildcareOnUtils, ionicMaterialInk, ionicMaterialMotion) {

  $scope.addMedication = false;
  $scope.addMedicalHistory = false;
  $scope.addMedicationParams = {};
  $scope.medicalHistoryParams = {};
  $scope.urgentNotification = {};
  $scope.showNotifications = false;
  $scope.showMedicine = -1;
  $scope.isPast = {};
  $scope.medicalHistoryImageData = '';

  $scope.convertDate = function(date){
    return date.substring(0,2) + "/"+ date.substring(2,4);
  };

  setTimeout(function(){
    ionicMaterialInk.displayEffect();
    ionicMaterialMotion.ripple();
  },500);

  var fillHourArray = function(){
    var hourSelection = [];
    for(var i=0; i<24; i++){
      hourSelection.push(i);
    }
    $scope.hourSelection = hourSelection;
  };
  $scope.minutesSelection = ['00','10','20','30','40','50'];

  var loadHealth = function(){
    if($rootScope.allUserInfo.type === 'user'){
      var studentId = $rootScope.childSelected;
      var childTitle = $rootScope.allUserChilds[$rootScope.childSelected].name;
    }else{
      var studentId = $rootScope.studentSelected.id;
      var childTitle = $rootScope.studentSelected.name;
    }
    childTitle = childTitle.split(" ");
    $scope.childTitle = {name:childTitle[0]};

    ChildFactory.getHealthChild(studentId).then(function(health){
      console.log("getHealthChild",health);
      $scope.health = health;
    },function(){
      $scope.health = null;
      $rootScope.showToast("serverError");
    });
    if ($rootScope.allUserInfo.type !== 'user') {
      ChildFactory.getUrgentNotification(studentId).then(function(urgentNotifications){
        $scope.urgentNotifications = urgentNotifications.sort(function (a, b) { return b.date - a.date; });
      },function(){
        $scope.urgentNotifications = [];
      });
      console.log('entra parents', $rootScope.studentSelected);
      ChildFactory.getParents($rootScope.studentSelected.id).$loaded()
      .then(function(parents) {
        if (parents.length > 0) {
          $scope.hasNoParents = false;
          console.log('entra parents 2');
          $scope.parents = ChildFactory.getChildParents(parents);
        } else {
          $scope.parents = [];
          $scope.hasNoParents = true;
        }
        console.log($scope.parents);
      });
    }
  };

  function sendAddMedication(){
    var date = new Date().getTime().toString();
    date = date.slice(0,date.length-3);
    if(!$scope.health.medication) $scope.health.medication = {};
    $scope.health.medication[date] = $scope.addMedicationParams;
    CommonFactory._save($scope.health).then(function(){
      $scope.addMedicationParams = {};
      $scope.addMedication = false;
    },function(){
      $rootScope.showToast('serverError');
    });
  }

  function onSuccess(imageData) {
    console.log("success",imageData);
    $scope.medicalHistoryImageData = imageData;
    $rootScope.showToast("imageUpdatedSuccess");
  }

  function onFail(message) {
    console.log('Failed because: ' + message);
  }

  $scope.sendAddMedication = function(){
    if(!$scope.addMedicationParams || !$scope.addMedicationParams.medicine){
      return alert($translate.instant('fillFields'));
    }
    if (!!$scope.addMedicationParams.schedule && !!$scope.addMedicationParams.schedule.value) {
      $scope.addMedicationParams.schedule.hour = $scope.addMedicationParams.schedule.value.getHours();
      $scope.addMedicationParams.schedule.minutes = $scope.addMedicationParams.schedule.value.getMinutes();
    }
    _confirm($translate.instant('confirmGeneric'), $translate.instant('health_confirm') ,$translate.instant('login_forgotPassword_cancelButton'), $translate.instant('button_accept'), function(buttonIndex){
      if(buttonIndex === 2){
        sendAddMedication();
      }
    });
  };

  $scope.changeItem = function(item){
    $scope[item] = !($scope[item]);
  };

  $scope.callParent = function(phone) {
    var phoneParsed = phone.replace(/ /g,'');
    window.open("tel:" + phoneParsed, '_system', 'location=yes');
  };

  function uploadMedicalHistoryImage() {
    return $q(function(resolve, reject) {
      if ($scope.medicalHistoryImageData === '') {
        return resolve();
      }
      var date = new Date().getTime();
      ImageFactory.saveImage($scope.medicalHistoryImageData, 'health/' + $rootScope.childSelected, date, 'image/jpeg', false).then(function(url) {
        $scope.medicalHistoryParams.image = url;
        $scope.medicalHistoryParams.imageLocation = 'health/' + $rootScope.childSelected + '/' + date + '.jpg';
        resolve();
      },function(e){
        console.log("error upload medical image",e);
        resolve();
      });
    });
  };

  $scope.selectPhoto = function(image){
    $state.go('app.imageViewer',{ img: image.image, canDelete: false, imageComplete: image, canDownload: true });
  };

  $scope.saveMedicalHistory = function(){
    if(!$scope.addMedicalHistory || !$scope.medicalHistoryParams.text){
      alert('fillFields');
      return;
    }
    uploadMedicalHistoryImage()
    .then(function() {
      var date = new Date().getTime();
      if(!$scope.health.medicalHistory) $scope.health.medicalHistory = {};
      $scope.medicalHistoryParams.date = date;
      $scope.health.medicalHistory[date.toString()] = $scope.medicalHistoryParams;
      CommonFactory._save($scope.health).then(function(){
        $scope.addMedicationParams = {};
        $scope.medicalHistoryParams = {};
        $scope.medicalHistoryImageData = '';
        $scope.addMedicalHistory = false;
      },function(){
        $rootScope.showToast('serverError');
      });
    });
  };

  $scope.removeMedicalHistory = function(date){
    if($scope.health.medicalHistory[date]){
      delete $scope.health.medicalHistory[date];
      CommonFactory._save($scope.health).then(null,function(){
        $rootScope.showToast('serverError');
      });
    }
  };

  $scope.removeMedicine = function(item) {
    for(var i in $scope.health.medication){
      if($scope.health.medication[i] === item){
        delete $scope.health.medication[i];
        CommonFactory._save($scope.health).then(null,function(){
          $rootScope.showToast('serverError');
        });
      }
    }
  };

  $scope.sendUrgentNotification = function() {
    if(!$scope.urgentNotification){
      alert($translate.instant('fillFields'));
      return;
    }
    ChildFactory.sendUrgentNotification($scope.urgentNotification.value,$rootScope.studentSelected.id).then(function(){
      $scope.urgentNotification = {};
      $rootScope.showToast('sentSuccessfully');
    },function(){
      alert($translate.instant('serverError'));
    });
  };

  $scope.uploadImageMedicalHistory = function() {
    $translate(['communications_selectImage','communications_imageTitle','communications_camera','communications_gallery','login_forgotPassword_cancelButton']).then(function(t){
      navigator.notification.confirm(
        t.communications_selectImage, // message
         function(index){
           if(index === 2) return;
           var source = (index === 1)? Camera.PictureSourceType.CAMERA: Camera.PictureSourceType.PHOTOLIBRARY;
           navigator.camera.getPicture(onSuccess, onFail, { correctOrientation:true, quality: 80, targetWidth: 600, targetHeight: 600, sourceType: source,
             destinationType: Camera.DestinationType.DATA_URL, encodingType: Camera.EncodingType.JPEG
           });
         },
        t.communications_imageTitle,           // title
        [t.communications_camera, t.login_forgotPassword_cancelButton, t.communications_gallery]     // buttonLabels
      );
    });
  };

  $scope.openUrl = function(url){
    if (url.indexOf('http') === -1) {
      url = 'http://' + url;
    }
    $rootScope.show();
    inAppBrowserRef = cordova.InAppBrowser.open(url, "_blank", "location=yes,hidden=yes,shouldPauseOnSuspend=yes");

    inAppBrowserRef.addEventListener('loadstart', function() {
      console.log('loadstart');
    });

    inAppBrowserRef.addEventListener('loadstop', function() {
      console.log('loadStop');
      $rootScope.hide();
      inAppBrowserRef.show();
    });

    inAppBrowserRef.addEventListener('loaderror', function() {
      console.log('loaderror');
      $rootScope.hide();
      inAppBrowserRef.close();
      window.open(url, '_system', 'location=false');
    });
  };

  $scope.$on("$ionicView.afterEnter", function(){
    if(!$rootScope.dictionary && $rootScope.allUserInfo.type !== 'user') DiaryFactory.getDictionary().then(function(dictionary){
      $rootScope.dictionary = dictionary;
    });
    if(!$scope.health || $scope.health.$id != $rootScope.childSelected) loadHealth();
  });

  $scope.selectNotification = function(){
    $scope.showNotifications = !$scope.showNotifications;
  };

  $scope.expandMedicine = function(index){
    if($scope.showMedicine == index) $scope.showMedicine = -1;
    else $scope.showMedicine = index;
  };

  $scope.setIsPast = function(key, pastDate){
    var date = new Date();
    date = parseInt(date.getFullYear().toString() + ChildcareOnUtils.addLeadingZeros(date.getMonth() +1)+ ChildcareOnUtils.addLeadingZeros(date.getDate()));
    $scope.isPast[key] = (parseInt(pastDate.substring(4,8) + pastDate.substring(2,4) + pastDate.substring(0,2)) < date);
    delete date;
  };

  $scope.getIfPDF = function(link){
    return (link.indexOf('.pdf') !== -1 || link.indexOf('.PDF') !== -1);
  };

  (function(){
    fillHourArray();
  }());
});
