angular.module('childcareOnApp').controller('FeedbackCtrl', function($scope, $state, $rootScope, $translate, $ionicScrollDelegate, FeedbackFactory, ImageFactory) {

  $scope.feedbackText = {};
  $scope.sendFeedback = function(){
    if(!$scope.feedbackText.message){
      alert($translate.instant('fillFields'));
      return;
    }
    FeedbackFactory.sendFeedback($scope.feedbackText.message).then(function(){
      // $rootScope.showToast('help_feedbackSent');
      setTimeout(function(){
        $ionicScrollDelegate.scrollBottom(true);
      },10);
      $scope.feedbackText = {};
    },function(){
      console.log("error sendFeedback");
      alert($translate.instant('serverError'))
    });
  };

  $scope.selectImage = function(image) {
    $state.go('app.imageViewer',{img:image.message, canDelete: false, canDownload:true, imageComplete: {image: image.message}});
  };

  $scope.openUrl = function (link){
    window.open(link, '_system', 'location=false');
  };

  function onSuccess(imageData){
    $rootScope.show(true);
    ImageFactory.saveImage(imageData, 'feedback/'+ $rootScope.allUserInfo.id, new Date().getTime(), 'image/jpeg')
    .then(function(url) {
      FeedbackFactory.sendFeedback(url, 'image').then(function(){
        $rootScope.hide();
        setTimeout(function(){
          $ionicScrollDelegate.scrollBottom(true);
        },10);
      }, function(){
        $rootScope.hide();
        console.log("error sendFeedback");
        alert($translate.instant('serverError'))
      });
    }, function() {
      $rootScope.hide();
      alert($translate.instant('serverError'));
    });
  }

  function onFail(message) {
    console.log('Failed because: ' + message);
  }

  $scope.attach = function(event) {
    event.preventDefault();
    console.log('attach yes');
    navigator.camera.getPicture(onSuccess, onFail, { correctOrientation: true,quality: 60,targetWidth: 800, targetHeight: 800, sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
      destinationType: Camera.DestinationType.DATA_URL, encodingType: Camera.EncodingType.PNG, mediaType: Camera.MediaType.PICTURE
    });
  };

  (function(){
    $rootScope.show();
    FeedbackFactory.getFeedback().then(function(feedback){
      $scope.feedback = feedback;
      setTimeout(function(){
        $ionicScrollDelegate.scrollBottom(true);
      },10);
    },function(){
      $rootScope.showToast('serverError');
    }).finally($rootScope.hide);
  }());
});
