angular.module('childcareOnApp').controller('HomeCtrl', function($scope, $rootScope, $translate, $firebaseObject, $firebaseArray, ChildcareOnUtils, ChildFactory, UserFactory, NotificationFactory, configuration, FirebasePluginFactory, BadgeNumberFactory, ImageFactory, CommonFactory, $filter, configuration) {
  $scope.todayDay = null;
  function getData(){
    UserFactory.getUserUid().then(function(userUid){
      var ref = firebase.database().ref('users/' + userUid);
      var list = $firebaseObject(ref);
      list.$loaded().then(function(userInfo){
        UserFactory.checkRegistrationsId();
        console.log("list",list);
        console.log("allUserInfo",userInfo);
        $rootScope.allUserInfo = userInfo;
        if(userInfo.type === 'user'){
          var child = null;
          for(var i in userInfo.childs){
            child = i;
            break;
          }
          if(child != null) ChildFactory.getUserChilds($rootScope.allUserInfo.childs).then(function(childInfo){
            console.log("childInfo",childInfo);
            $rootScope.allUserChilds = childInfo;
            if(childInfo != null){
              for(var i in childInfo){
                $rootScope.childSelected = i; break;
              }
            }else{
              $rootScope.childSelected = null;
            }
          },function(e){
            console.log("error en getChild",e);
            $rootScope.childSelected = null;
          });
        }
      },function(e){
        console.log("Error:",e);
      });
    },function(e){
      setTimeout(function(){console.log("try again");getData()},1000);
      console.log("error on get user");
    });
  }

  // $scope.goToPage = NotificationFactory.goToPage;
  $scope.goToPage = function(item){
    if("isReaded" in item && !item.isReaded){
      item.isReaded = true;
      item.isAck = true;
      try {
        $rootScope.notifications.$save(item).then(function(){
          console.log("notifications updated!");
          BadgeNumberFactory.setBadgeNumber();
        },function(e){
          console.log("error updating notifications",e);
        });
      } catch (error) {
        CommonFactory.saveLog({
          user: $rootScope.allUserInfo.id,
          error: "error line 56 home notifications",
          errorMessage: JSON.stringify(error)
        });
      }
    }
    if (item.typeOfNotification === 'link') {
      NotificationFactory.goToExternalWebpage(item.url);
    } else {
      NotificationFactory.goToPage(item.page,item.extra,item.pushText);
    }
  };

  $scope.getImage = function(){
    if(!$rootScope.allUserInfo || (!$rootScope.allUserChilds && $rootScope.allUserInfo.type === 'user')) return 'img/'+configuration.homeImage.default;
    var timestamp = new Date().getTime();
    for (var eventName in configuration.homeImage.events) {
      var event = configuration.homeImage.events[eventName];
      try {
        if (timestamp > event.from && timestamp < event.to) return 'img/'+event.image;
      } catch (error) {
        console.log("error",error);
      }
    }
    return 'img/'+configuration.homeImage.default;
  };

  function uploadHomeImage (imageData) {
    $rootScope.show();
    ImageFactory.saveImage(imageData, "homeImage", $rootScope.allUserInfo.school, 'image/jpeg').then(function (url) {
      $rootScope.school.homeImage = url;
      $rootScope.school.$save()
      .then(function() {
        $rootScope.hide();
        alert($translate.instant('imageUpdatedSuccess'));
      }, function(error) {
        $rootScope.hide();
        console.log('error', error);
        alert($translate.instant('serverError'));
      });
    }, function () {
      alert($translate.instant('serverError'));
    });
  }

  $scope.setHomeImage = function() {
    navigator.camera.getPicture(function(imageData) {
      uploadHomeImage(imageData);
    }, function(message) {
      if(message.indexOf('cancelled') === -1) alert($translate.instant('imageUpdatedError'));
      console.log('Failed because: ' + message);
    }, { correctOrientation:true, quality: 75,targetWidth: 600, targetHeight: 600, sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
      destinationType: Camera.DestinationType.DATA_URL, encodingType: Camera.EncodingType.JPEG, mediaType: Camera.MediaType.PICTURE
    });
  };

  $scope.$on("$ionicView.afterEnter", function(){
    if($rootScope.notifications) $scope.notificationsNumber = $filter('filter')($rootScope.notifications,{isAck:'!true'}).length;
  });

  (function(){
    $scope.dateObject = ChildcareOnUtils.getDateParsed(new Date());
    $scope.todayDay = ChildcareOnUtils.getTodayDate(new Date());
    $scope.todayDateParsed = ChildcareOnUtils.parseDateToNumbers(new Date());
    FirebasePluginFactory.hasPermission()
    .then(function (permission) {
      FirebasePluginFactory.grantPermission();
      FirebasePluginFactory.getUserToken(permission);
    });
    setTimeout(function() {
      UserFactory.checkRegistrationsId();
    }, 5000);
  }());
});
