angular.module('childcareOnApp').controller('ImageViewerCtrl', function($scope, $stateParams, $rootScope, $translate, $ionicHistory, ImageFactory, configuration) {

  var deleteImage = function(){
    if (!$stateParams.custom || $stateParams.custom.type !== 'custom') {
      var index = $rootScope.imagesInfo.indexOf($stateParams.imageComplete);
      $rootScope.imagesInfo.$remove(index).then(function(){
        $rootScope.showToast('infoDeletedSuccessfully');
        $ionicHistory.goBack();
      },function(){
        alert($translate.instant('serverError'));
      });
    } else {
      ImageFactory.deleteCustomFolderImage($stateParams.custom.folderId, $stateParams.imageComplete.$id).then(function(){
        $rootScope.showToast('infoDeletedSuccessfully');
        $ionicHistory.goBack();
      },function(){
        alert($translate.instant('serverError'));
      });
    }
  };

  $rootScope.removeInMenu = function(){
    if($rootScope.allUserInfo.type === 'user') return;
    _confirm($translate.instant('gallery_deleteImageTitle'),$translate.instant('gallery_deleteImageText'),$translate.instant('login_forgotPassword_cancelButton'),$translate.instant('yes'),
      function(buttonIndex){
      if(buttonIndex === 2){
        deleteImage();
      }
    });
  };

  $scope.setMessageView = function(){
    if(!$scope.message.totalValue) return;
    $scope.message.value = !$scope.message.value;
  };

  $scope.downloadImage = function(){
    ImageFactory.getAndAskStoragePermissions('read')
    .then(function() {
      ImageFactory.getAndAskStoragePermissions('write')
      .then(function() {
        $rootScope.showToast('image_downloading');
        ImageFactory.downloadImgToGallery($stateParams.imageComplete.image, configuration.appName + " Img", $stateParams.imageComplete.date);
      }, function() {
        alert($translate.instant('permission_not_accepted'));
      });
    }, function() {
      alert($translate.instant('permission_not_accepted'));
    });
  };

  $scope.shareImage = function() {
    ImageFactory.shareImage($stateParams.imageComplete.image);
  };

  $scope.$on("$ionicView.beforeEnter", function(){
    console.log("$stateParams.imageComplete",$stateParams.imageComplete);
    if(typeof $stateParams.imageComplete !== 'undefined' && typeof $stateParams.imageComplete.message !== 'undefined'){
      $scope.message = {
        value: true, text: $stateParams.imageComplete.message,
        totalValue:true
      };
    }else{
      $scope.message = {
        value: false, totalValue:false
      };
    }
    $scope.img = $stateParams.img;
    $rootScope.removeButton = ($rootScope.allUserInfo.type !== 'user' && $stateParams.canDelete);
    $scope.canDownload = $stateParams.canDownload || false;
  });

  (function(){
  }());
});
