angular.module('childcareOnApp').controller('MultiImageCtrl', function($scope, $stateParams, $rootScope, $translate, $ionicHistory, ImageFactory, configuration) {

  var deleteImage = function(){
    if (!$stateParams.custom || $stateParams.custom.type !== 'custom') {
      var index = $rootScope.imagesInfo.findIndex(function(image) {
        return image.$id === $scope.currentImage.$id;
      });
      if (index === -1) {
        alert($translate.instant('serverError'));
        return;
      }
      $rootScope.imagesInfo.$remove(index).then(function(){
        $rootScope.showToast('infoDeletedSuccessfully');
        $ionicHistory.goBack();
      },function(){
        alert($translate.instant('serverError'));
      });
    } else {
      ImageFactory.deleteCustomFolderImage($stateParams.custom.folderId, $scope.currentImage.$id).then(function(){
        $rootScope.showToast('infoDeletedSuccessfully');
        $ionicHistory.goBack();
      },function(){
        alert($translate.instant('serverError'));
      });
    }
  };

  $rootScope.removeInMenu = function(){
    if($rootScope.allUserInfo.type === 'user') return;
    _confirm($translate.instant('gallery_deleteImageTitle'),$translate.instant('gallery_deleteImageText'),$translate.instant('login_forgotPassword_cancelButton'),$translate.instant('yes'),
      function(buttonIndex){
      if(buttonIndex === 2){
        deleteImage();
      }
    });
  };

  $scope.setMessageView = function(){
    if(!$scope.message.totalValue) return;
    $scope.message.value = !$scope.message.value;
  };

  $scope.downloadImage = function(){
    $rootScope.showToast('image_downloading');
    ImageFactory.downloadImgToGallery($scope.currentImage.image, configuration.appName + " Img", new Date().getTime().toString());
  };

  $scope.shareImage = function() {
    ImageFactory.shareImage($scope.currentImage.image);
  };

  $scope.slideHasChanged = function(index) {
    console.log('index', index);
    $scope.currentImage = $scope.img[index];
    $scope.index = index;
    console.log('$scope.currentImage', $scope.currentImage);
    if (!!$scope.currentImage.message) {
      console.log('text si');
      $scope.message.text = $scope.currentImage.message;
      $scope.message.totalValue = true;
      $scope.message.value = true;
    } else {
      console.log('text no');
      $scope.message.value = false;
      $scope.message.text = '';
      $scope.message.totalValue = false;
    }
  };

  $scope.$on("$ionicView.beforeEnter", function(){
    console.log("$stateParams",$stateParams);
    $scope.img = $stateParams.img;
    $scope.index = $stateParams.index;
    $scope.currentImage = $scope.img[$stateParams.index];
    if(!!$scope.currentImage.message){
      $scope.message = {
        value: true, text: $stateParams.imageComplete.message,
        totalValue:true
      };
    }else{
      $scope.message = {
        value: false,
        totalValue: false
      };
    }
    $rootScope.removeButton = ($rootScope.allUserInfo.type !== 'user' && $stateParams.canDelete);
    $scope.canDownload = $stateParams.canDownload;
  });

  $scope.$on("$ionicView.beforeLeave", function(){
    console.log('leaving');
    $scope.currentImage = {};
  });

  (function(){
  }());
});
