angular.module('childcareOnApp').controller('VideoViewerCtrl', function($scope, $stateParams, $rootScope, $translate, $ionicHistory, ImageFactory, configuration) {

  var deleteImage = function(){
    if (!$stateParams.custom || $stateParams.custom.type !== 'custom') {
      var index = $rootScope.imagesInfo.findIndex(function (el) {
        return el.$id === $stateParams.videoComplete.$id;
      });
      $rootScope.imagesInfo.$remove(index).then(function(){
        $rootScope.showToast('infoDeletedSuccessfully');
        $ionicHistory.goBack();
      }, function(error) {
        alert($translate.instant('serverError'));
      });
    } else {
      ImageFactory.deleteCustomFolderImage($stateParams.custom.folderId, $stateParams.videoComplete.$id).then(function(){
        $rootScope.showToast('infoDeletedSuccessfully');
        $ionicHistory.goBack();
      },function(){
        alert($translate.instant('serverError'));
      });
    }
  };

  $rootScope.removeInMenu = function(){
    if($rootScope.allUserInfo.type === 'user') return;
    _confirm($translate.instant('gallery_deleteImageTitle'),$translate.instant('gallery_deleteImageText'),$translate.instant('login_forgotPassword_cancelButton'),$translate.instant('yes'),
      function(buttonIndex){
      if(buttonIndex === 2){
        deleteImage();
      }
    });
  };

  $scope.setMessageView = function(){
    if(!$scope.message.totalValue) return;
    $scope.message.value = !$scope.message.value;
  };

  $scope.downloadVideo = function(){
    ImageFactory.getAndAskStoragePermissions('read')
    .then(function() {
      ImageFactory.getAndAskStoragePermissions('write')
      .then(function() {
        var folderName = configuration.appName + " Video";
        $rootScope.showToast('video_downloading');
        console.log($stateParams.videoComplete);
        ImageFactory.downloadImgToGallery($stateParams.videoComplete.image, folderName, $stateParams.videoComplete.date);
      }, function() {
        alert($translate.instant('permission_not_accepted'));
      });
    }, function() {
      alert($translate.instant('permission_not_accepted'));
    });
  };

  $scope.$on("$ionicView.beforeEnter", function(){
    console.log("$stateParams",$stateParams);
    console.log("$stateParams.videoComplete",$stateParams.videoComplete);
    if(typeof $stateParams.videoComplete !== 'undefined' && typeof $stateParams.videoComplete.message !== 'undefined'){
      $scope.message = {
        value: true, text: $stateParams.videoComplete.message,
        totalValue:true
      };
    }else{
      $scope.message = {
        value: false, totalValue:false
      };
    }
    $scope.url = $stateParams.url;
    $rootScope.removeButton = ($rootScope.allUserInfo.type !== 'user' && $stateParams.canDelete);
    $scope.canDownload = $stateParams.canDownload || false;
  });

  (function(){
  }());
});
