angular.module('childcareOnApp').controller('InternalChatDetailCtrl', function($scope, $rootScope, $translate, $state, $stateParams, $ionicScrollDelegate, UserFactory, InternalChatFactory, configuration) {
  console.log("$stateParams",$stateParams);


  //  url! https://github.com/apache/cordova-plugin-media
  // https://stackoverflow.com/questions/48222077/how-to-upload-audio-file-to-firebase-storage
  // https://forum.ionicframework.com/t/firebase-storage-audio/113787/4

  $scope.messageToSend = {text: ''};
  $scope.isRecording = false;
  var mediaRec;
  $scope.pending = [];

  $scope.sendMessage = function(){
    var message = {
      type: "text",
      date: new Date().getTime(),
      message: $scope.messageToSend.text,
      sender: $rootScope.allUserInfo.id,
      senderName: $rootScope.allUserInfo.name
    };
    $scope.pending.push(message);
    setTimeout(function(){
      $ionicScrollDelegate.scrollBottom(true);
    },10);
    console.log("message to send",message);
    $scope.messages.chat.$add(message)
    .then(function(){
      $scope.messageToSend = {text: ''};
      $scope.pending = [];
      setTimeout(function(){
        $ionicScrollDelegate.scrollBottom(true);
      },10);
    },function(error){
      console.log("error al enviar mensaje");
      alert($translate.instant('serverError'));
    });
  };

  $scope.showName = function(index,sender) {
    if($stateParams.key !== 'all' || sender === $rootScope.allUserInfo.id) return false;
    if(index === 0) return true;
    var keys = Object.keys($scope.messages.chat);
    return ($scope.messages.chat[keys[index-1]].sender !== sender);
  };

  $scope.getName = function(key){
    if(key in $rootScope.school.teachers){
      return $rootScope.school.teachers[key];
    }else{
      return $rootScope.school.principals[key];
    }
  };

  $scope.showDay = function(index) {
    if(index === 0) {
      return true;
    }
    var previousMessageKey = Object.keys($scope.messages.chat)[index - 1];
    var previousMessageDate = new Date(parseInt($scope.messages.chat[previousMessageKey].date));
    var currentMessageDate = new Date(parseInt($scope.messages.chat[index].date));
    return (
      previousMessageDate.getDate() !== currentMessageDate.getDate() ||
      previousMessageDate.getMonth() !== currentMessageDate.getMonth() ||
      previousMessageDate.getFullYear() !== currentMessageDate.getFullYear()
    );
  };

  $scope.getDay = function(date) {
    date = new Date(date);
    var today = new Date();
    if (date.getFullYear() !== today.getFullYear()) {
      return date.getDate() + '/' + (date.getMonth() + 1) + '/' + date.getFullYear();
    }
    switch (true) {
      case date.getDate() === today.getDate() && date.getMonth() === today.getMonth(): return $translate.instant('date_today');
      case date.getDate() === (today.getDate() - 1) && date.getMonth() === today.getMonth(): return $translate.instant('date_yesterday');
      default: return date.getDate() + '/' + (date.getMonth() + 1);
    }
  };

  $scope.startRecord = function(){
    function startRecord(){
      console.log("start record!");
      var src = "myrecording.mp3";
      mediaRec = new Media(src,
        // success callback
        function() {
            console.log("recordAudio():Audio Success");
            $scope.$evalAsync(function(){$scope.isRecording = false;});
            setTimeout((function(){
              // media.play();
              console.log("playing!");
              mediaRec.play({ playAudioWhenScreenIsLocked : true });
              mediaRec.setVolume('1.0');
            }),5000);
        },

        // error callback
        function(err) {
            console.log("recordAudio():Audio Error: "+ err.code);
            $scope.$evalAsync(function(){$scope.isRecording = false;});
        });

      // Record audio
      console.log("try to startRecord");
      $rootScope.showToast('audioRecord_recording');
      $scope.$evalAsync(function(){$scope.isRecording = true;});
      mediaRec.startRecord();

      setTimeout(function() {
        console.log("autoStop");
        mediaRec.stopRecord();
    }, 60000);
    }
    function stopRecord(){
      console.log("stop Recording!");
      mediaRec.stopRecord();
    }
    function record(){
      if($scope.isRecording) return stopRecord();
      return startRecord();
    }
    InternalChatFactory.getIfAdviced()
    .then(function(){
      record();
    },function(){
      navigator.notification.alert(
        $translate.instant('audioRecord_usageMessage'),    // message
        function(){
          InternalChatFactory.setStorage();
          record();
        },       // callback
        //"Alert", // title
        configuration.appName,
        $translate.instant('audioRecord_startRecording')        // buttonName
      );
    });
  };

  $scope.$on("$ionicView.beforeEnter", function(){
    $scope.messages = InternalChatFactory.getChats($stateParams.key);
    $scope.key = $stateParams.key;
    console.log("$stateParams",$stateParams);
    switch($stateParams.key){
      case "all": $scope.name = $translate.instant('internalChat_all'); break;
      default:
      var key = $stateParams.key.split("_");
      key = (key[0] === $rootScope.allUserInfo.id)? key[1]:key[0];
      if(key in $rootScope.school.teachers){
        $scope.name = $rootScope.school.teachers[key];
      }else{
        $scope.name = $rootScope.school.principals[key];
      }
      // $scope.photo = UserFactory.getUserPhoto(key);
    }
  });
  $scope.$on("$ionicView.afterEnter", function(){
    setTimeout(function(){
      $ionicScrollDelegate.scrollBottom(true);
    },10);
  });


});
