angular.module('childcareOnApp').controller('LoginCtrl', function($scope, $rootScope, $state, $translate,$ionicPopup, $window, $stateParams, $log, FirebasePluginFactory, CommonFactory) {
    $scope.isLogged = false;
    // Form data for the login modal
    $scope.loginData = {};
    $scope.forgotPasswordData = {email:""};
    $scope.doLogin = function() {
      if(!$scope.loginData.username || !$scope.loginData.password){
        alert($translate.instant('fillFields'));
        return;
      }
      if(typeof cordova !== 'undefined') cordova.plugins.Keyboard.close();
      $rootScope.show();
      $scope.$evalAsync(function(){$scope.isLogged = true;});
      console.log('Doing login', $scope.loginData);
      firebase.auth().signInWithEmailAndPassword($scope.loginData.username, $scope.loginData.password).then(function(user){
        FirebasePluginFactory.logEvent('login'); // save event "login"
        if(typeof cordova !== 'undefined'){
          NativeStorage.setItem("login",{u:$scope.loginData.username,p:$scope.loginData.password}, function(){
            console.log("saved login");
          }, function(error){
            console.log("error on saving login",error);
          });
        }
      }).catch(function(error) {
        $scope.$evalAsync(function(){$scope.isLogged = false;});
        var errorCode = error.code;
        var errorMessage = error.message;
        console.log("login failed",errorCode,errorMessage);
        var msg = "";
        switch(error.code){
          case "auth/invalid-email": msg = $translate.instant('login_error_invalidEmail'); break;
          case "auth/wrong-password": msg = $translate.instant('login_error_wrongPassword'); break;
          case "auth/user-not-found": msg = $translate.instant('login_error_wrongUsername'); break;
          case "auth/network-request-failed": msg = $translate.instant('login_error_network_request_failed'); break;
          default: msg = $translate.instant('login_error_wrongPassword');
        }
        $rootScope.hide();
        $rootScope.showToast(msg);
      });
    };

    $scope.forgotPasswordDo = function(){
      $translate(['login_forgotPassword','login_forgotPasswordText','login_forgotPassword_successSend','login_forgotPassword_cancelButton','email']).then(function(translations){
        $ionicPopup.prompt({
          cssClass: "childcarePopup",
          title: translations.login_forgotPassword,
          template: translations.login_forgotPasswordText,
          inputType: 'email',
          inputPlaceholder: translations.email,
          cancelText:translations.login_forgotPassword_cancelButton
        }).then(function(res) {
           if(res){
             console.log('Your email is', res);
             firebase.auth().sendPasswordResetEmail(res).then(function(){
               alert(translations.login_forgotPassword_successSend + ' ' + res, "Childcare On");
             }).catch(function(e){
               console.log("error sendPasswordResetEmail",e);
               if(e.code === "auth/user-not-found"){
                 alert($translate.instant('login_error_wrongUsername'),$translate.instant('error'))
               }else{
                 alert($translate.instant('login_forgotPassword_errorSend'),$translate.instant('error'));
               }
             });
           }
         });
      });
    };

    $scope.$on("$ionicView.afterEnter", function(){
      if($scope.userInfo && $stateParams.logout){
        $window.location.reload(true);
      }
    });
});
