angular.module('childcareOnApp').controller('AttendanceCtrl', function($scope, $rootScope, $state, $stateParams, $translate, $ionicModal, $ionicHistory, ionicMaterialInk, ionicMaterialMotion, AttendanceFactory, CommonFactory, ChildcareOnUtils, ionicDatePicker) {

  setTimeout(function(){
    ionicMaterialInk.displayEffect();
    ionicMaterialMotion.ripple();
  },500);

  $scope.options = {};
  $scope.visibilityOptions = false;
  $scope.fields = [{
    value: $rootScope.allUserInfo.email
  }];

  var ipObj1 = {
    callback: function (val) {  //Mandatory
      console.log('Return value from the datepicker popup is : ' + val, new Date(val));
      $scope.currentDate = ChildcareOnUtils.parseDateToNumbers(new Date(val));
      $scope.isToday = (new Date(val).toDateString() === new Date().toDateString());
      getAttendance($scope.currentDate);
    },
    from: new Date(2016, 9, 1), //Optional
    titleLabel: $translate.instant('diary_selectADay'),
    todayLabel: $translate.instant('date_today'),
    closeLabel: $translate.instant('diary_close'),
    setLabel: 'Ok',
    weeksList:[$translate.instant('sunday_short'),$translate.instant('monday_short'),$translate.instant('tuesday_short'),$translate.instant('wednesday_short'),$translate.instant('thursday_short'),$translate.instant('friday_short'),$translate.instant('saturday_short')],
    monthsList:[$translate.instant('january'),$translate.instant('february'),$translate.instant('march'),$translate.instant('april'),$translate.instant('may'),$translate.instant('june'),$translate.instant('july'),$translate.instant('august'),$translate.instant('september'),$translate.instant('october'),$translate.instant('november'),$translate.instant('december')]
  };

  $scope.openDatePicker = function(){
    ionicDatePicker.openDatePicker(ipObj1);
  };

  $rootScope.calendarInMenu = function(){
    console.log("calendarInMenu pushed");
    $scope.openDatePicker();
  };

  var getAttendance = function(day){
    console.log("day",day);
    $scope.currentDay = day;
    $scope.dateObject = ChildcareOnUtils.getDateParsed(new Date("20"+day.substr(4,2),parseInt(day.substr(2,2)) -1,day.substr(0,2)));
    if(!$scope.attendance || !$scope.attendance[$rootScope.classSelected.id] || !$scope.attendance[$rootScope.classSelected.id][day]){
      $rootScope.show();
      AttendanceFactory.getAttendance($rootScope.classSelected.id,$scope.currentDay).then(function(attendance){
        if(!$scope.attendance) $scope.attendance = {};
        if(!$scope.attendance[$rootScope.classSelected.id]) $scope.attendance[$rootScope.classSelected.id] = {};
        $scope.attendance[$rootScope.classSelected.id][$scope.currentDay] = attendance;
        $rootScope.hide();
      });
    }
  };

  function updateAttendance(){
    $scope.attendance[$rootScope.classSelected.id][$scope.currentDay].notify = !!($scope.options.sendNotification);
    console.log($scope.attendance[$rootScope.classSelected.id][$scope.currentDay]);
    CommonFactory._save($scope.attendance[$rootScope.classSelected.id][$scope.currentDay]).then(function(){
      $rootScope.showToast('infoSavedSuccessfully');
    },function(){
      $rootScope.showToast('serverError');
    });
  };

  function exportExcel(data) {
    $rootScope.showToast('loading');
    $scope.closeModal();
    AttendanceFactory.exportExcel(data)
    .then(function(body) {
      $rootScope.showToast('sentSuccessfully');
    }, function(error) {
      console.log("error!",error);
      alert("error: "+error);
    });
  }

  $scope.updateAttendance = function(){
    if(!$scope.options.sendNotification) return updateAttendance();
    _confirm($translate.instant('attendance_confirm_title'),$translate.instant('attendance_confirm_text'),$translate.instant('no'),$translate.instant('button_save'),
    function(buttonIndex){
      if(buttonIndex === 2){
        updateAttendance();
      }
    });
  };

  $scope.openOptions = function () {
    $scope.visibilityOptions = !$scope.visibilityOptions;
  };

  $scope.exportExcel = function () {
    var emailTotal = [];
    for(var i=0; i<$scope.fields.length; i++) {
      if ($scope.fields[i].value !== "") {
        emailTotal.push($scope.fields[i].value);
      }
    }
    emailTotal = emailTotal.join(", ");
    console.log("emailTotal",emailTotal);
    return exportExcel({
      email: emailTotal,
      classroomId: $rootScope.classSelected.id,
      schoolId: $rootScope.allUserInfo.school,
      lang: $rootScope.school.lang || "es"
    });
  };

  $scope.addField = function () {
    $scope.fields.push({value: ""});
  };

  var loadAttendance = function(){
    $rootScope.show();
    $scope.currentDate = ChildcareOnUtils.parseDateToNumbers(new Date());
    $scope.isToday = true;
    getAttendance($scope.currentDate);
  };


  $scope.$on("$ionicView.afterEnter", function(){
    $scope.pageTitle = {name:$rootScope.classSelected.name};
    if(!$scope.attendance || !$scope.attendance[$rootScope.classSelected.id]){
      loadAttendance();
    }
  });

  $ionicModal.fromTemplateUrl('modal-exportExcelEmail.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modal = modal;
  });
  $scope.openModal = function() {
    $scope.modal.show();
  };
  $scope.closeModal = function() {
    $scope.modal.hide();
  };

  (function(){
  }());
});
