angular.module('childcareOnApp').controller('AuthorizationsCtrl', function($scope, $rootScope, $state, $translate, $ionicModal, ionicMaterialInk, ionicMaterialMotion, AuthorizationsFactory, CommonFactory, ClassroomFactory, $q, ImageFactory, $ionicActionSheet) {

  setTimeout(function(){
    ionicMaterialInk.displayEffect();
    ionicMaterialMotion.ripple();
  },500);
  
  $scope.docDisabled = false;
  $scope.descriptionOpened = false;
  $scope.fileUploaded = false;
  $scope.docRoute = "";
  $scope.progress = {};
  $scope.uploading = {};
  $scope.addAuthorizationParams = {};
  $scope.classroomsToSend = {};
  $scope.userAuthorizationSelected = false;
  try {
    $scope.userAuthorization = {
      device: {
        deviceUuid: device.uuid,
        deviceModel: device.model,
        deviceVersion: device.version
      }
    };
  } catch (error) {
    console.log('error getting users device');
    $scope.userAuthorization = {};
  }
  var docLink;
  if ($rootScope.allUserInfo.type !== 'user') {
    $scope.students = ClassroomFactory.getStudentsClassroom($rootScope.classSelected.id);
    $rootScope.addInMenu = function() {
      $scope.addAuthorization();
    }
  }

  function uploadDocument (file){
    return $q(function(resolve,reject){
      if(typeof file === 'undefined'){
        reject('undefined');
        return;
      }
      if(file.indexOf('application/pdf') === -1){
        alert($translate.instant('communications_noPdf'));
        reject('noPdf');
      }
      file = file.split('base64,');
      file = file[file.length -1];
      $scope.$evalAsync(function () {
        $scope.uploading.document = true;
        $scope.progress.document = 0;
      });

      var interval = setInterval(function() {
        $scope.$evalAsync(function () {
          $scope.progress.document = ImageFactory.getPercentageProgress();
        });
      }, 200);

      ImageFactory.uploadDocumentDefault(file, "application/pdf", 'authorizations', false).then(function(url){
        docLink = url;
        $scope.addAuthorizationParams.document = url;
        console.log('file uploaded', $scope.addAuthorizationParams);
        delete $rootScope.documentUrl;
        clearInterval(interval);
        resolve();
      },function(){
        clearInterval(interval);
        reject('error');
      });
    });
  };

  function onSuccess(imageData) {
    console.log("success",imageData);
    var date = new Date().getTime();
    $scope.uploading.image = true;
    $scope.fileUploaded = true;
    var interval = setInterval(function() {
      $scope.$evalAsync(function () {
        $scope.progress.image = ImageFactory.getPercentageProgress();
      });
    }, 200);
    ImageFactory.saveImage(imageData, 'authorizations/' + $rootScope.allUserInfo.school, date, 'image/jpeg', false).then(function(url){
      console.log("imagen subida",url);
      $rootScope.showToast("imageUpdatedSuccess");
      if(!$scope.addAuthorizationParams.images) {
        $scope.addAuthorizationParams.images = {};
      }
      $scope.addAuthorizationParams.images[date] = {image: url};
      $scope.uploading.image = false;
      delete $scope.progress.image;
      clearInterval(interval);
      setTimeout(function() {
        $scope.$evalAsync(function() {
          $scope.fileUploaded = false;
        });
      }, 3000);
    },function(){
      clearInterval(interval);
      alert($translate.instant('serverError'));
      $scope.uploading.image = false;
    });
  }

  $scope.authTypes = [
    {name: 'yes',value: true},
    {name: 'no',value: false}
  ];

  $scope.relationshipTypes = [{
    name: "profile_parentType_father",
    value: "father"
  },{
    name: "profile_parentType_mother",
    value: "mother"
  },{
    name: "profile_parentType_other",
    value: "other"
  }];
  // Cleanup the modal when we're done with it!
  $scope.$on('$destroy', function() {
    if (!!$scope.modalAnswers) {
      $scope.modalAnswers.remove();
    }
    if (!!$scope.modalUserAnswer) {
      $scope.modalUserAnswer.remove();
    }
    if (!!$scope.modalAdd) {
      $scope.modalAdd.remove();
    }
  });

  $ionicModal.fromTemplateUrl('modal-add.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modalAdd = modal;
  });

  $ionicModal.fromTemplateUrl('modal-answers.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modalAnswers = modal;
  });
  $scope.openModalAnswers = function(item) {
    $scope.authorizationSelected = item;
    $scope.modalAnswers.show();
  };
  $scope.closeModalAuth = function() {
    console.log("entra closeModalAuth");
    $scope.modalAnswers.hide();
  };

  if ($rootScope.allUserInfo.type === 'user') {
    $ionicModal.fromTemplateUrl('modal-user-answer.html', {
      scope: $scope,
      animation: 'slide-in-up'
    }).then(function(modal) {
      $scope.modalUserAnswer = modal;
    });
  }
  $scope.openModalUserAnswer = function(authorization) {
    console.log("openModalUserAnswer id",authorization);
    if(authorization.hasOwnProperty('answers') && authorization.answers.hasOwnProperty($rootScope.childSelected) && authorization.answers[$rootScope.childSelected].hasOwnProperty($rootScope.allUserInfo.id)){
      return alert($translate.instant('excursion_authDone'));
    }
    $scope.userAuthorizationSelected = authorization;
    $scope.modalUserAnswer.show();
  };
  $scope.closeModalUserAuth = function() {
    $scope.modalUserAnswer.hide();
  };

  $rootScope.removeInMenu = function(){
    $scope.$evalAsync(function(){$scope.isEdit = !$scope.isEdit});
  };

  var mandatoryProperties = ['title','description'];
  $scope.sendAddAuthorization = function(){
    for(var i=0; i< mandatoryProperties.length; i++){
      if(!$scope.addAuthorizationParams[mandatoryProperties[i]]){
        alert($translate.instant('fillFields'));
        return;
      }
    }
    var classroomsToSend = false;
    for(var i in $scope.classroomsToSend){
      if($scope.classroomsToSend[i] === true && i !== $rootScope.classSelected.id){
        if(!classroomsToSend) classroomsToSend = [];
        classroomsToSend.push(i);
      }
    }
    $scope.addAuthorizationParams.date = new Date().getTime();
    $scope.authorizations.$add($scope.addAuthorizationParams).then(function(){
      if(classroomsToSend){
        AuthorizationsFactory.addToClassrooms($scope.addAuthorizationParams, classroomsToSend);
      }
      $scope.addAuthorizationParams = {};
      $scope.modalAdd.hide();
    },function(error){
      console.log("error add excursion",error);
      $rootScope.showToast('serverError');
    });
  };

  $scope.changeItem = function(item){
    $scope[item] = !($scope[item]);
  };

  $scope.addAuthorization = function() {
    $scope.modalAdd.show();
  };

  $scope.sendAnswer = function(){
    var index = $scope.authorizations.indexOf($scope.userAuthorizationSelected);
    console.log("$scope.authorizations",$scope.authorizations, index);
    var childId = $rootScope.childSelected;
    if(!$scope.authorizations[index].hasOwnProperty('answers')) $scope.authorizations[index].answers = {};
    if(!$scope.authorizations[index].answers[$rootScope.childSelected]) $scope.authorizations[index].answers[$rootScope.childSelected] = {};
    if(!$scope.authorizations[index].answers[$rootScope.childSelected][$rootScope.allUserInfo.id]) $scope.authorizations[index].answers[$rootScope.childSelected][$rootScope.allUserInfo.id] = {};
    $scope.userAuthorization.date = new Date().getTime();
    $scope.authorizations[index].answers[$rootScope.childSelected][$rootScope.allUserInfo.id] = $scope.userAuthorization;

    if(
      !$scope.authorizations[index].answers[$rootScope.childSelected][$rootScope.allUserInfo.id].relationship
      || !$scope.authorizations[index].answers[$rootScope.childSelected][$rootScope.allUserInfo.id].dni
      || !$scope.authorizations[index].answers[$rootScope.childSelected][$rootScope.allUserInfo.id].auth
    ){
      alert($translate.instant('fillFields'));
      return;
    }
    $scope.authorizations[index].answers[$rootScope.childSelected][$rootScope.allUserInfo.id].name = $rootScope.allUserInfo.name + " " + $rootScope.allUserInfo.surname;
    try {
      $scope.authorizations[index].answers[$rootScope.childSelected][$rootScope.allUserInfo.id].device = {
        deviceUuid: device.uuid,
        deviceModel: device.model,
        deviceVersion: device.version
      };
    } catch (error) {
      console.log('error adding device', error);
    }
    $scope.authorizations.$save(index).then(function(){
      $rootScope.showToast('infoSavedSuccessfully');
      $scope.userAuthorizationSelected = false;
      $scope.closeModalUserAuth();
    },function(error){
      $rootScope.showToast('serverError');
      console.log("error saving auth excursion");
    });
  };

  $scope.uploadImage = function(){
    if (!$scope.userAuthorization.images) {
      $scope.userAuthorization.images = {};
    }
    if(Object.keys($scope.userAuthorization.images).length >= 4){
      return alert($translate.instant('auth_maximumImages'));
    }
    $translate(['communications_selectImage','communications_imageTitle','communications_camera','communications_gallery','login_forgotPassword_cancelButton']).then(function(t){
      navigator.notification.confirm(
        t.communications_selectImage, // message
         function(index){
           if(index === 2) return;
           var source = (index === 1)? Camera.PictureSourceType.CAMERA: Camera.PictureSourceType.PHOTOLIBRARY;
           navigator.camera.getPicture(onSuccess, null, { correctOrientation:true,quality: 80,targetWidth: 1080, targetHeight:1020, sourceType: source,
             destinationType: Camera.DestinationType.DATA_URL, encodingType: Camera.EncodingType.JPEG
           });
         },
        t.communications_imageTitle,           // title
        [t.communications_camera, t.login_forgotPassword_cancelButton, t.communications_gallery]     // buttonLabels
      );
    });
  };

  $scope.openDescription = function(id) {
    if ($scope.descriptionOpened === id) {
      $scope.descriptionOpened = false;
    } else {
      $scope.$evalAsync(function() {
        $scope.descriptionOpened = id;
      });
    }
  };

  $scope.finishUpload = function(file) {
    if (typeof file === 'undefined' || !file) {
      return false;
    }
    console.log("finish upload");
    uploadDocument(file).then(function(){
      $scope.$evalAsync(function() {
        $scope.docDisabled = true;
        $scope.uploading.document = false;
      });
    },function(error){
      if(error === 'error') alert($translate.instant('serverError'));
    });
  };

  $scope.removeAuthorization = function(item) {
    _confirm($translate.instant('button_delete'), $translate.instant('confirmRemoveGeneric') ,$translate.instant('login_forgotPassword_cancelButton'), $translate.instant('button_delete'), function(buttonIndex){
      if(buttonIndex === 2){
        $scope.authorizations.$remove(item)
        .then(function () {
          $rootScope.showToast('infoDeletedSuccessfully');
        }, function () {
          alert($translate.instant('serverError'));
        });
      }
    });
  };

  $scope.optionsAuthorization = function(item) {
    var options = {
      buttons: [
        { text: '<i class="icon ion-eye"></i>'+ $translate.instant('auth_seeAnswers') },
        { text: '<i class="icon ion-android-download"></i>'+ $translate.instant('catalog_description') }
      ],
      titleText: item.title,
      cancelText: $translate.instant('login_forgotPassword_cancelButton'),
      cancel: function() {
        // add cancel code..
      },
      buttonClicked: function(index) {
        console.log('button clicked', index);
        switch(index) {
          case 0: $scope.openModalAnswers(item); break;
          case 1: $scope.openDescription(item.$id); break;
          default: console.log('default');
        }
        return true;
      }
    };
    if ($rootScope.allUserInfo.type === 'principal') {
      options.destructiveText = '<i class="icon ion-trash-a"></i>'+ $translate.instant('documents_delete');
      options.destructiveButtonClicked = function() {
        $scope.removeAuthorization(item);
      }
    }
    $ionicActionSheet.show(options);
  };

  $scope.seeImage = function(image) {
    $state.go('app.imageViewer',{img:image.image, canDelete: false, canDownload:true, imageComplete: image});
  };

  $scope.seeDocument = function(documentUrl) {
    $rootScope.show();
    inAppBrowserRef = cordova.InAppBrowser.open(documentUrl, "_blank", "location=yes,hidden=yes,shouldPauseOnSuspend=yes");

    inAppBrowserRef.addEventListener('loadstart', function() {
      console.log('loadstart');
    });

    inAppBrowserRef.addEventListener('loadstop', function() {
      console.log('loadStop');
      $rootScope.hide();
      inAppBrowserRef.show();
    });

    inAppBrowserRef.addEventListener('loaderror', function() {
      console.log('loaderror');
      $rootScope.show();
      window.open(documentUrl, '_system', 'location=false');
    });
  };

  $scope.$on("$ionicView.afterEnter", function(){
    console.log("$rootScope.students",$rootScope.students);
    var classroomId = ($rootScope.allUserInfo.type === 'user')? $rootScope.allUserChilds[$rootScope.childSelected].classroomId : $rootScope.classSelected.id;
    if($rootScope.allUserInfo.type !== 'user'){
      $scope.classroomsToSend[$rootScope.classSelected.id] = true;
    }
    if(!$scope.authorizations || $scope.authorizations.$id !== classroomId){
      $scope.authorizations = AuthorizationsFactory.get(classroomId);
    }
  });


  (function(){
  }());
});
