angular.module('childcareOnApp').controller('DocumentsCtrl', function($scope, $rootScope, $translate, $ionicModal, $q, ionicMaterialInk, ionicMaterialMotion, DocumentsFactory, ImageFactory) {

  ionicMaterialInk.displayEffect();
  ionicMaterialMotion.ripple();
  var inAppBrowserRef;

  $scope.documentAdd = {};
  $scope.file = false;
  $scope.isEdit = false;
  $scope.docDisabled = false;

  if($rootScope.allUserInfo.type === 'user') var schoolId = $rootScope.allUserChilds[$rootScope.childSelected].school;
  else var schoolId = $rootScope.allUserInfo.school;
  $scope.documents = DocumentsFactory.getDocuments(schoolId);
  console.log("documents",$scope.documents);

  var uploadDocument = function(){
    return $q(function(resolve,reject){
      if ($scope.documentAdd.type === 'link') {
        resolve();
        return;
      }
      var date = new Date().getTime().toString();
      var location = 'documents/'+ $rootScope.allUserInfo.school;
      ImageFactory.saveImageFromBlob($scope.file, location, date, $scope.file.type, true)
      .then(function (url) {
        $scope.docLink = url;
        $scope.documentAdd.url = url;
        $scope.documentAdd.location =  location + '/' + date + '.pdf';
        $scope.file = false;
        resolve();
      }, function() {
        $scope.file = false;
        reject('error');
      });
    });
  };

  function finishSendDocument() {
    $rootScope.hide();
    alert($translate.instant('infoSavedSuccessfully'));
    $scope.closeModal();
    $scope.documentAdd = {};
    $scope.docDisabled = false;
  }

  $scope.sendDocument = function(){
    if(!$scope.documentAdd.name || !$scope.documentAdd.type || (!$scope.documentAdd.url && $scope.documentAdd.type === 'link')){
      return alert($translate.instant('fillFields'));
    }
    $rootScope.show();
    uploadDocument().then(function(){
      DocumentsFactory.addMenuDocument($scope.documentAdd).then(function(){
        finishSendDocument();
      }, function(){
        alert($translate.instant('serverError'));
      });
    }, function(){
      alert($translate.instant('serverError'));
    });
  };

  $scope.removeDocument = function(item){
    _confirm($translate.instant('button_delete'), $translate.instant('confirmRemoveGeneric') ,$translate.instant('login_forgotPassword_cancelButton'), $translate.instant('button_accept'), function(buttonIndex){
      if(buttonIndex === 2){
        $scope.documents.$remove(item)
        .then(function(){
          $rootScope.showToast('infoDeletedSuccessfully');
        },function(error){
          console.log("error removeDocument",error);
          alert($translate.instant('serverError'));
        });
      }
    });
  };

  $rootScope.removeInMenu = function(){
    $scope.$evalAsync(function(){$scope.isEdit = !$scope.isEdit});
  };

  $ionicModal.fromTemplateUrl('modal-add.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modal = modal;
  });
  $scope.openModal = function() {
    $scope.modal.show();
  };
  $scope.closeModal = function() {
    $scope.modal.hide();
  };
  // Cleanup the modal when we're done with it!
  $scope.$on('$destroy', function() {
    if (!!$scope.modal) {
      $scope.modal.remove();
    }
  });

  // $scope.$watch('$root.documentUrl', function(newV,oldV) {
  //   console.log("se actualiza documentUrl!",newV);
  //   console.log(typeof newV !== 'undefined');
  //   console.log(oldV !== newV);
  //   if(typeof newV !== 'undefined' && oldV !== newV){
  //     console.log("aqui entraaa!", typeof $rootScope.documentUrl);
  //     $scope.$evalAsync(function(){$scope.docDisabled = true;});
  //   }
  // });

  $scope.finishUpload = function(file) {
    if (typeof file === 'undefined' || !file) {
      return false;
    }
    console.log("finish upload");

    $scope.$evalAsync(function(){$scope.docDisabled = true;});
    $scope.file = file;
  };

  $scope.openDocument = function(item){
    console.log("item is",item);
    if (item.url.indexOf('http') === -1) {
      item.url = 'http://' + item.url;
    }
    if (item.type === 'link') {
      window.open(item.url, '_system', 'location=false');
    } else {
      $rootScope.show();
      ImageFactory.openDocument(item)
      .then(function() {
        $rootScope.hide();
      }, function() {
        $rootScope.hide();
        window.open(item.url, '_system', 'location=true');
      });
    }
  };

});
