angular.module('childcareOnApp').controller('ExcursionCtrl', function($scope, $rootScope, $state, $translate, $ionicModal, ionicMaterialInk, ionicMaterialMotion, ExcursionFactory, CommonFactory, ClassroomFactory, NotificationFactory, configuration) {

  setTimeout(function(){
    ionicMaterialInk.displayEffect();
    ionicMaterialMotion.ripple();
  },500);

  $scope.isModalShowMore = false;
  $scope.detailShowMore = false;
  $scope.authTypes = [
    {name: 'yes',value: true},
    {name: 'no',value: false}
  ];

  $scope.showMoreProperties = [
    {
      name: 'excursion_clothes',
      value: 'clothes'
    },
    {
      name: 'excursion_price',
      value: 'price'
    },
    {
      name: 'excursion_schedule',
      value: 'schedule'
    },
    {
      name: 'excursion_departurePlace',
      value: 'departurePlace'
    },
    {
      name: 'excursion_transport',
      value: 'transport'
    },
    {
      name: 'excursion_food',
      value: 'food'
    },
    {
      name: 'diary_comments',
      value: 'comments'
    }
  ];

  $scope.relationshipTypes = [{
    name: "profile_parentType_father",
    value: "father"
  },{
    name: "profile_parentType_mother",
    value: "mother"
  },{
    name: "profile_parentType_other",
    value: "other"
  }];

  $scope.modalShowMore = function() {
    $scope.isModalShowMore = true;
  };
  
  $scope.seeMoreInfo = function(id) {
    $scope.detailShowMore = id;
  };

  $ionicModal.fromTemplateUrl('modal-classrooms.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modal = modal;
  });
  $scope.openModal = function() {
    $scope.modal.show();
  };
  $scope.closeModal = function() {
    $scope.modal.hide();
  };
  // Cleanup the modal when we're done with it!
  $scope.$on('$destroy', function() {
    if (!!$scope.modal) {
      $scope.modal.remove();
    }
    if (!!$scope.modalAuth) {
      $scope.modalAuth.remove();
    }
    if (!!$scope.modalUserAuth) {
      $scope.modalUserAuth.remove();
    }
    if (!!$scope.modalAdd) {
      $scope.modalAdd.remove();
    }
  });

  $ionicModal.fromTemplateUrl('modal-add.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modalAdd = modal;
  });

  $ionicModal.fromTemplateUrl('modal-authorizations.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modalAuth = modal;
  });
  $scope.openModalAuth = function(item) {
    $scope.excursionSelected = item;
    if(!$rootScope.classroom){
      $rootScope.show();
      ClassroomFactory.getClassroomStudents($rootScope.classSelected.id).then(function(classroom){
        console.log("classroom selected",classroom);
        $rootScope.classroom = classroom;
        $scope.modalAuth.show();
      },function(){
        alert($translate.instant('serverError'));
      }).finally($rootScope.hide);
    }else{
      $scope.modalAuth.show();
    }
  };
  $scope.closeModalAuth = function() {
    console.log("entra closeModalAuth");
    $scope.modalAuth.hide();
  };

  $ionicModal.fromTemplateUrl('modal-user-authorization.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modalUserAuth = modal;
  });
  $scope.openModalUserAuth = function(excursion) {
    console.log("openModalUserAuth id",excursion);
    if(excursion.hasOwnProperty('authorizations') && excursion.authorizations.hasOwnProperty($rootScope.childSelected) && excursion.authorizations[$rootScope.childSelected].hasOwnProperty($rootScope.allUserInfo.id)){
      return alert($translate.instant('excursion_authDone'));
    }
    $scope.userExcursionSelected = excursion;
    $scope.modalUserAuth.show();
  };
  $scope.closeModalUserAuth = function() {
    $scope.modalUserAuth.hide();
  };

  $scope.addExcursionParams = {};
  $scope.classroomsToSend = {};
  $scope.userExcursionSelected = false;
  try {
    $scope.userAuthorization = {
      device: {
        deviceUuid: device.uuid,
        deviceModel: device.model,
        deviceVersion: device.version
      }
    };
  } catch (error) {
    console.log('error getting users device');
    $scope.userAuthorization = {};
  }

  $rootScope.removeInMenu = function(){
    $scope.$evalAsync(function(){$scope.isEdit = !$scope.isEdit});
  };

  var excursionProperties = ['activity','place','dateStart','dateFinish'];
  $scope.sendAddExcursion = function(){
    if(!$scope.addExcursionParams.moreThanOneDay){
      $scope.addExcursionParams.dateFinish = $scope.addExcursionParams.dateStart;
    }
    for(var i=0; i< excursionProperties.length; i++){
      if(!$scope.addExcursionParams[excursionProperties[i]]){
        alert($translate.instant('fillFields'));
        return;
      }
    }
    $scope.isModalShowMore = false;
    var classroomsToSend = false;
    for(var i in $scope.classroomsToSend){
      if($scope.classroomsToSend[i] === true && i !== $rootScope.classSelected.id){
        if(!classroomsToSend) classroomsToSend = [];
        classroomsToSend.push(i);
      }
    }
    delete $scope.addExcursionParams.moreThanOneDay;
    $scope.excursion.$add($scope.addExcursionParams).then(function(){
      if(classroomsToSend){
        ExcursionFactory.addToClassrooms($scope.addExcursionParams, classroomsToSend);
      }
      $scope.addExcursionParams = {};
      $scope.modalAdd.hide();
    },function(error){
      console.log("error add excursion",error);
      $rootScope.showToast('serverError');
    });
  };

  $scope.changeItem = function(item){
    $scope[item] = !($scope[item]);
  };

  $scope.addExcursion = function() {
    $scope.modalAdd.show();
  };

  $scope.sendAuth = function(){
    var index = $scope.excursion.indexOf($scope.userExcursionSelected);
    console.log("$scope.excursion",$scope.excursion, index);
    var childId = $rootScope.childSelected;
    if(!$scope.excursion[index].hasOwnProperty('authorizations')) $scope.excursion[index].authorizations = {};
    if(!$scope.excursion[index].authorizations[$rootScope.childSelected]) $scope.excursion[index].authorizations[$rootScope.childSelected] = {};
    if(!$scope.excursion[index].authorizations[$rootScope.childSelected][$rootScope.allUserInfo.id]) $scope.excursion[index].authorizations[$rootScope.childSelected][$rootScope.allUserInfo.id] = {};
    $scope.userAuthorization.date = new Date().getTime();
    $scope.excursion[index].authorizations[$rootScope.childSelected][$rootScope.allUserInfo.id] = $scope.userAuthorization;

    if(
      !$scope.excursion[index].authorizations[$rootScope.childSelected][$rootScope.allUserInfo.id].relationship
      || !$scope.excursion[index].authorizations[$rootScope.childSelected][$rootScope.allUserInfo.id].dni
      || !$scope.excursion[index].authorizations[$rootScope.childSelected][$rootScope.allUserInfo.id].auth
    ){
      alert($translate.instant('fillFields'));
      return;
    }
    $scope.excursion[index].authorizations[$rootScope.childSelected][$rootScope.allUserInfo.id].name = $rootScope.allUserInfo.name + " " + $rootScope.allUserInfo.surname;
    $scope.excursion.$save(index).then(function(){
      if($scope.excursion[index].authorizations[$rootScope.childSelected][$rootScope.allUserInfo.id].auth.value){
        var _dateStart = angular.copy($scope.excursion[index].dateStart.toString());
        console.log("dateStart",_dateStart);
        var day = _dateStart.substr(0,2), month = parseInt(_dateStart.substr(2,2)-1), year = _dateStart.substr(4,4);
        var firstNotification = new Date(year,month,day); firstNotification.setDate(firstNotification.getDate() - 1); firstNotification.setHours(15);
        var secondNotification = new Date(year,month,day); secondNotification.setHours(8);
        console.log("notification dates",firstNotification,secondNotification);
        NotificationFactory.setLocalNotification(
          "2"+firstNotification.getTime().toString().substr(1,5),
          $translate.instant('menu_excursion') + " - " + configuration.appName,
          $translate.instant('notifications_remember') + ": "+ $translate.instant('notifications_tomorrowExcursion') +$scope.excursion[index].activity,
          firstNotification
        );
        NotificationFactory.setLocalNotification(
          "2"+secondNotification.getTime().toString().substr(1,5),
          $translate.instant('menu_excursion') + " - " + configuration.appName,
          $translate.instant('notifications_remember') + ": "+ $translate.instant('notifications_todayExcursion') +$scope.excursion[index].activity,
          secondNotification
        );
      }
      $rootScope.showToast('infoSavedSuccessfully');
      $scope.userExcursionSelected = false;
      $scope.closeModalUserAuth();
    },function(error){
      $rootScope.showToast('serverError');
      console.log("error saving auth excursion");
    });
  };



  $scope.$on("$ionicView.afterEnter", function(){
    console.log("$rootScope.students",$rootScope.students);
    var classroomId = ($rootScope.allUserInfo.type === 'user')? $rootScope.allUserChilds[$rootScope.childSelected].classroomId : $rootScope.classSelected.id;
    if($rootScope.allUserInfo.type !== 'user'){
      $scope.classroomsToSend[$rootScope.classSelected.id] = true;
    }
    if(!$scope.excursion || $scope.excursion.$id !== classroomId){
      $rootScope.show();
      ExcursionFactory.getExcursion(classroomId).then(function(excursion){
        $scope.excursion = excursion;
        $rootScope.hide();
      });
    }
  });


  (function(){
  }());
});
