angular.module('childcareOnApp').controller('MySchoolInfoCtrl', function($scope, $rootScope, $state, $translate, ionicMaterialInk, ionicMaterialMotion, AdminProfilesFactory, CommonFactory, ImageFactory) {

  setTimeout(function(){
    ionicMaterialInk.displayEffect();
    ionicMaterialMotion.ripple();
  },500);

  $scope.ytText = $translate.instant('youtube_channel_img').replace('&lt;','<').replace('&gt;','>');

  $scope.languages = ['es', 'ca', 'en'];

  $scope.openMaps = function(){
    if($rootScope.allUserInfo.type === 'user'){
      var geoQuery = $scope.school.geoQuery;
    }else{
      var geoQuery = $rootScope.school.geoQuery;
    }
    if($rootScope.isAndroid){
      window.open("geo://0,0?q="+geoQuery, '_system', 'location=yes');
    }else{
      window.open("maps://?q="+geoQuery, '_system', 'location=yes');
    }
  };
  $scope.openPhone = function(phoneNumber){
    if(!phoneNumber){
      if($rootScope.allUserInfo.type === 'user'){
        phoneNumber = $scope.school.phoneNumber;
      }else{
        phoneNumber = $rootScope.school.phoneNumber;
      }
    }
    window.open("tel:"+phoneNumber, '_system', 'location=yes');
  };

  $scope.openLink = function() {
    if($rootScope.allUserInfo.type === 'user'){
      var website = $scope.school.website;
    }else{
      var website = $rootScope.school.website;
    }
    if (website.indexOf('http') === -1) {
      website = 'https://' + website;
    }
    window.open(website, '_system', 'location=yes');
  };

  $scope.openSocial = function(media){
    var mediaName;
    switch(media) {
      case 'youtube': mediaName = 'youtubeChannel'; break;
      case 'facebook': mediaName = 'facebook'; break;
      case 'instagram': mediaName = 'instagram'; break;
      case 'twitter': mediaName = 'twitter'; break;
      default: mediaName = 'youtubeChannel';
    }
    if($rootScope.allUserInfo.type === 'user'){
      var website = $scope.school[mediaName];
    }else{
      var website = $rootScope.school[mediaName];
    }
    window.open(website, '_system', 'location=yes');
  };

  $scope.updateSchool = function(){
    CommonFactory._save($rootScope.school).then(function(){
      $rootScope.showToast('infoSavedSuccessfully');
    },function(){
      $rootScope.showToast('serverError');
    });
  };

  $scope.changeImage = function(){
    navigator.camera.getPicture(onSuccess, onFail, { correctOrientation:true,quality: 60,targetWidth: 800, targetHeight:800,sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
      destinationType: Camera.DestinationType.DATA_URL, encodingType: Camera.EncodingType.PNG
    });
  };

  function onSuccess(imageData) {
    console.log("success",imageData);
    $rootScope.show();
    ImageFactory.saveImage(imageData, "info", $rootScope.allUserInfo.school).then(function(url){
      $rootScope.school.image = url;
      $rootScope.school.$save()
      .then(function() {
        $rootScope.hide();
        alert($translate.instant('imageUpdatedSuccess'));
      }, function(error) {
        $rootScope.hide();
        console.log('error', error);
        alert($translate.instant('serverError'));
      });
    },function(){
      alert($translate.instant('serverError'));
    });
  }

  function onFail(message) {
    if(message.indexOf('cancelled') === -1) alert($translate.instant('imageUpdatedError'));
    console.log('Failed because: ' + message);
  }

  $scope.$on("$ionicView.afterEnter", function(){
    if($rootScope.allUserInfo.type === 'user'){
      if(!$scope.school || $rootScope.allUserChilds[$rootScope.childSelected].school !== $scope.school.$id){
        if($scope.school) console.log($rootScope.allUserChilds[$rootScope.childSelected].school,$scope.school.$id);
        $scope.school = AdminProfilesFactory.getSchool($rootScope.allUserChilds[$rootScope.childSelected].school);
      }
    }
  });


  (function(){
  }());
});
