angular.module('childcareOnApp').controller('MarksCtrl', function($scope, $rootScope, $translate, ionicMaterialInk, ionicMaterialMotion, MarksFactory, DiaryFactory, CommonFactory) {

  ionicMaterialInk.displayEffect();
  ionicMaterialMotion.ripple();
  var studentId, childTitle, schoolId;
  $scope.quarters = ['firstQuarter','secondQuarter','thirdQuarter'];
  $scope.addMarkParams = {firstQuarter:{},secondQuarter:{},thirdQuarter:{}};

  $scope.clickAddMark = function(quarter){
    console.log("entra clickAddMark",quarter);
    if("show" in $scope.addMarkParams[quarter]) $scope.addMarkParams[quarter].show = !$scope.addMarkParams[quarter].show;
    else $scope.addMarkParams[quarter].show = true;
  };

  $scope.addMark = function(quarter){
    console.log("entra addMark",quarter);
    console.log("params",$scope.addMarkParams[quarter]);
    if(!$scope.marks[quarter]) $scope.marks[quarter] = [];
    $scope.marks[quarter].push($scope.addMarkParams[quarter]);
    console.log("marks",$scope.marks[quarter]);
    $scope.addMarkParams[quarter] = {};
    saveMarks(true);
  };

  $scope.removeMarks = function(item,quarter){
    console.log("entra removeMark",item,quarter);
    var index = $scope.marks[quarter].indexOf(item);
    $scope.marks[quarter].splice(index, 1);
    saveMarks(false);
  };

  $rootScope.removeInMenu = function(){
    $scope.$evalAsync(function(){$scope.shouldShowDelete = !$scope.shouldShowDelete});
  };

  var saveMarks = function(isAdding){
    CommonFactory._save($scope.marks).then(function(){
      if(isAdding) $rootScope.showToast('infoSavedSuccessfully');
      else $rootScope.showToast('infoDeletedSuccessfully');
    },function(){
      alert($translate.instant('serverError'));
    });
  };

  var loadMarks = function(){
    MarksFactory.getMarks(studentId).then(function(marks){
      $scope.marks = marks;
    },function(){
      $rootScope.showToast("serverError");
    });
  };

  $scope.$on("$ionicView.afterEnter", function(){
    $scope.shouldShowDelete = false;
    if($rootScope.allUserInfo.type === 'user'){
      studentId = $rootScope.childSelected;
      childTitle = $rootScope.allUserChilds[$rootScope.childSelected].name.split(" ");
      schoolId = $rootScope.allUserChilds[$rootScope.childSelected].school;
      $scope.classroomId = $rootScope.allUserChilds[$rootScope.childSelected].classroomId;
      $scope.childTitle = {name:childTitle[0]};
    }else{
      studentId = $rootScope.studentSelected.id;
      childTitle = $rootScope.studentSelected.name.split(" ");
      $scope.childTitle = {name:childTitle[0]};
      schoolId = $rootScope.allUserInfo.school;
      $scope.classroomId = $rootScope.classSelected.id;
      if(!$rootScope.dictionary) DiaryFactory.getDictionary().then(function(dictionary){
        $rootScope.dictionary = dictionary;
      });
    }
    if(!$scope.marks || $scope.marks.$id != studentId) loadMarks();
  });

  (function(){
  }());
});
