angular.module('childcareOnApp').controller('MeetingCtrl', function($scope, $rootScope, $state, $stateParams, $translate, $ionicModal, ionicMaterialInk, ionicMaterialMotion, MeetingFactory, NotificationFactory, configuration) {

  setTimeout(function(){
    ionicMaterialInk.displayEffect();
    ionicMaterialMotion.ripple();
  },500);

  $scope.answerTypes = [
    {name: 'yes',value: true},
    {name: 'no',value: false}
  ];

  $scope.relationshipTypes = [{
    name: "profile_parentType_father",
    value: "father"
  },{
    name: "profile_parentType_mother",
    value: "mother"
  },{
    name: "profile_parentType_other",
    value: "other"
  }];

  $scope.addMeetingParams = {};
  $scope.userMeetingSelected = false;

  $scope.$on('$destroy', function() {
    if (!!$scope.modalAdd) {
      $scope.modalAdd.remove();
    }
  });

  $ionicModal.fromTemplateUrl('modal-add.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modalAdd = modal;
  });

  $scope.addMeeting = function() {
    $scope.modalAdd.show();
  };

  $scope.changeItem = function(item){
    $scope[item] = !($scope[item]);
  };

  $scope.modifyAnswer = function(id){
    if($scope.userMeetingSelected !== id) $scope.userMeetingSelected = id;
    else $scope.userMeetingSelected = false;
  };

  $rootScope.removeInMenu = function(){
    $scope.$evalAsync(function(){$scope.isEdit = !$scope.isEdit});
  };

  $scope.sendAddMeeting = function(){
    if(!$scope.addMeetingParams.date || !$scope.addMeetingParams.hour || !$scope.addMeetingParams.reason){
      alert($translate.instant('fillFields'));
      return;
    }
    $scope.addMeetingParams.senderName = $rootScope.allUserInfo.name;
    $scope.addMeetingParams.timestamp = new Date(
      parseInt($scope.addMeetingParams.date.substring(4,8)),
      (parseInt($scope.addMeetingParams.date.substring(2,4)) -1),
      parseInt($scope.addMeetingParams.date.substring(0,2))
    ).getTime();

    $scope.meeting.$add($scope.addMeetingParams).then(function(){
      $scope.addMeetingParams = {};
      $scope.modalAdd.hide();
      alert($translate.instant('infoSavedSuccessfully'));
    },function(error){
      console.log("error add meeting",error);
      $rootScope.showToast('serverError');
    });
  };

  $scope.sendAnswer = function(item, isClassroom){
    console.log("$scope.meeting",$scope.meeting, item);
    if(
      !item.answers[$rootScope.allUserInfo.id].relationship
      || !item.answers[$rootScope.allUserInfo.id].answer
    ){
      alert($translate.instant('fillFields'));
      return;
    }
    try {
      item.answers[$rootScope.allUserInfo.id].date = new Date().getTime();
      item.answers[$rootScope.allUserInfo.id].device = {
        deviceUuid: device.uuid,
        deviceModel: device.model,
        deviceVersion: device.version
      };
    } catch (error) {
      console.log('error setting device');
    }
    item.answers[$rootScope.allUserInfo.id].name = $rootScope.allUserInfo.name + " " + $rootScope.allUserInfo.surname;

    var meeting = (isClassroom) ? $scope.classroomMeeting : $scope.meeting;
    meeting.$save(item).then(function(){
      $rootScope.showToast('infoSavedSuccessfully');
      $scope.userMeetingSelected = false;
      // title, text, notTime
      var hour = item.hour.substring(0,2), minutes = item.hour.substring(2,4), notTime = new Date(item.timestamp);
      notTime.setHours(8);
      console.log("notTime",notTime);
      if(item.answers[$rootScope.allUserInfo.id].answer.value) NotificationFactory.setLocalNotification(
        "1"+notTime.getTime().toString().substr(1,5),
        $translate.instant('menu_meeting') + " - " + configuration.appName,
        $translate.instant('notifications_todayMeeting') + " "+hour+":"+minutes,
        notTime
      );
    },function(error){
      $rootScope.showToast('serverError');
      console.log("error saving auth meeting");
    });
  };

  var getMeetingUser = function(id,classroomId){
    if(!$scope.meeting || !$scope.classroomMeeting || $scope.meeting.$id !== id || $scope.classroomMeeting.$id !== idClassroom){
      $rootScope.show();
      MeetingFactory.getMeeting(id).then(function(meeting){
        $scope.meeting = meeting;
        MeetingFactory.getClassroomMeeting(classroomId).then(function(classroomMeeting){
          $scope.classroomMeeting = classroomMeeting;
          $rootScope.hide();
        });
      });
    }

  };

  var getMeetingNoUser = function(id){
    if($scope.allClassroomMeeting){
      if(!$scope.meeting || $scope.meeting.$id !== id){
        $rootScope.show();
        MeetingFactory.getClassroomMeeting(id).then(function(meeting){
          $scope.meeting = meeting;
          $rootScope.hide();
        });
      }
    }else{
      if(!$scope.meeting || $scope.meeting.$id !== id){
        $rootScope.show();
        MeetingFactory.getMeeting(id).then(function(meeting){
          $scope.meeting = meeting;
          $rootScope.hide();
        });
      }
    }
  };


  $scope.$on("$ionicView.afterEnter", function(){
    $scope.allClassroomMeeting = ($stateParams.allClassroomMeeting);
    console.log("allClassroomMeeting",$scope.allClassroomMeeting);
    var id, pageTitle;
    if($rootScope.allUserInfo.type === 'user'){
      id = $rootScope.childSelected;
      pageTitle = $rootScope.allUserChilds[$rootScope.childSelected].name.split(" ");
      var classroomId = $rootScope.allUserChilds[$rootScope.childSelected].classroomId;
    }else{
      if($scope.allClassroomMeeting){
        id = $rootScope.classSelected.id;
        pageTitle = $rootScope.classSelected.name.split(" ");
      }else{
        id = $rootScope.studentSelected.id;
        pageTitle = $rootScope.studentSelected.name.split(" ");
      }
    }
    $scope.pageTitle = {name:pageTitle[0]};
    ($rootScope.allUserInfo.type === 'user')? getMeetingUser(id, classroomId) : getMeetingNoUser(id);
  });


  (function(){
  }());
});
