angular.module('childcareOnApp').controller('MenusDocumentsCtrl', function($scope, $rootScope, $translate, $state, MenusFactory, ImageFactory, $ionicModal, $q) {

  console.log("entra");

  $scope.isEdit = false;
  $scope.docDisabled = false;
  $scope.monthList = [
    {
      name: 'menus_dontBelongMonth',
      value: 'all'
    },
    {
      name: 'january',
      value: '0'
    },
    {
      name: 'february',
      value: '1'
    },
    {
      name: 'march',
      value: '2'
    },
    {
      name: 'april',
      value: '3'
    },
    {
      name: 'may',
      value: '4'
    },
    {
      name: 'june',
      value: '5'
    },
    {
      name: 'july',
      value: '6'
    },
    {
      name: 'august',
      value: '7'
    },
    {
      name: 'september',
      value: '8'
    },
    {
      name: 'october',
      value: '9'
    },
    {
      name: 'november',
      value: '10'
    },
    {
      name: 'december',
      value: '11'
    }
  ];
  $scope.classroomsToSend = {};
  $scope.classroomsToSend[$rootScope.classSelected.id] = true;
  $scope.documentAdd = {};

  console.log($scope.documents);

  function uploadDocument(){
    return $q(function(resolve,reject){
      if(typeof $rootScope.documentUrl === 'undefined'){
        reject('undefined');
        return;
      }
      var documentUrl = angular.copy($rootScope.documentUrl);
      if(documentUrl.indexOf('application/pdf') === -1){
        alert($translate.instant('communications_noPdf'));
        reject('noPdf');
      }
      documentUrl = documentUrl.split('base64,');
      documentUrl = documentUrl[documentUrl.length -1];
      ImageFactory.uploadDocumentDefault(documentUrl, "application/pdf", "menusDocuments").then(function(url){
        $scope.docLink = url;
        delete $rootScope.documentUrl;
        resolve();
      },function(){
        reject('error');
      });
    });
  };

  $scope.sendDocument = function() {
    console.log($scope.documentAdd);
    console.log($scope.classroomsToSend);
    if(!$scope.documentAdd.name || !$scope.documentAdd.month || !$rootScope.documentUrl){
      return alert($translate.instant('fillFields'));
    }
    $rootScope.show();
    uploadDocument().then(function(){
      for (var key in $scope.classroomsToSend) {
        if (!$scope.classroomsToSend[key]) delete $scope.classroomsToSend[key];
      }
      MenusFactory.addMenusDocument($scope.documentAdd, $scope.docLink, $scope.classroomsToSend).then(function(){
        $rootScope.hide();
        alert($translate.instant('infoSavedSuccessfully'));
        $scope.closeModal();
        $scope.documentAdd = {};
        $scope.docDisabled = false;
        $scope.classroomsToSend = {};
        $scope.classroomsToSend[$rootScope.classSelected.id] = true;
      },function(){
        alert($translate.instant('serverError'));
      });
    });
  };

  $scope.removeDocument = function(item){
    _confirm($translate.instant('button_delete'), $translate.instant('confirmRemoveGeneric') ,$translate.instant('login_forgotPassword_cancelButton'), $translate.instant('button_accept'), function(buttonIndex){
      if(buttonIndex === 2){
        $scope.documents.$remove(item)
        .then(function(){
          $rootScope.showToast('infoDeletedSuccessfully');
        },function(error){
          console.log("error removeDocument",error);
          alert($translate.instant('serverError'));
        });
      }
    });
  };

  $rootScope.addInMenu = function(){
    $scope.openModal();
  };
  $rootScope.removeInMenu = function(){
    $scope.$evalAsync(function(){$scope.isEdit = !$scope.isEdit});
  };

  $ionicModal.fromTemplateUrl('modal-add.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modal = modal;
  });
  $scope.openModal = function() {
    $scope.modal.show();
  };
  $scope.closeModal = function() {
    $scope.modal.hide();
  };
  // Cleanup the modal when we're done with it!
  $scope.$on('$destroy', function() {
    if (!!$scope.modal) {
      $scope.modal.remove();
    }
  });

  $scope.$watch('$root.documentUrl', function(newV,oldV) {
    console.log("se actualiza documentUrl!",newV);
    console.log(typeof newV !== 'undefined');
    console.log(oldV !== newV);
    if(typeof newV !== 'undefined' && oldV !== newV){
      console.log("aqui entraaa!", typeof $rootScope.documentUrl);
      $scope.$evalAsync(function(){$scope.docDisabled = true;})
    }
  });

  $scope.openDocument = function(item){
    console.log("item is",item);
    if (typeof cordova === 'undefined') {
      window.open(item.url,'_blank');
    }
    if (item.url.indexOf('http') === -1) {
      item.url = 'http://' + item.url;
    }
    $rootScope.show();
    inAppBrowserRef = cordova.InAppBrowser.open(encodeURI('https://docs.google.com/gview?embedded=true&url='+item.url), '_blank', 'location=yes,hidden=yes,shouldPauseOnSuspend=yes');

    inAppBrowserRef.addEventListener('loadstart', function() {
      console.log('loadstart');
    });

    inAppBrowserRef.addEventListener('loadstop', function() {
      console.log('loadStop');
      $rootScope.hide();
      inAppBrowserRef.show();
    });

    inAppBrowserRef.addEventListener('loaderror', function() {
      console.log('loaderror');
      $rootScope.show();
      inAppBrowserRef.close();
      window.open(item.url, '_system', 'location=false');
    });
  };

  (function(){
    if($rootScope.allUserInfo.type === 'user') {
      var classroomId = $rootScope.allUserChilds[$rootScope.childSelected].classroomId;
      var schoolId = $rootScope.allUserChilds[$rootScope.childSelected].school;
    } else {
      var classroomId = $rootScope.classSelected.id;
      var schoolId = $rootScope.allUserInfo.school;
    }
    $scope.documents = MenusFactory.getMenusDocuments(schoolId, classroomId);
  }());
})