angular.module('childcareOnApp').controller('MenusCtrl', function($scope, $rootScope, $translate, $q, $state, $ionicModal, CommonFactory, ionicMaterialInk, ionicMaterialMotion, MenusFactory, ChildcareOnUtils, ClassroomFactory, ImageFactory) {

  setTimeout(function(){
    ionicMaterialInk.displayEffect();
    ionicMaterialMotion.ripple();
  },1000);

  $scope.document = [];
  $scope.docDisabled = false;
  $scope.monthList = [
    {
      name: 'menus_dontBelongMonth',
      value: 'all'
    },
    {
      name: 'january',
      value: '0'
    },
    {
      name: 'february',
      value: '1'
    },
    {
      name: 'march',
      value: '2'
    },
    {
      name: 'april',
      value: '3'
    },
    {
      name: 'may',
      value: '4'
    },
    {
      name: 'june',
      value: '5'
    },
    {
      name: 'july',
      value: '6'
    },
    {
      name: 'august',
      value: '7'
    },
    {
      name: 'september',
      value: '8'
    },
    {
      name: 'october',
      value: '9'
    },
    {
      name: 'november',
      value: '10'
    },
    {
      name: 'december',
      value: '11'
    }
  ];
  
  var uploadDocument = function(file){
    return $q(function(resolve,reject){
      if(typeof file === 'undefined'){
        reject('undefined');
        return;
      }
      if(file.indexOf('application/pdf') === -1){
        alert($translate.instant('communications_noPdf'));
        reject('noPdf');
      }
      file = file.split('base64,');
      file = file[file.length -1];
      $scope.$evalAsync(function () {
        $scope.uploading.document = true;
        $scope.progress.document = 0;
      });

      var interval = setInterval(function() {
        $scope.$evalAsync(function () {
          $scope.progress.document = ImageFactory.getPercentageProgress();
        });
      }, 200);

      ImageFactory.uploadDocumentDefault(file, "application/pdf", "menusDocuments", false).then(function(url){
        $scope.docLink = url;
        clearInterval(interval);
        resolve();
      },function(){
        clearInterval(interval);
        reject('error');
      });
    });
  };

  $scope.dictionary = {breakfast:[]};
  $scope.month = new Date().getMonth() +1;
  $scope.monthNames = ChildcareOnUtils.getCurrentAndNextMonth();
  $scope.isCurrentMonth = true;
  $scope.menuDisplayed = 'currentMonth';
  $scope.classroomShow = false;
  //$scope.dictionarySelected = {};
  $scope.rowSelected = {};
  var order = ["first","second","third","fourth","fifth"];
  $scope.mealOrder = ['first','second','third','fourth','fifth'];
  $scope.mealsName = ['breakfast','lunch','puree','meal'];

  var getShowDays = function(){
    var days = ($scope.menuDisplayed === 'nextMonth')? angular.copy($scope.daysNextMonth) : angular.copy($scope.days);
    var showDays = {};
    // console.log("days",days);
    for(var i=0; i<days.length;i++){
      showDays[days[i].value] = false;
    }
    // console.log("showDays",showDays);
    return showDays;
  };

  $scope.changeCurrentMonth = function(value){
    if($scope.menuDisplayed !== value){
      // console.log("typeof $scope.daysNextMonth",typeof $scope.daysNextMonth);
      if(typeof $scope.daysNextMonth === 'undefined') $scope.daysNextMonth = angular.copy(ChildcareOnUtils.getNextMonthDays());
      $scope.showDays = getShowDays();
      $scope.$evalAsync(function(){$scope.menuDisplayed = value;});
    }
  };

  $scope.selectClassrooms = function(){
    $scope.classroomShow = !$scope.classroomShow;
  };

  $scope.setDays = function(){
    $scope.isCurrentMonth = !$scope.isCurrentMonth;
    $scope.days = ($scope.isCurrentMonth)? ChildcareOnUtils.getCurrentMonthDays() : ChildcareOnUtils.getNextMonthDays();
    $scope.showDays = getShowDays();
  };

  $scope.changeShowDays = function(day){
    // console.log("day is",day);
    if($rootScope.allUserInfo.type === 'principal') $scope.showDays[day.value] = !$scope.showDays[day.value];
  };

  $scope.getMenus = function(classroomId){
    console.log("entra a getMenus!",$rootScope.menusInfo);
    if($rootScope.allUserInfo.type !== "principal"){
      console.log("before getUserMenus");
      MenusFactory.getUserMenus(classroomId, true).then(function(menus){
        console.log("getMenus success",menus);
        $rootScope.menusInfo = menus;
        MenusFactory.getUserMenusNextWeek(classroomId).then(function(menusNextWeek){
          $scope.nextWeekMenus = menusNextWeek;
          console.log("$scope.nextWeekMenus",$scope.nextWeekMenus);
        });
      },function(){
        console.log("error en getMenus");
      });
    }else{
      $scope.classroomId = classroomId;
      MenusFactory.getTeacherMenusV2(true).then(function(){
        $scope.menusMonth = MenusFactory.getMenusMonth(classroomId,$scope.month);
        console.log("menusMonth",$scope.menusMonth);
      });
    }
  };

  if($rootScope.allUserInfo.type !== "principal"){
    $scope.days = ChildcareOnUtils.getCurrentWeekDays();
    $scope.daysNextWeek = ChildcareOnUtils.getNextWeekDays();
  }else{
    $scope.days = angular.copy(ChildcareOnUtils.getCurrentMonthDays());
    // $scope.daysNextMonth = angular.copy(ChildcareOnUtils.getNextMonthDays());
    $scope.showDays = angular.copy(getShowDays());
  }

  // hacer funcion que mire si tiene alguna clase 0-3 o no

  $scope.sendDocument = function() {
    console.log($scope.documentAdd);
    console.log($scope.classroomsToSend);
    if(!$scope.documentAdd.name || !$scope.documentAdd.month || !$scope.docLink){
      return alert($translate.instant('fillFields'));
    }
    $rootScope.show();
    for (var key in $scope.classroomsToSend) {
      if (!$scope.classroomsToSend[key]) delete $scope.classroomsToSend[key];
    }
    MenusFactory.addMenusDocument($scope.documentAdd, $scope.docLink, $scope.classroomsToSend).then(function(){
      $rootScope.hide();
      alert($translate.instant('infoSavedSuccessfully'));
      $scope.closeModal();
      $scope.documentAdd = {};
      $scope.docDisabled = false;
      $scope.classroomsToSend = {};
      $scope.classroomsToSend[$rootScope.classSelected.id] = true;
    },function(){
      alert($translate.instant('serverError'));
      $rootScope.hide();
    });
  };

  $scope.finishUpload = function(file) {
    if (typeof file === 'undefined' || !file) {
      return false;
    }
    console.log("finish upload");
    uploadDocument(file).then(function(){
      $scope.$evalAsync(function() {
        $scope.docDisabled = true;
        $scope.uploading.document = false;
      });
    },function(error){
      if(error === 'error') alert($translate.instant('serverError'));
    });
  };


  $scope.updateMenus = function(){
    console.log("menusMonth 2",$scope.menusMonth);
    for(var x in $scope.classroomsToSend){
      if($scope.classroomsToSend[x]){
        console.log("entra en x",x);
        if(!$rootScope.menusInfo[x]) $rootScope.menusInfo[x] = {};
        if(!$rootScope.menusInfo[x].school) $rootScope.menusInfo[x].school = $rootScope.allUserInfo.school;
        var classroomType = ClassroomFactory.getClassroomType(false,x);
        for(var i in $scope.menusMonth.menusInfo){
          if(!$rootScope.menusInfo[x][i]) $rootScope.menusInfo[x][i] = {};
          if(i.indexOf('$') === -1){
            var month = parseInt(i.slice(2,4));
            var date = new Date("20"+i.slice(4,6),month -1,i.slice(0,2));
            var menusInfo = angular.copy($scope.menusMonth.menusInfo[i]);
            if(menusInfo.hasOwnProperty('puree') && classroomType === 2) delete menusInfo.puree;
            $rootScope.menusInfo[x][i] = menusInfo;
            $rootScope.menusInfo[x][i].month = month;
            $rootScope.menusInfo[x][i].week = date.getWeekNumber();
          }
        }
        for(var i in $scope.menusMonth.nextMonthMenusInfo){
          if(i.indexOf('$') === -1){
            var month = parseInt(i.slice(2,4));
            var date = new Date("20"+i.slice(4,6),month -1,i.slice(0,2));
            var menusInfo = angular.copy($scope.menusMonth.nextMonthMenusInfo[i]);
            if(menusInfo.hasOwnProperty('puree') && classroomType === 2) delete menusInfo.puree;
            $rootScope.menusInfo[x][i] = $scope.menusMonth.nextMonthMenusInfo[i];
            $rootScope.menusInfo[x][i].month = month;
            $rootScope.menusInfo[x][i].week = date.getWeekNumber();
          }
        }
      }
    }

    console.log("$rootScope.menusInfo",$rootScope.menusInfo);

    MenusFactory.updateMenusV2().then(function(){
      $rootScope.showToast('infoSavedSuccessfully');
    },function(e){
      console.log("error save menus",e);
      alert($translate.intant('serverError'));
    });
  };

  $scope.courseChanged = function(day,course,dish){
    if($scope.menuDisplayed == 'currentMonth'){
      if($scope.menusMonth.menusInfo[day][course][dish] === '') $scope.rowSelected = {};
      else $scope.rowSelected = {day:day,course:course,dish:dish};
    }else if($scope.menuDisplayed == 'nextMonth'){
      if($scope.menusMonth.nextMonthMenusInfo[day][course][dish] === '') $scope.rowSelected = {};
      else $scope.rowSelected = {day:day,course:course,dish:dish};
    }
  };

  $ionicModal.fromTemplateUrl('modal-document.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modal = modal;
  });
  $scope.openModal = function() {
    $scope.modal.show();
  };
  $scope.closeModal = function() {
    $scope.modal.hide();
  };
  // Cleanup the modal when we're done with it!
  $scope.$on('$destroy', function() {
    if (!!$scope.modal) {
      $scope.modal.remove();
    }
  });

  $scope.$on("$ionicView.afterEnter", function(){
    

    if($rootScope.allUserInfo.type === 'principal'){
      var classroomId = $rootScope.classSelected.id;
      var schoolId = $rootScope.allUserInfo.school;
      $scope.classroomsToSend = {};
      $scope.classroomsToSend[classroomId] = true;
      $scope.documentAdd = {};
      $scope.docRoute = "";
      $scope.progress = {};
      $scope.uploading = {};
      if(!$rootScope.menuDictionary){
        MenusFactory.getDictionary().then(function(dictionary){
          $rootScope.menuDictionary = dictionary;
          for(var i in dictionary){
            if(!$scope.dictionary[i]) $scope.dictionary[i] = [];
            for(var x in dictionary[i]){
              $scope.dictionary[i].push(dictionary[i][x]);
            }
          }
          console.log("$scope.dictionary",$scope.dictionary);
        });
      }
      if(!$scope.menusMonth || $scope.classroomId != classroomId) $scope.getMenus(classroomId);
      $scope.documents = MenusFactory.getMenusDocuments(schoolId, classroomId);
      console.log('documents', $scope.documents);
    } else {
      if($rootScope.allUserInfo.type === 'teacher'){
        var classroomId = $rootScope.classSelected.id;
        var schoolId = $rootScope.allUserInfo.school;
      }else{
        var classroomId = $rootScope.allUserChilds[$rootScope.childSelected].classroomId;
        var schoolId = $rootScope.allUserChilds[$rootScope.childSelected].school;
      }
      if(!$rootScope.menusInfo || $rootScope.menusInfo.$id != classroomId || !$scope.nextWeekMenus) $scope.getMenus(classroomId);
      $scope.documents = MenusFactory.getMenusDocuments(schoolId, classroomId);
      console.log('documents', $scope.documents);
    }

    if ($rootScope.settings && !!$rootScope.settings.classroomsDetails && !!$rootScope.settings.classroomsDetails[classroomId]) {
      $scope.classroomType = $rootScope.settings.classroomsDetails[$scope.classroomId]; //classroomType es la edad de los niños.
    } else {
      $scope.classroomType = 1;
    }
    console.log('$scope.classroomType', $scope.classroomType);
  });




  (function(){

  }());
})
