angular.module('childcareOnApp').controller('PrincipalCommunicationsCtrl', ['$scope', '$rootScope', '$filter', '$firebaseObject', '$firebaseArray', 'ImageFactory', '$state', '$stateParams', '$q', 'ChildcareOnUtils', '$translate', '$ionicModal', PrincipalCommunicationsCtrl]);

function PrincipalCommunicationsCtrl($scope, $rootScope, $filter, $firebaseObject, $firebaseArray, ImageFactory, $state, $stateParams, $q, ChildcareOnUtils, $translate, $ionicModal) {
  var schoolId, studentId;
  var toUpload = {}, textToUpload = false;
  var inAppBrowserRef;

  $scope.monthSelected = {};
  $scope.monthList = [
    {
      name: 'january',
      value: '0'
    },
    {
      name: 'february',
      value: '1'
    },
    {
      name: 'march',
      value: '2'
    },
    {
      name: 'april',
      value: '3'
    },
    {
      name: 'may',
      value: '4'
    },
    {
      name: 'june',
      value: '5'
    },
    {
      name: 'july',
      value: '6'
    },
    {
      name: 'august',
      value: '7'
    },
    {
      name: 'september',
      value: '8'
    },
    {
      name: 'october',
      value: '9'
    },
    {
      name: 'november',
      value: '10'
    },
    {
      name: 'december',
      value: '11'
    }
  ];
  $scope.chatModel = {
    comment: ''
  };
  $scope.pending = [];
  $scope.viewDisplayed = 'chat';
  $scope.uploading = false;
  $scope.evidenceDocument = {};
  $scope.documentLink = {
    url: '',
    name: ''
  };

  $scope.load = function() {
    $scope.chat = $firebaseArray(firebase.database().ref('principalCommunications/' + schoolId + '/' + studentId + '/' + $scope.monthSelected.month.value + new Date().getFullYear() + '/' + 'chat'));
    $scope.documents = $firebaseArray(firebase.database().ref('principalCommunications/' + schoolId + '/' + studentId + '/' + $scope.monthSelected.month.value + new Date().getFullYear() + '/' + 'documents'));
    console.log('chat', $scope.chat);
    console.log('documents', $scope.documents);
    $scope.isThisMonth = ($scope.monthSelected.month.value === $scope.monthList[new Date().getMonth()].value);
    console.log('isThisMonth', $scope.isThisMonth);
  };

  $scope.sendChat = function() {
    if ($scope.chatModel.comment === '') {
      alert($translate.instant('fillFields'));
      return;
    }
    var message = {
      date: new Date().getTime(),
      message: $scope.chatModel.comment,
      sender: $rootScope.allUserInfo.id,
      senderName: $rootScope.allUserInfo.name,
      type: $rootScope.allUserInfo.type
    };
    $scope.pending.push(message);
    $scope.chat.$add(message)
    .then(function() {
      $scope.pending = [];
      $scope.chatModel = {
        comment: ''
      };
    }, function(error) {
      $scope.pending = [];
      console.log('error', error);
      alert($translate.instant('serverError'));
    });
  };

  $scope.isFirstOnDay = function(message) {
    var date = new Date(message.date);
    var show = true;
    $scope.chat.forEach(function (item) {
      var itemDate = new Date(item.date);
      if (ChildcareOnUtils.isSameDay(date, itemDate) && item.date < message.date) {
        show = false;
      }
    });
    return show;
  };

  $scope.changeView = function(element) {
    $scope.viewDisplayed = element;
  };

  function upload() {
    toUpload.text = textToUpload;
    toUpload.sender = $rootScope.allUserInfo.id;
    toUpload.senderName = $rootScope.allUserInfo.name;
    toUpload.senderType = $rootScope.allUserInfo.type;
    $scope.documents.$add(toUpload).then(function () {
      $scope.$evalAsync(function () {
        $scope.uploading = false;
      });
      console.log('toUpload', toUpload);
      if (toUpload.type === 'image') {
        alert($translate.instant('imageUpdatedSuccess'));
      } else {
        alert($translate.instant('home_notifications_documentUploaded'));
      }
      toUpload = {};
      textToUpload = false;
    });
  }

  function textPrompt() {
    navigator.notification.prompt(
      $translate.instant('communications_title'),  // message
      function (results) {
        if(results.buttonIndex === 1 && results.input1 !== ''){
          textToUpload = results.input1;
        } else {
          textToUpload = '';
        }
        if (!!toUpload.type) {
          upload();
        }
      },                  // callback to invoke
      $translate.instant('diary_uploading'),            // title
      [$translate.instant('button_send'),$translate.instant('login_forgotPassword_cancelButton')],             // buttonLabels
      ''                 // defaultText
    );
  }

  $scope.uploadPhotos = function() {
    var args = {
      'selectMode': 100, //101=picker image and video , 100=image , 102=video
      'maxSelectCount': 5, //default 40 (Optional)
      'maxSelectSize': 188743680, //188743680=180M (Optional)
    };
    MediaPicker.getMedias(args, function(medias) {
      //medias [{mediaType: "image", path:'/storage/emulated/0/DCIM/Camera/20170808_145202.jpg', size: 21993}]
      if (!medias || medias.length === 0) {
        return console.log('no images selected');
      }
      textPrompt();
      $scope.$evalAsync(function () {
        $scope.uploading = true;
      });
      ImageFactory.multipleImages.getCompressedImages(medias)
      .then(function(thumbnails) {
        ImageFactory.multipleImages.uploadImages(thumbnails, 'principalCommunications/' + schoolId + '/' + studentId)
        .then(function (imagesUploaded) {
          toUpload = {
            images: imagesUploaded,
            type: 'image',
            date: new Date().getTime()
          };
          if (!!textToUpload || textToUpload === '') {
            upload();
          }
        });
      });
    }, function(e) { 
      console.log(e);
      alert($translate.instant('serverError'));
    });
  };

  $scope.uploadVideos = function() {
    var args = {
      'selectMode': 102, //101=picker image and video , 100=image , 102=video
      'maxSelectCount': 5, //default 40 (Optional)
      'maxSelectSize': 188743680, //188743680=180M (Optional)
    };
    console.log('before MediaPicker');
    MediaPicker.getMedias(args, function(medias) {
      if (!medias || medias.length === 0) {
        return console.log('no images selected');
      }
      console.log('videos received', medias);
      textPrompt();
      $scope.$evalAsync(function () {
        $scope.uploading = true;
      });
      ImageFactory.multipleImages.getCompressedVideos(medias)
      .then(function(thumbnails) {
        ImageFactory.multipleImages.uploadVideos(thumbnails, 'principalCommunications/' + schoolId + '/' + studentId)
        .then(function (videosUploaded) {
          videosUploaded = videosUploaded.map(function(video) {
            delete video.month;
            return video;
          });
          console.log('videosUploaded', videosUploaded);
          toUpload = {
            videos: videosUploaded,
            type: 'video',
            date: new Date().getTime()
          };
          if (!!textToUpload || textToUpload === '') {
            upload();
          }
        });
      });
    }, function(e) { 
      console.log(e);
      alert($translate.instant('serverError'));
    });
  };

  $scope.finishUpload = function(file) {
    if (typeof file === 'undefined' || !file) {
      return false;
    }
    $scope.$evalAsync(function () {
      $scope.uploading = true;
    });
    textPrompt();
    var date = new Date().getTime().toString();
    var location = 'principalCommunications/' + schoolId + '/' + studentId;
    ImageFactory.saveImageFromBlob(file, location, date, file.type, false)
    .then(function (url) {
      toUpload = {
        date: new Date().getTime(),
        type: 'document',
        url: url,
        fileType: file.type,
        location: location + '/' + date + '.pdf'
      };
      if (!!textToUpload || textToUpload === '') {
        upload();
      }
    });
  };

  $scope.sendLink = function() {
    if ($scope.documentLink.url === '' || $scope.documentLink.name === '') {
      alert($translate.instant('fillFields'));
      return;
    }
    var message = {
      type: 'link',
      date: new Date().getTime(),
      url: $scope.documentLink.url,
      text: $scope.documentLink.name,
      sender: $rootScope.allUserInfo.id,
      senderName: $rootScope.allUserInfo.name,
      senderType: $rootScope.allUserInfo.type
    };
    $scope.documents.$add(message).then(function () {
      $scope.closeModal();
      $scope.documentLink = {
        url: '',
        name: ''
      };
    }, function() {
      alert($translate.instant('serverError'));
    });
  };

  $scope.selectPhoto = function(image) {
    $state.go('app.imageViewer',{img:image.image, canDelete:false, imageComplete: image, canDownload: false});
  };

  $scope.openDocument = function(item) {
    if (item.type === 'link' || item.fileType !== 'application/pdf') {
      return cordova.InAppBrowser.open(item.url, '_system', 'location=yes');
    }
    $rootScope.show();
    console.log('item', item.url);
    item.name = 'doc';
    ImageFactory.openDocument(item)
    .then(function() {
      $rootScope.hide();
    }, function() {
      $rootScope.hide();
      cordova.InAppBrowser.open(item.url, '_system', 'location=yes');
    });
  };

  $scope.$on("$ionicView.afterEnter", function(){
    $scope.monthSelected = {
      month: $scope.monthList[new Date().getMonth()]
    };
    if($rootScope.allUserInfo.type === 'user') {
      studentId = $rootScope.childSelected;
      schoolId = $rootScope.allUserChilds[$rootScope.childSelected].school;
      var childTitle = $rootScope.allUserChilds[$rootScope.childSelected].name.split(' ');
      $scope.childTitle = childTitle[0];
    } else {
      if(typeof $rootScope.classSelected === 'undefined' || $rootScope.studentSelected === 'undefined') {
        $state.go('app.home');
        return;
      }
      studentId = $rootScope.studentSelected.id;
      $scope.childTitle = $rootScope.studentSelected.name;
      schoolId = $rootScope.allUserInfo.school;
    }
    $scope.load();
  });

  $ionicModal.fromTemplateUrl('modal-link.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modal = modal;
  });
  $scope.openModal = function() {
    $scope.modal.show();
  };
  $scope.closeModal = function() {
    $scope.modal.hide();
  };
  // Cleanup the modal when we're done with it!
  $scope.$on('$destroy', function() {
    if (!!$scope.modal) {
      $scope.modal.remove();
    }
  });

  (function(){

  }());

}
