angular.module('childcareOnApp').controller('SchedulesCtrl', function($scope, $rootScope, $translate, $ionicSideMenuDelegate,CommonFactory, ionicMaterialInk, ionicMaterialMotion, SchedulesFactory, $ionicModal, $q, ImageFactory) {

  ionicMaterialInk.displayEffect();
  ionicMaterialMotion.ripple();
  $scope.isEdit = false;
  $scope.document = [];
  $scope.docDisabled = false;
  $scope.monthList = [
    {
      name: 'menus_dontBelongMonth',
      value: 'all'
    },
    {
      name: 'january',
      value: '0'
    },
    {
      name: 'february',
      value: '1'
    },
    {
      name: 'march',
      value: '2'
    },
    {
      name: 'april',
      value: '3'
    },
    {
      name: 'may',
      value: '4'
    },
    {
      name: 'june',
      value: '5'
    },
    {
      name: 'july',
      value: '6'
    },
    {
      name: 'august',
      value: '7'
    },
    {
      name: 'september',
      value: '8'
    },
    {
      name: 'october',
      value: '9'
    },
    {
      name: 'november',
      value: '10'
    },
    {
      name: 'december',
      value: '11'
    }
  ];
  
  var uploadDocument = function(file){
    return $q(function(resolve,reject){
      if(typeof file === 'undefined'){
        reject('undefined');
        return;
      }
      if(file.indexOf('application/pdf') === -1){
        alert($translate.instant('communications_noPdf'));
        reject('noPdf');
      }
      file = file.split('base64,');
      file = file[file.length -1];
      $scope.$evalAsync(function () {
        $scope.uploading.document = true;
        $scope.progress.document = 0;
      });

      var interval = setInterval(function() {
        $scope.$evalAsync(function () {
          $scope.progress.document = ImageFactory.getPercentageProgress();
        });
      }, 200);

      ImageFactory.uploadDocumentDefault(file, "application/pdf", "schedulesDocuments", false).then(function(url){
        $scope.docLink = url;
        clearInterval(interval);
        resolve();
      },function(){
        clearInterval(interval);
        reject('error');
      });
    });
  };

  $scope.sendDocument = function() {
    console.log($scope.documentAdd);
    console.log($scope.classroomsToSend);
    if(!$scope.documentAdd.name || !$scope.documentAdd.month || !$scope.docLink){
      return alert($translate.instant('fillFields'));
    }
    $rootScope.show();
    for (var key in $scope.classroomsToSend) {
      if (!$scope.classroomsToSend[key]) delete $scope.classroomsToSend[key];
    }
    SchedulesFactory.addSchedulesDocument($scope.documentAdd, $scope.docLink, $scope.classroomsToSend).then(function(){
      $rootScope.hide();
      alert($translate.instant('infoSavedSuccessfully'));
      $scope.closeModal();
      $scope.documentAdd = {};
      $scope.docDisabled = false;
      $scope.classroomsToSend = {};
      $scope.classroomsToSend[$rootScope.classSelected.id] = true;
    },function(){
      alert($translate.instant('serverError'));
      $rootScope.hide();
    });
  };

  $scope.finishUpload = function(file) {
    if (typeof file === 'undefined' || !file) {
      return false;
    }
    console.log("finish upload");
    uploadDocument(file).then(function(){
      $scope.$evalAsync(function() {
        $scope.docDisabled = true;
        $scope.uploading.document = false;
      });
    },function(error){
      if(error === 'error') alert($translate.instant('serverError'));
    });
  };

  $scope.getSchedule = function(classroomId){
    SchedulesFactory.getSchedule(classroomId, true).then(function(schedule){
      console.log("schedule success",schedule);
      $rootScope.scheduleInfo = schedule;
    },function(){
      console.log("error en getSchedule");
    });
  };

  $scope.days = ["monday","tuesday","wednesday","thursday","friday"];
  $scope.addScheduleParams = {monday:{},tuesday:{},wednesday:{},thursday:{},friday:{},saturday:{},sunday:{}};


  $scope.clickAddSchedule = function(day){
    console.log("entra clickAddSchedule",day);
    if("show" in $scope.addScheduleParams[day]) $scope.addScheduleParams[day].show = !$scope.addScheduleParams[day].show;
    else $scope.addScheduleParams[day].show = true;
  };

  $scope.saveScheduleHelper = function(day){ //esta funcion discrimina si está guardando o está editando un horario y llama a la funcion correspondiente
    if(!$scope.addScheduleParams[day].from || !$scope.addScheduleParams[day].to || !$scope.addScheduleParams[day].value){
      alert($translate.instant('fillFields'));
      return;
    }

    if($scope.isEdit){
      $rootScope.scheduleInfo[day][$scope.itemEditing] = {from:$scope.addScheduleParams[day].from.substring(0,2) +":"+ $scope.addScheduleParams[day].from.substring(2,4),
      to:$scope.addScheduleParams[day].to.substring(0,2) +":"+ $scope.addScheduleParams[day].to.substring(2,4),
      value:$scope.addScheduleParams[day].value};
      $scope.saveSchedule(true);
      $scope.isEdit = false;
      $scope.itemEditing = null;
    }else{
      $scope.addSchedule(day);
    }
  };

  $scope.addSchedule = function(day){
    console.log("entra addSchedule",day);
    console.log("params",$scope.addScheduleParams[day]);
    if(!$rootScope.scheduleInfo[day]) $rootScope.scheduleInfo[day] = [];
    $rootScope.scheduleInfo[day].push({from:$scope.addScheduleParams[day].from.substring(0,2) +":"+ $scope.addScheduleParams[day].from.substring(2,4),
      to:$scope.addScheduleParams[day].to.substring(0,2) +":"+ $scope.addScheduleParams[day].to.substring(2,4),
      value:$scope.addScheduleParams[day].value});
    console.log("scheduleInfo",$rootScope.scheduleInfo[day]);
    $scope.addScheduleParams[day] = {};
    saveSchedule(true);
  };

  $scope.editSchedule = function(item,day){
    console.log("entra a editSchedule",item,day);
    $scope.isEdit = true;
    $scope.itemEditing = $rootScope.scheduleInfo[day].indexOf(item);
    $scope.clickAddSchedule(day);
    $scope.addScheduleParams[day] = {from:item.from.substring(0,2),to:item.from.substring(3,5),value:item.value};
  };

  $scope.removeSchedule = function(item,day){
    console.log("entra removeSchedule",item,day);
    var index = $rootScope.scheduleInfo[day].indexOf(item);
    $rootScope.scheduleInfo[day].splice(index, 1);
    saveSchedule(false);
  };

  $ionicModal.fromTemplateUrl('modal-document.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modal = modal;
  });
  $scope.openModal = function() {
    $scope.modal.show();
  };
  $scope.closeModal = function() {
    $scope.modal.hide();
  };
  // Cleanup the modal when we're done with it!
  $scope.$on('$destroy', function() {
    if (!!$scope.modal) {
      $scope.modal.remove();
    }
  });

  var saveSchedule = function(isAdding){
    CommonFactory._save($rootScope.scheduleInfo).then(function(){
      if(isAdding) $rootScope.showToast('infoSavedSuccessfully');
      else $rootScope.showToast('infoDeletedSuccessfully');
    },function(){
      alert($translate.instant('serverError'));
    });
  };

  $scope.$on("$ionicView.afterEnter", function(){
    if($rootScope.allUserInfo.type === 'user') {
      var classroomId = $rootScope.allUserChilds[$rootScope.childSelected].classroomId;
      var schoolId = $rootScope.allUserChilds[$rootScope.childSelected].school;
    } else {
      var classroomId = $rootScope.classSelected.id;
      var schoolId = $rootScope.allUserInfo.school;
      $scope.classroomsToSend = {};
      $scope.classroomsToSend[classroomId] = true;
      $scope.documentAdd = {};
      $scope.docRoute = "";
      $scope.progress = {};
      $scope.uploading = {};
    }
    $scope.documents = SchedulesFactory.getScheduleDocuments(schoolId, classroomId);
    console.log('documents', $scope.documents);
  });

  (function(){
    $scope.shouldShowDelete = true;
    if($rootScope.allUserInfo.type === 'user') {
      var classroomId = $rootScope.allUserChilds[$rootScope.childSelected].classroomId;
      var schoolId = $rootScope.allUserChilds[$rootScope.childSelected].school;
    } else {
      var classroomId = $rootScope.classSelected.id;
      var schoolId = $rootScope.allUserInfo.school;
      $scope.classroomsToSend = {};
      $scope.classroomsToSend[classroomId] = true;
      $scope.documentAdd = {};
      $scope.docRoute = "";
      $scope.progress = {};
      $scope.uploading = {};
    }
    $scope.getSchedule(classroomId);
  }());
})
