angular.module('childcareOnApp').controller('NotificationsCtrl', function($scope, $rootScope, $translate, $ionicSideMenuDelegate,CommonFactory, ionicMaterialInk, ionicMaterialMotion, NotificationFactory, FirebasePluginFactory) {

  ionicMaterialInk.displayEffect();
  ionicMaterialMotion.ripple();
  $scope.isEdit = false;
  var errorSaved = false;

  $rootScope.removeInMenu = function(){
    $scope.$evalAsync(function(){$scope.isEdit = !$scope.isEdit});
  };

  $scope.removeNotification = function(item){
    $rootScope.notifications.$remove(item).then(function(){
      FirebasePluginFactory.setBadgeNumber();
    },function(e){
      console.log("error on remove notification",e);
      $rootScope.showToast('serverError');
    });
  };

  $scope.goToPage = function(item){
    console.log('item', item);
    if(!$rootScope.notifications) return;
    if("isReaded" in item && !item.isReaded){
      item.isReaded = true;
      try {
        $rootScope.notifications.$save(item).then(function(){
          console.log("notifications updated!");
          FirebasePluginFactory.setBadgeNumber();
        },function(e){
          console.log("error updating notifications",e);
        });
      } catch (error) {
        if (!errorSaved) {
          errorSaved = true;
          CommonFactory.saveLog({
            user: $rootScope.allUserInfo.id,
            error: "error line 37 notifications",
            errorMessage:JSON.stringify(error)
          });
        }
      }
    }
    if (item.typeOfNotification === 'link') {
      NotificationFactory.goToExternalWebpage(item.url);
    } else {
      NotificationFactory.goToPage(item.page,item.extra,item.pushText);
    }
  };

  $scope.goToDeviceSettings = function() {
    navigator.notification.alert($translate.instant('battery_optimization_instructions'), function() {
      cordova.plugins.PowerOptimization.RequestOptimizations().then( function (result) {
        console.log('ok');
        $scope.showBatteryOptimizationMessage = false;
      }, function (err) {
        console.log(err);
      });
    }, '', $translate.instant('button_accept'))
  };

  $scope.$on("$ionicView.afterEnter", function(){
    if(!$rootScope.notifications) return;
    $rootScope.notifications.forEach(function(item){
      if(!item.isAck){
        item.isAck = true;
        try {
          $rootScope.notifications.$save(item);
        } catch (error) {
          if (!errorSaved) {
            errorSaved = true;
            CommonFactory.saveLog({
              user: $rootScope.allUserInfo.id,
              error: "error line 58 notifications",
              errorMessage:JSON.stringify(error)
            });
          }
        }
      }
    });
    if (window.cordova && $rootScope.isAndroid) {
      cordova.plugins.PowerOptimization.IsIgnoringBatteryOptimizations().then(function (result) {
        console.log('IsIgnoringBatteryOptimizations', result);
        $scope.showBatteryOptimizationMessage = !result;
      }, function (err) {
        console.log('IsIgnoringBatteryOptimizations', err);
      });
    }
    FirebasePluginFactory.setBadgeNumber();
  });



  (function(){
  }());
})
