angular.module('childcareOnApp').controller('SignupNameCtrl', function($rootScope, $scope,$translate, UserFactory, CommonFactory, ChildFactory, $state, $ionicHistory, $stateParams, ionicMaterialInk, ionicMaterialMotion, TeacherFactory, FirebasePluginFactory, $q) {
  ionicMaterialInk.displayEffect();
  ionicMaterialMotion.ripple();
  var isTeacher = false, schoolId = null, invitations, hasChilds = false;

  $rootScope.hide();

  function manageCode(code){
    return $q(function(resolve, reject){
      console.log(code);
      if(typeof code === 'undefined' || code === "") return resolve();
      UserFactory.sendCodeSignup(code.toUpperCase())
      .then(function(codeDB){
        for(var i=0; i<codeDB.length; i++){
          if(codeDB[i].type === 'teacher') isTeacher = true;
        }
        return resolve(codeDB);
      },function(){
        reject();
      });
    });
  }

  function deleteCode(code) {
    for (var i=0; i < code.length; i++) {
      code.$remove(code[i]);
    }
  }

  $scope.signupName = {};
  $scope.addName = function(){
    if(!$scope.signupName.hasOwnProperty("name") || !$scope.signupName.hasOwnProperty("surname")){
      return alert($translate.instant('fillFields'));
    }
    manageCode($scope.signupName.code).then(function(code){
      if(!isTeacher){
        if(code !== null && !!code) {
          console.log('entra', code);
          addChildrenToUser(code);
        }
        UserFactory.addUserTable($scope.userInfo.uid,$scope.signupName.name,$scope.signupName.surname, "user", $scope.parsedChilds,$scope.userInfo.email).then(function(){
          UserFactory.saveSignupLog($scope.userInfo.uid);
          if($scope.parsedChilds === null){
            $rootScope.userImg = "img/user_noPhoto.png";
            $rootScope.showToast('infoSavedSuccessfully');
            return goToHome();
          }
          ChildFactory.addParentToChild($scope.parsedChilds,$scope.userInfo.uid).then(function(){
            if(code !== null && !!code) {
              deleteCode(code);
            }
            acceptInvitations();
            ChildFactory.getUserChilds($rootScope.allUserInfo.childs).then(function(childInfo){
              console.log("childInfo",childInfo,childInfo.length);
              $rootScope.allUserChilds = childInfo;
              for(var i in childInfo){
                if(i.indexOf("$") !== -1 || typeof childInfo[i] === 'function') continue;
                $rootScope.childSelected = i;
                if(childInfo[i].photo) $scope.$evalAsync(function(){$rootScope.userImg = childInfo[i].photo;});
                else $scope.$evalAsync(function(){$rootScope.userImg = "img/user_noPhoto.png";});
                break;
              }
              $rootScope.showToast('infoSavedSuccessfully');
              goToHome();
            },function(){
              $rootScope.showToast('infoSavedSuccessfully');
              goToHome();
            });
          },function(){
            alert($translate.instant('signupName_inviteError'));
            goToHome();
          });
        },function(){
          goToHome();
        });
      }else{
        var promises = [
          TeacherFactory.addTeacherTable($scope.userInfo.uid,$scope.signupName.name,$scope.signupName.surname,"teacher", schoolId,$scope.userInfo.email),
          TeacherFactory.inviteTeacherAutomatic($scope.userInfo.uid, $scope.userInfo.email, schoolId, $scope.signupName.name, $scope.signupName.surname)
        ];
        $q.all(promises).then(function(result){
          acceptInvitations();
          UserFactory.saveSignupLog($scope.userInfo.uid);
          var classroomsInvited = result[1];
          $rootScope.parsedClassroomAccess = setParsedClassroomAccess(classroomsInvited);
          alert($translate.instant('teacherCreatedSuccessfully'));
          goToHome();
        },function(){
          goToHome();
        });
      }
    }, function(){
      alert($translate.instant('signupName_errorCode'));
    });
  };

  function addChildrenToUser(invitations){
    console.log(angular.copy($scope.parsedChilds));
    if(typeof invitations === 'undefined' || !invitations) invitations = [];
    if(typeof $scope.parsedChilds === 'undefined' || $scope.parsedChilds === null){
      var parsedChilds = {};
      hasChilds = (typeof invitations === 'object' && invitations.length > 0);
    }else{
      var parsedChilds = $scope.parsedChilds;
      if(!hasChilds) hasChilds = (typeof invitations === 'object' && invitations.length > 0);
    }
    for(var i=0;i<invitations.length;i++){
      parsedChilds[invitations[i].childUid] = "father";
    }
    if(!hasChilds) parsedChilds = null;
    $scope.parsedChilds = parsedChilds;
  }

  function setParsedClassroomAccess(classroomsInvited) {
    try {
      var parsedClassroomAccess = [];
      for (var i=0; i < classroomsInvited.length; i++) {
        var classroomId = classroomsInvited[i];
        parsedClassroomAccess.push({
          id: classroomId,
          name: $rootScope.school.classrooms[classroomId]
        });
      }
      return parsedClassroomAccess;
    } catch (error) {
      return [];
    }
  }

  var getInvitations = function(){
    invitations = UserFactory.lookForInvitationsV2($scope.userInfo.email);
    invitations.$loaded()
    .then(function() {
      console.log("invitations",invitations);
      for(var x=0; x<invitations.length;x++){
        if(invitations[x].type === "teacher"){
          isTeacher = true;
          schoolId = invitations[x].schoolId;
          break;
        }
      }
      if (!isTeacher) {
        return addChildrenToUser(invitations);
      }
    },function(){
      console.log("error childs");
    });
  };

  var acceptInvitations = function(){
    for(var i=0;i<invitations.length;i++){
      invitations[i].accepted = true;
      invitations[i].email_accepted = $scope.userInfo.email + "_true";
      invitations.$save(i);
    }
  };

  var goToHome = function(){
    FirebasePluginFactory.setUserId($rootScope.allUserInfo.id);
    FirebasePluginFactory.setUserProperty("type",$rootScope.allUserInfo.type);
    $ionicHistory.nextViewOptions({
      disableBack: true,
    });
    if ($rootScope.allUserInfo.type === 'user') {
      if (!$rootScope.allUserInfo.childs) {
        $state.go('app.firstSteps', {location:'replace'});
      } else {
        $state.go('app.home', {location:'replace'});
      }
    } else {
      $state.go('app.home', {location:'replace'});
    }
  };

  (function(){
    $scope.hasUser = $stateParams.hasUser;
    console.log("stateParams",$stateParams);
    getInvitations();
  }());

});
