angular.module('childcareOnApp').controller('SignupCtrl', function($scope, $rootScope,$translate,$state, $ionicHistory, FirebasePluginFactory, configuration) {
  $scope.signupData = {};

  $scope.openLink = function(type) {
    var link = configuration.help_links[type];
    window.open(link, '_system', 'location=yes');
  };

  $scope.doSignup = function(){
    if (!$scope.signupData.password || !$scope.signupData.confirmPassword || !$scope.signupData.username) {
      alert($translate.instant('fillFields'));
      return;
    }
    if($scope.signupData.password != $scope.signupData.confirmPassword) {
      alert($translate.instant('signup_error_passwordNotMatch'));
      return;
    }
    if(!$scope.signupData.tc) {
      alert($translate.instant('accept_tc_message'));
      return;
    }
    $rootScope.show();
    firebase.auth().createUserWithEmailAndPassword($scope.signupData.username,$scope.signupData.password).then(function(user){
      FirebasePluginFactory.logEvent('sign_up',{sign_up_method:"email_password"}); // save event "login"
      console.log("user created!");
      firebase.auth().useDeviceLanguage();
      var userNew = firebase.auth().currentUser;
      alert($translate.instant('signup_success'));
      $ionicHistory.nextViewOptions({
        disableBack: true,
      });
      $rootScope.userImg = 'img/user_noPhoto.png';
      $rootScope.hide();
      $state.go("app.signupName",{email:$scope.signupData.username});
    }).catch(function(error) {
      var errorCode = error.code;
      var errorMessage = error.message;
      console.log("signup failed",errorCode,errorMessage);
      $rootScope.hide();
      var msg = "";
      switch(error.code){
        case "auth/invalid-email": msg = 'login_error_invalidEmail'; break;
        case "auth/email-already-in-use": msg = 'signup_error_userExists'; break;
        case "auth/weak-password": msg = 'signup_error_weakPassword'; break;
        case "auth/network-request-failed": msg = 'login_error_network_request_failed'; break;
        default: msg = 'serverError';
      }
      alert($translate.instant(msg));
    });
  };
});
