var childcareOnApp = angular.module('childcareOnApp', ['ionic','pascalprecht.translate', 'childcareOnApp.controllers','ionic-material','firebase','ui.mask','jrCrop','ionic-datepicker','ionicImgCache', 'ui.rCalendar']);

childcareOnApp.run(function($ionicPlatform, $log, $rootScope, configuration) {
  $ionicPlatform.ready(function() {

    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);

    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      //StatusBar.styleDefault();
      StatusBar.backgroundColorByHexString("#1a6838");
    }
    if (navigator.notification) { // Override default HTML alert with native dialog
      console.log("si navigator.notification");
      window.alert = function (message) {
        navigator.notification.alert(
          message,    // message
          null,       // callback
          //"Alert", // title
          "Childcare On",
          'OK'        // buttonName
        );
      };
    }
    if (window.cordova) {
      window.open = cordova.InAppBrowser.open;
    }
    window._confirm = function(title, body, buttonLeft, buttonRight, callback){
      if(navigator.notification){
        navigator.notification.confirm(body, callback, title, [ buttonLeft, buttonRight]);
      }else{
        if(confirm(body)){ callback(2); }else{ callback(1); }
      }
    };

    if(!configuration.testMode) window.console.log = function(msg){}; //code to hide console logs if is not testmode
  });
})

.config(['$provide', function($provide) {
  $provide.decorator('$log', ['$delegate', 'serverLogging', function($delegate, serverLogging) {
    serverLogging.enabled = true;
    var methods = {
      error: function() {
        if (serverLogging.enabled) {
          $delegate.error.apply($delegate, arguments);
          serverLogging.error.apply(null, arguments);
        }
      },
      log: function() {
        if (serverLogging.enabled) {
          $delegate.log.apply($delegate, arguments);
          serverLogging.log.apply(null, arguments);
        }
      },
      info: function() {
        if (serverLogging.enabled) {
          $delegate.info.apply($delegate, arguments);
          serverLogging.info.apply(null, arguments);
        }
      },
      warn: function() {
        if (serverLogging.enabled) {
          $delegate.warn.apply($delegate, arguments);
          serverLogging.warn.apply(null, arguments);
        }
      }
    };
    return methods;
  }]);
}])

// .config(function ($qProvider) {
//   $qProvider.errorOnUnhandledRejections(false);
// })

// .config(function (ionicDatePickerProvider) {
//   $translate(['diary_selectADay','date_today','diary_close','sunday','monday','tuesday','wednesday','thursday','friday','saturday']).then(function(translations){
//     var datePickerObj = {
//       inputDate: new Date(),
//       titleLabel: translations.diary_selectADay,
//       setLabel: 'Ok',
//       todayLabel: translations.date_today,
//       closeLabel: translations.diary_close,
//       mondayFirst: true,
//       weeksList: [translations.sunday, translations.monday, translations.tuesday, translations.wednesday, translations.thursday, translations.friday, translations.sunday],
//       monthsList: ["Jan", "Feb", "March", "April", "May", "June", "July", "Aug", "Sept", "Oct", "Nov", "Dec"],
//       templateType: 'popup',
//       from: new Date(2012, 8, 1),
//       to: new Date(),
//       showTodayButton: true,
//       dateFormat: 'dd MMMM yyyy',
//       closeOnSelect: false,
//       disableWeekdays: []
//     };
//     ionicDatePickerProvider.configDatePicker(datePickerObj);
//   });
// })

.service('serverLogging', function($injector) {

  var service = {
    error: function() {
      self.type = 'error';
      log.apply(self, arguments);
    },
    warn: function() {
      self.type = 'warn';
      //log.apply(self, arguments);
    },
    info: function() {
      self.type = 'info';
      //log.apply(self, arguments);
    },
    log: function() {
      self.type = 'log';
      //log.apply(self, arguments);
    },
    enabled: false
  };

  var log = function() {

    args = [];
    if (typeof arguments === 'object') {
      for(var i = 0; i < arguments.length; i++ ) {
        if(typeof arguments[i] === 'object'){
          var stackSplitted = arguments[i].stack.split('at');
          var exception = {};
          exception.message = arguments[i].message;
          if(stackSplitted.length >2) exception.stack = stackSplitted[1] + stackSplitted[2];
          else exception.stack = arguments[i].stack;
          args.push(JSON.stringify(exception));
        }else{
          args.push(JSON.stringify(arguments[i]));
        }
      }
    } else if (typeof arguments === 'string') {
      args.push(arguments);
    }

    console.log("ha habido un error",args);
    $injector.invoke(function($rootScope, $firebaseArray, $state, ChildcareOnUtils, CommonFactory) {
      var date = new Date();
      var user = null;
      var appVersion = null;
      if($rootScope.allUserInfo) user = $rootScope.allUserInfo.id;
      else if(firebase.auth().currentUser) user = firebase.auth().currentUser.uid;
      ChildcareOnUtils.getAppVersion().then(function(version){
        console.log("version is",version);
        var error = stripslashes(JSON.stringify(args));
        var obj = {
          user: user,
          error:error,
          page:$state.current.name,
          date: JSON.stringify(date),
          appVersion: version
        };
        if($rootScope.allUserInfo && $rootScope.allUserInfo.type === 'user'){
          obj.extra = JSON.stringify({
            allUserChilds:typeof $rootScope.allUserChilds, childSelected:$rootScope.childSelected
          });
        }else if($rootScope.allUserInfo && $rootScope.allUserInfo.type !== 'user'){
          obj.extra = JSON.stringify({
            classSelected:$rootScope.classSelected, studentSelected:$rootScope.studentSelected
          });
        }
        var errorsAllowed = ['permission', '$digest', 'inprog'];
        var foundAllowed = false;
        errorsAllowed.forEach(function (element) {
          if (error.indexOf(element) !== -1) {
            foundAllowed = true;
          }
        });
        if(!$rootScope.testMode && !foundAllowed){
          CommonFactory.saveLog(obj).finally(function(){
            $rootScope.errorFound();
          });
        }
      });
    });

  };

  var stripslashes = function(str) {
    str = str.replace(/\\'/g, '\'');
    str = str.replace(/\\"/g, '"');
    str = str.replace(/\\0/g, '\0');
    str = str.replace(/\\\\/g, '');
    str = str.replace(/\n/g, '');
    str = str.replace(/\"/g,"");
    return str;
  }

  return service;

})

.config(function($translateProvider, $ionicConfigProvider, ionicDatePickerProvider) {
  $ionicConfigProvider.backButton.previousTitleText(false);
  $ionicConfigProvider.backButton.text('');
  $ionicConfigProvider.tabs.position('top');
  var config = {
    apiKey: "AIzaSyBmBjsZjlni-CPwVQKM8kNN7aPyAnmwLLg",
    authDomain: "childcare-on.firebaseapp.com",
    databaseURL: "https://childcare-on.firebaseio.com",
    storageBucket: "childcare-on.appspot.com",
    messagingSenderId: "778400249650",
    projectId: "childcare-on"
  };
  var firebase_dev = {
    apiKey: 'AIzaSyAAgEHTOQuW1fc7COUH4Bcbqgi7TceX0Bk',
    authDomain: 'childcare-on-dev.firebaseapp.com',
    databaseURL: 'https://childcare-on-dev-default-rtdb.europe-west1.firebasedatabase.app',
    projectId: 'childcare-on-dev',
    storageBucket: 'childcare-on-dev.appspot.com',
    messagingSenderId: '602660887772',
    appId: '1:602660887772:web:c3a89a8abe2d41bfc1a819'
  };
  firebase.initializeApp(config);
  // var settings = {timestampsInSnapshots: true};
  // firebase.firestore().settings(settings);


  $translateProvider.translations('es', translations_es);
  $translateProvider.translations('ca', translations_ca);
  $translateProvider.translations('en', translations_en);
  var language_list = ['es', 'ca', 'en'];
  var languageCode = navigator.language || navigator.userLanguage;
  languageCode = languageCode.split('-');
  var language = languageCode[0];
  if (language_list.indexOf(language) == -1) language = 'es';
  $translateProvider.fallbackLanguage('es').preferredLanguage(language);

  $translateProvider.useSanitizeValueStrategy('escape');
  var date = new Date();
  if(date.getDay() == 0 || date.getDay() == 6){
    if(date.getDay() == 0) date.setDate(date.getDate()+1);
    else date.setDate(date.getDate()+2);
  }

  var datePickerObj = {
  inputDate: date,
  mondayFirst: true,
  templateType: 'popup',
  to: date,
  showTodayButton: true,
  dateFormat: 'dd MMMM yyyy',
  closeOnSelect: false,
  disableWeekdays: [0,6]
};
ionicDatePickerProvider.configDatePicker(datePickerObj);

});
