angular.module('childcareOnApp').factory('AdminProfilesFactory',function($rootScope, $firebaseObject, $firebaseArray, $q, CommonFactory, $localStorage, $state){
  var profile = {
    addStudent: function(student){
      return $q(function(resolve, reject) {
        var list = $firebaseArray(firebase.database().ref('child/'));
        list.$add(student).then(function(ref) {
          var id = ref.key;
          if(!$rootScope.classroom.students) $rootScope.classroom.students = {};
          $rootScope.classroom.students[id] = student.name + " " + student.surname;
          CommonFactory._save($rootScope.classroom).then(function(){
            resolve();
          },function(){
            reject();
          });
        });
      });
    },deleteStudent: function(student){ //1. borramos el niño de la clase, 2. borramos el niño, 3. borramos al niño de los padres
      console.log("student is", student);
      return $q(function(resolve, reject) {
        try {
          var parents = {};
          if (student.parents) {
            parents = Object.assign({}, student.parents);
          }
          var studentCopy = Object.assign({}, student);
          console.log('studentCopy', studentCopy);
          delete $rootScope.classroom.students[student.$id];
          CommonFactory._save($rootScope.classroom).then(function(){
            firebase.database().ref('child').child(student.$id).remove()
            .then(function() {
              firebase.database().ref('classrooms/'+studentCopy.classroomId+'/studentsPhoto/'+studentCopy.$id).set(null);
              console.log("student deleted!");
              var promises = [];
              for (var parentId in parents) {
                promises.push(
                  firebase.database().ref('users/' + parentId + '/childs/' + studentCopy.$id),
                  firebase.database().ref('users/' + parentId + '/' + studentCopy.$id),
                );
              }
              $q.all(promises)
              .then(function() {
                var invitationsList = $firebaseArray(firebase.database().ref('invitations').orderByChild('childUid').equalTo(studentCopy.$id));
                invitationsList.$loaded().then(function(){
                  for(var i=0; i<invitationsList.length; i++) {
                    invitationsList.$remove(i);
                  }
                  resolve();
                });
              }, resolve);
            },function(e){
              console.log("error al borrar",e);
              var obj = { user: $rootScope.allUserInfo.id, error:"Error al borrar deleteStudent, user:"+student+"; error:"+stripslashes(JSON.stringify(e)), page:$state.current.name, date: JSON.stringify(new Date())};
              CommonFactory.saveLog(obj);
            });  
          },function(){
            console.log("error en save");
            var obj = { user: $rootScope.allUserInfo.id, error:"Error al borrar deleteStudent, user:"+student+"; error:"+stripslashes(JSON.stringify(e)), page:$state.current.name, date: JSON.stringify(new Date())};
            CommonFactory.saveLog(obj);
            reject();
          });
        }catch(e){
          console.log("error in deleteStudent",e);
          reject();
        }
      });
    },getUsersByType: function(type){
      return $q(function(resolve, reject) {
        var list = $firebaseArray(firebase.database().ref('users').orderByChild("type").equalTo(type));
        list.$loaded().then(function(parents){
          $rootScope.allParents = parents;
          resolve(parents);
        },function(e){
          console.log("parents false",e);
          reject();
        });
      });
    },getInvitationsByUser: function(user){
      return $q(function(resolve, reject) {
        var list = $firebaseArray(firebase.database().ref('invitations').orderByChild('id').equalTo(user));
        list.$loaded().then(function(invitations){
          console.log("invitations true",invitations);
          resolve(invitations);
        },function(e){
          console.log("invitations false",e);
          reject();
        });
      });
    },getInvitationsByUserV2: function(user){
      return $q(function(resolve, reject) {
        var list = $firebaseArray(firebase.database().ref('invitations').orderByChild("email").equalTo(user));
        list.$loaded().then(function(invitations){
          console.log("invitations v2 true",invitations);
          resolve(invitations);
        },function(e){
          console.log("invitations v2 false",e);
          reject();
        });
      });
    },getInvitationsByUserV3: function(user){
      return $q(function(resolve, reject) {
        if ($rootScope.allUserInfo.hasOwnProperty('childs') && (Math.floor((Math.random() * 5) + 1) !== 1)) return resolve([]);
        console.log("entra a getInvitations!");
        var ref = firebase.database().ref('invitations').orderByChild("email_accepted").equalTo(user+"_false");
        var list = $firebaseArray(ref);
        list.$loaded().then(function(invitations){
          console.log("invitations v2 true",invitations);
          resolve(invitations);
        },function(e){
          console.log("invitations v2 false",e);
          reject();
        });
      });
    },getInvitationsByChild: function(childUid){
      return $q(function(resolve, reject) {
        var query = firebase.database().ref('invitations').orderByChild("childUid").equalTo(childUid);
        var list = $firebaseArray(query);
        list.$loaded().then(function(invitations){
          console.log("getInvitationsByChild true",invitations);
          resolve(invitations);
        },function(e){
          console.log("getInvitationsByChild false",e);
          reject();
        });
      });
    }, getInvitationsByChildV2: function(childUid) {
      var ref = firebase.database().ref('invitations').orderByChild("childUid").equalTo(childUid);
      return $firebaseArray(ref);
    },getInvitationsSent: function(uid){
      return $q(function(resolve, reject) {
        var query = firebase.database().ref('invitations').orderByChild("sentBy").equalTo(uid);
        var list = $firebaseArray(query);
        list.$loaded().then(function(invitations){
          console.log("getInvitationsByChild true",invitations);
          resolve(invitations);
        },function(e){
          console.log("getInvitationsByChild false",e);
          reject();
        });
      });
    }, getInvitationsBySchool: function(schoolId) {
      return $firebaseArray(
        firebase.database().ref('invitations').orderByChild('schoolId').equalTo(schoolId)
      );
    }, inviteParent: function(email,id){
      console.log("email and id",email,id);
      return $q(function(resolve, reject) {
        var emailParsed = email.replace(".",";");
        var ref = firebase.database().ref('invitations/');
        ref = ref.child(emailParsed);
        var list = $firebaseObject(ref);
        list.$loaded().then(function(invitation){
          console.log("invitation",invitation);
          invitation[id] = true;
          invitation.id = id;
          invitation.$save().then(function(){
            console.log("save success");
            resolve();
          },function(){
            console.log("save error");
            reject();
          });
        },function(e){
          console.log("error load invitation",e);
          reject();
        });
      });
    },inviteParentV2: function(email,childUid,sentBy,childName){
      console.log("email and id",email,childUid,sentBy);
      return $q(function(resolve, reject) {
        var date = new Date();
        var lang = typeof $rootScope.school.lang === 'undefined'? 'es':$rootScope.school.lang;
        var ref = firebase.database().ref('invitations');
        var list = $firebaseArray(ref);
        var objToAdd = {
          accepted: false,
          childUid: childUid,
          date: date.getTime(),
          email: email,
          email_accepted: email+"_false",
          sentBy: sentBy,
          type:"parent",
          lang: lang,
          schoolName: $rootScope.school.name,
          childName: childName,
        };
        console.log('invite parent', objToAdd);
        list.$add(objToAdd).then(function(ref) {
          console.log("add invitation to array success");
          // var url = "https://childcareon.com/api/request/v0/sendEmail.php", data = {school:$rootScope.school.name,type:'child',sendTo:email, childName:childName};
          // CommonFactory.serverRequest(url,data);
          resolve();
        },function(e){
          console.log("add invitation to array error",e);
          reject();
        });
      });
    }, inviteTeacher: function(email, sentBy, schoolId, schoolName, classroomsToInvite){
      console.log("email and id",email,schoolId,sentBy);
      return $q(function(resolve, reject) {
        var date = new Date();
        var list = $firebaseArray(firebase.database().ref('invitations'));
        var objToAdd = {
          accepted: false,
          schoolId: schoolId,
          schoolName: schoolName,
          date: date.getTime(),
          email: email,
          email_accepted: email+"_false",
          sentBy: sentBy,
          type: "teacher"
        };
        list.$add(objToAdd).then(function(ref) {
          console.log("add invitation to array success");
          if (Object.keys(classroomsToInvite).length > 0) {
            var promises = [];
            for (var classroomId in classroomsToInvite) {
              var invitationsAutomaticObj = {
                email: email,
                classroomId: classroomId,
                date: new Date().getTime()
              };
              promises.push(
                firebase.database().ref('invitationsAutomatic').push(invitationsAutomaticObj)
              );
            }
            $q.all(promises)
            .then(function () {
              resolve();
            }, function () {
              resolve();
            });
          } else {
            resolve();
          }
        },function(e){
          console.log("add invitation to array error",e);
          reject();
        });
      });
    },getClassroom: function(classroomId){
      return $q(function(resolve, reject) {
        var ref = firebase.database().ref('classrooms/');
        ref = ref.child(classroomId);
        var list = $firebaseObject(ref);
        list.$loaded().then(function(classroom){
          resolve(classroom);
        });
      });
    },deleteInvitation: function(usersInvited,index){
      console.log("invitation to delete",usersInvited,index);
      return $q(function(resolve, reject) {
        usersInvited.$remove(index).then(function(ref) {
          console.log("invitation delete successful");
          resolve();
        },function(e){
          console.log("error deleteInvitation", e);
          reject();
        });
      });
    },getSchool: function(schoolId){
      var ref = firebase.database().ref('schools').child(schoolId);
      return $firebaseObject(ref);
    }, getSchoolLocal: function(schoolId) {
      var localSchool = $localStorage.getCHObject('school');
      if(localSchool.id === schoolId && !!localSchool.time && Object.keys(localSchool.obj).length > 0 && (parseInt(localSchool.time) + 2.592e+9) > new Date().getTime()){
        return localSchool.obj;
      }
      var ref = $firebaseObject(firebase.database().ref('schools').child(schoolId));
      ref.$loaded().then(function(value) {
        $localStorage.setCHObject('school', value, schoolId);
      });
      return ref;
    }, getClassroomAccess: function(schoolId){
      return $q(function(resolve, reject) {
        var ref = firebase.database().ref('classroomAccess');
        ref = ref.child(schoolId);
        var list = $firebaseObject(ref);
        $rootScope.classroomAccess = list;
        list.$loaded().then(function(classroomAccess){
          console.log("getClassroomAccess",classroomAccess);
          resolve(classroomAccess);
        });
      });
    },updateClassroomName: function(classroomId, name){
      return $q(function(resolve, reject) {
        var ref = firebase.database().ref('schools');
        ref = ref.child($rootScope.allUserInfo.school);
        ref = ref.child("classrooms");
        var list = $firebaseObject(ref);
        list[classroomId] = name;
        list.$save().then(resolve,function(e){
          console.log("updateClassroomName failed",e);
        })
      });
    },deleteClassroom: function(id){
      return $q(function(resolve, reject) {
        if(!id){
          reject();
          return;
        }
        console.log("try delete classroom",id);
        var obj = $firebaseObject(firebase.database().ref('classrooms/'+id));
        obj.$remove().then(function(ref) {
          if(typeof $rootScope.school.classrooms[id] !== "undefined") delete $rootScope.school.classrooms[id];
          $rootScope.school.$save().then(function(){
            console.log("classroom deleted successfully",ref);
            firebase.database().ref('classroomAccess/'+ $rootScope.allUserInfo.school + '/' + id).set(null);
            resolve();
          },function(error){
            reject();
            console.log("error delete classroom from school");
          });
        }, function(error) {
          console.log("Error deleting classroom:", error);
          reject();
        });
      });
    }, getChildCode: function(childId){
      return $firebaseArray(
        firebase.database().ref('signupCode').orderByChild('childUid').equalTo(childId)
      );
    }, generateCode: function(child) {
      function getRandomNumber(){
        var rand = Math.floor((Math.random() * 2) + 1);
        return (rand === 1);
      }
      function getRandomNumberTen(){
        return Math.floor((Math.random() * 9) + 1);
      }
      function getLastLetter(string){
        return string.toLowerCase().slice(-1)
      }
      function convertToLetter(char){
        if(getRandomNumber()) return char;
        return (char.charCodeAt(0) - 97);
      }
      function getCode(){
        console.log('child', child);
        var schoolL = convertToLetter(getLastLetter(child.school));
        var classroomL = convertToLetter(getLastLetter(child.classroomId));
        var childL = convertToLetter(getLastLetter(child.$id));
        var randomNumber = getRandomNumberTen().toString();
        
        return schoolL.toString() + classroomL.toString() + childL.toString() + randomNumber.toString();  
      }

      return $q(function (resolve, reject) {
        // var code = getCode().replace("-","").toUpperCase();
        var code = getCode().replace(/-/g,"").toUpperCase();
        var toPush = {
          childUid: child.$id,
          code: code,
          type: 'user'
        };
        $firebaseArray(
          firebase.database().ref('signupCode').orderByChild('code').equalTo(code)
        ).$loaded(function (codes) {
          if (codes.length > 0) {
            code = getCode().replace(/-/g,"").toUpperCase();
            toPush = {
              childUid: child.$id,
              code: code,
              type: 'user'
            };
          }
          firebase.database().ref('signupCode').push(toPush)
          .then(function() {
            resolve(code);
          }, function() {
            reject();
          });
        });
      });

    }
  };
  return profile;
});
