angular.module('childcareOnApp').factory('CalendarFactory',function($firebaseObject, $firebaseArray, $q, $rootScope, ChildcareOnUtils){
  var fn = {
    getCalendar: function(type, id, start, end) {
      var ref;
      switch(type) {
        case 'allSchool': ref = firebase.database().ref('calendar/events/allSchool/'+id).orderByChild('date').startAt(start.getTime()).endAt(end.getTime());
        break;
        case 'classroom': ref = firebase.database().ref('calendar/events/classroom/'+id).orderByChild('date').startAt(start.getTime()).endAt(end.getTime());
        break;
        case 'child': console.log('id is', id); ref = firebase.database().ref('calendar/events/child/'+id).orderByChild('date').startAt(start.getTime()).endAt(end.getTime());
        break;
        case 'teacher': ref = firebase.database().ref('calendar/events/teacher/'+id).orderByChild('date').startAt(start.getTime()).endAt(end.getTime());
        break;
      }
      return $firebaseArray(ref);
    }, addEventToCalendar: function(type, ids, obj) {
      console.log('type', type);
      console.log('ids', ids);
      console.log('obj', obj);
      return $q(function (resolve, reject) {
        var ref;
        switch(type) {
          case 'allSchool': ref = firebase.database().ref('calendar/events/allSchool'); ids = [$rootScope.allUserInfo.school];
          break;
          case 'classroom': ref = firebase.database().ref('calendar/events/classroom');
          break;
          case 'child': ref = firebase.database().ref('calendar/events/child');
          break;
          case 'teacher': ref = firebase.database().ref('calendar/events/teacher');
          break;
        }
        if (ids.length > 1) {
          var objToUpload = [];
          ids.forEach(function(id) {
            console.log('id', id);
            var copiedObj = angular.copy(obj);
            copiedObj.notifications = copiedObj.notificationsIds[id];
            delete copiedObj.notificationsIds;
            console.log('copiedObj', copiedObj);
            objToUpload.push(copiedObj);
          });
          console.log('objToUpload', objToUpload);
        } else {
          var objToUpload = [obj];
        }
        var initialRef = $firebaseArray(ref.child(ids[0]));
        initialRef.$add(objToUpload[0])
        .then(function(initialResponse) {
          var promises = [];
          for (var i=1; i < ids.length; i++) {
            promises.push(
              ref.child(ids[i]).child(initialResponse.key).set(objToUpload[i])
            );
          }
          $q.all(promises)
          .then(function() {
            resolve();
          }, function() {
            reject();
          });
        });
      });
    }, addNotification: function(obj) {
      var ref = firebase.database().ref('calendar/notifications');
      if (!obj.ids) {
        return $firebaseArray(ref).$add(obj);
      } else {
        var promises = [];
        obj.ids.forEach(function(id) {
          var copyObj = angular.copy(obj);
          delete copyObj.ids;
          copyObj.id = id;
          promises.push(
            $firebaseArray(ref).$add(copyObj)
          );
        });
        return $q.all(promises);
      }
    }, deleteEvent: function(eventId, type, typeId) {
      return firebase.database().ref('calendar/events/'+type+'/'+typeId+'/'+eventId).remove();
    }, deleteNotification: function(notificationId) {
      return firebase.database().ref('calendar/notifications/'+notificationId).remove();
    }
  };
  return fn;
});