angular.module('childcareOnApp').factory('ChildFactory',function($firebaseObject, $firebaseArray, $q, $rootScope, CommonFactory, ChildcareOnUtils, configuration, $http){
  var user = {
    getChild: function(child){
      return $q(function(resolve, reject) {
        try{
          var ref = firebase.database().ref('child/');
          var dataRef = ref.child(child);
          var list = $firebaseObject(dataRef);
          list.$loaded().then(function(childInfo){
            resolve(childInfo);
          });
        }catch(e){
          console.log("error on getChild",e);
          reject();
        }
      });
    }, getUserChilds: function(children) {
      return $q(function(resolve, reject) {
        var childrenToReturn = {};
        var promises = [];
        for (var childId in children) {
          childrenToReturn[childId] = $firebaseObject(firebase.database().ref('child').child(childId));
          promises.push(childrenToReturn[childId].$loaded());
        }
        $q.all(promises)
        .then(function() {
          for (var childId in childrenToReturn) {
            if (!childrenToReturn[childId].name) {
              delete childrenToReturn[childId];
              delete $rootScope.allUserInfo.childs[childId];
              var obj = { user: $rootScope.allUserInfo.id, error:'Child in user not found in DB', page: 'app.main', date: JSON.stringify(new Date())};
              CommonFactory.saveLog(obj);
            }
          }
          resolve(childrenToReturn);
        });
      });
    },addParentToChild: function(childs,userUid){
      return $q(function(resolve, reject){
        if(childs === null) return resolve();
        var updates = {};
        for(var i in childs){
          updates ['child/'+i+'/parents/'+userUid] = "father";
          updates ['child/'+i+'/'+userUid] = "parent";
        }
        console.log("updates", updates);
        firebase.database().ref().update(updates)
        .then(function(){
          console.log("saved");
          resolve();
        },function(e){
          console.log("error on save",e);
          reject();
        });
      });
    }, getChildParents: function(parents) {
      var parentsToReturn = [];
      parents.forEach(function (parent) {
        parentsToReturn.push(
          $firebaseObject(firebase.database().ref('users').child(parent.$id))
        );
      });
      return parentsToReturn;
    }, getParents: function(childId) {
      return $firebaseArray(
        firebase.database().ref('child').child(childId).child('parents')
      );
    }, getHealthChild: function(childId){
      return $q(function(resolve, reject) {
        try{
          var ref = firebase.database().ref('health');
          var query = ref.child(childId);
          var list = $firebaseObject(query);
          list.$loaded().then(function(childHealth){
            console.log("child health",childHealth);
            resolve(childHealth);
          },function(e){
            console.log("error getHealthChild",e);
            reject();
          });
        }catch(e){
          console.log("error on getHealthChild",e);
          reject();
        }
      });
    }, getMedication: function (childId) {
      return $firebaseArray(
        firebase.database().ref('health').child(childId).child('medication')
      );
    }, getMedicalHistory: function (childId) {
      return $firebaseArray(
        firebase.database().ref('health').child(childId).child('medicalHistory')
      );
    }, getUrgentNotification: function(childId) {
      return $q(function(resolve, reject) {
        FirebasePlugin.fetchFirestoreCollection('health/' + childId + '/urgentNotification', [], function(documents){
          console.log("Successfully fetched collection: "+JSON.stringify(documents));
          var urgentNotification = Object.keys(documents).map(function (documentId) {
            var doc = documents[documentId];
            doc.$id = documentId;
            return doc;
          });
          resolve(urgentNotification);
        }, function(error){
          console.error("Error fetching collection: "+error);
          reject();
        });
      });
    }, sendUrgentNotification: function(notification,childId) {
      return $q(function(resolve, reject) {
        try {
          var obj = {
            senderId: $rootScope.allUserInfo.id,
            childId: childId,
            date: new Date().getTime(),
            message: notification,
          };
          FirebasePlugin.addDocumentToFirestoreCollection(obj, 'health/' + childId + '/urgentNotification', function(documentId) {
            resolve();
          }, function(error) {
            console.log('error', error);
            reject();  
          });
        } catch (error) {
          console.log('error', error);
          reject();
        }
      });
    }, getBirthdays: function () {
      return $q(function (resolve, reject) {
        try {
          var date = ChildcareOnUtils.parseDateToNumbers(new Date());
          FirebasePlugin.fetchDocumentInFirestoreCollection($rootScope.allUserInfo.school, 'statistics/birthday/' + date, function(document){
            console.log("Successfully fetched document: "+JSON.stringify(document));
            if (!!document && !!document.birthdays) {
              resolve(document.birthdays);
            } else {
              resolve([]);
            }
          }, function(error){
            console.log('error', error);
            resolve([]);
          });
        } catch (error) {
          console.log('error nono', error);
          console.log("$rootScope.allUserInfo.school",$rootScope.allUserInfo.school);
          reject($firebaseArray(firebase.database().ref('statistics/birthday/'+$rootScope.allUserInfo.school)));
        }
      });
    // }, getBirthdaysV2: function () {
    //   return $q(function (resolve, reject) {
    //     var date = ChildcareOnUtils.parseDateToNumbers(new Date());
    //     var birthdays = [];
    //     firebase.firestore().collection('statistics/birthday/'+date+'/schools/'+$rootScope.allUserInfo.school).get()
    //     .then(function (querySnapshot) {
    //       try {
    //         querySnapshot.forEach(function (doc) {
    //           // console.log(`${doc.id} => ${JSON.stringify(doc.data())}`);
    //           var data = doc.data();
    //           data.$id = doc.id;
    //           birthdays.push(data);
    //         });
    //         return resolve(birthdays);
    //       } catch (error) {
    //         console.log("error on try-catch", error);
    //         return resolve([]);
    //       }
    //     }, function (error) {
    //       console.log("error in birthdays");
    //       return resolve([]);
    //     });
    //   });
    }, removeParent: function(childId, parentId) {
      var promises = [
        firebase.database().ref('child/'+ childId +'/'+ parentId).set(null),
        firebase.database().ref('child/'+ childId +'/parents/'+ parentId).set(null),
        firebase.database().ref('users/'+ parentId +'/'+ childId).set(null),
        firebase.database().ref('users/'+ parentId +'/childs/'+ childId).set(null)
      ];
      return $q.all(promises);
    }, updateChildrenClassroomName: function(classroomName, children) {
      var promises = [];
      for (var childId in children) {
        promises.push(
          firebase.database().ref('child/'+ childId).update({classroomName: classroomName})
        );
      }
      return $q.all(promises);
    }, getChildrenFromClassroom: function(classroomId) {
      return $firebaseArray(firebase.database().ref('classrooms/'+classroomId+'/students'));
    }, createFirstStepsChild: function(child) {
      return $q(function(resolve, reject) {
        $firebaseArray(firebase.database().ref('child')).$add(child)
        .then(function (ref) {
          var id = ref.key;
          firebase.database().ref('classrooms').child(child.classroomId).child('students').child(id).set(child.name)
          .then(function() {
            resolve();
          });
        });
      });
    }, exportHealthExcel: function(data) {
      console.log("data",data);
      var url = configuration.url.exportHealthExcel;
      return $http({
        method: 'POST',
        url: url,
        headers: {
          'Content-Type': 'application/x-www-form-urlencoded'
        },
        data: data
      });
    }
  };
  return user;
});
