angular.module('childcareOnApp').factory('ClassroomFactory',function($firebaseObject, $firebaseArray, $q, $rootScope, CommonFactory){
  return {
    getClassroomStudents: function(classId){
      return $q(function(resolve, reject) {
        try{
          var ref = firebase.database().ref('classrooms/');
          var dataRef = ref.child(classId);
          var list = $firebaseObject(dataRef);
          list.$loaded().then(function(classInfo){
            resolve(classInfo);
          });
        }catch(e){
          console.log("error on getClassroomStudents",e);
          reject();
        }
      });
    }, getClassroomStudentsV2: function(classId) {
      return $firebaseObject(firebase.database().ref('classrooms/').child(classId));
    }, getStudentsClassroom: function(classroomId) {
      return $firebaseArray(
        firebase.database().ref('classrooms/').child(classroomId).child('students')
      );
    }, addClassroom:function(classroom){
      return $q(function(resolve, reject) {
        try{
          var list = $firebaseArray(firebase.database().ref('classrooms'));
          list.$add(classroom).then(function(ref) {
            var id = ref.key;
            console.log("added record with id " + id);
            var indexFor = list.$indexFor(id); // returns location in the array
            console.log("indexFor",indexFor);
            if(!$rootScope.school.classrooms) $rootScope.school.classrooms = {};
            $rootScope.school.classrooms[id] = classroom.name;
            CommonFactory._save($rootScope.school).then(function(){
              if (classroom.type.value !== 1) {
                if(!$rootScope.settings.classroomsDetails) $rootScope.settings.classroomsDetails = {};
                $rootScope.settings.classroomsDetails[id] = classroom.type.value;
              }
              if (!classroom.options.bottles) {
                if (!$rootScope.settings.hasOwnProperty('hideCard')) {
                  $rootScope.settings.hideCard = {};
                }
                if (!$rootScope.settings.hideCard.hasOwnProperty(id)) {
                  $rootScope.settings.hideCard[id] = {};
                }
                $rootScope.settings.hideCard[id].bottles = true;
              }
              console.log("settings now",$rootScope.settings);
              CommonFactory._save($rootScope.settings).then(function(){
                console.log("saved allUserInfo in addClassroom");
                if(!classroom.teachers) return resolve(id);
                console.log("continue");
                var accesRef = firebase.database().ref('classroomAccess').child($rootScope.school.$id).child(id);
                accesRef.update(classroom.teachers)
                .then(function(){
                  resolve(id);
                });
              });
            });
          });
        }catch(e){
          console.log("error on addClassroom",e);
          reject();
        }
      });
    }, addClassroomFirstSteps: function(classroom, schoolId) {
      return $q(function(resolve, reject) {
        $firebaseArray(firebase.database().ref('classrooms'))
        .$add(classroom).then(function(ref) {
          var id = ref.key;
          console.log("added classroom with id " + id);
          var addToSchool = firebase.database().ref('schools/'+ schoolId +'/classrooms/'+ id).set(classroom.name);
          var addToSettings = firebase.database().ref('diarySettings').child(schoolId).child('classroomsDetails').child(id).set(classroom.type.value);
          $q.all([addToSchool, addToSettings])
          .then(function() {
            resolve(id);
          });
        },function(e){
          console.log("error allUserInfo in addClassroom",e);
          reject();
        });
      });
    }, getClassroomType: function(settings,classroomId){
      if(!settings) settings = $rootScope.settings;
      if(settings.classroomsDetails && classroomId in settings.classroomsDetails){
        return settings.classroomsDetails[classroomId];
      } else {
        return 1;
      }
    }
  };
});
