angular.module('childcareOnApp').factory('CommonFactory',function($rootScope, $q, $http, $localStorage, ChildcareOnUtils){

  var stripslashes = function(str) {
    str = str.replace(/\\'/g, '\'');
    str = str.replace(/\\"/g, '"');
    str = str.replace(/\\0/g, '\0');
    str = str.replace(/\\\\/g, '');
    str = str.replace(/\n/g, '');
    str = str.replace(/\"/g,"");
    return str;
  };

  var common = {
    _save: function(user){
      return $q(function(resolve, reject) {
        user.$save().then(function(r){
          console.log("success save",r);
          resolve();
        },function(e){
          console.log("Error save",e);
          reject();
        });
      });
    },saveLog: function(obj){
      return $q(function(resolve, reject) {
        if(typeof cordova !== 'undefined') {
          cordova.getAppVersion.getVersionNumber().then(function (version) {
            obj.appVersion = version;
            try {
              if (!!obj.page) {
                var localObj = $localStorage.getCHObject('errors' + obj.page);
                if(
                  localObj.time && !!$rootScope.allUserInfo && localObj.id === $rootScope.allUserInfo.id &&
                  ChildcareOnUtils.isSameDay(new Date(parseInt(localObj.time)), new Date()) && localObj.obj.page === obj.page
                ) {
                  console.log('not updating error');
                } else {
                  console.log('updating error');
                  $localStorage.setCHObject('errors' + obj.page, {page: obj.page});
                  FirebasePlugin.addDocumentToFirestoreCollection(obj, 'errors', function(documentId) {
                    console.log("success save log", documentId);
                    resolve();
                  }, function(error) {
                    console.log("error on save log", error);
                    reject();
                  });
                }
              }
            } catch (error) {
              console.log("error on save log", error);
              reject();
            }
          });
        } else {
          resolve();
        }
      });
    },serverRequest: function(url,data){
      return $q(function(resolve, reject) {
        $http({
          method: 'POST',
          url: url,
          headers: {
            'Content-Type': 'application/x-www-form-urlencoded',
            'appName': 'ChildcareOn'
          },
          transformRequest: function(obj) {
              var str = [];
              for(var p in obj)
              str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
              return str.join("&");
          },
          data: data
        }).then(function(body){
          console.log("serverRequest success $http",body);
          resolve(body.data);
        },function(e){
          console.log("serverRequest $http failed",e);
          // var obj = {
          //   user: $rootScope.allUserInfo.id,
          //   error:stripslashes(JSON.stringify(e)),
          //   page:$state.current.name,
          //   date: JSON.stringify(new Date())
          // };
          // common.saveLog(obj);
          reject(e.data);
        });
      });
    },removeFirebaseProperties: function(obj){
      var objReturn = {};
      for(var i in obj){
        if(i.indexOf('$') === -1 && typeof obj[i] !== 'function'){
          objReturn[i] = obj[i];
        }
      }
      return objReturn;
    }
  };
  return common;
});
