angular.module('childcareOnApp').factory('CommunicationsFactory',function($q, $firebaseObject, $firebaseArray, UserFactory, ChildcareOnUtils, $rootScope){
  var ref = firebase.database().ref('communications');

  var _list = false;
  var _listScheduled = false;

  var communications = {
    getUserMessages: function(userUid){
      console.log("entra en getUserMessages:",userUid);
      //var ref = firebase.database().ref('communications/'+userUid);
      var userRef = ref.child('messages').child(userUid);
      var query = userRef.orderByChild('date');
      var list = $firebaseObject(query);
      return $q(function(resolve, reject) {
        list.$loaded().then(function(messages){
          console.log("messages",messages);
          var messageTemp = [];
          var sendersTemp = {};
          angular.forEach(messages, function(value, key) {
            if(value.userSender in sendersTemp){
              value.nameSender = sendersTemp[value.userSender];
            }else{
              UserFactory.getUserNameByUid(value.userSender).then(function(name){
                sendersTemp[value.userSender] = name;
                value.nameSender = name;
              });
            }
            value.id = key;
            ChildcareOnUtils.dateCommunications(value.date).then(function(dateParsed){
              value.date = dateParsed;
              messageTemp.push(value);
            });
          });
          resolve(messageTemp);
        },function(e){
          reject(e);
        });
      });
    },getClassroomMessages: function(classroomId){
      _list = $firebaseArray(ref.child('messages').child(classroomId).orderByChild('date'));
      return _list;
    }, getChildMessages: function(childId) {
      console.log('childId', childId);
      _list = $firebaseArray(ref.child('messagesChild').child(childId).orderByChild('date'));
      return _list;
    }, getScheduledMessages: function(classroomId) {
      _listScheduled = $firebaseArray(ref.child('scheduled').orderByChild('classroomId').equalTo(classroomId));
      return _listScheduled;
    }, getChildScheduledMessages: function(childId) {
      _listScheduled = $firebaseArray(ref.child('scheduled').orderByChild('childId').equalTo(childId));
      return _listScheduled;
    },sendMessage: function(classroomsToSend,message, imageUrl, documentUrl, addedLink1, addedLink2, scheduledTime){
      return $q(function(resolve, reject) {
        console.log("imageUrl",imageUrl,typeof imageUrl);
        // int userSender, array userReceiver, string message
        var dateTime = new Date().getTime();
        var messageToSend = {
          date: dateTime,
          title: message.title,
          userSender: $rootScope.allUserInfo.$id,
          userSenderName: $rootScope.allUserInfo.name,
          message: message.message,
          school: $rootScope.allUserInfo.school
        };
        if(typeof imageUrl !== 'undefined') messageToSend.image = imageUrl;
        if(typeof message.images !== 'undefined') messageToSend.images = message.images;
        if(typeof documentUrl !== 'undefined') messageToSend.document = documentUrl;
        if(typeof addedLink1 !== 'undefined') messageToSend.addedLink1 = addedLink1;
        if(typeof addedLink2 !== 'undefined') messageToSend.addedLink2 = addedLink2;
        if(scheduledTime !== null) messageToSend.scheduledTime = scheduledTime.getTime();
        if($rootScope.allUserInfo.hasOwnProperty('photo')) messageToSend.photo = $rootScope.allUserInfo.photo;
        for (var i in classroomsToSend) {
          if(!classroomsToSend[i]) delete classroomsToSend[i];
        }
        var firstClassroomId = Object.keys(classroomsToSend)[0];
        var firstClassroomRef;
        if(scheduledTime === null) {
          firstClassroomRef = ref.child('messages').child(firstClassroomId);
        }else{
          messageToSend.classroomId = firstClassroomId;
          firstClassroomRef = ref.child('scheduled');
        }
        var copiedMessageToSend = angular.copy(messageToSend);
        $firebaseArray(firstClassroomRef).$add(messageToSend).then(function(savedRef) {
          console.log('saved communication classroom base', messageToSend);
          var promises = [];
          var messageId = savedRef.key;
          for(var i in classroomsToSend) {
            if (i === firstClassroomId) {
              continue;
            }
            var userRef;
            if(scheduledTime === null) {
              userRef = ref.child('messages').child(i).child(messageId);
              console.log('add to promise new classroom', i);
              promises.push(
                userRef.set(copiedMessageToSend)
              );
            }else{
              copiedMessageToSend.classroomId = i;
              userRef = ref.child('scheduled');
              console.log('add to promise new classroom', i);
              promises.push(
                userRef.push(copiedMessageToSend)
              );
            }
          }
          $q.all(promises)
          .then(function() {
            console.log('after all promises');
            resolve(messageId);
          }, function() {
            console.log('after all promises error');
            reject();
          });
        });
      });
    }, sendIndividualMessage: function(childrenToSend, message, imageUrl, documentUrl, addedLink1, addedLink2, scheduledTime) {
      return $q(function(resolve, reject) {
        console.log("imageUrl",imageUrl,typeof imageUrl);
        // int userSender, array userReceiver, string message
        var dateTime = new Date().getTime();
        var messageToSend = {
          date: dateTime,
          title: message.title,
          userSender: $rootScope.allUserInfo.$id,
          userSenderName: $rootScope.allUserInfo.name,
          message: message.message,
          school: $rootScope.allUserInfo.school,
          type: 'individual'
        };
        if(typeof imageUrl !== 'undefined') messageToSend.image = imageUrl;
        if(typeof message.images !== 'undefined') messageToSend.images = message.images;
        if(typeof documentUrl !== 'undefined') messageToSend.document = documentUrl;
        if(typeof addedLink1 !== 'undefined') messageToSend.addedLink1 = addedLink1;
        if(typeof addedLink2 !== 'undefined') messageToSend.addedLink2 = addedLink2;
        if(scheduledTime !== null) messageToSend.scheduledTime = scheduledTime.getTime();
        if($rootScope.allUserInfo.hasOwnProperty('photo')) messageToSend.photo = $rootScope.allUserInfo.photo;
        for (var i in childrenToSend) {
          if(!childrenToSend[i]) delete childrenToSend[i];
        }
        var firstChildId = Object.keys(childrenToSend)[0];
        var firstChildRef;
        if(scheduledTime === null) {
          firstChildRef = ref.child('messagesChild').child(firstChildId);
        }else{
          messageToSend.childId = firstChildId;
          messageToSend.type = 'individual';
          firstChildRef = ref.child('scheduled');
        }
        var copiedMessageToSend = angular.copy(messageToSend);
        $firebaseArray(firstChildRef).$add(messageToSend).then(function(savedRef) {
          console.log('saved communication child base', messageToSend);
          var promises = [];
          var messageId = savedRef.key;
          for(var i in childrenToSend) {
            if (i === firstChildId) {
              continue;
            }
            var userRef;
            if(scheduledTime === null) {
              userRef = ref.child('messagesChild').child(i).child(messageId);
            }else{
              copiedMessageToSend.childId = i;
              userRef = ref.child('scheduled').child(messageId);
            }
            console.log('add to promise new child', i);
            promises.push(
              userRef.set(copiedMessageToSend)
            );
          }
          $q.all(promises)
          .then(function() {
            console.log('after all promises');
            resolve(messageId);
          }, function() {
            console.log('after all promises error');
            reject();
          });
        });
      });
    }, deleteScheduledCommunication: function(item){
      return $q(function(resolve, reject){
        _listScheduled.$remove(item).then(function(){
          console.log("success deleteCommunication");
          resolve();
        },function(error){
          console.log("error on deleteCommunication");
          reject();
        });
      });
    },deleteCommunication: function(item){
      if(item.hasOwnProperty('scheduledTime')) return communications.deleteScheduledCommunication(item);
      return $q(function(resolve, reject){
        _list.$remove(item).then(function(){
          console.log("success deleteCommunication");
          resolve();
        },function(error){
          console.log("error on deleteCommunication");
          reject();
        });
      });
    }, getReadMessage: function() {
      return $firebaseObject(ref.child('readed').child($rootScope.allUserInfo.id));
    }, saveReadedMessage: function (id) {
      return ref.child('readed').child($rootScope.allUserInfo.id).child(id).set({
        date: new Date().getTime()
      });
    }, testSave: function(userSender, userReceiver, message){
      // int userSender, array userReceiver, string message
      console.log("entra en testSave");
      //var ref = firebase.database().ref('communications/messages/testReceiver');
      var userRef = ref.child('messages').child('testReceiver');
      var list = $firebaseObject(userRef);
      return $q(function(resolve, reject) {
        try{
          var dateTime = new Date().getTime();
          list.userReceiver = userReceiver;
          list.date = dateTime;
          list.userSender = userSender;
          list.sentBy = message;
          list.$save().then(function(ref) {
            resolve(ref);
          },function(e){
            reject(e);
          });
        }catch(e){
          reject(e);
        }
      });
    }
  };
  return communications;
});
