angular.module('childcareOnApp').factory('DiaryFactory',function($firebaseObject, $firebaseArray, $rootScope, $q, $translate, ChildcareOnUtils, $localStorage){

  function checkSettings (name, classroomType, classroomId) {
    if(!$rootScope.settings) return false;
    var classroomSelectedType = (!!$rootScope.settings.classroomsDetails && $rootScope.settings.classroomsDetails[classroomId]) ?
      $rootScope.settings.classroomsDetails[classroomId] : 1;
    if(!$rootScope.settings[name] && (classroomSelectedType === classroomType || classroomType === 0)) return true;
    if (classroomType !== 0 && classroomSelectedType !== classroomType) return false;
    return (!$rootScope.settings[name] || !$rootScope.settings[name].hasOwnProperty('type') || $rootScope.settings[name].type === 'all' || $rootScope.settings[name].type === classroomType);
  }

  var diary = {
    getDiary: function(childId,day){
      return $q(function(resolve, reject) {
        try{
          var ref = firebase.database().ref('diary').child(childId);
          //if($rootScope.allUserInfo.type === 'user') ref = ref.child(day);
          var list = $firebaseObject(ref);
          list.$loaded().then(function(childInfo){
            console.log("getDiary",childInfo);
            resolve(childInfo);
          });
        }catch(e){
          console.log("error on getDiary",e);
          reject();
        }
      });
    },getNewDiary:function(childId,day){
      return $q(function(resolve, reject) {
        try{
          var ref = firebase.database().ref('diary').child(childId).child(day);
          //if($rootScope.allUserInfo.type === 'user') ref = ref.child(day);
          var list = $firebaseObject(ref);
          list.$loaded().then(function(childInfo){
            console.log("getDiary",childInfo);
            resolve(childInfo);
          });
        }catch(e){
          console.log("error on getDiary",e);
          reject();
        }
      });
    },getNewDiaryV2:function(childId,day){
      var ref = firebase.database().ref('diary').child(childId).child(day);
      return $firebaseObject(ref);
    },getMedals:function(childId){
      var ref = firebase.database().ref('diaryMedals').child('medals').child(childId);
      return $firebaseObject(ref);
    },getDictionary: function(){
      return $q(function(resolve, reject) {
        var ref = firebase.database().ref('diaryDictionary').child($rootScope.allUserInfo.school);
        var list = $firebaseObject(ref);
        list.$loaded().then(function(dictionary){
          console.log("diaryDictionary",dictionary);
          resolve(dictionary);
        }),function(e){
          console.log("error load diaryDictionary",e);
          reject();
        };
      });
    }, getSettings: function(schoolId) {
      return $q(function(resolve, reject) {
        if($rootScope.settings && $rootScope.settings.$id === schoolId) {
          resolve($rootScope.settings);
          return;
        }
        var list = $firebaseObject(
          firebase.database().ref('diarySettings').child(schoolId)
        );
        list.$loaded().then(function(settings){
          console.log("getSettings",settings);
          $localStorage.setCHObject('settings', settings, schoolId);
          resolve(settings);
        }),function(e){
          console.log("error load getSettings",e);
          reject();
        };
      });
    }, sendCommentAllClassroom: function(comment, childsInput){
      console.log("childsInput",childsInput);
      var childs = [];
      for(var i in childsInput) {
        if(childsInput[i]) {
          childs.push(i);
        }
      }
      if(childs.length === 0) return $q.reject('noChildren');
      console.log("childs final",childs);
      console.log("comment is",comment);
      var message = {
        date: new Date().getTime(),
        message: comment,
        sender: $rootScope.allUserInfo.$id,
        senderName: $rootScope.allUserInfo.name,
        type: 'teacher'
      };
      var currentDiaryDate = ChildcareOnUtils.parseDateToNumbers(ChildcareOnUtils.getCurrentDayOrMonday());
      var promises = [];
      for (var i=0; i < childs.length; i++) {
        promises.push(
          $firebaseArray(firebase.database().ref('diaryChat').child(childs[i]).child(currentDiaryDate)).$add(message),
          firebase.database().ref('/diary/'+ childs[i] +'/'+ currentDiaryDate +'/observationsTeacher/'+ message.date)
          .set(message)
        );
      }
      return $q.all(promises);
    }, sendSleepAllClassroom: function(comment, childsInput){
      return $q(function(resolve, reject) {
        console.log("childsInput",childsInput);
        var childs = [];
        for(var i in childsInput) {
          if(childsInput[i]) {
            childs.push(i);
          }
        }
        if(childs.length === 0) return reject('noChilds');
        console.log("childs final",childs);
        console.log("comment is",comment);
        var message = {
          value: true
        };
        if (!!comment.time) {
          message.time = comment.time;
        }
        var currentDiaryDate = ChildcareOnUtils.parseDateToNumbers(ChildcareOnUtils.getCurrentDayOrMonday());
        var promises = [];
        for (var i=0; i < childs.length; i++) {
          promises.push(
            firebase.database().ref('/diary/'+ childs[i] +'/'+ currentDiaryDate +'/rest/'+ comment.type)
            .set(message)
          );
        }
        $q.all(promises)
        .then(function () {
          console.log("success sendSleepAllClassroom");
          resolve();
        }, function(error) {
          console.log('error is', error);
          reject();
        });
      });
    }, sendMealAllClassroom: function(comment, childsInput, typeOfMeal) {
      return $q(function(resolve, reject) {
        console.log("childsInput",childsInput);
        var childs = [];
        for(var i in childsInput) {
          if(childsInput[i]) {
            childs.push(i);
          }
        }
        if(childs.length === 0) {
          return reject('noChilds');
        }
        console.log("childs final",childs);
        console.log("comment is",comment);
        var message = {
          value: comment
        };
        var currentDiaryDate = ChildcareOnUtils.parseDateToNumbers(ChildcareOnUtils.getCurrentDayOrMonday());
        for (var i=0; i < childs.length; i++) {
          firebase.database().ref('/diary/'+ childs[i] +'/'+ currentDiaryDate +'/meals/'+ typeOfMeal)
          .update(message);
        }
        console.log("success sendMealAllClassroom");
        resolve();
      });
    },sendDefecationsAllClassroom: function(comment, childsInput){
      return $q(function(resolve, reject) {
        console.log("childsInput",childsInput);
        console.log("comment",comment);
        var childs = [];
        for(var i in childsInput) {
          if(childsInput[i]) {
            childs.push(i);
          }
        }
        if(childs.length === 0) return reject('noChilds');
        console.log("childs final",childs);
        console.log("comment is",comment);
        var currentDiaryDate = ChildcareOnUtils.parseDateToNumbers(ChildcareOnUtils.getCurrentDayOrMonday());
        var updates = {};
        if (!comment.time) {
          return reject();
        }
        if (!!comment.time.morning) {
          updates.morning = comment.time.morning;
        }
        if (!!comment.time.afternoon) {
          updates.afternoon = comment.time.afternoon;
        }
        for (var i=0; i < childs.length; i++) {
          firebase.database().ref('/diary/'+ childs[i] +'/'+ currentDiaryDate +'/defecations/')
          .update(updates);
        }
        console.log("success sendMealAllClassroom");
        resolve();
      });
    },sendDailyActivityAllClassroom: function(comment, childsInput){
      return $q(function(resolve, reject) {
        console.log("childsInput",childsInput);
        console.log("comment",comment);
        var childs = [];
        for(var i in childsInput)
          if(childsInput[i])
            childs.push(i);
        if(childs.length === 0) return reject('noChilds');
        var currentDiaryDate = ChildcareOnUtils.parseDateToNumbers(ChildcareOnUtils.getCurrentDayOrMonday());
        console.log("currentDiaryDate",currentDiaryDate);
        for(var i=0; i<childs.length; i++){
          var studentId = childs[i];
          console.log("studentId",studentId);
          firebase.database().ref('diary/'+studentId+'/'+currentDiaryDate+'/dailyActivity/value').set(comment);
        }
        resolve();
      });
    },getIfShowCard: function(name, classroomType, classroomId) {
      var settings = checkSettings(name, classroomType, classroomId);
      if (!settings) return false;
      return (!$rootScope.settings.hideCard || !$rootScope.settings.hideCard[classroomId] || !$rootScope.settings.hideCard[classroomId][name]);
    }, saveLastView: function(studentId,currentDiaryDate){
      firebase.database().ref('diaryLastView/'+studentId+'/'+currentDiaryDate+'/'+$rootScope.allUserInfo.id).set({date: new Date().getTime(), name: $rootScope.allUserInfo.name + " " + $rootScope.allUserInfo.surname });
    },getLastView: function(studentId,currentDiaryDate){
      return $firebaseArray(firebase.database().ref('diaryLastView/'+studentId+'/'+currentDiaryDate));
    }, getIfPaidDiary: function(childId) {
      return $firebaseObject(firebase.database().ref('diaryPaid/paid/'+childId));
    }, saveLogPayClick: function(childId, lang) {
      $firebaseArray(firebase.database().ref('diaryPaid/log')).$add({
        date: new Date().getTime(),
        user: $rootScope.allUserInfo.id,
        childId: childId,
        action: 'requested',
        lang: lang
      });
    }, productPurchased: function(product, childId, lang, productPurchased) {
      return $q(function (resolve, reject) {
        if (!childId) {
          childId = 'unknown';
        }
        var dataToSend = {
          date: new Date().getTime(),
          user: $rootScope.allUserInfo.id,
          product: JSON.stringify(product),
          platform: ($rootScope.isAndroid)? 'Android' : 'iOS'
        };
        if (!!lang) {
          dataToSend.lang = lang;
        }
        if (!!productPurchased) {
          dataToSend.productPurchased = productPurchased;
        }
        $firebaseArray(firebase.database().ref('diaryPaid/log')).$add({
          date: new Date().getTime(),
          user: $rootScope.allUserInfo.id,
          childId: childId,
          action: 'paid',
          additional: JSON.stringify(product),
          platform: ($rootScope.isAndroid)? 'Android' : 'iOS'
        });
        firebase.database().ref('diaryPaid/paid/'+childId).set(dataToSend)
        .then(function () {
          resolve();
        });
      });
    }, saveTransactionLog: function(log) {
      $firebaseArray(firebase.database().ref('diaryPaid/paidLog')).$add({
        date: new Date().getTime(),
        user: $rootScope.allUserInfo.id,
        platform: ($rootScope.isAndroid)? 'Android' : 'iOS'
      });
      $firebaseArray(firebase.database().ref('diaryPaid/paidLog')).$add({
        date: new Date().getTime(),
        user: $rootScope.allUserInfo.id,
        log: JSON.stringify(log),
        platform: ($rootScope.isAndroid)? 'Android' : 'iOS'
      });
    }, savePossibleBuyer: function() {
      $firebaseArray(firebase.database().ref('diaryPaid/paidLog')).$add({
        date: new Date().getTime(),
        user: $rootScope.allUserInfo.id,
        type: 'possibleBuyer',
        platform: ($rootScope.isAndroid)? 'Android' : 'iOS'
      });
    }, saveLoginPossibleBuyer: function() {
      $firebaseArray(firebase.database().ref('diaryPaid/loginPaidLog')).$add({
        date: new Date().getTime(),
        user: $rootScope.allUserInfo.id,
        type: 'possibleBuyer',
        platform: ($rootScope.isAndroid)? 'Android' : 'iOS'
      });
    }, saveNeeded: function(studentId, inputDate) {
      var todayNotification = new Date();
      todayNotification.setMinutes(0);
      todayNotification.setSeconds(0);
      var tomorrowNotification = ChildcareOnUtils.getTomorrowOrMonday();
      var lang = $rootScope.school.lang || 'es';
      if (todayNotification.getHours() < 18) {
        todayNotification.setHours(18);
        firebase.database().ref('diaryAdvice/needed/today/'+ studentId).set({
          date: todayNotification.getTime(),
          diaryDay: inputDate,
          childId: studentId,
          lang: lang
        });
      }
      tomorrowNotification.setHours(7); 
      tomorrowNotification.setMinutes(0);
      tomorrowNotification.setSeconds(0);
      firebase.database().ref('diaryAdvice/needed/tomorrow/'+ studentId).set({
        date: tomorrowNotification.getTime(),
        diaryDay: inputDate,
        childId: studentId,
        lang: lang
      });
    }, getTempThumb: function (studentId, inputDate) {
      return $firebaseObject(firebase.database().ref('diary/tempThumb/' + studentId + '/' + inputDate));
    }, getDiaryChat: function(childId, day) {
      return $firebaseArray(
        firebase.database().ref('diaryChat').child(childId).child(day)
      );
    }, getOtherDayLocalDiaryChat: function(childId, day) {
      var localDiaryChat = $localStorage.getCHObject('diaryChat_' + childId + '_' + day);
      console.log('localDiaryChat', localDiaryChat);
      if (!!localDiaryChat.time) {
        console.log('using local');
        return localDiaryChat.obj;
      } else {
        var chat = $firebaseArray(
          firebase.database().ref('diaryChat').child(childId).child(day)
        );
        chat.$loaded()
        .then(function() {
          $localStorage.setCHArray('diaryChat_' + childId + '_' + day, chat, childId)
        });
        return chat;
      }
    }, getParentsDocuments: function(childId, day) {
      var ref = firebase.database().ref('diaryCards/parentsDocuments').child(childId).child(day);
      return $firebaseArray(ref);
    }
  };
  return diary;
});
