angular.module('childcareOnApp').factory('DocumentsFactory',function($firebaseObject, $firebaseArray, $rootScope, $q, CommonFactory){
  var fn = {
    getDocuments: function(schoolId){
      return $firebaseArray(firebase.database().ref('documents/'+schoolId));
    },
    addMenuDocument: function(documentAdd){
      return $q(function(resolve,reject){
        console.log("before add");
        var obj = {
          name: documentAdd.name,
          type: documentAdd.type,
          url: documentAdd.url,
          date: new Date().getTime()
        };
        if (!!documentAdd.location) {
          obj.location = documentAdd.location;
        }
        console.log('obj', obj);
        $firebaseArray(firebase.database().ref('documents').child($rootScope.allUserInfo.school))
        .$add(obj).then(function(){
          console.log("success add to db");
          resolve();
        },function(error){
          console.log("error on add to db",error);
          CommonFactory.saveLog({
            user: $rootScope.allUserInfo.id,
            error: "Error upload document on db",
            errorCode: error,
            errorMessage: error
          });
          reject();
        });
      });
    }
  };
  return fn;
});
