angular.module('childcareOnApp').factory('FeedbackFactory',function($rootScope, $firebaseObject, $firebaseArray, $q, FirebasePluginFactory, $translate, $http, configuration){
  var fn = {
    getFeedback: function(message){
      return $q(function(resolve, reject) {
        var ref = firebase.database().ref('feedback/'+$rootScope.allUserInfo.id).limitToLast(100);
        var list = $firebaseArray(ref);
        list.$loaded().then(function(feedback) {
          console.log("get feedback",feedback);
          resolve(feedback);
        },function(e){
          console.log("error getFeedback",e);
          reject();
        });
      });
    },sendFeedback: function(message, type){
      return $q(function(resolve, reject) {
        var list = $firebaseArray(
          firebase.database().ref('feedback/'+$rootScope.allUserInfo.id)
        );
        var dateTime = new Date().getTime();
        var messageToSend = {
          date:dateTime,
          sender: "user",
          message:message,
          email:$rootScope.allUserInfo.email,
          name: $rootScope.allUserInfo.name
        };
        if (type === 'image') {
          messageToSend.type = 'image';
        }
        list.$add(messageToSend).then(function(ref) {
          resolve(ref);
        },function(e){
          console.log("error sendFeedback",e);
          reject();
        });
      });
    }, sendFirstSteps: function(message) {
      return $q(function(resolve, reject) {
        var messageToSend = {
          date: new Date().getTime(),
          sender: "user",
          message:message,
          email:$rootScope.allUserInfo.email,
          name: $rootScope.allUserInfo.name,
        };
        try {
          messageToSend.timezoneOffset = new Date().getTimezoneOffset();
        } catch (error) {
          console.log('error', error);
        }
        $firebaseArray(firebase.database().ref('feedbackFirstSteps/'+$rootScope.allUserInfo.id))
        .$add(messageToSend).then(function() {
          FirebasePluginFactory.logEvent('firstSteps');
          resolve();
        },function(e){
          console.log("error sendFeedback",e);
          reject();
        });
      });
    // }, getPoll: function() {
    //   return $q(function (resolve, reject) {
    //     firebase.firestore().doc('news/poll/result/'+$rootScope.allUserInfo.id).get()
    //     .then(function (doc) {
    //       resolve(doc.exists);
    //     }).catch(function(error) {
    //       reject();
    //       console.log('Error getting document:', error);
    //     });
    //   });
    // }, savePoll: function(questions) {
    //   return $q(function (resolve, reject) {
    //     firebase.firestore().doc('news/poll/result/'+$rootScope.allUserInfo.id).set(questions)
    //     .then(function () {
    //       if (!NativeStorage) {
    //         return resolve();
    //       }
    //       NativeStorage.setItem("poll", {completed: true}, function(){
    //         console.log("saved nativeStorage poll");
    //         resolve();
    //       }, function(error){
    //         console.log("error on saving nativeStorage poll", error);
    //         resolve();
    //       });
    //     }).catch(function(error) {
    //       reject();
    //       console.log('Error saving document:', error);
    //     });
    //   });
    // }, getIfPollActivated: function() {
    //   return $q(function (resolve, reject) {
    //     fn.getPollFromStorage()
    //     .then(function () {
    //       firebase.firestore().doc('news/poll').get()
    //       .then(function (doc) {
    //         if (doc.exists) {
    //           var poll = doc.data();
    //           console.log('poll is', poll);
    //           resolve(poll.active);
    //         } else {
    //           console.log('poll not exists');
    //           resolve(false);
    //         }
    //       }).catch(function(error) {
    //         reject();
    //         console.log('Error getting document:', error);
    //       });
    //     }, function () {
    //       resolve(false);
    //     });
    //   });
    // }, getPollFromStorage: function() {
    //   return $q(function(resolve, reject) {
    //     if (typeof NativeStorage === 'undefined') {
    //       return resolve();
    //     }
    //     NativeStorage.getItem("poll", function(poll){
    //       console.log('nativeStorage poll', poll);
    //       if (!poll.hasOwnProperty('completed') || !poll.completed) {
    //         console.log('getPollFromStorage no exists');
    //         return resolve();
    //       }
    //       console.log('getPollFromStorage exists');
    //       return reject();
    //     }, function (error) {
    //       console.log('error getting nativeStorage poll', error);
    //       return resolve();
    //     });
    //   });
    }, createFirstStepsSchool: function(name, city, phoneNumber, comment) {
      return $q(function(resolve, reject) {
        var school = {
          name: name,
          test: true,
          city: city,
          phoneNumber: phoneNumber,
          dateCreated: new Date().getTime(),
          principals: {}
        };
        if (!!comment) {
          school.comment = comment;
        }
        school[$rootScope.allUserInfo.id] = 'principal';
        school.principals[$rootScope.allUserInfo.id] = $rootScope.allUserInfo.name + ' ' + $rootScope.allUserInfo.surname;
        try {
          if ($translate.use().indexOf('en') !== -1) {
            school.lang = 'en';
          }
          if ($translate.use().indexOf('ca') !== -1) {
            school.lang = 'ca';
          }
        } catch (error) {
          console.log('error trying to get lang', error);
        }
        $firebaseArray(firebase.database().ref('schools')).$add(school)
        .then(function(ref) {
          var id = ref.key;
          $rootScope.allUserInfo.type = 'principal';
          $rootScope.allUserInfo.school = id;
          $rootScope.allUserInfo.$save().then(function(){
            resolve(id);
          });
        });
      });
    }, saveSchoolLog: function(schoolId) {
      return $q(function(resolve, reject) {
        var json = configuration.url.schoolCreated + '?schoolId='+schoolId+'&userId='+$rootScope.allUserInfo.id;
        $http.get(json).then(function(result) {
          resolve();
        }, function(e) {
          resolve();
        });
      });
    }
  };
  return fn;
});
