angular.module('childcareOnApp').factory('FirebasePluginFactory',function($rootScope, $q, $translate, CommonFactory, UserFactory, $state, $filter, NotificationFactory){
  var tokenCache = false;

  var firebase = {
    setUserId:function(){
      try{
        if(window.FirebasePlugin && !$rootScope.testMode){
          window.FirebasePlugin.setUserId($rootScope.allUserInfo.id);
          window.FirebasePlugin.setCrashlyticsUserId($rootScope.allUserInfo.id);
          console.log("setUserId done");
        }
      }catch(e){
        console.log("error on setUserId FirebasePlugin",e);
      }
    },setUserProperty: function(name,value){
      if(window.FirebasePlugin && !$rootScope.testMode){
        window.FirebasePlugin.setUserProperty(name, value);
        console.log("setUserProperty done",name,value);
      }
    }, getUserToken: function(permissionGranted) {
      if(!window.FirebasePlugin){
        return false;
      }
      window.FirebasePlugin.getToken(function(token) {
        // save this server-side and use it to push notifications to this device
        console.log("getToken success",token);
        if (!!token) {
          tokenCache = token;
          UserFactory.saveRegistrationId(token, permissionGranted).then(function(topics){
            console.log("topics",topics);
            for(var i=0; i<topics.length; i++){
              firebase.subscribeToTopic(topics[i]);
            }
          });
        }
        firebase.onMessageReceived();
      }, function(error) {
        console.log("getToken error",error);
      });
      window.FirebasePlugin.onTokenRefresh(function(token) {
        // save this server-side and use it to push notifications to this device
        console.log('token refresh', token);
        if (tokenCache !== token) {
          tokenCache = token;
          console.log('entra en token refresh');
          UserFactory.saveRegistrationId(token, permissionGranted);
        }
      }, function(error) {
          console.log(error);
      });
    },setCurrentScreen: function(name){
      if(window.FirebasePlugin && !$rootScope.testMode){
        console.log("try to save currentScreen");
        window.FirebasePlugin.setScreenName(name);
      }
    },grantPermission: function(){
      if(!$rootScope.isAndroid && window.FirebasePlugin && !$rootScope.testMode){
        window.FirebasePlugin.grantPermission();
      }
    }, hasPermission: function () {
      return $q(function (resolve, reject) {
        if (window.FirebasePlugin) {
          window.FirebasePlugin.hasPermission(function(hasPermission){
            console.log("Notifications Permission is " + (hasPermission ? "granted" : "denied"));
            resolve(hasPermission);
          });
        } else {
          resolve(true);
        }
      });
    }, onMessageReceived: function(){
      if(window.FirebasePlugin){
        window.FirebasePlugin.onMessageReceived(function(notification) {
          // var notification = {"google.sent_time": 1510182520874, tap: true, from: "778400249650", hasExtra: "true", "google.message_id": "0:1510182520887889%2ff3513d2ff3513d",collapse_key:"com.childcareon.childcareon", genNotificationId:"1510182486045"};
          console.log("notification received!",notification);
          console.log("notification.tap",notification.tap);
          ionic.Platform.ready(function(){
            if(!$rootScope.allUserInfo) return console.log("no $rootScope.allUserInfo");
            if(notification.tap) {
              $rootScope.show();
              setTimeout(function() {
                $rootScope.hide();
                if(typeof notification.hasExtra === 'undefined'){
                  $state.go('app.notifications');
                  return console.log("no notification.hasExtra");
                }
                console.log("after notification.hasExtra");
                if(typeof notification.genNotificationId !== 'undefined'){
                  if(typeof $rootScope.notifications === 'undefined'){
                    return console.log("$rootScope.notifications === 'undefined'");
                  }
                  $rootScope.notifications.$loaded().then(function() {
                    var notifSelected = $filter('filter')($rootScope.notifications,{genNotificationId:notification.genNotificationId});
                    console.log("notifSelected",notifSelected);
                    if(notifSelected.length !== 1) return;
                    if("isReaded" in notifSelected[0] && !notifSelected[0].isReaded){
                      notifSelected[0].isReaded = true;
                      notifSelected[0].isAck = true;
                      $rootScope.notifications.$save(notifSelected[0]).then(function(){
                        console.log("notifications updated!");
                        firebase.setBadgeNumber();
                      },function(e){
                        console.log("error updating notifications",e);
                      });
                    }
                    setTimeout(function(){
                      NotificationFactory.goToPage(notifSelected[0].page,notifSelected[0].extra,notifSelected[0].pushText,500);
                    },500);
                  });
                }else if(typeof notification.page !== 'undefined' && typeof notification.chat !== 'undefined'){
                  console.log("after ionic ready");
                  setTimeout(function(){
                    NotificationFactory.goToPageOther(notification.page,{chat:notification.chat},500);
                  },500);
                }
              }, 5000);
            } else {
              navigator.notification.confirm($translate.instant('notifications_goToPageNotifications'), function(buttonIndex) {
                if(buttonIndex === 2) {
                  $state.go('app.notifications');
                }
              }, $translate.instant('notifications_newNotification'), [ $translate.instant('no'), $translate.instant('yes')]);
            }
          });
        }, function(error) {
          console.error("error notification received",error);
        });
      }
    },logEvent: function(name, value){
      if(typeof value === 'undefined') value = {};
      if(window.FirebasePlugin && !$rootScope.testMode){
        try {
          window.FirebasePlugin.logEvent(name, value);
        } catch (error) {
          console.log('error', error);
        }
      }
    },subscribeToTopic: function(topicName){
      if(window.FirebasePlugin) window.FirebasePlugin.subscribe(topicName);
    },unregister: function(){
      if(window.FirebasePlugin) window.FirebasePlugin.unregister();
    },setBadgeNumber: function(){
      if(!window.FirebasePlugin) return;
      if(typeof $rootScope.notifications === 'undefined') return;
      window.FirebasePlugin.setBadgeNumber($filter('filter')($rootScope.notifications,{isAck:'!true'}).length);
    },removeBadgeNumber: function(){
      if(!window.FirebasePlugin) return;
      window.FirebasePlugin.setBadgeNumber(0);
    }, getRemoteConfigValue: function(key) {
      return $q(function (resolve, reject) {
        if(!window.FirebasePlugin) {
          return reject();
        }
        window.FirebasePlugin.getValue(key, function(value) {
          console.log('remote config value', value);
          resolve(value);
        }, function(error) {
          console.error(error);
          reject();
        });
      });
    }
  };
  return firebase;
})

.factory('BadgeNumberFactory',function($rootScope, $filter){
  var methods = {
    setBadgeNumber: function(){
      if(!window.FirebasePlugin) return;
      if(typeof $rootScope.notifications === 'undefined') return;
      window.FirebasePlugin.setBadgeNumber($filter('filter')($rootScope.notifications,{isAck:'!true'}).length);
    },removeBadgeNumber: function(){
      if(!window.FirebasePlugin) return;
      window.FirebasePlugin.setBadgeNumber(0);
    }
  };
  return methods;
});
