angular.module('childcareOnApp').factory('InternalChatFactory',function($rootScope, $firebaseObject, $firebaseArray, $q){
  var chats = [];
  var chatsLoaded = {};
  var relationChatKey = {};
  function getChatKey(chat1, chat2){
    return (chat1 < chat2)? chat1+"_"+chat2 : chat2+"_"+chat1;
  }
  for(var i in $rootScope.school.teachers){
    if(i !== $rootScope.allUserInfo.id){
      var key = getChatKey($rootScope.allUserInfo.id, i);
      var ref = firebase.database().ref('internalChat/'+$rootScope.allUserInfo.school+'/'+key).limitToLast(5);
      // chats[key] = $firebaseArray(ref);
      chats.push({name: key, chat:$firebaseArray(ref)});
      chatsLoaded[key] = 5;
      relationChatKey[i] = key;
    }
  }
  for(var i in $rootScope.school.principals){
    if(i !== $rootScope.allUserInfo.id){
      var key = getChatKey($rootScope.allUserInfo.id, i);
      var ref = firebase.database().ref('internalChat/'+$rootScope.allUserInfo.school+'/'+key).limitToLast(5);
      // chats[key] = $firebaseArray(ref);
      chats.push({name: key, chat:$firebaseArray(ref)});
      chatsLoaded[key] = 5;
      relationChatKey[i] = key;
    }
  }
  chats['all'] = $firebaseArray(firebase.database().ref('internalChat/'+$rootScope.allUserInfo.school+'/all').limitToLast(5));
  chats.push({name:'all',chat:$firebaseArray(firebase.database().ref('internalChat/'+$rootScope.allUserInfo.school+'/all').limitToLast(5))});
  chatsLoaded['all'] = 5;
  console.log("chats",chats);
  console.log("relationChatKey",relationChatKey);
  var fn = {
    getChats: function(key){
      if(typeof key === 'undefined') return chats;
      var index;
      for(var i=0; i<chats.length; i++){
        if(chats[i].name === key){
          index = i;
        }
      }
      if(chatsLoaded[key] === 5){
        var ref = firebase.database().ref('internalChat/'+$rootScope.allUserInfo.school+'/'+key).limitToLast(50);
        chats[index].chat = $firebaseArray(ref);
        chatsLoaded[key] = 50;
      }
      return chats[index];
    },getIfAdviced: function(){
      return $q(function(resolve,reject){
        NativeStorage.getItem("audioRecord",function(localAudio){
          console.log("localAudio value",localAudio);
          resolve();
        },function(error){
          console.log("error getting storage");
          reject();
        });
      });
    },setStorage: function(){
      NativeStorage.setItem("audioRecord",true, function(){
        console.log("saved audioRecord");
      }, function(error){
        console.log("error on saving audioRecord",error);
      });
    }
  };
  return fn;

});
