angular.module('childcareOnApp').factory('$localStorage', ['$window', '$rootScope', '$q', function ($window, $rootScope, $q) {
  var local = {
    set: function (key, value) {
      if(!$window.localStorage) return console.log("oldBrowser");
      $window.localStorage[key] = value;
    },
    get: function (key, defaultValue) {
      return $window.localStorage[key] || defaultValue;
    },
    setObject: function (key, value) {
      if(!$window.localStorage) return console.log("oldBrowser");
      $window.localStorage[key] = JSON.stringify(value);
    },
    getObject: function (key) {
      if(!$window.localStorage) return {};
      return JSON.parse($window.localStorage[key] || '{}');
    },
    remove: function(key) {
      if(!$window.localStorage) return console.log("oldBrowser");
      $window.localStorage.removeItem(key);
    },
    getCHObject:function(name){
      if(!$window.localStorage){
        return {
          obj: {},
          time: false,
          id: false
        };
      }
      var obj = this.getObject(name);
      obj.$loaded = function(){return $q(function(resolve,reject){resolve(obj)})};
      obj.$resolved = true;
      obj._fromLocalStorage = true;
      return {
        obj: obj,
        time: this.get(name+'Time',false),
        id: this.get(name+'Id',false)
      }
    },setCHObject: function(name, value, id){
      if(!$window.localStorage) return console.log("oldBrowser");
      this.setObject(name,local.removeFirebaseProperties(value));
      this.set(name+'Time',new Date().getTime());
      if(typeof id === 'undefined') this.set(name+'Id',$rootScope.allUserInfo.id);
      else this.set(name+'Id',id);
    },setCHArray: function(name, value, id){
      if(!$window.localStorage) return console.log("oldBrowser");
      this.setObject(name,value);
      this.set(name+'Time',new Date().getTime());
      if(typeof id === 'undefined') this.set(name+'Id',$rootScope.allUserInfo.id);
      else this.set(name+'Id',id);
    }, removeFirebaseProperties: function(obj){
      var objReturn = {};
      for(var i in obj){
        if(i.indexOf('$') === -1 && typeof obj[i] !== 'function'){
          objReturn[i] = obj[i];
        }
      }
      return objReturn;
    }
  };
  return local;
}]);