angular.module('childcareOnApp').factory('MenusFactory',function($rootScope, $firebaseObject, $firebaseArray, $q, $localStorage, ChildcareOnUtils){
  var menu = {
    getUserMenus: function(id, shouldReload){
      return $q(function(resolve, reject) {
        if(typeof shouldReload === 'undefined') shouldReload = false;
        var localMenus = $localStorage.getCHObject('menus');
        console.log("localMenus",localMenus);
        if(!shouldReload && localMenus.id === id && localMenus.time && localMenus.time !== {} && ChildcareOnUtils.isSameDay(new Date(parseInt(localMenus.time)),new Date())){
          console.log("usa localStorage en menus");
          resolve(localMenus.obj);
          return;
        }
        var ref = firebase.database().ref('menu').child(id);
        var query = ref.orderByChild('week').equalTo(new Date().getWeekNumber());
        var list = $firebaseObject(query);
        list.$loaded().then(function(menuInfo){
          $localStorage.setCHObject('menus',menuInfo, id);
          resolve(menuInfo);
        });
      });
    },getUserMenusNextWeek: function(id){
      return $q(function(resolve, reject) {
        console.log("id classroom is",id);
        console.log("week is",new Date().getWeekNumber()+1);
        var ref = firebase.database().ref('menu').child(id);
        var query = ref.orderByChild('week').equalTo(new Date().getWeekNumber()+1);
        var list = $firebaseObject(query);
        list.$loaded().then(function(menuInfo){
          resolve(menuInfo);
        });
      });
    },getTeacherMenus: function(id, month){
      console.log("month is",month);
      return $q(function(resolve, reject) {
        var ref = firebase.database().ref('menu').child(id);
        var query = ref.orderByChild('month').equalTo(month);
        var list = $firebaseObject(query);
        list.$loaded().then(function(menuInfo){
          console.log("menuInfo",menuInfo);
          $rootScope.menusInfo = menuInfo;
          var nextMonthquery = ref.orderByChild('month').equalTo(month+1);
          var nextMonthlist = $firebaseObject(nextMonthquery);
          nextMonthlist.$loaded().then(function(nextMontMenuInfo){
            console.log("nextMontMenuInfo",nextMontMenuInfo);
            $rootScope.nextMonthMenusInfo = nextMontMenuInfo;
            resolve({menuInfo:menuInfo, nextMonthMenusInfo:nextMontMenuInfo});
          });
        });
      });
    },getTeacherMenusV2: function(shouldReload){
      return $q(function(resolve, reject) {
        if(typeof shouldReload === 'undefined') shouldReload = false;
        var localMenus = $localStorage.getCHObject('menus');
        if(!shouldReload && localMenus.id === $rootScope.allUserInfo.id && localMenus.time && localMenus.time !== {} && ChildcareOnUtils.isSameDay(new Date(parseInt(localMenus.time)),new Date())){
          console.log("usa localStorage en menus");
          $rootScope.menusInfo = localMenus.obj;
          resolve(localMenus.obj);
          return;
        }
        var ref = firebase.database().ref('menu').orderByChild('school').equalTo($rootScope.allUserInfo.school);
        var list = $firebaseObject(ref);
        list.$loaded().then(function(menuInfo){
          console.log("menuInfo",menuInfo);
          $localStorage.setCHObject('menus',menuInfo);
          $rootScope.menusInfo = menuInfo;
          resolve();
        });
      });
    },getMenusMonth: function(classroom, month){
      var menusInfo = {};
      var nextMonthMenusInfo = {};
      console.log('$rootScope.menusInfo[classroom]',$rootScope.menusInfo);
      for(var i in $rootScope.menusInfo[classroom]){
        if($rootScope.menusInfo[classroom][i].month === month) menusInfo[i] = $rootScope.menusInfo[classroom][i];
        if($rootScope.menusInfo[classroom][i].month === month+1) nextMonthMenusInfo[i] = $rootScope.menusInfo[classroom][i];
      }
      return {menusInfo:menusInfo, nextMonthMenusInfo:nextMonthMenusInfo};
    },updateMenus: function(){
      return $q(function(resolve, reject) {
        if(!$rootScope.menusInfo.school) $rootScope.menusInfo.school = $rootScope.allUserInfo.school;
        $rootScope.menusInfo.$save().then(function(){
          $rootScope.nextMonthMenusInfo.$save().then(resolve,reject);
        },reject);
      });
    },updateMenusV2: function(){
      return $q(function(resolve, reject) {
        $rootScope.menusInfo.$save().then(resolve,reject);
      });
    },getDictionary: function(){
      return $q(function(resolve, reject) {
        var ref = firebase.database().ref('menuDictionary').child($rootScope.allUserInfo.school);
        var list = $firebaseObject(ref);
        list.$loaded().then(function(dictionary){
          console.log("menuDictionary",dictionary);
          resolve(dictionary);
        }),function(e){
          console.log("error load menuDictionary",e);
          reject();
        };
      });
    }, getMenusDocuments: function(schoolId, classroomId) {
      var ref = firebase.database().ref('menusDocuments').child(schoolId).child(classroomId);
      return $firebaseArray(ref);
    }, addMenusDocument: function(documentAdd, link, classroomsToSend) {
      return $q(function(resolve, reject) {
        var schoolRef = firebase.database().ref('menusDocuments').child($rootScope.allUserInfo.school);
        for (var classroomKey in classroomsToSend) {
          $firebaseArray(schoolRef.child(classroomKey)).$add({
            date: new Date().getTime(),
            name: documentAdd.name,
            month: documentAdd.month,
            url: link
          })
          .catch(function(error) {
            return reject();
          });
        }
        return resolve();
      });
    }
  };
  return menu;
});
