angular.module('childcareOnApp').factory('NotificationFactory',function($rootScope, $firebaseObject, $translate, $firebaseArray, $q, $http, $state, $localStorage, ChildcareOnUtils, CommonFactory, BadgeNumberFactory){

  var shouldChangeChild = function(classroomId){
    if($rootScope.allUserChilds[$rootScope.childSelected].classroomId === classroomId) return;
    for(var i in $rootScope.allUserChilds){
      if(i.indexOf('$') === -1 && typeof $rootScope.allUserChilds[i] === 'object'){
        if($rootScope.allUserChilds[i].classroomId === classroomId){
          $rootScope.selectChild(i);
          return;
        }
      }
    }
  };

  var childTeachersAvailable = [];

  var notification = {
    getUserNotifications: function(userUid){
      return $q(function(resolve, reject) {
        // var localNotifications = $localStorage.getCHObject('notifications');
        // console.log("localNotifications",localNotifications);
        // if(localNotifications.id === userUid){
        //   console.log("usa localStorage en notifications");
        //   $rootScope.notifications = localNotifications.obj;
        //   resolve(localNotifications.obj);
        // }
        var ref = firebase.database().ref('notifications').orderByChild('receiverId').equalTo(userUid);
        var list = $firebaseArray(ref);
        $rootScope.notifications = list;
        list.$loaded().then(function(notifications){
          console.log("notifications user",notifications);
          // $rootScope.notifications = notifications;
          // $localStorage.setCHArray('notifications',notifications,userUid);
          BadgeNumberFactory.setBadgeNumber();
          var dateToRemove = new Date();
          dateToRemove.setDate(dateToRemove.getDate() -5);
          var dateToRemoveAll = new Date();
          dateToRemoveAll.setDate(dateToRemoveAll.getDate() -10);
          list.forEach(function(item){
            if (item.isReaded && item.date < dateToRemove.getTime()) {
              list.$remove(item);
            } else if (item.date < dateToRemoveAll.getTime()) {
              list.$remove(item);
            }
          });
          resolve(notifications);
        },function(e){
          console.log("error notifications user",e);
          reject();
        });
      });
    },getUserNotificationSettings: function(){
      return $firebaseObject(firebase.database().ref('notificationSettings').child($rootScope.allUserInfo.id)); 
    },getNotificationSettingsByClassroom: function(classroomId){
      return $q(function(resolve,reject){
        var ref = firebase.database().ref('notificationSettings').orderByChild(classroomId).equalTo("teacher_classroom");
        var list = $firebaseObject(ref);
        list.$loaded().then(function(settingClassroom){
          console.log("settingClassroom",settingClassroom);
          resolve(settingClassroom);
        });
      });
    },getClassroomAccess: function(child){
      return $q(function(resolve,reject){
        var ref = firebase.database().ref('classroomAccess').child(child.school).child(child.classroomId);
        var list = $firebaseArray(ref);
        list.$loaded().then(function(classroomAccess){
          console.log("classroomAccess",classroomAccess);
          resolve(classroomAccess);
        });
      });
    },childTeachersAvailable: {
      get : function () {
        return childTeachersAvailable;
      },
      set: function(child){
        var localChildTeachersAvailable = $localStorage.getObject('childTeachersAvailable'),
        localChildTeachersAvailableTime = $localStorage.get('childTeachersAvailableTime',false),
        localChildTeachersAvailableId = $localStorage.get('childTeachersAvailableId',false);
        console.log("localChildTeachersAvailable",localChildTeachersAvailable,localChildTeachersAvailableTime,localChildTeachersAvailableId);
        if(localChildTeachersAvailableId === child.classroomId && localChildTeachersAvailableTime && localChildTeachersAvailableTime !== {} && ChildcareOnUtils.isSameDay(new Date(parseInt(localChildTeachersAvailableTime)),new Date()) && !ChildcareOnUtils.isPastHour(new Date(parseInt(localChildTeachersAvailableTime)),18)){
          childTeachersAvailable = localChildTeachersAvailable;
          return console.log("usa localStorage en childTeachersAvailable");
        }
        notification.getNotificationSettingsByClassroom(child.classroomId).then(function(settingClassroom){
          notification.getClassroomAccess(child).then(function(classroomAccess){
            var teachersInformation = [];
            for(var i=0; i<classroomAccess.length; i++){
              var name = classroomAccess[i].$value;
              name = name.split(" ");
              if(name.length === 4) name = name[0] + " " + name[1];
              else name = name[0];
              if(!settingClassroom.hasOwnProperty(classroomAccess[i].$id)){ //no tienen guardado settings, se avisan todo el día
                teachersInformation.push({
                  name: name,
                  value:"allDay"
                });
              }else{
                var daysObj = ['sunday','monday','tuesday','wednesday','thursday','friday','saturday'];
                var currentDate = new Date(), currentDay = currentDate.getDay();
                if(!settingClassroom[classroomAccess[i].$id].hasOwnProperty(daysObj[currentDay])){
                  teachersInformation.push({
                    name: name,
                    value:"notToday"
                  });
                }else{
                  if(settingClassroom[classroomAccess[i].$id][daysObj[currentDay]].value){
                    if (settingClassroom[classroomAccess[i].$id][daysObj[currentDay]].allDay) {
                      teachersInformation.push({
                        name: name,
                        value: "allDay"
                      });
                    } else {
                      var daySetting = settingClassroom[classroomAccess[i].$id][daysObj[currentDay]];
                      teachersInformation.push({
                        name: name,
                        value:daySetting.from + " - " + daySetting.to
                      });
                    }
                  }else{
                    teachersInformation.push({
                      name: name,
                      value:"notToday"
                    });
                  }
                }
              }
            }
            $localStorage.setObject('childTeachersAvailable',teachersInformation);
            $localStorage.set('childTeachersAvailableTime',new Date().getTime());
            $localStorage.set('childTeachersAvailableId',child.classroomId);
            console.log("teachersInformation",teachersInformation);
            childTeachersAvailable = teachersInformation;
          });
        });
      }
    },goToPage: function(page,extra,pushText,waitTime) {
      if(typeof waitTime === 'undefined') waitTime = 0;
      if((!extra && typeof pushText !== 'undefined') || !page) {
        if(typeof pushText !== 'undefined') alert(pushText);
        return false;
      }
      if (!extra) {
        extra = {};
      }
      if($rootScope.allUserInfo.type === 'user') notification.goToPageUser(page,extra,waitTime);
      else notification.goToPageOther(page,extra,waitTime);
    },goToPageUser: function(page,extra,waitTime){
      if(extra.child) $rootScope.selectChild(extra.child);
      else if(extra.classroomId && Object.keys($rootScope.allUserChilds).length > 1) shouldChangeChild(extra.classroomId);
      var changes = extra.changes || false;
      try {
        $rootScope.allUserChilds[$rootScope.childSelected].$loaded()
        .then(function () {
          $state.go('app.'+page,{notification_day:extra.day, changes: changes});
        });
      } catch (error) {
          setTimeout(function(){
            $state.go('app.'+page,{notification_day:extra.day, changes: changes});
          },waitTime + 1000);
      }
    }, changeSchoolIfNeeded: function(extra) {
      return $q(function(resolve,reject) {
        if (extra.schoolId) {
          if ($rootScope.allUserInfo.school !== extra.schoolId && (!$rootScope.allUserInfo.allSchools || !$rootScope.allUserInfo.allSchools[extra.schoolId])) {
            alert($translate.instant('no_access'));
            return reject();
          }
          if ($rootScope.allUserInfo.school === extra.schoolId) {
            return resolve();
          }
          $rootScope.allUserInfo.school = extra.schoolId;
          $rootScope.getTeacherInfo()
          .then(function() {
            resolve();
          }, function() {
            alert($translate.instant('no_access'));
            reject();
          });
        } else {
          return resolve();
        }
      });
    }, goToPageOther: function(page,extra,waitTime){
      notification.changeSchoolIfNeeded(extra)
      .then(function() {
        if(extra.classroomId){
          var found = false;
          for(var i=0; i<$rootScope.parsedClassroomAccess.length; i++){
            if($rootScope.parsedClassroomAccess[i].id === extra.classroomId){
              $rootScope.globalClassSelected = {id:extra.classroomId,name:$rootScope.parsedClassroomAccess[i].name};
              $rootScope.classSelected = $rootScope.globalClassSelected;
              found = true;
              break;
            }
          }
          if (!found) {
            alert($translate.instant('no_access'));
            return;
          }
        }
        if(extra.child){
          $rootScope.studentSelected = {id:extra.child.id,name:extra.child.name};
        }
        var stateParams = {};
        if(typeof extra.day !== 'undefined') stateParams.notification_day = extra.day;
        if(typeof extra.chat !== 'undefined') stateParams.chat = extra.chat;
        setTimeout(function(){
          $state.go('app.'+page,stateParams);
        },waitTime);
      });
    }, goToExternalWebpage: function(url) {
      window.open(url, '_system', 'location=yes');
    }, setLocalNotification: function(id, title, body, time){
      console.log("setLocalNotification",id,title,body,time);
      // 1 = meeting, 2 = excursion
      // cordova.plugins.notification.local.schedule({
      //     id: id,
      //     text: body,
      //     title:title,
      //     sound: $rootScope.isAndroid ? 'file://sound.mp3' : 'file://beep.caf',
      //     icon: 'res://notification_icon',
      //     at: time
      // });
    }, getAllTeachersAvailability: function() {
      var obj = {};
      for (var id in $rootScope.school.teachers) {
        obj[id] = $firebaseObject(
          firebase.database().ref('notificationSettings').child(id)
        );
      }
      return obj;
    }, getAppSettings: function() {
      try {
        var localGlobalSettings = $localStorage.getCHObject('globalSettings');
        if (!!localGlobalSettings.time && ChildcareOnUtils.differenceHourLessThan(new Date(parseInt(localGlobalSettings.time)), new Date(), 36)) {
          $rootScope.globalSettings = localGlobalSettings.obj;
        } else {
          FirebasePlugin.fetchDocumentInFirestoreCollection('app', 'globalSettings', function(document) {
            console.log("Successfully fetched document: "+JSON.stringify(document));
            $localStorage.setCHObject('globalSettings', document);
            $rootScope.globalSettings = document;
          }, function(error) {
            console.log("error loading app settings: "+error);
          });
        }
      } catch (e) {
        console.log(e);
      }
    }
  };
  return notification;
});
