angular.module('childcareOnApp').factory('PaymentsFactory', function($rootScope, $firebaseObject, $translate, $firebaseArray, $q) {

  var fn = {
    get: function(childId) {
      return $firebaseArray(
        firebase.database().ref('payments/payments').child(childId)
      );
    }, add: function(paymentParams, childrenToSend, notificationIds) {
      return $q(function (resolve, reject) {
        var promises = [];
        paymentParams.notificationId = notificationIds[0];
        $firebaseArray(firebase.database().ref('payments/payments').child(childrenToSend[0])).$add(paymentParams)
        .then(function(ref) {
          var id = ref.key;
          for (var index = 1; index < childrenToSend.length; index++) {
            paymentParams.notificationId = notificationIds[index];
            promises.push(
              firebase.database().ref('payments/payments').child(childrenToSend[index]).child(id).set(paymentParams)
            );
          }
          $q.all(promises).then(function() {
            resolve();
          });
        }, function() {
          reject();
        });
      });
    }, addNotification: function(obj) {
      var ref = firebase.database().ref('payments/notifications');
      var promises = [];
      obj.ids.forEach(function(id) {
        var copyObj = angular.copy(obj);
        delete copyObj.ids;
        copyObj.id = id;
        promises.push(
          $firebaseArray(ref).$add(copyObj)
        );
      });
      return $q.all(promises);
    }, removeNotification: function(id) {
      return firebase.database().ref('payments/notifications').child(id).remove();
    }
  };

  return fn;
});