angular.module('childcareOnApp').factory('SchedulesFactory',function($firebaseObject, $firebaseArray, $q, $localStorage, $rootScope, ChildcareOnUtils){
  var schedule = {
    getSchedule: function(id, shouldReload){
      if(typeof shouldReload === 'undefined') shouldReload = false;
      return $q(function(resolve, reject) {
        try{
          var localSchedules = $localStorage.getCHObject('schedules');
          if(!shouldReload && localSchedules.id === $rootScope.allUserInfo.id && localSchedules.time && localSchedules.time !== {} && ChildcareOnUtils.differenceHourLessThan(new Date(parseInt(localSchedules.time)), new Date(), 36)){
            resolve(localSchedules.obj);
            return;
          }
          var list = $firebaseObject(firebase.database().ref('schedule').child(id));
          list.$loaded().then(function(scheduleInfo){
            $localStorage.setCHObject('schedules',scheduleInfo);
            resolve(scheduleInfo);
        });
        }catch(e){
          console.log("error on getSchedule",e);
          reject();
        }
      });
    }, getScheduleDocuments: function(schoolId, classroomId) {
      return $firebaseArray(
        firebase.database().ref('schedulesDocuments').child(schoolId).child(classroomId)
      );
    }, addSchedulesDocument: function(documentAdd, link, classroomsToSend) {
      return $q(function(resolve, reject) {
        var ref = firebase.database().ref('schedulesDocuments').child($rootScope.allUserInfo.school);
        for (var classroomKey in classroomsToSend) {
          $firebaseArray(ref.child(classroomKey)).$add({
            date: new Date().getTime(),
            name: documentAdd.name,
            month: documentAdd.month,
            url: link
          })
          .catch(function(error) {
            return reject();
          });
        }
        return resolve();
      });
    }
  };
  return schedule;
});
