angular.module('childcareOnApp').factory('TeacherFactory',function($rootScope, $firebaseObject, $firebaseArray, $q, $translate, CommonFactory, AdminProfilesFactory){

  var converUserToTeacher = function(users){
    return $q(function(resolve, reject) {
      users[0].type = "teacher";
      users[0].school = $rootScope.allUserInfo.school;
      users.$save(0).then(function(){
        console.log("usuario convertido a profesor");
        resolve();
      },function(e){
        console.log("error al guardar usuario",e);
        reject();
      });
    });
  };

  function addTeacherToSchool(user) {
    if(!$rootScope.school.teachers) $rootScope.school.teachers = {};
    $rootScope.school.teachers[user.id] = user.name + " " + user.surname;
    return CommonFactory._save($rootScope.school);
  }

  function addClassroomsTeacher(user, classroomsToInvite) {
    var promises = [];
    for (var classroomId in classroomsToInvite) {
      promises.push(
        firebase.database().ref('classroomAccess').child($rootScope.allUserInfo.school).child(classroomId).child(user.id).set(user.name + ' ' + user.surname)
      );
    }
    return $q.all(promises);
  }

  var teacher = {
    addTeacherToSchool: function(email, classroomsToInvite){
      return $q(function(resolve, reject) {
        var list = $firebaseArray(
          firebase.database().ref('users').orderByChild("email").equalTo(email)
        );
        list.$loaded().then(function(users){
          console.log("users loaded",users);
          if(users.length === 1){ //user exists, try to convert to teacher
            switch(true){
              case (users[0].type === "user" && !users[0].hasOwnProperty('childs')):
                var promises = [
                  converUserToTeacher(users),
                  addTeacherToSchool(users[0])
                ];
                if (Object.keys(classroomsToInvite).length > 0) {
                  promises.push(addClassroomsTeacher(users[0], classroomsToInvite));
                }
                $q.all(promises)
                .then(function() {
                  resolve();
                }, function() {
                  alert($translate.instant('serverError')); reject();
                });
                break;
              case (users[0].type === "user" && users[0].hasOwnProperty('childs')): alert($translate.instant('adminProfiles_userHasChilds')); reject(); break;
              case (users[0].type === "teacher"): alert($translate.instant('adminProfiles_userIsTeacher')); reject(); break;
              default: alert($translate.instant('serverError')); reject();
            }
          }else{ //user doesn't exists, send an invitation
            AdminProfilesFactory.inviteTeacher(email, $rootScope.allUserInfo.id, $rootScope.allUserInfo.school, $rootScope.school.name, classroomsToInvite).then(resolve,function(){
              alert($translate.instant('serverError'));
              reject();
            });
          }
        });
      });
    },addTeacherTable: function(id,name,surname,type,school,email){
      console.log("addUserTable teacher info",id,name,surname,type,school);
      return $q(function(resolve, reject) {
        var db = firebase.database();
        var ref = db.ref('users');
        var dataRef = ref.child(id);
        var obj = $firebaseObject(dataRef);
        var date = new Date();
        obj.name = name; obj.surname = surname; obj.type = type;
        obj.email = email;
        obj.registrationDate = date.getTime();
        obj.id = id;
        obj.school = school;
        console.log("user to save",obj);
        $rootScope.allUserInfo = obj;
        console.log("success in addTeacherTable");
        $rootScope.school = $firebaseObject(db.ref('schools').child(school));
        var promises = [
          obj.$save(),
          $rootScope.school.$loaded()
        ];
        $q.all(promises).then(function(results){
            if(!$rootScope.school.teachers) {
              $rootScope.school.teachers = {};
            }
            $rootScope.school.teachers[id] = name + " " + surname;
            $rootScope.school.$save().then(resolve,reject);
        }, function(e) {
          console.log("error in addTeacherTable",e);
          reject();
        });
      });
    },addTeacherTableTest: function(id,name,surname,type,school,email){
      console.log("addUserTable teacher test info",id,name,surname,type,school);
      return $q(function(resolve, reject) {
        var db = firebase.database();
        var ref = db.ref('users');
        var dataRef = ref.child(id);
        var obj = $firebaseObject(dataRef);
        var date = new Date();
        obj.name = name; obj.surname = surname; obj.type = type;
        obj.email = email;
        obj.registrationDate = date.getTime();
        obj.id = id;
        obj.classrooms = {
          "c094f2be-d125-435b-acaa-335650fd0e41":"Feria 1"
        };
        obj.school = school;
        console.log("user to save",obj);
        obj.$save().then(function(ref) {
          $rootScope.allUserInfo = obj;
          console.log("success in addTeacherTable");
          var schoolRef = db.ref('schools');
          schoolRef = schoolRef.child(school);
          var schoolObj = $firebaseObject(schoolRef);
          schoolObj.$loaded().then(function(school){
            if(!school.teachers) school.teachers = {};
            school.teachers[id] = name + " " + surname;
            school.$save().then(resolve,reject);
          },reject);
        },function(e){
          console.log("error in addTeacherTable",e);
          reject();
        });
      });
    },getTeacher: function(id){
      return $q(function(resolve,reject){
        var ref = firebase.database().ref('users');
        var dataRef = ref.child(id);
        var list = $firebaseObject(dataRef);
        list.$loaded().then(function(user){
          resolve(user);
        },reject);
      });
    }, inviteTeacherAutomatic: function(userId, userEmail, schoolId, name, surname) {
      return $q(function(resolve, reject) {
        var promises = [];
        var classroomsToInvite = [];
        var invitationsAutomatic = $firebaseArray(firebase.database().ref('invitationsAutomatic').orderByChild('email').equalTo(userEmail));
        invitationsAutomatic.$loaded()
        .then(function () {
          for (var i=0; i < invitationsAutomatic.length; i++) {
            promises.push(
              firebase.database().ref('classroomAccess/' + schoolId + '/' + invitationsAutomatic[i].classroomId + '/' + userId).set(name + ' ' + surname)
            );
            if (classroomsToInvite.indexOf(invitationsAutomatic[i].classroomId) === -1) {
              classroomsToInvite.push(invitationsAutomatic[i].classroomId);
            }
          }
          $q.all(promises)
          .then(function() {
            resolve(classroomsToInvite);
          });
        });
      });
    }
  };
  return teacher;
});
