angular.module('childcareOnApp').factory('UserFactory',function($rootScope, $firebaseObject, $translate, $firebaseArray, $q, CommonFactory, ChildcareOnUtils, configuration, $localStorage){

  var isEmailVerified = false;

  function removeNativeStorage(){
    return $q(function(resolve,reject){
      if(typeof cordova === 'undefined') return resolve();
      NativeStorage.remove("login",function(){
        console.log("NativeStorage removed successfully");
        return resolve();
      }, function(){
        console.log("error on removing NativeStorage");
        return resolve();
      });
    });
  }

  function getCurrentObjRegDevice(token) {
    if (!device) {
      var device = {};
    }
    var obj = {
      userId: $rootScope.allUserInfo.id,
      registrationId: token,
      deviceUuid: device.uuid,
      deviceModel: device.model,
      deviceVersion: device.version,
      platform: ionic.Platform.platform(),
      language: $translate.use()
    };
    var topics = [];
    if($rootScope.allUserInfo.type === 'user'){
      if($rootScope.allUserChilds){
        for(var i in $rootScope.allUserChilds){
          if(i.indexOf('$') !== -1 || typeof $rootScope.allUserChilds[i] !== "object") continue;
          console.log("child",$rootScope.allUserChilds[i]);
          obj[i] = "child";
          obj[$rootScope.allUserChilds[i].classroomId] = $rootScope.allUserInfo.type+"_classroom";
          obj[$rootScope.allUserChilds[i].school] = $rootScope.allUserInfo.type+"_school";
          topics.push("child_"+i);
        }
      }
      console.log("obj is",obj);
    }else{
      if($rootScope.parsedClassroomAccess){
        console.log("entra a $rootScope.parsedClassroomAccess");
        for(var i=0; i<$rootScope.parsedClassroomAccess.length; i++){
          obj[$rootScope.parsedClassroomAccess[i].id] = "teacher_classroom";
        }
      }
      obj[$rootScope.allUserInfo.school] = "teacher_school";
      obj.school = $rootScope.allUserInfo.school;
    }
    return obj;
  }

  var user = {
    getUserUid: function(){
      return $q(function(resolve, reject) {
        try{
          var userUid = firebase.auth().currentUser.uid;
          resolve(userUid);
        }catch(e){
          console.log("error on waitForSignIn",e);
          reject();
        }
      });
    },getUsername: function(){
      return $q(function(resolve, reject) {
        try{
          var userAuth = firebase.auth().currentUser.email;
          resolve(userAuth);
        }catch(e){
          console.log("error on waitForSignIn",e);
          reject();
        }
      });
    },getUserObject: function(){
      return $q(function(resolve, reject) {
        try{
          user.getUserUid().then(function(userUid){
            var ref = firebase.database().ref('users/'+userUid);
            var list = $firebaseObject(ref);
            list.$loaded().then(function(user){
              resolve(user);
            },function(e){
              console.log("error in user return",e);
              reject();
            });
          },function(e){
            console.log("error in getUserObject on get getUserUid",e);
            reject();
          });
        }catch(e){
          console.log("error in getUserObjectByUid",e);
          reject();
        }
      });
    },getUserOrderedById: function(){
      return $q(function(resolve, reject) {
        try{
          var ref = firebase.database().ref('users');
          var query = ref.orderByChild('id');
          var list = $firebaseObject(query);
          list.$loaded().then(function(users){
            resolve(users);
          },function(e){
            console.log("error in user return",e);
            reject();
          });
        }catch(e){
          console.log("error in getUserObjectByUid",e);
          reject();
        }
      });
    },getUserById: function(uid){
      return $firebaseObject(firebase.database().ref('users').child(uid));
    },getUserNameByUid: function(userUid){
      console.log("userUid",userUid);
      return $q(function(resolve, reject) {
        var ref = firebase.database().ref('users');
        var dataRef = ref.child(userUid);
        var list = $firebaseObject(dataRef);
        list.$loaded().then(function(user){
          console.log("user return",user);
          var toR = "";
          if(user.hasOwnProperty("name")) toR = user.name;
          if(user.hasOwnProperty("surname")) toR += user.surname;
          console.log("toR is",toR,(toR == ""));
          if(toR != ""){
            resolve(toR);
          }else{
            reject();
          }
        },function(e){
          reject(e);
        });
      });
    }, getUserPhoto: function(userId) {
      return $firebaseObject(firebase.database().ref('users').child(userId).child('photo'));
    }, saveUser: function(user){
      return $q(function(resolve, reject) {
        user.$save().then(function(r){
          console.log("success saveUser",r);
          resolve();
        },function(e){
          console.log("Error saveUser",e);
          reject();
        });
      });
    },save: function(objectToSave){
      return $q(function(resolve, reject) {
        objectToSave.$save().then(function(r){
          console.log("success save",r);
          resolve();
        },function(e){
          console.log("Error save",e);
          reject();
        });
      });
    },changePassword: function(password){
      return $q(function(resolve, reject) {
        firebase.auth().updatePassword(password).then(function(){
          resolve();
        },function(e){
          console.log("error update password",e);
          reject();
        });
      });
    },addUserTable: function(id,name,surname,type,childs,email){ //cambiar childs con el nuevo modo, aceptando además más de un child
      console.log("addUserTable info",id,name,surname,type,childs);
      return $q(function(resolve, reject) {
        var ref = firebase.database().ref('users');
        var dataRef = ref.child(id);
        var obj = $firebaseObject(dataRef);
        var date = new Date();
        obj.name = name; obj.surname = surname; obj.type = type;
        obj.email = email;
        obj.registrationDate = date.getTime();
        obj.id = id;
        if(childs != null){
          delete childs.id;
          obj.childs = childs;
          for(var i in childs){
            obj[i] = 'child';
          }
        }
        console.log("user to save",obj);
        obj.$save().then(function(ref) {
          $rootScope.allUserInfo = obj;
          for(var i in obj.childs){
            $rootScope.childSelected = i; break;
          }
          console.log("success in addUserTable");
          user.checkSchoolMarketing(email);
          resolve();
        },function(e){
          console.log("error in addUserTable",e);
          reject();
        });
      });
    },lookForInvitationsV2: function(user){
      console.log("user email",user);
      var ref = firebase.database().ref('invitations').orderByChild("email").equalTo(user);
      return $firebaseArray(ref);
    },saveUserVersion: function(){
      if(typeof cordova === 'undefined'){
        console.log("getAppVersion not available");
        return;
      }
      cordova.getAppVersion.getVersionNumber().then(function (version) {
        var platform = ionic.Platform.platform();
        var document = {
          appVersion: version,
          platform: platform,
          lastAccess: new Date().getTime(),
          version: ionic.Platform.version(),
        };
        try {
          document.deviceUuid = device.uuid;
          document.deviceModel = device.model;
          document.deviceVersion = device.version;
        } catch (error) {
          console.log('error saving device version', error);
        }
        try {
          document.userAgent = navigator.userAgent;
          document.lang = navigator.language || navigator.userLanguage;
        } catch (error) {
          console.log('error saving user agent', error);
        }
        try {
          var localVersion = $localStorage.getCHObject('appVersion');
          if(
            localVersion.id === $rootScope.allUserInfo.id && localVersion.time && localVersion.time !== {} &&
            ChildcareOnUtils.differenceHourLessThan(new Date(parseInt(localVersion.time)), new Date(), 36) && localVersion.obj.version === version
          ) {
            console.log('not updating new version');
          } else {
            FirebasePlugin.setDocumentInFirestoreCollection($rootScope.allUserInfo.id, document, 'userVersion', function(){
              console.log("new version updated");
              $localStorage.setCHObject('appVersion',{version: version}, $rootScope.allUserInfo.id);
            }, function(error){
              console.error("Error setting document: "+error);
            });
          }
        } catch (error) {
          console.log('error saving document');
        }
        user.handleMinVersion(document);
      });
    },getTeachersBySchool: function(school){
      return $q(function(resolve,reject){
        var ref = firebase.database().ref('users');
        var dataRef = ref.orderByChild('school').equalTo(school);
        var list = $firebaseArray(dataRef);
        list.$loaded().then(function(teachers){
          console.log("loaded teachers",teachers);
          resolve(teachers);
        },reject);
      });
    },knowIfVersionLower: function(minVersion,userVersion,platform) {
      minVersion = user.parseVersionCodeToNumber(minVersion);
      userVersion = user.parseVersionCodeToNumber(userVersion);
      console.log("minVersion",minVersion,"userVersion",userVersion,"platform",platform);
      if(userVersion < minVersion){
        var translateText;
        if ($rootScope.isAndroid) {
          translateText = $translate.instant('oldVersionText_android');
        } else {
          translateText = $translate.instant('oldVersionText');
        }
        if(navigator.notification) {
          navigator.notification.confirm(translateText, function(buttonIndex) {
            if (buttonIndex === 2) user.sendToStore(platform);
          }, $translate.instant('oldVersionTitle'), [ $translate.instant('login_forgotPassword_cancelButton'), $translate.instant('button_accept')]);
        } else {
          if(confirm(translateText)){
            console.log("si!",translateText);
            user.sendToStore(platform);
          }
        }
      }
    },parseVersionCodeToNumber: function(version){
      console.log("parseVersionCodeToNumber version is",version);
      var minVersionParsed = version.toString().split(".");
      var number = minVersionParsed[0].toString()+".";
      for(var i=1; i<minVersionParsed.length; i++){
        if(minVersionParsed[i].toString().length < 3) minVersionParsed[i] += "0";
        if(minVersionParsed[i].toString().length < 3) minVersionParsed[i] += "0";
        number += minVersionParsed[i].toString();
      }
      return parseFloat(number);
    },sendToStore: function(platform){
      var url = (platform === 'ios')? configuration.stores.ios: configuration.stores.android;
      window.open(url, '_system', 'location=yes');
    },saveRegistrationId: function(token, permissionGranted){
      return $q(function(resolve,reject){
        if(!device.uuid) return reject();
        var list = $firebaseArray(firebase.database().ref('registrationDevices').orderByChild('deviceUuid').equalTo(device.uuid));
        list.$loaded().then(function(registrationDevices){
          console.log("registrationDevices",registrationDevices);
          var obj = {
            userId:$rootScope.allUserInfo.id,
            registrationId: token,
            deviceUuid: device.uuid,
            deviceModel: device.model,
            deviceVersion: device.version,
            platform: ionic.Platform.platform(),
            language:$translate.use(),
            permissionGranted: permissionGranted,
            date: new Date().getTime()
          };
          var deviceUuidShort = user.getDeviceShortId(device.uuid);
          FirebasePlugin.setDocumentInFirestoreCollection(deviceUuidShort, obj, 'registrationDevices/' + $rootScope.allUserInfo.id + '/regs');
          var topics = [];
          if($rootScope.allUserInfo.type === 'user'){
            if($rootScope.allUserChilds){
              for(var i in $rootScope.allUserChilds){
                if(i.indexOf('$') !== -1 || typeof $rootScope.allUserChilds[i] !== "object") continue;
                console.log("child",$rootScope.allUserChilds[i]);
                obj[i] = "child";
                obj[$rootScope.allUserChilds[i].classroomId] = $rootScope.allUserInfo.type+"_classroom";
                obj[$rootScope.allUserChilds[i].school] = $rootScope.allUserInfo.type+"_school";
                topics.push("child_"+i);
              }
            }
            console.log("obj is",obj);
          }else{
            if($rootScope.parsedClassroomAccess){
              console.log("entra a $rootScope.parsedClassroomAccess");
              for(var i=0; i<$rootScope.parsedClassroomAccess.length; i++){
                obj[$rootScope.parsedClassroomAccess[i].id] = "teacher_classroom";
              }
            }
            obj[$rootScope.allUserInfo.school] = "teacher_school";
            obj.school = $rootScope.allUserInfo.school;
          }
          if(registrationDevices.length > 0){
            if(registrationDevices.length === 1){
              if(token !== registrationDevices[0].registrationId){
                registrationDevices[0].registrationId = token;
                list.$save(0).then(function(ref) {
                  console.log("saved regId success",ref);
                  resolve(topics);
                },function(e){
                  console.log("saved regId failed",e);
                  CommonFactory.saveLog({user: $rootScope.allUserInfo.id,error:"failed save regId"+JSON.stringify(e)});
                  reject();
                });
              }else{
                var changed = false;
                for(var i in obj){
                  if(!(i in registrationDevices[0]) || obj[i] !== registrationDevices[0]) changed = true;
                }
                if(changed){
                  list.$remove(0).then(function(){
                    list.$add(obj).then(function(ref) {
                      console.log("add regId success",ref);
                      resolve(topics);
                    },function(e){
                      console.log("add regId failed",e);
                      reject();
                    });
                  },function(e){
                    console.log("saved regId failed",e);
                    CommonFactory.saveLog({
                      user: $rootScope.allUserInfo.id,
                      error:"failed save regId"+JSON.stringify(e)
                    });
                    reject();
                  });
                }
              }
            }else{
              list.$remove(0);
              resolve(topics);
            }
          }else{
            list.$add(obj).then(function(ref) {
              console.log("add regId success",ref);
              resolve(topics);
            },function(e){
              console.log("add regId failed",e);
              reject();
            });
          }
          FirebasePlugin.setDocumentInFirestoreCollection($rootScope.allUserInfo.id, obj, 'registrationDevices');
        }),function(e){
          console.log("error load registrationDevices",e);
          reject();
        };
      });
    }, checkRegistrationsId: function(forceCheck) {
      if (typeof forceCheck === 'undefined') {
        forceCheck = false;
      }
      var randNumber = Math.floor((Math.random() * 9) + 1);
      if (randNumber !== 1 && !forceCheck) { // only 1/10 times should exec
        return false;
      }
      var list = $firebaseArray(firebase.database().ref('registrationDevices').orderByChild('userId').equalTo($rootScope.allUserInfo.id));
      list.$loaded().then(function() {
        var obj = getCurrentObjRegDevice('check');
        var whitelistProp = ['deviceModel', 'deviceUuid', 'deviceVersion', 'language', 'platform', 'registrationId'];
        list.forEach(function(regDevice) {
          var toRemove = false;
          for (var i in regDevice) {
            if(i.indexOf('$') !== -1 || typeof regDevice[i] === "function" || whitelistProp.indexOf(i) !== -1) continue;
            if (!obj[i] || obj[i] !== regDevice[i]) {
              toRemove = true;
            }
          }
          if (!!toRemove) {
            firebase.database().ref('registrationDevices/' + regDevice.$id).remove();
          }
        });
      });
    }, removeRegistrationId: function(){
      if(window.FirebasePlugin){
        var ref = firebase.database().ref('registrationDevices').orderByChild('deviceUuid').equalTo(device.uuid);
        var list = $firebaseArray(ref);
        list.$loaded().then(function(registrationDevices){
          if(registrationDevices.length > 0){
            list.$remove(0).then(function(ref) {
              console.log("success on removeRegistrationId");
            },function(e){
              console.log("error on removeRegistrationId",e);
            });
          }
          var deviceUuidShort = user.getDeviceShortId(device.uuid);
          FirebasePlugin.deleteDocumentFromFirestoreCollection(deviceUuidShort, 'registrationDevices/' + $rootScope.allUserInfo.id + '/regs', function(){
            console.log("Successfully deleted document with id="+documentId);
          }, function(error){
            console.error("Error deleting document: "+error);
          });
        });
      }
    },saveGlobalClassroom:function(){
      if(!$rootScope.globalClassSelected){
        console.log("not exists globalClassSelected");
        return;
      }
      $rootScope.allUserInfo.globalClassSelected = $rootScope.globalClassSelected;
      CommonFactory._save($rootScope.allUserInfo);
    },sendCodeSignup:function(code){
      return $q(function(resolve, reject){
        var codeDB = $firebaseArray(firebase.database().ref('signupCode').orderByChild('code').equalTo(code));
        codeDB.$loaded()
        .then(function(){
          if(codeDB.length === 0) return reject();
          return resolve(codeDB);
        });
      });
    },logout:function(){
      return $q(function(resolve,reject){
        removeNativeStorage()
        .then(function(){
          firebase.auth().signOut().then(function(){
            //$window.location.reload(true);
            console.log("sign out!");
            user.removeRegistrationId();
            resolve();
          },function(e){
            console.log("error in sign out",e);
            reject();
          });
        });
      });
    },emailVerified: {
      get: function () {
        return isEmailVerified;
      },set: function (isVerified) {
        isEmailVerified = isVerified;
      }
    }, handleMinVersion: function(userVersion) {
      var platform = 'android';
      if (!$rootScope.isAndroid) {
        platform = 'ios';
      }
      FirebasePlugin.fetchDocumentInFirestoreCollection(platform, 'minVersion', function(document){
        console.log("Successfully fetched document: "+JSON.stringify(document));
        user.knowIfVersionLower(document.value, userVersion.appVersion, userVersion.platform);
      }, function(error){
        console.log("error loading minVersion: "+error);
      });
    // }, handleMinVersionV2: function(userVersion) {
    //   var platform = userVersion.platform === 'android'? 'android' : 'ios'; 
    //   console.log('platform', platform);
    //   firebase.firestore().doc('minVersion/'+platform).get()
    //     .then(function (doc) {
          
    //       if (doc.exists) {
    //         console.log('doc exists!', doc.data());
    //         var version = doc.data().value;
    //         console.log("minVersion", version);
    //         user.knowIfVersionLower(version,userVersion.appVersion,userVersion.platform);
    //       } else {
    //           // doc.data() will be undefined in this case
    //           console.log("No such document!");
    //       }
    //     }).catch(function(error) {
    //         console.log("Error getting document:", error);
    //     });
    }, checkSchoolMarketing: function(email) {
      var keywords = [
        /* en */'school', 'kinder', 'garten', 'primary', 'baby', 'child', 'kid',
        /* es */'escuela', 'guarderia', 'primaria', 'bebe', '@ei',
        /* ca */'escola', 'infant', 'jardi', '@eb'
      ];
      var found = false;
      try {
        keywords.forEach(function (keyword) {
          if (email.indexOf(keyword) !== -1) {
            found = true;
          }
        });
        if (!!found) {
          firebase.database().ref('marketing/possiblePrincipals').push({
            email: email,
            date: new Date().getTime()
          });
        }
      } catch (error) {
        console.log('error checkSchoolMarketing', error);
      }
    }, saveSignupLog: function(id) {
      try {
        var logObj = {
          deviceUuid: device.uuid,
          deviceModel: device.model,
          deviceVersion: device.version,
          platform: ionic.Platform.platform()
        };
        return firebase.database().ref('signupInformation').child(id).set(logObj);
      } catch (error) {
        console.log(error);
      }
    }, sendServerCreateSchool: function(schoolId) {
      var url = configuration.url.schoolCreated;
      return $q(function(resolve, reject) {
        $http({
          method: 'PUT',
          url: url,
          data: {
            schoolId: schoolId,
            userId: $rootScope.allUserInfo.id
          }
        }).then(function(){
          console.log("serverRequest success $http");
          resolve();
        },function(e){
          console.log("serverRequest $http failed",e);
          reject(e.data);
        });
      });
    }, getDeviceShortId: function(deviceUuid) {
      var splittedDeviceUuid = deviceUuid.split('-');
      return splittedDeviceUuid[0];
    }
  };
  return user;
});
