angular.module('childcareOnApp').factory('ChildcareOnUtils',function($translate, $q){

  // VARS and COMPLEMENTARY FUNCIONS
  var weekDays = ["sunday","monday","tuesday","wednesday","thursday","friday","saturday"];
  var shortWeekDays = ["sunday_short","monday_short","tuesday_short","wednesday_short","thursday_short","friday_short","saturday_short"];
  var months = ["january","february","march","april","may","june","july","august","september","october","november","december"];
  var daysSt = [1,21,31], daysNd = [2,22], daysRd = [3,23];

  Date.prototype.getWeekNumber = function(){
    var d = new Date(+this);
    d.setHours(0,0,0,0);
    d.setDate(d.getDate()+4-(d.getDay()||7));
    return Math.ceil((((d-new Date(d.getFullYear(),0,1))/8.64e7)+1)/7);
  };

  //factory functions
  var ChildcareOnUtils = {
    generateUUID: function(){
      var d = new Date().getTime();
      if(window.performance && typeof window.performance.now === "function"){
          d += performance.now(); //use high-precision timer if available
      }
      var uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
          var r = (d + Math.random()*16)%16 | 0;
          d = Math.floor(d/16);
          return (c=='x' ? r : (r&0x3|0x8)).toString(16);
      });
      return uuid;
    },dateCommunications: function(timestamp){
      return $q(function(resolve, reject) {
        var dateTimestamp = new Date(timestamp);
        var today = new Date();
        var timestampTemp = {day:dateTimestamp.getDate(),month:dateTimestamp.getMonth(),year:dateTimestamp.getFullYear(),hour:dateTimestamp.getHours(),minutes:dateTimestamp.getMinutes()};
        var timestampToday = {day:today.getDate(),month:today.getMonth(),year:today.getFullYear()};
        var dateTemp = null;
        switch(true){
          case timestampTemp.day === timestampToday.day && timestampTemp.month === timestampToday.month && timestampTemp.year === timestampToday.year: dateTemp = ChildcareOnUtils.addLeadingZeros(timestampTemp.hour) +":"+ ChildcareOnUtils.addLeadingZeros(timestampTemp.minutes); break;
          case timestampTemp.day === (timestampToday.day - 1) && timestampTemp.month === timestampToday.month && timestampTemp.year === timestampToday.year: dateTemp = $translate.instant('date_yesterday') + " " + translate.instant('date_at') + " " + ChildcareOnUtils.addLeadingZeros(timestampTemp.hour) + ":" + ChildcareOnUtils.addLeadingZeros(timestampTemp.minutes); break;
          default : dateTemp = ChildcareOnUtils.addLeadingZeros(timestampTemp.day) + "/" + ChildcareOnUtils.addLeadingZeros(timestampTemp.month) + "/" + timestampTemp.year.toString().slice(2,4);
        }
        resolve(dateTemp);
      });
    },addLeadingZeros:function(number){
      if(parseInt(number) < 10)number = 0 + number.toString();
      return number;
    },getDateParsed: function(date){
      var dayNumber = date.getDate();
      var dayNumberFinal = "th";
      switch(true){
        case (daysSt.indexOf(dayNumber) !== -1): dayNumberFinal="st"; break;
        case (daysNd.indexOf(dayNumber) !== -1): dayNumberFinal="nd"; break;
        case (daysRd.indexOf(dayNumber) !== -1): dayNumberFinal="rd"; break;
      }
      return {
        dayName: $translate.instant(weekDays[date.getDay()]),
        dayNumber: dayNumber,
        dayNumberFinal:dayNumberFinal,
        month: $translate.instant(months[date.getMonth()])
      };
    },getTodayDate: function(date){
      return weekDays[date.getDay()];
    },parseTimestampToDate: function(timestamp){
        var dateTimestamp = new Date(timestamp);
        return ChildcareOnUtils.addLeadingZeros(dateTimestamp.getDate()) + "/" + ChildcareOnUtils.addLeadingZeros(dateTimestamp.getMonth() +1) + "/" + dateTimestamp.getFullYear().toString().slice(2,4);
    },parseDateToNumbers: function(date){
      return ChildcareOnUtils.addLeadingZeros(date.getDate()).toString() + ChildcareOnUtils.addLeadingZeros(date.getMonth() +1).toString() + date.getFullYear().toString().slice(2,4);
    },
    getAppVersion: function(){
      return $q(function(resolve,reject){
        if(typeof cordova !== 'undefined'){
          cordova.getAppVersion.getVersionNumber().then(function (version) {
            resolve(version);
          });
        }else{
          resolve(null);
        }
      });
    },daysInMonth: function(month, year) {
      return new Date(year, month, 0).getDate();
    },getWeekDay: function(j) {
      var d = new Date();
      var day = d.getDay();
      if(day === 0){
        d.setDate(d.getDate() -1);
        day = d.getDay();
      }
      var diff = d.getDate() - day + (day == 0 ? -6:j);
      return new Date(d.setDate(diff));
    },getNextWeekDay: function(j) {
      var d = new Date();
      console.log("d is",angular.copy(d));
      d.setDate(d.getDate() + 7);
      console.log("d2 is",angular.copy(d));
      var day = d.getDay();
      if(day === 0){
        d.setDate(d.getDate() -1);
        day = d.getDay();
      }
      var diff = d.getDate() - day + (day == 0 ? -6:j);
      return new Date(d.setDate(diff));
    },getCurrentWeekDays: function(){
      var days = [];
      for(var i=1; i<6; i++){
        var day = ChildcareOnUtils.getWeekDay(i);
        days.push({name:ChildcareOnUtils.getDateParsed(day),value:ChildcareOnUtils.parseDateToNumbers(day)});
      }
      return days;
    },getNextWeekDays: function(){
      var days = [];
      for(var i=1; i<6; i++){
        var day = ChildcareOnUtils.getNextWeekDay(i);
        days.push({name:ChildcareOnUtils.getDateParsed(day),value:ChildcareOnUtils.parseDateToNumbers(day)});
      }
      return days;
    },getCurrentMonthDays: function(){
      var days = [];
      var date = new Date();
      var currentMonth = date.getMonth()+1, currentYear = date.getFullYear();
      var monthDays = ChildcareOnUtils.daysInMonth(currentMonth,currentYear);
      for(var i=1; i<=monthDays; i++){
        if(date.getDate() <= i){
          var dayParsed = new Date(currentYear, currentMonth -1, i);
          if(dayParsed.getDay() != 0 && dayParsed.getDay() != 6) days.push({name:ChildcareOnUtils.getDateParsed(dayParsed),value:ChildcareOnUtils.parseDateToNumbers(dayParsed)});
        }
      }
      return days;
    },getNextMonthDays: function(){
      var days = [];
      var date = new Date();
      var currentMonth = date.getMonth()+2, currentYear = date.getFullYear();
      var monthDays = ChildcareOnUtils.daysInMonth(currentMonth,currentYear);
      for(var i=1; i<=monthDays; i++){
        var dayParsed = new Date(currentYear, currentMonth -1, i);
        if(dayParsed.getDay() != 0 && dayParsed.getDay() != 6) days.push({name:ChildcareOnUtils.getDateParsed(dayParsed),value:ChildcareOnUtils.parseDateToNumbers(dayParsed)});
      }
      return days;
    }, getCurrentDayOrMonday: function(){
      var date = new Date();
      if(date.getDay() == 0 || date.getDay() == 6){
        if(date.getDay() == 0) date.setDate(date.getDate()+1);
        else date.setDate(date.getDate()+2);
      }
      return date;
    }, getTomorrowOrMonday: function() {
      var date = new Date();
      date.setDate(date.getDate() +1);
      if(date.getDay() == 0 || date.getDay() == 6){
        if (date.getDay() == 0) date.setDate(date.getDate()+1);
        else date.setDate(date.getDate()+2);
      }
      return date;
    },getCurrentAndNextMonth: function(){
      var date = new Date();
      var thisMonth = date.getMonth();
      if (thisMonth === 11) {
        return [months[thisMonth],months[0]];
      } else {
        return [months[thisMonth],months[thisMonth+1]];
      }
    },copyToClipboard: function(text){
      if(cordova.plugins && cordova.plugins.clipboard){
        cordova.plugins.clipboard.copy(text);
        return true;
      }else{
        console.log("no cordova.plugins.clipboard");
        return false;
      }
    },isSameDay: function(date1,date2){
      return (date1.getDay() === date2.getDay() && date1.getMonth() === date2.getMonth() && date1.getFullYear() === date2.getFullYear());
    },isPastHour: function(date, hour){ //mira si ahora > que la hora enviada (hour) y si la fecha enviada (date) es menor que la hora enviada (hour)
      return (new Date().getHours() > hour && new Date(date).getHours() < hour);
    }, differenceHourLessThan: function(date1, date2, hours) {
      var difference = Math.abs(date1.getTime() - date2.getTime()) / 36e5;
      return difference < hours;
    }, getMonth: function(index) {
      return months[index];
    }, getMonthsTranslated: function() {
      return months.map(function(month) {
        return $translate.instant(month);
      });
    }, getShortDaysTranslated: function() {
      return shortWeekDays.map(function(month) {
        return $translate.instant(month);
      });
    }, getDaysTranslated: function() {
      return weekDays.map(function(month) {
        return $translate.instant(month);
      });
    }
  };
  return ChildcareOnUtils;
});
