angular.module('childcareOnApp').filter('childParents', function() {
  return function(parents, id) {
    var parentsResult = [];
    console.log("parents filter",parents,id);
    for (var i=0; i<parents.length; i++) {
      if(parents[i].hasOwnProperty('childs'))
        if(id in parents[i].childs) parentsResult.push(parents[i]);
    }
    return parentsResult;
  }
}).filter('childParentsName', function() {
  return function(parents, id) {
    var parentsResult = {};
    console.log("parents filter",parents,id);
    for (var i=0; i<parents.length; i++) {
      if(parents[i].hasOwnProperty('childs'))
        //if(id in parents[i].childs !== -1) parentsResult[parents[i].$id] = parents[i].name + " " + parents[i].surname;
        if(id in parents[i].childs !== -1) parentsResult[parents[i].$id] = parents[i].name;
    }
    return parentsResult;
  };
}).filter('orderObjectBy', function() {
  return function(items, field, reverse) {
    var filtered = [];
    angular.forEach(items, function(item) {
      filtered.push(item);
    });
    filtered.sort(function (a, b) {
      return (a[field] > b[field] ? 1 : -1);
    });
    if(reverse) filtered.reverse();
    return filtered;
  };
})

.filter('hour', function() {
  return function(hour) {
    hour = hour.toString();
    return hour.substring(0,2)+":"+hour.substring(2,4);
  };
})

.filter('month', function() {
  var months = ["january","february","march","april","may","june","july","august","september","october","november","december"];
  return function(index) {
    return months[parseInt(index)];
  };
})

.filter('convertDate',['$translate', function($translate) {
  var months = ["january","february","march","april","may","june","july","august","september","october","november","december"];
  return function(date) {
    if(!date) return "";
    date = date.toString();
    return date.substring(0,2) + " " + $translate.instant(months[parseInt(date.substring(2,4) -1)]);
  };
}])

.filter('convertDateMonth',['$translate', function($translate) {
  var months = ["january","february","march","april","may","june","july","august","september","october","november","december"];
  return function(date) {
    if(!date) return "";
    return $translate.instant(months[parseInt(date.month)]) + " " + date.year;
  };
}])

.filter('convertDateDay',['$translate', function($translate) {
  var months = ["january","february","march","april","may","june","july","august","september","october","november","december"];
  return function(date) {
    if(!date) return "";
    return date.day + " " + $translate.instant(months[parseInt(date.month)]);
  };
}])

.filter('dateCommunications',['$translate', function($translate) {
  function addLeadingZeros(number){
    if(parseInt(number) < 10) number = 0 + number.toString();
    return number;
  }
  return function(timestamp) {
    console.log("timestamp",timestamp);
    var dateTimestamp = new Date(timestamp);
    var today = new Date();
    var timestampTemp = {day:dateTimestamp.getDate(),month:dateTimestamp.getMonth(),year:dateTimestamp.getFullYear(),hour:dateTimestamp.getHours(),minutes:dateTimestamp.getMinutes()};
    var timestampToday = {day:today.getDate(),month:today.getMonth(),year:today.getFullYear()};
    var dateTemp = null;
    switch(true){
      case timestampTemp.day === timestampToday.day && timestampTemp.month === timestampToday.month && timestampTemp.year === timestampToday.year: dateTemp = addLeadingZeros(timestampTemp.hour) +":"+ addLeadingZeros(timestampTemp.minutes); break;
      case timestampTemp.day === (timestampToday.day - 1) && timestampTemp.month === timestampToday.month && timestampTemp.year === timestampToday.year: dateTemp = $translate.instant('date_yesterday') + " " + $translate.instant('date_at') + " " + addLeadingZeros(timestampTemp.hour) + ":" + addLeadingZeros(timestampTemp.minutes); break;
      default : dateTemp = addLeadingZeros(timestampTemp.day) + "/" + addLeadingZeros(timestampTemp.month+1) + "/" + timestampTemp.year.toString().slice(2,4);
    }
    return dateTemp;
  };
}])

.filter('dateCommunicationsFuture',['$translate', function($translate) {
  function addLeadingZeros(number){
    if(parseInt(number) < 10) number = 0 + number.toString();
    return number;
  }
  return function(timestamp) {
    console.log("timestamp",timestamp);
    var dateTimestamp = new Date(timestamp);
    var today = new Date();
    var timestampTemp = {day:dateTimestamp.getDate(),month:dateTimestamp.getMonth(),year:dateTimestamp.getFullYear(),hour:dateTimestamp.getHours(),minutes:dateTimestamp.getMinutes()};
    var timestampToday = {day:today.getDate(),month:today.getMonth(),year:today.getFullYear()};
    var dateTemp = null;
    switch(true){
      case timestampTemp.day === timestampToday.day && timestampTemp.month === timestampToday.month && timestampTemp.year === timestampToday.year: dateTemp = $translate.instant('date_today'); break;
      default : dateTemp = addLeadingZeros(timestampTemp.day) + "/" + addLeadingZeros(timestampTemp.month+1) + "/" + timestampTemp.year.toString().slice(2,4);
    }
    dateTemp = dateTemp  + " " + addLeadingZeros(timestampTemp.hour) +":"+ addLeadingZeros(timestampTemp.minutes);
    return dateTemp;
  };
}])

.filter('dateLastMessage',['$translate', function($translate) {
  function addLeadingZeros(number){
    if(parseInt(number) < 10)number = 0 + number.toString();
    return number;
  }
  return function(chat) {
    chat = chat.chat;
    if(!Array.isArray(chat) || chat.length === 0) return "";
    var timestamp = chat[chat.length -1].date;
    var dateTimestamp = new Date(timestamp);
    var today = new Date();
    var timestampTemp = {day:dateTimestamp.getDate(),month:dateTimestamp.getMonth(),year:dateTimestamp.getFullYear(),hour:dateTimestamp.getHours(),minutes:dateTimestamp.getMinutes()};
    var timestampToday = {day:today.getDate(),month:today.getMonth(),year:today.getFullYear()};
    var dateTemp = null;
    switch(true){
      case timestampTemp.day === timestampToday.day && timestampTemp.month === timestampToday.month && timestampTemp.year === timestampToday.year: dateTemp = addLeadingZeros(timestampTemp.hour) +":"+ addLeadingZeros(timestampTemp.minutes); break;
      case timestampTemp.day === (timestampToday.day - 1) && timestampTemp.month === timestampToday.month && timestampTemp.year === timestampToday.year: dateTemp = $translate.instant('date_yesterday') + " " + $translate.instant('date_at') + " " + addLeadingZeros(timestampTemp.hour) + ":" + addLeadingZeros(timestampTemp.minutes); break;
      default : dateTemp = addLeadingZeros(timestampTemp.day) + "/" + addLeadingZeros(timestampTemp.month+1) + "/" + timestampTemp.year.toString().slice(2,4);
    }
    return dateTemp;
  };
}])

.filter('dateOnlyDay',['$translate', function($translate) {
  function addLeadingZeros(number){
    if(parseInt(number) < 10) number = 0 + number.toString();
    return number;
  }
  return function(timestamp) {
    var dateTimestamp = new Date(timestamp);
    var today = new Date();
    var timestampTemp = {day:dateTimestamp.getDate(),month:dateTimestamp.getMonth(),year:dateTimestamp.getFullYear(),hour:dateTimestamp.getHours(),minutes:dateTimestamp.getMinutes()};
    var timestampToday = {day:today.getDate(),month:today.getMonth(),year:today.getFullYear()};
    var dateTemp = null;
    switch(true){
      case timestampTemp.day === timestampToday.day && timestampTemp.month === timestampToday.month && timestampTemp.year === timestampToday.year: dateTemp = $translate.instant('date_today'); break;
      case timestampTemp.day === (timestampToday.day - 1) && timestampTemp.month === timestampToday.month && timestampTemp.year === timestampToday.year: dateTemp = $translate.instant('date_yesterday'); break;
      default : dateTemp = addLeadingZeros(timestampTemp.day) + "/" + addLeadingZeros(timestampTemp.month+1) + "/" + timestampTemp.year.toString().slice(2,4);
    }
    return dateTemp;
  };
}])

.filter('photos', function() {
  return function(photos,date) {
    if(!date || !photos) return [];
    var toReturn = [];
    for(var i=0; i<photos.length; i++){
      var photoDate = new Date(parseInt(photos[i].date +"000"));
      if(photoDate.getMonth() == date.month && photoDate.getFullYear() == date.year) toReturn.push(photos[i]);
    }
    return toReturn;
  };
})

.filter('todayPhotos', function() {
  return function(photos) {
    if(!photos) return [];
    var toReturn = [], todayDate = new Date();
    for(var i=0; i<photos.length; i++){
      var photoDate = new Date(parseInt(photos[i].date +"000"));
      if(photoDate.getDate() == todayDate.getDate() && photoDate.getMonth() == todayDate.getMonth() && photoDate.getFullYear() == todayDate.getFullYear()) toReturn.push(photos[i]);
    }
    return toReturn;
  };
})

.filter('maximumPhotos', function() {
  function getDays() {
    var curr = new Date();
    var firstday, lastday;
    // monday
    if (curr.getDay() === 1) {
      firstday = new Date();
      firstday.setHours(0,0);
      lastday = new Date(curr.setDate(curr.getDate() - curr.getDay()+7));
    } else if(curr.getDay() === 0) {
    	firstday = new Date(curr.setDate(curr.getDate() - curr.getDay()+1));
    	lastday = new Date();
    } else {
    	firstday = new Date(curr.setDate(curr.getDate() - curr.getDay()+1));
      firstday.setHours(0, 0);
      lastday = new Date(curr.setDate(curr.getDate() - curr.getDay()+7));
    }
    return {
      monday: firstday.getTime(),
      sunday: lastday.getTime()
    };
  }
  return function(photos) {
    if(!photos) return [];
    var todayDate = new Date(), weekDays = getDays();
    var toReturn = photos.filter(function(photo) {
      var photoDate = new Date(parseInt(photo.date +"000"));
      return (photoDate.getTime() > weekDays.monday && photoDate.getTime() < weekDays.sunday);
    });
    return toReturn;
  };
})

.filter('beautifyUrl', function(){
  return function(url){
    var knownApplications = {"youtu": "Youtube", "forms.gle": "Google Forms", "drive.google": "Google Drive", "meet.google": "Google Meet", "docs.google": "Google Docs"};
    for (var appUrl in knownApplications) {
      if (url.indexOf(appUrl) !== -1) {
        return knownApplications[appUrl];
      }
    }
    url = url.replace("https://","").replace("http://","");
    url = url.replace("www.","");
    var urlSplitted = url.split("/");
    return urlSplitted[0];
  }
})

.filter('lastviewTime', function(){
  function addLeadingZeros(number){
    if(parseInt(number) < 10)number = 0 + number.toString();
    return number;
  }
  return function(time){
    if(!time || time.length < 5) return "";
    var date = new Date(time);
    return addLeadingZeros(date.getHours()) + ":" + addLeadingZeros(date.getMinutes());
  }
})

.filter('convertToBoolean',['$translate', function($translate) {
  return function(myString){
    if(myString === true || myString === 'true') return $translate.instant('yes');
    return $translate.instant('no');
  }
}])

.filter('trusted', ['$sce', function ($sce) {
  return function(url) {
      return $sce.trustAsResourceUrl(url);
  };
}])

.filter('filterByPrincipalOrSender', ['$rootScope', '$filter', function ($rootScope, $filter) {
  return function(messages) {
    if(!messages) return [];
    if($rootScope.allUserInfo.type === 'principal') return messages;
    return $filter('filter')(messages,{userSender: $rootScope.allUserInfo.id});
  };
}])

.filter('birthdayFilter', ['$translate', function ($translate) {
  return function(birthday) {
    if(!birthday) return "";
    var birthdaySplitted = birthday.split("/");
    var year = parseInt(birthdaySplitted[2]);
    var currentYear = new Date().getFullYear();
    var totalYears = currentYear - year;
    var yearWord = (totalYears > 1)? "years": "year";
    return "(" + totalYears + " " + $translate.instant(yearWord) + ")";
  };
}])

.filter('menusDocumentsFilter', ['$rootScope', function($rootScope) {
  return function(menus) {
    if (!menus) return [];
    var toR = [];
    menus.forEach(function (menu) {
      menu.visible = (menu.month === 'all' || parseInt(menu.month) === new Date().getMonth() || parseInt(menu.month) === (new Date().getMonth() +1));
      if (menu.visible || ($rootScope.allUserInfo.type === 'principal' || $rootScope.allUserInfo.type === 'teacher')) {
        toR.push(menu);
      }
    });
    return toR;
  }
}])

.filter('filterName', function () {
  function removeAccentsAndSpaces(value) {
    return value
      .replace(/á/g, 'a')           
      .replace(/à/g, 'a')           
      .replace(/é/g, 'e')
      .replace(/è/g, 'e')
      .replace(/í/g, 'i')
      .replace(/ó/g, 'o')
      .replace(/ò/g, 'o')
      .replace(/ú/g, 'u')
      .replace(/ /g, '')
      .toLowerCase();
  }
  return function(children, string) {
    if (!children || !string || string === '' || children.length === 0) {
      return children;
    }
    var toR = [];
    string = removeAccentsAndSpaces(string);
    children.forEach(function (child) {
      var nameSurname = removeAccentsAndSpaces(child.name + child.surname);
      if (nameSurname.indexOf(string) !== -1) {
        toR.push(child);
      }
    });
    return toR;
  }
})

.filter('foldersCustomFilter', function() {
  return function(folders, classroomId) {
    if (!folders) {
      return [];
    }
    folders = folders.filter(function (folder) {
      if (!folder.classrooms) {
        return false;
      }
      return !!folder.classrooms[classroomId];
    });
    return folders;
  }
})

.filter('joinCommunications', function() {
  return function(messages, individualMessages) {
    if (!messages) {
      messages = [];
    }
    if (!individualMessages) {
      individualMessages = [];
    }
    individualMessages.forEach(function(individualMessage) {
      individualMessage.individual = true;
      messages.push(individualMessage);
    });
    messages = messages.sort(function (a, b) {
      var dateA = parseInt(a.date);
      var dateB = parseInt(b.date);
      return (dateA - dateB);
    });
    return messages;
  }
});