
angular.module('childcareOnApp').config(function($stateProvider, $urlRouterProvider) {

  $stateProvider
    .state('app', {
    url: '/app',
    abstract: true,
    templateUrl: 'app/components/menu.html',
    controller: 'AppCtrl'
  })

  .state('app.splash', {
    url: '/splash',
		leftmenu: false,
		auth: false,
	  params: {
	    error: false
	  },
    views: {
      'menuContent': {
        templateUrl: 'app/components/splash/splash.html',
        controller: 'SplashCtrl'
      }
    }
  })

  .state('app.login', {
    url: '/login',
		leftmenu: false,
		auth: false,
	  params: {
	    logout: false
	  },
    analyticsName: 'Login',
    views: {
      'menuContent': {
        templateUrl: 'app/components/login/login.html',
        controller: 'LoginCtrl'
      }
    }
  })

  .state('app.signup', {
    url: '/signup',
		leftmenu: false,
		auth: false,
    analyticsName: 'Signup',
    views: {
      'menuContent': {
        templateUrl: 'app/components/signup/signup.html',
        controller: 'SignupCtrl'
      }
    }
  })

  .state('app.signupName', {
    url: '/signupName',
		leftmenu: false,
		auth: false,
    params: {
	    email: false,
      hasUser: false
	  },
    views: {
      'menuContent': {
        templateUrl: 'app/components/signup/signup-name/signup-name.html',
        controller: 'SignupNameCtrl'
      }
    }
  })

  .state('app.home', {
    url: '/home',
    leftmenu: true,
		auth: true,
    analyticsName: 'Home',
    views: {
      'menuContent': {
        templateUrl: 'app/components/home/home.html',
        controller: 'HomeCtrl',
      }
    }
  })

  .state('app.no_connection', {
    url: '/no-connection',
    leftmenu: true,
		auth: false,
    views: {
      'menuContent': {
        templateUrl: 'app/components/no-connection/no-connection.html',
        controller: 'NoConnectionCtrl',
      }
    }
  })

  .state('app.diary', {
    url: '/diary',
    leftmenu: true,
		auth: true,
    analyticsName: 'Diary',
    calendarButton:{
      value:true,
      type: "user"
    },
    params:{
      notification_day:false,
      changes:false
    },
    views: {
      'menuContent': {
        templateUrl: 'app/components/diary/diary.html',
        controller: 'DiaryCtrl'
      }
    }
  })
  
  .state('app.exportDiary', {
    url: '/diary-export',
    leftmenu: true,
		auth: true,
    analyticsName: 'Export Diary',
    views: {
      'menuContent': {
        templateUrl: 'app/components/diary/export/export.html',
        controller: 'DiaryExportCtrl'
      }
    }
  })

  .state('app.gallery', {
    url: '/gallery',
    leftmenu: true,
		auth: true,
    analyticsName: 'Gallery',
    views: {
      'menuContent': {
        templateUrl: 'app/components/gallery/gallery.html',
        controller: 'GalleryCtrl'
      }
    }
  })

  .state('app.photos', {
    url: '/gallery/photos',
    leftmenu: true,
		auth: true,
    analyticsName: 'Photos',
    params:{
      monthDate: false,
      customFolder: false
    },
    views: {
      'menuContent': {
        templateUrl: 'app/components/gallery/photos/photos.html',
        controller: 'PhotosCtrl'
      }
    }
  })
  
  .state('app.newImage', {
    url: '/gallery/new',
    leftmenu: true,
		auth: true,
    analyticsName: 'New photo',
    params:{
      imageSelected: false,
    },
    views: {
      'menuContent': {
        templateUrl: 'app/components/gallery/new-image/new-image.html',
        controller: 'GalleryNewImageCtrl'
      }
    }
  })

  .state('app.galleryFolders', {
    url: '/gallery/folders',
    leftmenu: true,
		auth: true,
    analyticsName: 'Gallery Folders',
    views: {
      'menuContent': {
        templateUrl: 'app/components/gallery/folders/folders.html',
        controller: 'FoldersCtrl as vm'
      }
    }
  })
  
  .state('app.galleryFoldersDetail', {
    url: '/gallery/folders/detail',
    leftmenu: true,
		auth: true,
    analyticsName: 'Gallery Folders Detail',
    params:{
      folder: false,
    },
    views: {
      'menuContent': {
        templateUrl: 'app/components/gallery/folders/folder/folder.html',
        controller: 'FoldersDetailCtrl as vm'
      }
    }
  })

  .state('app.communications', {
    url: '/communications',
    leftmenu: true,
		auth: true,
    analyticsName: 'Communications',
    params: {
      type: 'classrooms'
    },
    views: {
      'menuContent': {
        templateUrl: 'app/components/communications/communications.html',
        controller: 'CommunicationsCtrl as vm'
      }
    }
  })

  .state('app.message', {
    url: '/communications/message',
    leftmenu: false,
		auth: true,
    analyticsName: 'Communications - Message',
    params: {
      message: false,
      type: 'classrooms'
	  },
    views: {
      'menuContent': {
        templateUrl: 'app/components/communications/message/message.html',
        controller: 'MessageCtrl'
      }
    }
  })

  .state('app.createCommunication', {
    url: '/communications/message/createCommunication',
    leftmenu: false,
		auth: true,
    analyticsName: 'Communications - Send Message',
    params: {
      type: 'classrooms'
	  },
    views: {
      'menuContent': {
        templateUrl: 'app/components/communications/create-communication/create-communication.html',
        controller: 'CreateCommunicationCtrl'
      }
    }
  })

  .state('app.principalCommunications', {
    url: '/principal-communications',
    leftmenu: true,
		auth: true,
    analyticsName: 'Principal Communications',
    views: {
      'menuContent': {
        templateUrl: 'app/components/my-school/principal-communications/principal-communications.html',
        controller: 'PrincipalCommunicationsCtrl'
      }
    }
  })

  .state('app.imageViewer', {
    url: '/imageViewer',
    leftmenu: true,
		auth: true,
    analyticsName: 'Image viewer',
    params:{
      img:false,
      canDelete:false,
      imageComplete: false,
      canDownload: false,
      custom: false
    },
    views: {
      'menuContent': {
        templateUrl: 'app/components/imageViewer/imageViewer.html',
        controller: 'ImageViewerCtrl'
      }
    }
  })

  .state('app.multiImage', {
    url: '/multi-image',
    leftmenu: false,
		auth: true,
    analyticsName: 'Multi image viewer',
    params:{
      img:false,
      index: 0,
      canDelete:false,
      imageComplete: false,
      canDownload: false,
      custom: false
    },
    views: {
      'menuContent': {
        templateUrl: 'app/components/imageViewer/multi-image/multi-image.html',
        controller: 'MultiImageCtrl'
      }
    }
  })

  .state('app.videoViewer', {
    url: '/videoViewer',
    leftmenu: true,
		auth: true,
    analyticsName: 'Video viewer',
    params:{
      url:false,
      canDelete:false,
      videoComplete: false,
      canDownload: false,
      custom: false
    },
    views: {
      'menuContent': {
        templateUrl: 'app/components/imageViewer/video/video.html',
        controller: 'VideoViewerCtrl'
      }
    }
  })

  .state('app.health', {
    url: '/health',
    leftmenu: true,
		auth: true,
    analyticsName: 'Health',
    views: {
      'menuContent': {
        templateUrl: 'app/components/health/health.html',
        controller: 'HealthCtrl'
      }
    }
  })

  .state('app.internalChat', {
    url: '/internal-chat',
    leftmenu: true,
		auth: true,
    analyticsName: 'Internal Chat',
    params:{
      chat:false,
    },
    views: {
      'menuContent': {
        templateUrl: 'app/components/internal-chat/internal-chat.html',
        controller: 'InternalChatCtrl'
      }
    }
  })

  .state('app.internalChatDetail', {
    url: '/internal-chat/detail/:key',
    leftmenu: true,
		auth: true,
    analyticsName: 'Internal Chat Detail',
    views: {
      'menuContent': {
        templateUrl: 'app/components/internal-chat/detail/detail.html',
        controller: 'InternalChatDetailCtrl'
      }
    }
  })

  .state('app.notifications', {
    url: '/notifications',
    leftmenu: true,
		auth: true,
    analyticsName: 'Notifications',
    removeButton:{
      value:true,
      type: "user"
    },
    views: {
      'menuContent': {
        templateUrl: 'app/components/notifications/notifications.html',
        controller: 'NotificationsCtrl'
      }
    }
  })

  .state('app.adminSuggestions', {
    url: '/adminProfiles/suggestions',
    leftmenu: true,
		auth: true,
    views: {
      'menuContent': {
        templateUrl: 'app/components/admin-profiles/suggestions/suggestions.html',
        controller: 'AdminSuggestionsCtrl'
      }
    }
  })

  .state('app.adminTeachers', {
    url: '/adminProfiles/teachers',
    leftmenu: true,
		auth: true,
    views: {
      'menuContent': {
        templateUrl: 'app/components/admin-profiles/teachers/teachers.html',
        controller: 'AdminTeachersCtrl'
      }
    }
  })

  .state('app.selectClassroom', {
    url: '/adminProfiles/selectClassroom',
    leftmenu: true,
		auth: true,
    //goBackPage: 'home',
	  params: {
	    nextPage: false
	  },
    views: {
      'menuContent': {
        templateUrl: 'app/components/admin-profiles/select-classroom/select-classroom.html',
        controller: 'SelectClassroomCtrl'
      }
    }
  })

  .state('app.selectClassrooms', {
    url: '/adminProfiles/selectClassrooms',
    leftmenu: true,
		auth: true,
    goBackPage: 'home',
	  params: {
	    nextPage: false
	  },
    views: {
      'menuContent': {
        templateUrl: 'app/components/admin-profiles/select-classrooms/select-classrooms.html',
        controller: 'SelectClassroomsCtrl'
      }
    }
  })

  .state('app.selectStudent', {
    url: '/adminProfiles/selectStudent',
    leftmenu: true,
		auth: true,
    //goBackPage: 'selectClassroom',
    params:{
      comeFromSelectClassroom: false
    },
    views: {
      'menuContent': {
        templateUrl: 'app/components/admin-profiles/select-student/select-student.html',
        controller: 'SelectStudentDetailCtrl'
      }
    }
  })

  .state('app.adminStudentsInfo', {
    url: '/adminProfiles/studentsInfo',
    leftmenu: true,
		auth: true,
    views: {
      'menuContent': {
        templateUrl: 'app/components/admin-profiles/students-info/students-info.html',
        controller: 'AdminStudentsInfoCtrl'
      }
    }
  })

  .state('app.selectSchool', {
    url: '/adminProfiles/select-school',
    leftmenu: true,
		auth: true,
    views: {
      'menuContent': {
        templateUrl: 'app/components/admin-profiles/select-school/select-school.html',
        controller: 'SelectSchoolCtrl'
      }
    }
  })

  .state('app.adminStudentsInfoParents', {
    url: '/adminProfiles/studentsInfo/parents',
    leftmenu: true,
    auth: true,
    params: {
      studentParents: false
    },
    views: {
      'menuContent': {
        templateUrl: 'app/components/admin-profiles/students-parents/students-parents.html',
        controller: 'AdminStudentsParentsCtrl'
      }
    }
  })

  .state('app.adminClassrooms', {
    url: '/classrooms',
    leftmenu: true,
		auth: true,
    views: {
      'menuContent': {
        templateUrl: 'app/components/admin-profiles/classrooms/classrooms.html',
        controller: 'AdminClassroomsCtrl'
      }
    }
  })

  .state('app.adminClassroomsDetail', {
    url: '/classrooms/classroomsDetail',
    leftmenu: true,
		auth: true,
    views: {
      'menuContent': {
        templateUrl: 'app/components/admin-profiles/classrooms-detail/classrooms-detail.html',
        controller: 'AdminClassroomsDetailCtrl'
      }
    }
  })

  .state('app.adminClassroomsTeachers', {
    url: '/classrooms/classroomsDetail/teachers',
    leftmenu: true,
		auth: true,
    views: {
      'menuContent': {
        templateUrl: 'app/components/admin-profiles/classroom-teachers/classroom-teachers.html',
        controller: 'AdminClassroomsTeachersCtrl'
      }
    }
  })

  .state('app.schedules', {
    url: '/schedules',
    leftmenu: true,
		auth: true,
    analyticsName: 'Schedules',
    views: {
      'menuContent': {
        templateUrl: 'app/components/my-school/schedules/schedules.html',
        controller: 'SchedulesCtrl'
      }
    }
  })

  .state('app.payments', {
    url: '/payments',
    leftmenu: true,
		auth: true,
    analyticsName: 'Payments',
    views: {
      'menuContent': {
        templateUrl: 'app/components/my-school/payments/payments.html',
        controller: 'PaymentsCtrl as vm'
      }
    }
  })

  .state('app.mySchool', {
    url: '/my-school',
    leftmenu: true,
		auth: true,
    analyticsName: 'My School',
    views: {
      'menuContent': {
        templateUrl: 'app/components/my-school/my-school.html',
        controller: 'MySchoolCtrl'
      }
    }
  })

  .state('app.mySchoolInfo', {
    url: '/my-school/info',
    leftmenu: true,
		auth: true,
    analyticsName: 'My School Info',
    views: {
      'menuContent': {
        templateUrl: 'app/components/my-school/info/info.html',
        controller: 'MySchoolInfoCtrl'
      }
    }
  })

  .state('app.excursion', {
    url: '/my-school/excursion',
    leftmenu: true,
		auth: true,
    analyticsName: 'Excursion',
    removeButton:{
      value:true,
      type: "teacher"
    },
    views: {
      'menuContent': {
        templateUrl: 'app/components/my-school/excursion/excursion.html',
        controller: 'ExcursionCtrl'
      }
    }
  })
  
  .state('app.authorizations', {
    url: '/my-school/authorizations',
    leftmenu: true,
		auth: true,
    analyticsName: 'Authorizations',
    views: {
      'menuContent': {
        templateUrl: 'app/components/my-school/authorizations/authorizations.html',
        controller: 'AuthorizationsCtrl'
      }
    }
  })

  .state('app.meeting', {
    url: '/my-school/meeting',
    leftmenu: true,
		auth: true,
    analyticsName: 'Meeting',
    removeButton:{
      value:true,
      type: "teacher"
    },
    params:{
      allClassroomMeeting: false
    },
    views: {
      'menuContent': {
        templateUrl: 'app/components/my-school/meeting/meeting.html',
        controller: 'MeetingCtrl'
      }
    }
  })

  .state('app.documents', {
    url: '/my-school/documents',
    leftmenu: true,
		auth: true,
    analyticsName: 'Documents',
    removeButton:{
      value:true,
      type: "principal"
    },
    views: {
      'menuContent': {
        templateUrl: 'app/components/my-school/documents/documents.html',
        controller: 'DocumentsCtrl'
      }
    }
  })

  .state('app.attendance', {
    url: '/my-school/attendance',
    leftmenu: true,
		auth: true,
    analyticsName: 'Attendance',
    calendarButton:{
      value:true,
      type: "teacher"
    },
    views: {
      'menuContent': {
        templateUrl: 'app/components/my-school/attendance/attendance.html',
        controller: 'AttendanceCtrl'
      }
    }
  })

  .state('app.menus', {
    url: '/menus',
    leftmenu: true,
		auth: true,
    analyticsName: 'Menus',
    views: {
      'menuContent': {
        templateUrl: 'app/components/my-school/menus/menus.html',
        controller: 'MenusCtrl'
      }
    }
  })
  
  .state('app.menusDocuments', {
    url: '/menus-documents',
    leftmenu: true,
		auth: true,
    analyticsName: 'Menus Documents',
    addSomething:{
      value:true,
      type: "teacher"
    },
    removeButton:{
      value:true,
      type: "principal"
    },
    views: {
      'menuContent': {
        templateUrl: 'app/components/my-school/menus/menus-documents/menus-documents.html',
        controller: 'MenusDocumentsCtrl'
      }
    }
  })

  .state('app.marks', {
    url: '/marks',
    leftmenu: true,
		auth: true,
    analyticsName: 'Marks',
    removeButton:{
      value:true,
      type: "teacher"
    },
    views: {
      'menuContent': {
        templateUrl: 'app/components/my-school/marks/marks.html',
        controller: 'MarksCtrl'
      }
    }
  })

  .state('app.configuration', {
    url: '/configuration',
    leftmenu: true,
		auth: true,
    views: {
      'menuContent': {
        templateUrl: 'app/components/configuration/configuration.html',
        controller: 'ConfigurationCtrl'
      }
    }
  })

  .state('app.profile', {
    url: '/configuration/profile',
    leftmenu: true,
		auth: true,
    analyticsName: 'Profile',
    params: {
      openCode: false
    },
    views: {
      'menuContent': {
        templateUrl: 'app/components/configuration/profile/profile.html',
        controller: 'ProfileCtrl'
      }
    }
  })

  .state('app.profileEditChild', {
    url: '/profile/editChild',
    leftmenu: false,
		auth: true,
    params:{
      child:false
    },
    views: {
      'menuContent': {
        templateUrl: 'app/components/configuration/profile/editChild/editChild.html',
        controller: 'ProfileEditChildCtrl'
      }
    }
  })

  .state('app.configNotifications', {
    url: '/configuration/notifications',
    leftmenu: true,
		auth: true,
    analyticsName: 'Configuration Notifications',
    views: {
      'menuContent': {
        templateUrl: 'app/components/configuration/notifications/notifications.html',
        controller: 'ConfigNotificationsCtrl'
      }
    }
  })


  .state('app.configGlobalClassroom', {
    url: '/configuration/global-classroom',
    leftmenu: true,
		auth: true,
    analyticsName: 'Configuration Select Global Platform',
    views: {
      'menuContent': {
        templateUrl: 'app/components/configuration/select-globalClassroom/select-globalClassroom.html',
        controller: 'ConfigGlobalClassroomCtrl'
      }
    }
  })

  .state('app.teacherInfo', {
    url: '/adminProfiles/teacherProfile',
    leftmenu: false,
		auth: true,
    params:{
      teacher:false
    },
    views: {
      'menuContent': {
        templateUrl: 'app/components/admin-profiles/teacher-info/teacher-info.html',
        controller: 'TeacherInfoCtrl'
      }
    }
  })

  .state('app.invitationInfo', {
    url: '/adminProfiles/invitationInfo',
    leftmenu: false,
		auth: true,
    params:{
      invitation:false
    },
    views: {
      'menuContent': {
        templateUrl: 'app/components/admin-profiles/invitation-info/invitation-info.html',
        controller: 'InvitationInfoCtrl'
      }
    }
  })

  .state('app.help', {
    url: '/help',
    leftmenu: true,
		auth: true,
    analyticsName: 'Help',
    views: {
      'menuContent': {
        templateUrl: 'app/components/help/help.html',
        controller: 'HelpCtrl'
      }
    }
  })

  .state('app.feedback', {
    url: '/help/feedback',
    leftmenu: true,
		auth: true,
    analyticsName: 'Feedback',
    views: {
      'menuContent': {
        templateUrl: 'app/components/help/feedback/feedback.html',
        controller: 'FeedbackCtrl'
      }
    }
  })

  .state('app.privacyPolicy', {
    url: '/help/privacyPolicy',
    leftmenu: false,
		auth: false,
    views: {
      'menuContent': {
        templateUrl: 'app/components/help/privacyPolicy.html',
        controller: 'HelpCtrl'
      }
    }
  })

  .state('app.termsAndConditions', {
    url: '/help/termsAndConditions',
    leftmenu: false,
		auth: false,
    views: {
      'menuContent': {
        templateUrl: 'app/components/help/termsAndConditions.html',
        controller: 'HelpCtrl'
      }
    }
  })

  // .state('app.firstStepsNoChildren', {
  //   url: '/help/first-steps/no-children',
  //   leftmenu: true,
	// 	auth: true,
  //   analyticsName: 'First Steps - No Children',
  //   views: {
  //     'menuContent': {
  //       templateUrl: 'app/components/help/first-steps/no-children/no-children.html',
  //       controller: 'FirstStepsNoChildrenCtrl'
  //     }
  //   }
  // })

  .state('app.firstSteps', {
    url: '/help/firstSteps',
    leftmenu: true,
		auth: false,
    analyticsName: 'First Steps',
    views: {
      'menuContent': {
        templateUrl: 'app/components/help/first-steps/first-steps.html',
        controller: 'FirstStepsCtrl'
      }
    }
  })

  .state('app.firstStepsPrincipal', {
    url: '/help/firstSteps/principal',
    leftmenu: true,
		auth: false,
    analyticsName: 'First Steps Principal',
    views: {
      'menuContent': {
        templateUrl: 'app/components/help/first-steps/principal/principal.html',
        controller: 'FirstStepsPrincipalCtrl'
      }
    }
  })

  .state('app.poll', {
    url: '/poll',
    leftmenu: true,
		auth: false,
    analyticsName: 'Poll',
    views: {
      'menuContent': {
        templateUrl: 'app/components/poll/poll.html',
        controller: 'PollCtrl'
      }
    }
  })

  .state('app.calendar', {
    url: '/calendar',
    leftmenu: true,
		auth: false,
    analyticsName: 'Calendar',
    views: {
      'menuContent': {
        templateUrl: 'app/components/calendar/calendar.html',
        controller: 'CalendarCtrl as vm'
      }
    }
  });
  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/app/splash');
})
