angular.module('childcareOnApp.controllers', [])

.controller('AppCtrl', function($scope, $ionicModal, ionicMaterialInk, ionicMaterialMotion, $ionicSideMenuDelegate, $timeout, $rootScope, $state, $ionicHistory, $firebaseAuth, $firebaseObject, $firebaseArray, $translate, $q, ChildcareOnUtils,ChildFactory,UserFactory,SchedulesFactory,MenusFactory, NotificationFactory, AdminProfilesFactory, $ionicLoading, FirebasePluginFactory, CommonFactory, DiaryFactory, $localStorage, ImageFactory, ClassroomFactory, $ionicPlatform, $ionicPopup) {

  ionicMaterialInk.displayEffect();
  ionicMaterialMotion.ripple();
  $rootScope.isAndroid = ionic.Platform.isAndroid();
  $rootScope.testMode = testMode;
  console.log("testMode is",$rootScope.testMode);
  // Disable BACK button on home
  $ionicPlatform.registerBackButtonAction(function(event) {
    if ($state.current.name !== 'app.home'){
      $ionicHistory.goBack();
      return;
    } // your check here
    if(navigator.notification){
      navigator.notification.confirm($translate.instant('closeApp_body'), function(buttonIndex) {
        if(buttonIndex === 2) ionic.Platform.exitApp();
      }, $translate.instant('closeApp_title'), [ $translate.instant('no'), $translate.instant('yes')]);
    }
  }, 100);

  $scope.$on('$ionicView.enter', function(e) {
    try{
      $rootScope.authPage = $state.current.auth;
      $rootScope.leftmenuPage = $state.current.leftmenu;
      $ionicSideMenuDelegate.canDragContent($state.current.leftmenu);
    }catch(e){
      console.log("error in appctrl",e);
      $rootScope.authPage = true;
      $rootScope.leftmenuPage = false;
    }
  });

  $rootScope.addSomething = false;
  $rootScope.calendarButton = false;
  $rootScope.removeButton = false;
  $scope.authObj = $firebaseAuth();
  var timeToLoad = new Date().getTime();

  firebase.auth().onAuthStateChanged(function(user) {
    if (user) {
      // User is signed in.
      console.log("user signed in!",user);
      $scope.userInfo = user;
      if($state.current.name !== 'app.signup'){
        console.log("entra a getUserData porque no es app.signup",$state.current.name);
        getUserData(user.uid).then(function(){
          FirebasePluginFactory.setUserId();
          FirebasePluginFactory.setUserProperty("type",$rootScope.allUserInfo.type);
          UserFactory.emailVerified.set(user.emailVerified);
          //save user version and OS
          UserFactory.saveUserVersion();
          //UserFactory.get
          if($rootScope.allUserInfo.type === 'user'){
            console.log("allUserInfo.email",$rootScope.allUserInfo.email);
            AdminProfilesFactory.getInvitationsByUserV3($rootScope.allUserInfo.email).then(function(invitations){
              if(invitations && invitations.length > 0){
                console.log("try to add user by invitation");
                var isTeacher = false, parsedClassrooms = {};
                var parsedChilds = {}, number = 0;
                for(var i=0;i<invitations.length;i++){
                  if(!invitations[i].accepted){
                    if(invitations[i].type === "teacher"){
                      isTeacher = true;
                      var schoolId = invitations[i].schoolId;
                    }
                    if(!isTeacher || invitations[i].type !== "user"){
                      if(isTeacher){
                        if(!parsedClassrooms[invitations[i].classroomId]) parsedClassrooms[invitations[i].classroomId] = {};
                        parsedClassrooms[invitations[i].classroomId][$rootScope.allUserInfo.id] = $rootScope.allUserInfo.name + " " + $rootScope.allUserInfo.surname;
                      } else {
                        parsedChilds[invitations[i].childUid] = "father";
                      }
                      invitations[i].accepted = true;
                      invitations[i].email_accepted = $rootScope.allUserInfo.email + "_true";
                      number++;
                    }
                    console.log("try to save invitations",invitations);
                    invitations.$save(i).then(function(){
                      console.log("invitations saved successfully");
                    },function(e){
                      console.log("invitations saved error",e);
                    });
                  }
                }
                if(!isTeacher){
                  if(number > 0){
                    console.log("parsedChilds",parsedChilds);
                    ChildFactory.addParentToChild(parsedChilds,$rootScope.allUserInfo.id).then(function(){
                      console.log("parent added to child");
                      if(!$rootScope.allUserInfo.childs) $rootScope.allUserInfo.childs = {};
                      for(var i in parsedChilds){
                        $rootScope.allUserInfo.childs[i] = parsedChilds[i];
                        $rootScope.allUserInfo[i] = "child";
                      }
                      $rootScope.allUserInfo.$save().then(function(){
                        getChild().then(function(){
                          var schoolId = $rootScope.allUserChilds[$rootScope.childSelected].school;
                          $rootScope.schoolLocal = AdminProfilesFactory.getSchoolLocal(schoolId);
                          $rootScope.school = $rootScope.schoolLocal;
                          if(number > 1) alert($translate.instant('invitations_addedChilds',{number:number}));
                          else alert($translate.instant('invitations_addedChild'));
                          $rootScope.schoolLocal.$loaded()
                          .then(function() {
                            goToHome();
                          });
                        });
                      },function(e){
                        console.log("error saving user",e);
                        alert($translate.instant('serverError'))
                      });
                    },function(){
                      console.log("parent error added to child");
                      goToHome();
                    });
                  }else{
                    goToHome();
                  }
                }else{ //is teacher
                  $rootScope.school = AdminProfilesFactory.getSchool(schoolId);
                  $rootScope.schoolLocal = $rootScope.school;
                  $rootScope.school.$loaded().then(function(){
                    var wasParent = false;
                    if($rootScope.allUserInfo.type === "user"){
                      $rootScope.allUserInfo.type = "teacher";
                      wasParent = true;
                    }
                    if(!$rootScope.allUserInfo.school) $rootScope.allUserInfo.school = schoolId;
                    if(!$rootScope.allUserInfo.classrooms) $rootScope.allUserInfo.classrooms = {};
                    console.log("parsedClassrooms",parsedClassrooms);
                    for(var i in parsedClassrooms){
                      console.log("i is",i,$rootScope.school.classrooms);
                      $rootScope.allUserInfo.classrooms[i] = $rootScope.school.classrooms[i];
                    }
                    console.log("try to save user",$rootScope.allUserInfo);
                    $rootScope.allUserInfo.$save().then(function(){
                      if(wasParent) alert($translate.instant('teacherInvitation'));
                      else alert($translate.instant('invitation_addedClassroom'));
                    },function(e){
                      console.log("error saving user",e);
                    });
                    AdminProfilesFactory.getClassroomAccess($rootScope.allUserInfo.school).then(function(classroomAccess){
                      for(var i in parsedClassrooms){
                        classroomAccess[i] = parsedClassrooms[i];
                      }
                      console.log("try to save classroomAccess",classroomAccess);
                      classroomAccess.$save().then(function(){
                        console.log("saved classroomAccess success");
                        $scope.$evalAsync(function(){$rootScope.userImg = "img/user_noPhoto.png";});
                        goToHome();
                      },function(error){
                        alert($translate.instant('serverError'));
                        $rootScope.hide();
                      });
                    });
                  });
                }
              }else{
                if($rootScope.allUserChilds){
                  $rootScope.schoolLocal = AdminProfilesFactory.getSchoolLocal($rootScope.allUserChilds[$rootScope.childSelected].school);
                  $rootScope.schoolLocal.$loaded()
                  .then(function() {
                    $rootScope.school = $rootScope.schoolLocal;
                    console.log('schoolLocal', $rootScope.schoolLocal);
                    goToHome();
                  });
                }else goToHome();
              }
            });
          }else if($rootScope.allUserInfo.type !== "user"){ //is principal or teacher
            $rootScope.getTeacherInfo().finally(function(){
              goToHome();
            });
          }
        },function(){
          $rootScope.hide();
          console.log("error getUserData");
          alert($translate.instant('serverError'));
        });
      }
    } else {
      // No user is signed in.
      console.log("user no signed in");
      if(typeof cordova === 'undefined') return noLogin();
      document.addEventListener('deviceready', function(){
        NativeStorage.getItem("login",function(localLogin){
          console.log("login value",localLogin);
          if(localLogin.hasOwnProperty('u') && localLogin.hasOwnProperty('p')){
            firebase.auth().signInWithEmailAndPassword(localLogin.u, localLogin.p).then(function(user){
              console.log("re-logged!");
            }).catch(function(error) {
              noLogin();
            });
          }else{
            noLogin();
          }
        }, function(error){
          console.log("error en NativeStorage",error);
          noLogin();
        });
      }, false);
    }
  });

  // document.addEventListener(
  //   'visibilitychange'
  //   , () => {
  //     if (!document.hidden) {
  //       if (!$rootScope.allUserInfo && !$rootScope.settings) {
  //         var localSettings = $localStorage.getCHObject('settings');
  //         if (!!localSettings.time) {
  //           $rootScope.settings = localSettings.obj;
  //         }
  //       }
  //     }
  //   }
  // );

  var noLogin = function(){
    // UserFactory.removeRegistrationId();
    FirebasePluginFactory.removeBadgeNumber();
    // if($rootScope.isAndroid) FirebasePluginFactory.unregister();
    $ionicHistory.clearCache();
    $rootScope.hide();
    if($state.current.name !== 'app.login' && $state.current.name !== 'app.signup') $state.go('app.login',{logout:true});
  };

  var goToHome = function(){
    if($state.current.name == "app.login" || $state.current.name == "app.splash"){
      $ionicHistory.nextViewOptions({
        disableBack: true,
        historyRoot: true
      });
      $rootScope.hide();
      if($state.current.name == "app.splash"){
        var ttl = parseFloat((new Date().getTime() - timeToLoad)/1000);
        FirebasePluginFactory.logEvent('app_first_timeToLoad',{time:ttl, time_value:ttl});
      }
      delete timeToLoad;
      $state.go('app.home',{location:'replace'});
    }
  };

  var getIfPaidTemp = function() {
    if (Object.keys($rootScope.allUserInfo.diaryExport).length > 1 || $rootScope.isAndroid) {
      return;
    }
    store.register({type: store.NON_CONSUMABLE, id: 'export_diary_18_19_no_consumable'});
    var productTemp = store.get('export_diary_18_19_no_consumable');
    console.log('start product loading');
    var adviced = false;
    store.once('export_diary_18_19_no_consumable')
    .owned(function() {
      productTemp = store.get('export_diary_18_19_no_consumable');
      console.log('product updated', angular.copy(productTemp));
      if (productTemp.state === 'owned' && !adviced) {
        adviced = true;
        DiaryFactory.saveLoginPossibleBuyer();
      }
    });
    store.refresh();
    $rootScope.hasRefreshedStore = true;
  };


  var getUserData = function(userUid){
    return $q(function(resolve,reject){
      var date = new Date();
      var list = $firebaseObject(firebase.database().ref('users/' + userUid));
      $rootScope.allUserInfo = list;
      list.$loaded().then(function(userInfo){
        console.log("new Date().getTime() - date.getTime()",new Date().getTime() - date.getTime());
        if((new Date().getTime() - date.getTime()) > 2500) $rootScope.showToast($translate.instant('lowConnection'));
        console.log("allUserInfo",userInfo);
        var localUser = $localStorage.getCHObject('user');
        console.log(localUser);
        if(!userInfo.type && localUser.id !== userUid){ //el user está en auth pero no en database
          $state.go('app.signupName',{hasUser:true});
          return;
        } else {
          $localStorage.setCHObject('user', userInfo, userUid);
        }
        if(userInfo.hasOwnProperty('lang')){
          $translate.use(userInfo.lang);
          console.log("changing language to",userInfo.lang);
        }
        if(userInfo.type !== "user"){
          if(userInfo.hasOwnProperty('photo')){
            $scope.$evalAsync(function(){
              $rootScope.userImg = userInfo.photo;
            });
          }else $scope.$evalAsync(function(){
            $rootScope.userImg = "img/user_noPhoto.png";
          });
        }
        if(userInfo.type === 'user'){
          var child = null;
          for(var i in userInfo.childs){
            child = i;
            break;
          }
          if(child != null){
            getChild().then(resolve,reject);
          }else{
            $scope.$evalAsync(function(){$rootScope.userImg = "img/user_noPhoto.png";});
            $rootScope.childSelected = null;
            NotificationFactory.getAppSettings();
            resolve();
          }
        }else{
          NotificationFactory.getUserNotifications($rootScope.allUserInfo.id);
          NotificationFactory.getAppSettings();
          resolve();
        }
      },function(e){
        console.log("Error:",e);
        reject();
      });
    });
  };

  $rootScope.getTeacherInfo = function(){
    return $q(function(resolve, reject) {
      $rootScope.school = AdminProfilesFactory.getSchool($rootScope.allUserInfo.school);
      $rootScope.schoolLocal = $rootScope.school;
      var getClassroomAccessFn = AdminProfilesFactory.getClassroomAccess($rootScope.allUserInfo.school);

      $q.all([getClassroomAccessFn, $rootScope.school.$loaded()]).then(function(result) {
        var classroomAccess = result[0];
        console.log("school", $rootScope.school);
        var parsedClassroomAccess = [];
        if($rootScope.allUserInfo.type === 'teacher'){
          console.log("entra aqui type",classroomAccess);
          for(var i in classroomAccess){
            if(i.indexOf('$') === -1 && typeof classroomAccess[i] === 'object'){
              if($rootScope.allUserInfo.id in classroomAccess[i]){
                if(!$rootScope.globalClassSelected){
                  if(!$rootScope.allUserInfo.globalClassSelected || $rootScope.allUserInfo.globalClassSelected.id === i || !$rootScope.globalClassSelected){
                    if(!$rootScope.allUserInfo.globalClassSelected || $rootScope.allUserInfo.globalClassSelected.id !== i){
                      var provisionalClass = {id:i,name: $rootScope.school.classrooms[i]};
                    }else{
                      $rootScope.globalClassSelected = {id:i,name: $rootScope.school.classrooms[i]};
                      if(!$rootScope.allUserInfo.globalClassSelected){
                        UserFactory.saveGlobalClassroom();
                      }
                    }
                  }
                }
                parsedClassroomAccess.push({id:i,name:$rootScope.school.classrooms[i]});
              }
            }
          }
          if(!$rootScope.globalClassSelected || $rootScope.globalClassSelected.id !== $rootScope.allUserInfo.globalClassSelected.id){
            if(typeof provisionalClass !== "undefined"){
              $rootScope.globalClassSelected = angular.copy(provisionalClass);
              delete provisionalClass;
              UserFactory.saveGlobalClassroom();
            }else $rootScope.globalClassSelected = false;
          }
        }
        if($rootScope.allUserInfo.type === 'principal'){
          if($rootScope.school.hasOwnProperty('classrooms')){
            for(var i in $rootScope.school.classrooms){
              if(!$rootScope.globalClassSelected || $rootScope.allUserInfo.globalClassSelected.id === i) $rootScope.globalClassSelected = {id:i,name:$rootScope.school.classrooms[i]};
              if(!$rootScope.allUserInfo.globalClassSelected){
                UserFactory.saveGlobalClassroom();
              }
              parsedClassroomAccess.push({id:i, name: $rootScope.school.classrooms[i]});
            }
          }else $rootScope.globalClassSelected = false;
        }
        $rootScope.parsedClassroomAccess = parsedClassroomAccess;
        console.log("$rootScope.parsedClassroomAccess",$rootScope.parsedClassroomAccess);
        console.log("$rootScope.globalClassSelected",$rootScope.globalClassSelected);
        DiaryFactory.getSettings($rootScope.allUserInfo.school).then(function(settings){
          $rootScope.settings = settings;
          if($rootScope.globalClassSelected !== false) $scope.classroomType = ClassroomFactory.getClassroomType(settings,$rootScope.globalClassSelected.id);
          else $scope.classroomType = 1;
        });
        resolve();
      });
    });
  };

  var getChild = function(){
    return $q(function(resolve,reject){
      console.log("childs",$rootScope.allUserInfo.childs);
      ChildFactory.getUserChilds($rootScope.allUserInfo.childs).then(function(childInfo){
        console.log("childInfo",childInfo,childInfo.length);
        $rootScope.allUserChilds = childInfo;
        for(var i in childInfo){
          if(i.indexOf("$") !== -1 || typeof childInfo[i] === 'function') continue;
          try {
            FirebasePluginFactory.setUserProperty("school",childInfo[i].school);
          } catch (error) {
            console.log("error setting schoolId", error);
          }
          $rootScope.childSelected = i;
          if(childInfo[i].photo) $scope.$evalAsync(function(){$rootScope.userImg = childInfo[i].photo;});
          else $scope.$evalAsync(function(){$rootScope.userImg = "img/user_noPhoto.png";});
          break;
        }
        // write here code to delete child from user
        DiaryFactory.getSettings($rootScope.allUserChilds[$rootScope.childSelected].school).then(function(settings){
          $rootScope.settings = settings;
          var classroomId = $rootScope.allUserChilds[$rootScope.childSelected].classroomId;
          $scope.classroomType = ClassroomFactory.getClassroomType(settings,classroomId);
        });
        if(!$rootScope.childSelected){
          $scope.$evalAsync(function(){$rootScope.userImg = "img/user_noPhoto.png";});
          $rootScope.childSelected = null;
        }else{
          NotificationFactory.childTeachersAvailable.set($rootScope.allUserChilds[$rootScope.childSelected]);
        }
        NotificationFactory.getUserNotifications($rootScope.allUserInfo.id);
        NotificationFactory.getAppSettings();
        resolve();
      },function(e){
        console.log("error en getChild",e);
        var obj = { user: $rootScope.allUserInfo.id, error:stripslashes(JSON.stringify(e)), page:$state.current.name, date: JSON.stringify(new Date())};
        CommonFactory.saveLog(obj);
        $rootScope.allUserChilds = [];
        $rootScope.childSelected = null;
        resolve();
      });
    });
  };

  var getIfAddSomething = function(state){
    if(!state.addSomething || !state.addSomething.value || !$rootScope.allUserInfo) return false;
    var permissions = {user:0,teacher:1,principal:2,admin:3};
    if(permissions[$rootScope.allUserInfo.type] < permissions[state.addSomething.type]) return false;
    return true;
  };

  var getIfShowCalendar = function(state){
    if(!state.calendarButton || !state.calendarButton.value || !$rootScope.allUserInfo) return false;
    var permissions = {user:0,teacher:1,principal:2,admin:3};
    if(permissions[$rootScope.allUserInfo.type] < permissions[state.calendarButton.type]) return false;
    return true;
  };

  var getIfShowRemove = function(state){
    if(!state.removeButton || !state.removeButton.value || !$rootScope.allUserInfo) return false;
    var permissions = {user:0,teacher:1,principal:2,admin:3};
    if(permissions[$rootScope.allUserInfo.type] < permissions[state.removeButton.type]) return false;
    return true;
  };

  $ionicPlatform.ready(function() {
    if(typeof cordova !== 'undefined' && navigator.connection && navigator.connection.type == Connection.NONE) {
      $state.go('app.no_connection');
      return;
    }
  });

  $rootScope.$on('$stateChangeStart', function(e, toState, toParams, fromState, fromParams){
    console.log("typeof connection",typeof Connection);
    if(navigator.connection && (typeof Connection !== 'undefined') && navigator.connection.type == Connection.NONE && toState.name !== 'app.no_connection') {
      $state.go('app.no_connection');
      e.preventDefault();
      return;
    }
    if(!$rootScope.allUserInfo && toState.auth && toState.name !== 'app.splash'){
      var msg = {
        error:"$rootScope.allUserInfo doesn't exist"
      };
      if($scope.userInfo && $scope.userInfo.hasOwnProperty('uid')) msg.user = $scope.userInfo.uid;
      CommonFactory.saveLog(msg);
      firebase.auth().signOut();
      return;
    }
    $scope.$evalAsync(function(){
      $rootScope.leftmenuPage = toState.leftmenu;
      $rootScope.authPage = toState.auth;
      $rootScope.addSomething = getIfAddSomething(toState);
      $rootScope.calendarButton = getIfShowCalendar(toState);
      $rootScope.removeButton = getIfShowRemove(toState);
    });
    if(toState.analyticsName){
      FirebasePluginFactory.setCurrentScreen(toState.analyticsName);
    }
    $rootScope.currentPath = toState.url;
    $ionicSideMenuDelegate.canDragContent(toState.leftmenu);
    if($rootScope.authPage){
      if($state.current.name !== 'app.home' && $rootScope.allUserInfo.type !== 'user') $ionicHistory.clearCache();
    }
    if(toState.auth === true && !firebase.auth().currentUser){
      console.log('Auth: Permision Denied - Redirected to Login');
      $rootScope.authPage = false;
      $rootScope.leftmenuPage = false;
      $state.go('app.login');
      e.preventDefault();
      return;
    } else console.log('Auth: Permision Allowed');
    if($rootScope.allUserInfo && $rootScope.allUserInfo.type === 'user' && (!$rootScope.childSelected || $rootScope.childSelected === null)){
      for(var i in $rootScope.allUserChilds){
        if(i.indexOf('$') === -1 && typeof $rootScope.allUserChilds[i] == "object"){
          $rootScope.selectChild(i);
          break;
        }
      }
    }
  });

  $scope.toggleLeft = function() {
    $ionicSideMenuDelegate.toggleLeft();
  };

  $scope.convertToYesNo = function(value){
    if(value) return $translate.instant('yes'); else return $translate.instant('no');
  };

  $rootScope.setGoTo = function(page){
    $rootScope.goTo = page;
    console.log("setToGo page is",page);
  };

  $rootScope.setGoToArgs = function(args) {
    $rootScope.goToArgs = args;
    console.log("setToGo args is",args);
  };

  $rootScope.goToWithoutStudent = function(stateName, stopIfFree){
    if (typeof stopIfFree === 'undefined') {
      stopIfFree = false;
    }
    if (!stopIfFree || !$rootScope.disableLeftMenuFree(true)) {
      if($rootScope.allUserInfo.type === 'user'){
        if($rootScope.childSelected){
          $state.go('app.'+stateName);
        }else{
          alert($translate.instant('childMandatory'));
        }
      }else{
        $rootScope.setGoTo(stateName);
        console.log("stateName",stateName);
        if($rootScope.globalClassSelected){
          $rootScope.classSelected = $rootScope.globalClassSelected;
          if($rootScope.classroom && $rootScope.classroom.$id === $rootScope.classSelected.id){
            $state.go("app."+stateName);
          }else{
            $rootScope.classroom = ClassroomFactory.getClassroomStudentsV2($rootScope.classSelected.id);
            $state.go("app."+stateName);
            // ClassroomFactory.getClassroomStudents($rootScope.classSelected.id).then(function(classroom){
            //   console.log("classroom selected",classroom);
            //   $rootScope.classroom = classroom;
            //   $state.go("app."+stateName);
            // },function(){
            //   alert($translate.instant('serverError'));
            // }).finally($rootScope.hide);
          }
        }else{
          $state.go('app.selectClassroom',{ nextPage:stateName });
        }
      }
    }
  };

  $rootScope.goToWithoutStudentClassrooms = function(stateName){
    if($rootScope.allUserInfo.type === 'user'){
      if($rootScope.childSelected){
        $state.go('app.'+stateName);
      }else{
        alert($translate.instant('childMandatory'));
      }
    }else{
      $rootScope.setGoTo(stateName);
      console.log("stateName",stateName);
      $state.go('app.selectClassrooms',{ nextPage:stateName });
    }
  };

  $rootScope.goToWithStudent = function(stateName, args, stopIfFree){
    if (typeof stopIfFree === 'undefined') {
      stopIfFree = false;
    }
    if (!stopIfFree || !$rootScope.disableLeftMenuFree(true)) {
      if($rootScope.allUserInfo.type === 'user'){
        if($rootScope.childSelected){
          $state.go('app.'+stateName, args);
        }else{
          // alert($translate.instant('childMandatory'));
          _confirm($translate.instant('noKidSelected'), $translate.instant('childMandatory') ,$translate.instant('button_accept'), $translate.instant('menu_help'), function(buttonIndex){
            if(buttonIndex === 2){
              $state.go('app.firstSteps');
            }
          });
        }
      } else {
        $rootScope.setGoTo(stateName);
        if (typeof args !== 'undefined') {
          $rootScope.setGoToArgs(args);
        }
        $rootScope.globalClassSelected ? $state.go("app.selectStudent") : $state.go('app.selectClassroom',{ nextPage:false });
      }
    }
  };

  $rootScope.showToast = function(message, translateVars){
    if(typeof translateVars !== 'undefined'){
      var trans = $translate.instant(message,translateVars);
    }else{
      var trans = $translate.instant(message);
    }
    if(window.plugins){
      window.plugins.toast.show(trans, 'short', 'bottom');
    }else{
      alert(trans);
    }
  };

  $rootScope.show = function(unlimitedDuration) {
    var options = {
      template: '<ion-spinner style="stroke:#FFF;"></ion-spinner>'
    };
    if (typeof unlimitedDuration === 'undefined' || !unlimitedDuration) {
      options.duration = 25000;
    }
    $ionicLoading.show(options);
  };

  $rootScope.hide = function(){
    $ionicLoading.hide();
  };

  $rootScope.dateCommunications = function(timestamp){
      var dateTimestamp = new Date(parseInt(timestamp));
      var today = new Date();
      var timestampTemp = {day:dateTimestamp.getDate(),month:dateTimestamp.getMonth(),year:dateTimestamp.getFullYear(),hour:dateTimestamp.getHours(),minutes:dateTimestamp.getMinutes()};
      var timestampToday = {day:today.getDate(),month:today.getMonth(),year:today.getFullYear()};
      var dateTemp = null;
      switch(true){
        case timestampTemp.day === timestampToday.day && timestampTemp.month === timestampToday.month && timestampTemp.year === timestampToday.year: dateTemp = ChildcareOnUtils.addLeadingZeros(timestampTemp.hour) +":"+ ChildcareOnUtils.addLeadingZeros(timestampTemp.minutes); break;
        case timestampTemp.day === (timestampToday.day - 1) && timestampTemp.month === timestampToday.month && timestampTemp.year === timestampToday.year: dateTemp = $translate.instant('date_yesterday') + " " + $translate.instant('date_at') + " " + ChildcareOnUtils.addLeadingZeros(timestampTemp.hour) + ":" + ChildcareOnUtils.addLeadingZeros(timestampTemp.minutes); break;
        default : dateTemp = ChildcareOnUtils.addLeadingZeros(timestampTemp.day) + "/" + ChildcareOnUtils.addLeadingZeros(timestampTemp.month+1) + "/" + timestampTemp.year.toString().slice(2,4);
      }
      return dateTemp;
  };

  $rootScope.getSchedule = function(classroomId){
    return $q(function(resolve, reject) {
      SchedulesFactory.getSchedule(classroomId).then(function(schedule){
        console.log("schedule success",schedule);
        $rootScope.scheduleInfo = schedule;
        resolve();
      },function(){
        console.log("error en getSchedule");
        reject();
      });
    });
  };

  $rootScope.errorFound = function(){
    alert($translate.instant('errorFound'));
    $state.go('app.splash',{error:true});
  };

  $rootScope.myGoBack = function(){
    if(!$state.current.goBackPage || $state.current.name === "app."+$state.current.goBackPage){
      console.log("entra al if myGoBack");
      $ionicHistory.goBack();
    }else{
      console.log("entra al else myGoBack");
      $state.go("app."+$state.current.goBackPage);
    }
  };

  $rootScope.changeLanguage = function(langKey){
    $translate.use(langKey);
    $rootScope.showToast("idioma cambiado");
  };

  $rootScope.hideLeftMenu = function(page){ // if null, we don't show menu option
    if (!$rootScope.settings) return false;
    if ($rootScope.hideForTeachers(page)) {
      return true;
    }
    if(!$rootScope.settings.leftMenu) return false;
    if(!$rootScope.settings.leftMenu[page]) return false;
    return true;
  };

  $rootScope.hideForTeachers = function(page) {
    return (!!$rootScope.allUserInfo && $rootScope.allUserInfo.type === 'teacher' && !!$rootScope.settings.hideTeachers && $rootScope.settings.hideTeachers[page]);
  };

  $rootScope.disableLeftMenuFree = function(sendAlert){
    try {
      if(!!$rootScope.settings && $rootScope.settings.free) {
        var dateCreated = (!!$rootScope.schoolLocal.dateCreated) ? parseInt($rootScope.schoolLocal.dateCreated) : 0;
        if (dateCreated < (new Date().getTime() - 86400000)) {
          if (sendAlert) {
            var message = ($rootScope.allUserInfo.type === 'principal') ? 'freeMessage_principal' : 'freeMessage_users';
            alert($translate.instant(message));
          }
          return true;
        }
        return false;
      }
      return false;
    } catch (error) {
      return false;
    }
  };

  $rootScope.selectChild = function(childUid){
    if ($rootScope.childSelected !== childUid && !!$rootScope.allUserInfo.childs[childUid]) {
      $rootScope.childSelected = childUid;
      console.log("childSelected on Change",childUid);
      var classroomId = $rootScope.allUserChilds[$rootScope.childSelected].classroomId;
      var name = $rootScope.allUserChilds[$rootScope.childSelected].name;
      if($rootScope.allUserChilds[$rootScope.childSelected].photo) $scope.$evalAsync(function(){$rootScope.userImg = $rootScope.allUserChilds[$rootScope.childSelected].photo;});
      else $scope.$evalAsync(function(){$rootScope.userImg = "img/user_noPhoto.png";});
      NotificationFactory.childTeachersAvailable.set($rootScope.allUserChilds[$rootScope.childSelected]);
      if(!$rootScope.settings || $rootScope.settings.$id !== $rootScope.allUserChilds[$rootScope.childSelected].school){
        console.log("entra a settings");
        DiaryFactory.getSettings($rootScope.allUserChilds[$rootScope.childSelected].school).then(function(settings){
          console.log("settings",settings);
          $rootScope.settings = settings;
          $scope.classroomType = ClassroomFactory.getClassroomType(settings,classroomId);
          alert($translate.instant('childChanged',{name:name}));
        });
      }else{
        $scope.classroomType = ClassroomFactory.getClassroomType(false,classroomId);
        alert($translate.instant('childChanged',{name:name}));
      }
    }
  };

  $rootScope.copyToClipboard = function(message) {
    cordova.plugins.clipboard.copy(message);
    $rootScope.showToast('text_copied');
  };

  $rootScope.checkPremium = function() {
    var isPremium = false;
    if (!!$rootScope.settings && $rootScope.settings.$resolved) {
      isPremium = !!$rootScope.settings.premium;
    } else {
      var localSettings = $localStorage.getCHObject('settings');
      isPremium = (!!localSettings.time && localSettings.obj.premium);
    }
    if (!isPremium) {
      alert($translate.instant('premium_functionality'));
    }
    return isPremium;
  };

  $scope.disabledPage = function() {
    alert($translate.instant('page_disabled'));
  };

  $scope.isAvailableByDate = function(startDate) {
    return (new Date().getTime() > startDate);
  };

});
